=== modified file '.testr.conf'
--- .testr.conf	2018-06-26 00:06:27 +0000
+++ .testr.conf	2020-02-07 02:14:30 +0000
@@ -1,4 +1,4 @@
 [DEFAULT]
-test_command=BRZ_PLUGIN_PATH=-site:-user ./tools/testr-run.py $IDOPTION $LISTOPT
+test_command=BRZ_PLUGIN_PATH=-site:-user python3 ./brz selftest --subunit2 $IDOPTION $LISTOPT
 test_id_option=--load-list $IDFILE
 test_list_option=--list

=== modified file '.travis.yml'
--- .travis.yml	2020-02-05 01:40:59 +0000
+++ .travis.yml	2020-02-13 23:57:28 +0000
@@ -11,8 +11,6 @@
 
 matrix:
   include:
-    - python: 2.7
-      env: SELFTEST_OPTIONS="--coverage"
     - python: 3.7
       dist: xenial
     - python: 3.8

=== modified file 'Makefile'
--- Makefile	2020-02-05 02:40:11 +0000
+++ Makefile	2020-02-13 23:57:28 +0000
@@ -22,9 +22,7 @@
 
 SHELL=bash
 PYTHON?=python3
-PYTHON2?=python2
 PYTHON3?=python3
-PYTHON27=python27
 BRZ_TARGET=release
 PLUGIN_TARGET=plugin-release
 PYTHON_BUILDFLAGS=
@@ -81,10 +79,7 @@
 	# https://github.com/paramiko/paramiko/issues/713 is not a concern
 	# anymore -- vila 2017-05-24
 	set -o pipefail; \
-	BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON2) -Werror -Wignore::FutureWarning -Wignore::DeprecationWarning -Wignore::ImportWarning -Wignore::ResourceWarning -O \
-	  ./brz selftest -v --parallel=fork -Oselftest.timeout=120 --subunit2 \
-	  | subunit-filter -s --passthrough --rename "^" "python2."; \
-	  BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON3) -Werror -Wignore::FutureWarning -Wignore::DeprecationWarning -Wignore::PendingDeprecationWarning -Wignore::ImportWarning -Wignore::ResourceWarning -O \
+	BRZ_PLUGIN_PATH=$(BRZ_PLUGIN_PATH) $(PYTHON3) -Werror -Wignore::FutureWarning -Wignore::DeprecationWarning -Wignore::PendingDeprecationWarning -Wignore::ImportWarning -Wignore::ResourceWarning -O \
 	  ./brz selftest -v --parallel=fork -Oselftest.timeout=120 --subunit2 \
 	  | subunit-filter -s --passthrough --rename "^" "python3."
 
@@ -266,11 +261,10 @@
 	$(PYTHON) tools/win32/run_script.py cog.py -d -o tools/win32/brz.iss tools/win32/brz.iss.cog
 	iscc /Q tools/win32/brz.iss
 
-py-inst-27: docs
-	$(PYTHON27) setup.py bdist_wininst --install-script="brz-win32-bdist-postinstall.py" -d .
-
-python-installer: py-inst-27
-
+py-inst-37: docs
+	$(PYTHON37) setup.py bdist_wininst --install-script="brz-win32-bdist-postinstall.py" -d .
+
+python-installer: py-inst-37
 
 copy-docs: docs
 	$(PYTHON) tools/win32/ostools.py copytodir README win32_brz.exe/doc

=== modified file 'README.rst'
--- README.rst	2019-02-11 20:37:27 +0000
+++ README.rst	2020-03-22 01:35:14 +0000
@@ -18,8 +18,8 @@
 Breezy is a friendly fork of the Bazaar (``bzr``) project, hosted on
 http://bazaar.canonical.com/. It is backwards compatibility with
 Bazaar's disk format and protocols. One of the key differences with
-Bazaar is that Breezy also runs on Python 3.3 and later, in addition to
-Python 2.7.
+Bazaar is that Breezy runs on Python 3.3 and later, rather than on
+Python 2.
 
 Breezy highlights
 =================

=== modified file 'breezy/__init__.py'
--- breezy/__init__.py	2019-11-19 18:10:28 +0000
+++ breezy/__init__.py	2020-02-18 01:57:45 +0000
@@ -29,8 +29,6 @@
 We hope you enjoy this library.
 """
 
-from __future__ import absolute_import
-
 import time
 
 # Keep track of when breezy was first imported, so that we can give rough
@@ -43,7 +41,7 @@
 
 __copyright__ = (
     "Copyright 2005-2012 Canonical Ltd.\n"
-    "Copyright 2017-2019 Breezy developers"
+    "Copyright 2017-2020 Breezy developers"
 )
 
 # same format as sys.version_info: "A tuple containing the five components of
@@ -53,7 +51,7 @@
 # Python version 2.0 is (2, 0, 0, 'final', 0)."  Additionally we use a
 # releaselevel of 'dev' for unreleased under-development code.
 
-version_info = (3, 1, 0, 'dev', 0)
+version_info = (3, 2, 0, 'dev', 0)
 
 
 def _format_version_tuple(version_info):
@@ -129,26 +127,20 @@
     The use of intern() may defer breakage is but is not enough, the string
     object should be secure against module reloading and during teardown.
     """
-    is_py3 = sys.version_info > (3,)
     try:
         import ctypes
         old_ptr = ctypes.c_void_p.in_dll(ctypes.pythonapi,
                                          "Py_FileSystemDefaultEncoding")
-        if is_py3:
-            has_enc = ctypes.c_int.in_dll(ctypes.pythonapi,
-                                          "Py_HasFileSystemDefaultEncoding")
-            as_utf8 = ctypes.PYFUNCTYPE(
-                ctypes.POINTER(ctypes.c_char), ctypes.py_object)(
-                    ("PyUnicode_AsUTF8", ctypes.pythonapi))
+        has_enc = ctypes.c_int.in_dll(ctypes.pythonapi,
+                                      "Py_HasFileSystemDefaultEncoding")
+        as_utf8 = ctypes.PYFUNCTYPE(
+            ctypes.POINTER(ctypes.c_char), ctypes.py_object)(
+                ("PyUnicode_AsUTF8", ctypes.pythonapi))
     except (ImportError, ValueError):
         return  # No ctypes or not CPython implementation, do nothing
-    if is_py3:
-        new_enc = sys.intern(new_enc)
-        enc_ptr = as_utf8(new_enc)
-        has_enc.value = 1
-    else:
-        new_enc = intern(new_enc)
-        enc_ptr = ctypes.c_char_p(new_enc)
+    new_enc = sys.intern(new_enc)
+    enc_ptr = as_utf8(new_enc)
+    has_enc.value = 1
     old_ptr.value = ctypes.cast(enc_ptr, ctypes.c_void_p).value
     if sys.getfilesystemencoding() != new_enc:
         raise RuntimeError("Failed to change the filesystem default encoding")

=== modified file 'breezy/_annotator_py.py'
--- breezy/_annotator_py.py	2020-01-25 13:08:09 +0000
+++ breezy/_annotator_py.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Functionality for doing annotations in the 'optimal' way"""
 
-from __future__ import absolute_import
-
 from .lazy_import import lazy_import
 lazy_import(globals(), """
 
@@ -33,10 +31,6 @@
     osutils,
     ui,
     )
-from .sixish import (
-    range,
-    viewitems,
-    )
 
 
 class Annotator(object):
@@ -95,7 +89,7 @@
                     vf_keys_needed.add(key)
             needed_keys = set()
             next_parent_map.update(self._vf.get_parent_map(parent_lookup))
-            for key, parent_keys in viewitems(next_parent_map):
+            for key, parent_keys in next_parent_map.items():
                 if parent_keys is None:  # No graph versionedfile
                     parent_keys = ()
                     next_parent_map[key] = ()

=== modified file 'breezy/_annotator_pyx.pyx'
--- breezy/_annotator_pyx.pyx	2018-07-01 22:44:13 +0000
+++ breezy/_annotator_pyx.pyx	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Functionality for doing annotations in the 'optimal' way"""
 
-from __future__ import absolute_import
-
 
 cdef extern from "python-compat.h":
     pass

=== modified file 'breezy/_bencode_pyx.pyx'
--- breezy/_bencode_pyx.pyx	2018-08-21 19:28:52 +0000
+++ breezy/_bencode_pyx.pyx	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Pyrex implementation for bencode coder/decoder"""
 
-from __future__ import absolute_import
-
 from cpython.bool cimport (
     PyBool_Check,
     )

=== modified file 'breezy/_chunks_to_lines_py.py'
--- breezy/_chunks_to_lines_py.py	2017-06-11 01:12:29 +0000
+++ breezy/_chunks_to_lines_py.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """The python implementation of chunks_to_lines"""
 
-from __future__ import absolute_import
-
 
 def chunks_to_lines(chunks):
     """Re-split chunks into simple lines.

=== modified file 'breezy/_chunks_to_lines_pyx.pyx'
--- breezy/_chunks_to_lines_pyx.pyx	2018-07-01 20:02:53 +0000
+++ breezy/_chunks_to_lines_pyx.pyx	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Pyrex extensions for converting chunks to lines."""
 
-from __future__ import absolute_import
-
 
 cdef extern from "python-compat.h":
     pass

=== modified file 'breezy/_known_graph_py.py'
--- breezy/_known_graph_py.py	2018-11-23 02:42:39 +0000
+++ breezy/_known_graph_py.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 """Implementation of Graph algorithms when we have already loaded everything.
 """
 
-from __future__ import absolute_import
-
 try:
     from collections.abc import deque
 except ImportError:  # python < 3.7
@@ -27,10 +25,6 @@
     errors,
     revision,
     )
-from .sixish import (
-    viewitems,
-    viewvalues,
-    )
 
 
 class _KnownGraphNode(object):
@@ -88,7 +82,7 @@
           child_keys,
         """
         nodes = self._nodes
-        for key, parent_keys in viewitems(parent_map):
+        for key, parent_keys in parent_map.items():
             if key in nodes:
                 node = nodes[key]
                 node.parent_keys = parent_keys
@@ -104,11 +98,11 @@
                 parent_node.child_keys.append(key)
 
     def _find_tails(self):
-        return [node for node in viewvalues(self._nodes)
+        return [node for node in self._nodes.values()
                 if not node.parent_keys]
 
     def _find_tips(self):
-        return [node for node in viewvalues(self._nodes)
+        return [node for node in self._nodes.values()
                 if not node.child_keys]
 
     def _find_gdfo(self):
@@ -242,7 +236,7 @@
         seen = set()
         pending = []
         min_gdfo = None
-        for node in viewvalues(candidate_nodes):
+        for node in candidate_nodes.values():
             if node.parent_keys:
                 pending.extend(node.parent_keys)
             if min_gdfo is None or node.gdfo < min_gdfo:
@@ -269,7 +263,7 @@
 
         All parents must occur before all children.
         """
-        for node in viewvalues(self._nodes):
+        for node in self._nodes.values():
             if node.gdfo is None:
                 raise errors.GraphCycleError(self._nodes)
         pending = self._find_tails()
@@ -347,7 +341,7 @@
         """Compute the merge sorted graph output."""
         from breezy import tsort
         as_parent_map = dict((node.key, node.parent_keys)
-                             for node in viewvalues(self._nodes)
+                             for node in self._nodes.values()
                              if node.parent_keys is not None)
         # We intentionally always generate revnos and never force the
         # mainline_revisions

=== modified file 'breezy/_known_graph_pyx.pyx'
--- breezy/_known_graph_pyx.pyx	2019-01-27 18:53:46 +0000
+++ breezy/_known_graph_pyx.pyx	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 """Implementation of Graph algorithms when we have already loaded everything.
 """
 
-from __future__ import absolute_import
-
 cdef extern from "python-compat.h":
     pass
 

=== modified file 'breezy/_readdir_py.py'
--- breezy/_readdir_py.py	2017-11-12 13:53:51 +0000
+++ breezy/_readdir_py.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Python implementation of readdir interface."""
 
-from __future__ import absolute_import
-
 import stat
 
 

=== modified file 'breezy/_readdir_pyx.pyx'
--- breezy/_readdir_pyx.pyx	2018-08-18 22:45:58 +0000
+++ breezy/_readdir_pyx.pyx	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Wrapper for readdir which returns files ordered by inode."""
 
-from __future__ import absolute_import
-
 
 import os
 import sys

=== modified file 'breezy/_rio_py.py'
--- breezy/_rio_py.py	2018-11-11 04:08:32 +0000
+++ breezy/_rio_py.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Python implementation of _read_stanza_*."""
 
-from __future__ import absolute_import
-
 import re
 
 from .rio import (

=== modified file 'breezy/_rio_pyx.pyx'
--- breezy/_rio_pyx.pyx	2018-08-18 19:43:40 +0000
+++ breezy/_rio_pyx.pyx	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Pyrex implementation of _read_stanza_*."""
 
-from __future__ import absolute_import
-
 
 cdef extern from "python-compat.h":
     pass

=== modified file 'breezy/_simple_set_pyx.pyx'
--- breezy/_simple_set_pyx.pyx	2017-06-21 22:25:57 +0000
+++ breezy/_simple_set_pyx.pyx	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Definition of a class that is similar to Set with some small changes."""
 
-from __future__ import absolute_import
-
 from cpython.object cimport (
     hashfunc,
     Py_EQ,

=== modified file 'breezy/_static_tuple_py.py'
--- breezy/_static_tuple_py.py	2018-11-11 04:08:32 +0000
+++ breezy/_static_tuple_py.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 strings.
 """
 
-from __future__ import absolute_import
-
 import sys
 
 
@@ -76,8 +74,6 @@
 
 
 _valid_types = (bytes, str, StaticTuple, int, float, None.__class__, bool)
-if sys.version_info < (3,):
-    _valid_types += (long, unicode)
 
 
 # Have to set it to None first, so that __new__ can determine whether

=== modified file 'breezy/_termcolor.py'
--- breezy/_termcolor.py	2018-11-11 04:08:32 +0000
+++ breezy/_termcolor.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import os
 import sys
 

=== modified file 'breezy/_walkdirs_win32.pyx'
--- breezy/_walkdirs_win32.pyx	2017-06-10 00:09:13 +0000
+++ breezy/_walkdirs_win32.pyx	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Helper functions for Walkdirs on win32."""
 
-from __future__ import absolute_import
-
 
 cdef extern from "python-compat.h":
     struct _HANDLE:

=== modified file 'breezy/add.py'
--- breezy/add.py	2018-11-10 17:52:47 +0000
+++ breezy/add.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Helper functions for adding files to working trees."""
 
-from __future__ import absolute_import
-
 import sys
 import os
 

=== modified file 'breezy/annotate.py'
--- breezy/annotate.py	2020-01-11 17:41:33 +0000
+++ breezy/annotate.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """File annotate based on weave storage"""
 
-from __future__ import absolute_import
-
 # TODO: Choice of more or less verbose formats:
 #
 # interposed: show more details between blocks of modified lines

=== modified file 'breezy/archive/__init__.py'
--- breezy/archive/__init__.py	2018-11-11 04:08:32 +0000
+++ breezy/archive/__init__.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 """Export trees to tarballs, zipfiles, etc.
 """
 
-from __future__ import absolute_import
-
 import os
 import time
 import warnings

=== modified file 'breezy/archive/tar.py'
--- breezy/archive/tar.py	2019-01-13 17:32:22 +0000
+++ breezy/archive/tar.py	2020-02-18 01:57:45 +0000
@@ -16,9 +16,8 @@
 
 """Export a tree to a tarball."""
 
-from __future__ import absolute_import
-
 from contextlib import closing
+from io import BytesIO
 import os
 import sys
 import tarfile
@@ -28,9 +27,6 @@
     osutils,
     )
 from ..export import _export_iter_entries
-from ..sixish import (
-    BytesIO,
-    )
 
 
 def prepare_tarball_item(tree, root, final_path, tree_path, entry, force_mtime=None):
@@ -185,16 +181,12 @@
     except ImportError as e:
         raise errors.DependencyNotPresent('lzma', e)
 
-    if sys.version_info[0] == 2:
-        compressor = lzma.LZMACompressor(
-            options={"format": compression_format})
-    else:
-        compressor = lzma.LZMACompressor(
-            format={
-                'xz': lzma.FORMAT_XZ,
-                'raw': lzma.FORMAT_RAW,
-                'alone': lzma.FORMAT_ALONE,
-                }[compression_format])
+    compressor = lzma.LZMACompressor(
+        format={
+            'xz': lzma.FORMAT_XZ,
+            'raw': lzma.FORMAT_RAW,
+            'alone': lzma.FORMAT_ALONE,
+            }[compression_format])
 
     for chunk in tarball_generator(
             tree, root, subdir, force_mtime=force_mtime):

=== modified file 'breezy/archive/zip.py'
--- breezy/archive/zip.py	2018-11-16 18:33:17 +0000
+++ breezy/archive/zip.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 """Export a Tree to a zip file.
 """
 
-from __future__ import absolute_import
-
 from contextlib import closing
 import os
 import stat

=== modified file 'breezy/atomicfile.py'
--- breezy/atomicfile.py	2018-11-10 17:52:47 +0000
+++ breezy/atomicfile.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import os
 
 import stat

=== modified file 'breezy/bedding.py'
--- breezy/bedding.py	2020-01-11 17:41:33 +0000
+++ breezy/bedding.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Functions for deriving user configuration from system environment."""
 
-from __future__ import absolute_import
-
 import os
 import sys
 
@@ -33,9 +31,6 @@
 from . import (
     errors,
     )
-from .sixish import (
-    PY3,
-    )
 
 
 def ensure_config_dir_exists(path=None):
@@ -213,13 +208,9 @@
 def default_email():
     v = os.environ.get('BRZ_EMAIL')
     if v:
-        if not PY3:
-            v = v.decode(osutils.get_user_encoding())
         return v
     v = os.environ.get('EMAIL')
     if v:
-        if not PY3:
-            v = v.decode(osutils.get_user_encoding())
         return v
     name, email = _auto_user_id()
     if name and email:

=== modified file 'breezy/bencode.py'
--- breezy/bencode.py	2018-11-11 03:33:20 +0000
+++ breezy/bencode.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Wrapper around the bencode pyrex and python implementation"""
 
-from __future__ import absolute_import
-
 from . import osutils
 
 try:

=== modified file 'breezy/bisect.py'
--- breezy/bisect.py	2018-11-12 01:41:38 +0000
+++ breezy/bisect.py	2020-02-18 01:57:45 +0000
@@ -16,17 +16,12 @@
 
 """bisect command implementations."""
 
-from __future__ import absolute_import
-
 import sys
 from .controldir import ControlDir
 from . import revision as _mod_revision
 from .commands import Command
 from .errors import BzrCommandError
 from .option import Option
-from .sixish import (
-    text_type,
-    )
 from .trace import note
 
 BISECT_INFO_PATH = "bisect"
@@ -314,7 +309,7 @@
 
     takes_args = ['subcommand', 'args*']
     takes_options = [Option('output', short_name='o',
-                            help='Write log to this file.', type=text_type),
+                            help='Write log to this file.', type=str),
                      'revision', 'directory']
 
     def _check(self, controldir):

=== modified file 'breezy/bisect_multi.py'
--- breezy/bisect_multi.py	2018-11-11 14:23:06 +0000
+++ breezy/bisect_multi.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Bisection lookup multiple keys."""
 
-from __future__ import absolute_import
-
 __all__ = [
     'bisect_multi_bytes',
     ]

=== modified file 'breezy/branch.py'
--- breezy/branch.py	2020-02-18 03:11:01 +0000
+++ breezy/branch.py	2020-02-21 03:58:42 +0000
@@ -14,13 +14,11 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from .lazy_import import lazy_import
 lazy_import(globals(), """
+import contextlib
 import itertools
 from breezy import (
-    cleanup,
     config as _mod_config,
     debug,
     memorytree,
@@ -47,10 +45,6 @@
 from .hooks import Hooks
 from .inter import InterObject
 from .lock import LogicalLockResult
-from .sixish import (
-    text_type,
-    viewitems,
-    )
 from .trace import mutter, mutter_callsite, note, is_quiet, warning
 
 
@@ -371,7 +365,7 @@
                 raise errors.GhostRevisionsHaveNoRevno(revno[0], e.revision_id)
         revision_id_to_revno = self.get_revision_id_to_revno_map()
         revision_ids = [revision_id for revision_id, this_revno
-                        in viewitems(revision_id_to_revno)
+                        in revision_id_to_revno.items()
                         if revno == this_revno]
         if len(revision_ids) == 1:
             return revision_ids[0]
@@ -779,7 +773,7 @@
         # FIXUP this and get_parent in a future branch format bump:
         # read and rewrite the file. RBC 20060125
         if url is not None:
-            if isinstance(url, text_type):
+            if isinstance(url, str):
                 try:
                     url.encode('ascii')
                 except UnicodeEncodeError:
@@ -2223,7 +2217,7 @@
             is being called because it's the master of the primary branch,
             so it should not run its hooks.
         """
-        with cleanup.ExitStack() as exit_stack:
+        with contextlib.ExitStack() as exit_stack:
             exit_stack.enter_context(self.target.lock_write())
             bound_location = self.target.get_bound_location()
             if local and not bound_location:
@@ -2408,7 +2402,7 @@
         old_base = self.source.base
         new_base = self.target.base
         target_reference_dict = self.target._get_all_reference_info()
-        for tree_path, (branch_location, file_id) in viewitems(reference_dict):
+        for tree_path, (branch_location, file_id) in reference_dict.items():
             try:
                 branch_location = urlutils.rebase_url(branch_location,
                                                       old_base, new_base)

=== modified file 'breezy/branchbuilder.py'
--- breezy/branchbuilder.py	2018-11-16 11:37:47 +0000
+++ breezy/branchbuilder.py	2020-02-18 01:57:45 +0000
@@ -16,17 +16,12 @@
 
 """Utility for create branches with particular contents."""
 
-from __future__ import absolute_import
-
 from . import (
     controldir,
     commit,
     errors,
     revision,
     )
-from .sixish import (
-    viewitems,
-    )
 
 
 class BranchBuilder(object):
@@ -48,11 +43,11 @@
     ...     ('add', ('', b'root-id', 'directory', '')),
     ...     ('add', ('filename', b'f-id', 'file', b'content\n'))],
     ...     revision_id=b'rev-id')
-    'rev-id'
+    b'rev-id'
     >>> builder.build_snapshot([b'rev-id'],
     ...     [('modify', ('filename', b'new-content\n'))],
     ...     revision_id=b'rev2-id')
-    'rev2-id'
+    b'rev2-id'
     >>> builder.finish_series()
     >>> branch = builder.get_branch()
 
@@ -275,7 +270,7 @@
             tree.unversion(pending.to_unversion_paths)
         tree.add(pending.to_add_files, pending.to_add_file_ids,
                  pending.to_add_kinds)
-        for path, content in viewitems(pending.new_contents):
+        for path, content in pending.new_contents.items():
             tree.put_file_bytes_non_atomic(path, content)
 
     def get_branch(self):

=== modified file 'breezy/breakin.py'
--- breezy/breakin.py	2018-11-11 03:33:20 +0000
+++ breezy/breakin.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import os
 import signal
 

=== modified file 'breezy/bugtracker.py'
--- breezy/bugtracker.py	2018-11-17 01:04:53 +0000
+++ breezy/bugtracker.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from . import (
     errors,
     registry,

=== modified file 'breezy/builtins.py'
--- breezy/builtins.py	2020-01-31 02:34:57 +0000
+++ breezy/builtins.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """builtin brz commands"""
 
-from __future__ import absolute_import
-
 import errno
 import os
 import sys
@@ -86,12 +84,6 @@
     RevisionSpec,
     RevisionInfo,
     )
-from .sixish import (
-    PY3,
-    text_type,
-    viewitems,
-    viewvalues,
-)
 from .trace import mutter, note, warning, is_quiet, get_verbosity_level
 
 
@@ -221,7 +213,7 @@
     if ref_branch is None or ref_branch.name:
         if ref_branch is not None:
             control_dir = ref_branch.controldir
-        for name, branch in viewitems(control_dir.get_branches()):
+        for name, branch in control_dir.get_branches().items():
             yield name, branch
     else:
         repo = ref_branch.controldir.find_repository()
@@ -741,7 +733,7 @@
                     "anything."),
         'verbose',
         Option('file-ids-from',
-               type=text_type,
+               type=str,
                help='Lookup file ids from this tree.'),
         ]
     encoding_type = 'replace'
@@ -871,7 +863,7 @@
         Option('kind',
                help='List entries of a particular kind: file, directory, '
                     'symlink.',
-               type=text_type),
+               type=str),
         ]
     takes_args = ['file*']
 
@@ -1336,7 +1328,7 @@
                             help='Create a stacked branch that refers to another branch '
                             'for the commit history. Only the work not present in the '
                             'referenced branch is included in the branch created.',
-                            type=text_type),
+                            type=str),
                      Option('strict',
                             help='Refuse to push if there are uncommitted changes in'
                             ' the working tree, --no-strict disables the check.'),
@@ -1447,7 +1439,7 @@
     takes_options = ['revision',
                      Option(
                          'hardlink', help='Hard-link working tree files where possible.'),
-                     Option('files-from', type=text_type,
+                     Option('files-from', type=str,
                             help="Get file contents from this tree."),
                      Option('no-tree',
                             help="Create a branch without a working-tree."),
@@ -1619,7 +1611,7 @@
                 names[name] = active
             # Only mention the current branch explicitly if it's not
             # one of the colocated branches
-            if not any(viewvalues(names)) and active_branch is not None:
+            if not any(names.values()) and active_branch is not None:
                 self.outf.write("* %s\n" % gettext("(default)"))
             for name in sorted(names):
                 active = names[name]
@@ -1627,8 +1619,7 @@
                     prefix = "*"
                 else:
                     prefix = " "
-                self.outf.write("%s %s\n" % (
-                    prefix, (name if PY3 else name.encode(self.outf.encoding))))
+                self.outf.write("%s %s\n" % (prefix, name))
 
 
 class cmd_checkout(Command):
@@ -1662,7 +1653,7 @@
                                  "common operations like diff and status without "
                                  "such access, and also support local commits."
                             ),
-                     Option('files-from', type=text_type,
+                     Option('files-from', type=str,
                             help="Get file contents from this tree."),
                      Option('hardlink',
                             help='Hard-link working tree files where possible.'
@@ -2306,25 +2297,25 @@
     _see_also = ['status']
     takes_args = ['file*']
     takes_options = [
-        Option('diff-options', type=text_type,
+        Option('diff-options', type=str,
                help='Pass these options to the external diff program.'),
-        Option('prefix', type=text_type,
+        Option('prefix', type=str,
                short_name='p',
                help='Set prefixes added to old and new filenames, as '
                     'two values separated by a colon. (eg "old/:new/").'),
         Option('old',
                help='Branch/tree to compare from.',
-               type=text_type,
+               type=str,
                ),
         Option('new',
                help='Branch/tree to compare to.',
-               type=text_type,
+               type=str,
                ),
         'revision',
         'change',
         Option('using',
                help='Use this command to compare files.',
-               type=text_type,
+               type=str,
                ),
         RegistryOption('format',
                        short_name='F',
@@ -2699,7 +2690,7 @@
         Option('message',
                help='Show revisions whose message matches this '
                'regular expression.',
-               type=text_type,
+               type=str,
                hidden=True),
         Option('limit',
                short_name='l',
@@ -2725,23 +2716,23 @@
                    short_name='m',
                    help='Show revisions whose properties match this '
                    'expression.',
-                   type=text_type),
+                   type=str),
         ListOption('match-message',
                    help='Show revisions whose message matches this '
                    'expression.',
-                   type=text_type),
+                   type=str),
         ListOption('match-committer',
                    help='Show revisions whose committer matches this '
                    'expression.',
-                   type=text_type),
+                   type=str),
         ListOption('match-author',
                    help='Show revisions whose authors match this '
                    'expression.',
-                   type=text_type),
+                   type=str),
         ListOption('match-bugs',
                    help='Show revisions whose bugs match this '
                    'expression.',
-                   type=text_type)
+                   type=str)
         ]
     encoding_type = 'replace'
 
@@ -3007,7 +2998,7 @@
         Option('kind', short_name='k',
                help=('List entries of a particular kind: file, '
                      'directory, symlink, tree-reference.'),
-               type=text_type),
+               type=str),
         'null',
         'show-ids',
         'directory',
@@ -3331,12 +3322,12 @@
     takes_options = ['directory',
                      Option('format',
                             help="Type of file to export to.",
-                            type=text_type),
+                            type=str),
                      'revision',
                      Option('filters', help='Apply content filters to export the '
                             'convenient form.'),
                      Option('root',
-                            type=text_type,
+                            type=str,
                             help="Name of the root directory inside the exported file."),
                      Option('per-file-timestamps',
                             help='Set modification time of files to that of the last '
@@ -3538,33 +3529,33 @@
     takes_args = ['selected*']
     takes_options = [
         ListOption(
-            'exclude', type=text_type, short_name='x',
+            'exclude', type=str, short_name='x',
             help="Do not consider changes made to a given path."),
-        Option('message', type=text_type,
+        Option('message', type=str,
                short_name='m',
                help="Description of the new revision."),
         'verbose',
         Option('unchanged',
                help='Commit even if nothing has changed.'),
-        Option('file', type=text_type,
+        Option('file', type=str,
                short_name='F',
                argname='msgfile',
                help='Take commit message from this file.'),
         Option('strict',
                help="Refuse to commit if there are unknown "
                "files in the working tree."),
-        Option('commit-time', type=text_type,
+        Option('commit-time', type=str,
                help="Manually set a commit time using commit date "
                "format, e.g. '2009-10-10 08:00:00 +0100'."),
         ListOption(
-            'bugs', type=text_type,
+            'bugs', type=str,
             help="Link to a related bug. (see \"brz help bugs\")."),
         ListOption(
-            'fixes', type=text_type,
+            'fixes', type=str,
             help="Mark a bug as being fixed by this revision "
                  "(see \"brz help bugs\")."),
         ListOption(
-            'author', type=text_type,
+            'author', type=str,
             help="Set the author's name, if it's different "
                  "from the committer."),
         Option('local',
@@ -4030,7 +4021,7 @@
     def print_aliases(self):
         """Print out the defined aliases in a similar format to bash."""
         aliases = _mod_config.GlobalConfig().get_aliases()
-        for key, value in sorted(viewitems(aliases)):
+        for key, value in sorted(aliases.items()):
             self.outf.write('brz alias %s="%s"\n' % (key, value))
 
     @display_command
@@ -4147,10 +4138,10 @@
                                         'breezy.tests', 'parallel_registry'),
                                     value_switches=False,
                                     ),
-                     Option('randomize', type=text_type, argname="SEED",
+                     Option('randomize', type=str, argname="SEED",
                             help='Randomize the order of tests using the given'
                                  ' seed or "now" for the current time.'),
-                     ListOption('exclude', type=text_type, argname="PATTERN",
+                     ListOption('exclude', type=str, argname="PATTERN",
                                 short_name='x',
                                 help='Exclude tests that match this regular'
                                 ' expression.'),
@@ -4160,11 +4151,11 @@
                             help='Output test progress via subunit v2.'),
                      Option('strict', help='Fail on missing dependencies or '
                             'known failures.'),
-                     Option('load-list', type=text_type, argname='TESTLISTFILE',
+                     Option('load-list', type=str, argname='TESTLISTFILE',
                             help='Load a test id list from a text file.'),
-                     ListOption('debugflag', type=text_type, short_name='E',
+                     ListOption('debugflag', type=str, short_name='E',
                                 help='Turn on a selftest debug flag.'),
-                     ListOption('starting-with', type=text_type, argname='TESTID',
+                     ListOption('starting-with', type=str, argname='TESTID',
                                 param_name='starting_with', short_name='s',
                                 help='Load only the tests starting with TESTID.'),
                      Option('sync',
@@ -5590,7 +5581,7 @@
                        value_switches=True),
         Option('listen',
                help='Listen for connections on nominated address.',
-               type=text_type),
+               type=str),
         Option('port',
                help='Listen for connections on nominated port.  Passing 0 as '
                     'the port number will result in a dynamically allocated '
@@ -5732,10 +5723,10 @@
             diff='Normal unified diff.',
             plain='No patch, just directive.'),
         Option('sign', help='GPG-sign the directive.'), 'revision',
-        Option('mail-to', type=text_type,
+        Option('mail-to', type=str,
                help='Instead of printing the directive, email to this '
                'address.'),
-        Option('message', type=text_type, short_name='m',
+        Option('message', type=str, short_name='m',
                help='Message to use when committing this merge.')
         ]
 
@@ -5889,19 +5880,19 @@
                help='Branch to generate the submission from, '
                'rather than the one containing the working directory.',
                short_name='f',
-               type=text_type),
+               type=str),
         Option('output', short_name='o',
                help='Write merge directive to this file or directory; '
                     'use - for stdout.',
-               type=text_type),
+               type=str),
         Option('strict',
                help='Refuse to send if there are uncommitted changes in'
                ' the working tree, --no-strict disables the check.'),
         Option('mail-to', help='Mail the request to this address.',
-               type=text_type),
+               type=str),
         'revision',
         'message',
-        Option('body', help='Body for the email.', type=text_type),
+        Option('body', help='Body for the email.', type=str),
         RegistryOption('format',
                        help='Use the specified output format.',
                        lazy_registry=('breezy.send', 'format_registry')),
@@ -5957,9 +5948,9 @@
                help='Branch to generate the submission from, '
                'rather than the one containing the working directory.',
                short_name='f',
-               type=text_type),
+               type=str),
         Option('output', short_name='o', help='Write directive to this file.',
-               type=text_type),
+               type=str),
         Option('strict',
                help='Refuse to bundle revisions if there are uncommitted'
                ' changes in the working tree, --no-strict disables the check.'),
@@ -6089,7 +6080,7 @@
         from .tag import tag_sort_methods
         branch, relpath = Branch.open_containing(directory)
 
-        tags = list(viewitems(branch.tags.get_tag_dict()))
+        tags = list(branch.tags.get_tag_dict().items())
         if not tags:
             return
 
@@ -6193,13 +6184,13 @@
             with_no_trees='Reconfigure repository to not create '
             'working trees on branches by default.'
             ),
-        Option('bind-to', help='Branch to bind checkout to.', type=text_type),
+        Option('bind-to', help='Branch to bind checkout to.', type=str),
         Option('force',
                help='Perform reconfiguration even if local changes'
                ' will be lost.'),
         Option('stacked-on',
                help='Reconfigure a branch to be stacked on another branch.',
-               type=text_type,
+               type=str,
                ),
         Option('unstacked',
                help='Reconfigure a branch to be unstacked.  This '
@@ -6439,11 +6430,11 @@
                ),
         Option('name',
                help='Name of the view to define, list or delete.',
-               type=text_type,
+               type=str,
                ),
         Option('switch',
                help='Name of the view to switch to.',
-               type=text_type,
+               type=str,
                ),
         ]
 
@@ -6792,7 +6783,7 @@
     takes_options = [Option('plugin',
                             help='Export help text from named command '
                                  '(defaults to all built in commands).',
-                            type=text_type),
+                            type=str),
                      Option('include-duplicates',
                             help='Output multiple copies of the same msgid '
                                  'string if it appears more than once.'),
@@ -6898,13 +6889,13 @@
     takes_options = [
         'verbose',
         'revision',
-        Option('color', type=text_type, argname='when',
+        Option('color', type=str, argname='when',
                help='Show match in color. WHEN is never, always or auto.'),
         Option('diff', short_name='p',
                help='Grep for pattern in changeset for each revision.'),
-        ListOption('exclude', type=text_type, argname='glob', short_name='X',
+        ListOption('exclude', type=str, argname='glob', short_name='X',
                    help="Skip files whose base name matches GLOB."),
-        ListOption('include', type=text_type, argname='glob', short_name='I',
+        ListOption('include', type=str, argname='glob', short_name='I',
                    help="Search only files whose base name matches GLOB."),
         Option('files-with-matches', short_name='l',
                help='Print only the name of each input file in '

=== modified file 'breezy/bzr/__init__.py'
--- breezy/bzr/__init__.py	2019-11-06 01:31:41 +0000
+++ breezy/bzr/__init__.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from .. import (
     config,
     errors,

=== modified file 'breezy/bzr/_btree_serializer_py.py'
--- breezy/bzr/_btree_serializer_py.py	2018-11-11 04:08:32 +0000
+++ breezy/bzr/_btree_serializer_py.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """B+Tree index parsing."""
 
-from __future__ import absolute_import
-
 from .. import static_tuple
 
 

=== modified file 'breezy/bzr/_btree_serializer_pyx.pyx'
--- breezy/bzr/_btree_serializer_pyx.pyx	2019-09-22 02:25:23 +0000
+++ breezy/bzr/_btree_serializer_pyx.pyx	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Pyrex extensions to btree node parsing."""
 
-from __future__ import absolute_import
-
 
 cdef extern from "python-compat.h":
     pass

=== modified file 'breezy/bzr/_chk_map_py.py'
--- breezy/bzr/_chk_map_py.py	2018-11-16 13:30:12 +0000
+++ breezy/bzr/_chk_map_py.py	2020-02-18 01:57:45 +0000
@@ -16,12 +16,9 @@
 
 """Python implementation of _search_key functions, etc."""
 
-from __future__ import absolute_import
-
 import zlib
 import struct
 
-from ..sixish import bytesintern
 from ..static_tuple import StaticTuple
 
 _LeafNode = None
@@ -167,4 +164,4 @@
     """Take a CHKInventory value string and return a (file_id, rev_id) tuple"""
     sections = data.split(b'\n')
     kind, file_id = sections[0].split(b': ')
-    return (bytesintern(file_id), bytesintern(sections[3]))
+    return (file_id, sections[3])

=== modified file 'breezy/bzr/_chk_map_pyx.pyx'
--- breezy/bzr/_chk_map_pyx.pyx	2019-09-22 02:25:23 +0000
+++ breezy/bzr/_chk_map_pyx.pyx	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 cdef extern from "python-compat.h":
     pass
 

=== modified file 'breezy/bzr/_dirstate_helpers_py.py'
--- breezy/bzr/_dirstate_helpers_py.py	2018-11-11 04:08:32 +0000
+++ breezy/bzr/_dirstate_helpers_py.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Python implementations of Dirstate Helper functions."""
 
-from __future__ import absolute_import
-
 import binascii
 import os
 import struct
@@ -25,9 +23,6 @@
 # We cannot import the dirstate module, because it loads this module
 # All we really need is the IN_MEMORY_MODIFIED constant
 from .dirstate import DirState, DirstateCorrupt
-from ..sixish import (
-    range,
-    )
 
 
 def pack_stat(st, _b64=binascii.b2a_base64, _pack=struct.Struct('>6L').pack):

=== modified file 'breezy/bzr/_dirstate_helpers_pyx.pyx'
--- breezy/bzr/_dirstate_helpers_pyx.pyx	2020-01-31 10:39:02 +0000
+++ breezy/bzr/_dirstate_helpers_pyx.pyx	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 This is the python implementation for DirState functions.
 """
 
-from __future__ import absolute_import
-
 import binascii
 import bisect
 import errno

=== modified file 'breezy/bzr/_groupcompress_py.py'
--- breezy/bzr/_groupcompress_py.py	2020-01-26 01:12:31 +0000
+++ breezy/bzr/_groupcompress_py.py	2020-02-18 01:57:45 +0000
@@ -20,14 +20,7 @@
 useless stuff.
 """
 
-from __future__ import absolute_import
-
 from .. import osutils
-from ..sixish import (
-    indexbytes,
-    int2byte,
-    range,
-    )
 
 
 class _OutputHandler(object):
@@ -55,7 +48,7 @@
         if self.cur_insert_len > 127:
             raise AssertionError('We cannot insert more than 127 bytes'
                                  ' at a time.')
-        self.out_lines.append(int2byte(self.cur_insert_len))
+        self.out_lines.append(bytes([self.cur_insert_len]))
         self.index_lines.append(False)
         self.out_lines.extend(self.cur_insert_lines)
         if self.cur_insert_len < self.min_len_to_index:
@@ -71,7 +64,7 @@
         line_len = len(line)
         for start_index in range(0, line_len, 127):
             next_len = min(127, line_len - start_index)
-            self.out_lines.append(int2byte(next_len))
+            self.out_lines.append(bytes([next_len]))
             self.index_lines.append(False)
             self.out_lines.append(line[start_index:start_index + next_len])
             # We don't index long lines, because we won't be able to match
@@ -262,7 +255,7 @@
         # Each insert instruction is at most 127 bytes long
         for start_byte in range(0, insert_length, 127):
             insert_count = min(insert_length - start_byte, 127)
-            out_lines.append(int2byte(insert_count))
+            out_lines.append(bytes([insert_count]))
             # Don't index the 'insert' instruction
             index_lines.append(False)
             insert = bytes_to_insert[start_byte:start_byte + insert_count]
@@ -330,12 +323,12 @@
     offset = 0
     val = 0
     shift = 0
-    bval = indexbytes(data, offset)
+    bval = data[offset]
     while bval >= 0x80:
         val |= (bval & 0x7F) << shift
         shift += 7
         offset += 1
-        bval = indexbytes(data, offset)
+        bval = data[offset]
     val |= bval << shift
     offset += 1
     return val, offset
@@ -350,7 +343,7 @@
         base_byte = offset & 0xff
         if base_byte:
             copy_command |= copy_bit
-            copy_bytes.append(int2byte(base_byte))
+            copy_bytes.append(bytes([base_byte]))
         offset >>= 8
     if length is None:
         raise ValueError("cannot supply a length of None")
@@ -365,9 +358,9 @@
             base_byte = length & 0xff
             if base_byte:
                 copy_command |= copy_bit
-                copy_bytes.append(int2byte(base_byte))
+                copy_bytes.append(bytes([base_byte]))
             length >>= 8
-    copy_bytes[0] = int2byte(copy_command)
+    copy_bytes[0] = bytes([copy_command])
     return b''.join(copy_bytes)
 
 
@@ -390,25 +383,25 @@
     offset = 0
     length = 0
     if (cmd & 0x01):
-        offset = indexbytes(bytes, pos)
+        offset = bytes[pos]
         pos += 1
     if (cmd & 0x02):
-        offset = offset | (indexbytes(bytes, pos) << 8)
+        offset = offset | (bytes[pos] << 8)
         pos += 1
     if (cmd & 0x04):
-        offset = offset | (indexbytes(bytes, pos) << 16)
+        offset = offset | (bytes[pos] << 16)
         pos += 1
     if (cmd & 0x08):
-        offset = offset | (indexbytes(bytes, pos) << 24)
+        offset = offset | (bytes[pos] << 24)
         pos += 1
     if (cmd & 0x10):
-        length = indexbytes(bytes, pos)
+        length = bytes[pos]
         pos += 1
     if (cmd & 0x20):
-        length = length | (indexbytes(bytes, pos) << 8)
+        length = length | (bytes[pos] << 8)
         pos += 1
     if (cmd & 0x40):
-        length = length | (indexbytes(bytes, pos) << 16)
+        length = length | (bytes[pos] << 16)
         pos += 1
     if length == 0:
         length = 65536
@@ -437,7 +430,7 @@
     lines = []
     len_delta = len(delta)
     while pos < len_delta:
-        cmd = indexbytes(delta, pos)
+        cmd = delta[pos]
         pos += 1
         if cmd & 0x80:
             offset, length, pos = decode_copy_instruction(delta, cmd, pos)

=== modified file 'breezy/bzr/_groupcompress_pyx.pyx'
--- breezy/bzr/_groupcompress_pyx.pyx	2018-11-16 13:30:16 +0000
+++ breezy/bzr/_groupcompress_pyx.pyx	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Compiled extensions for doing compression."""
 
-from __future__ import absolute_import
-
 
 cdef extern from "python-compat.h":
     pass

=== modified file 'breezy/bzr/_knit_load_data_py.py'
--- breezy/bzr/_knit_load_data_py.py	2019-03-18 04:31:21 +0000
+++ breezy/bzr/_knit_load_data_py.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from .knit import KnitCorrupt
 
 

=== modified file 'breezy/bzr/_knit_load_data_pyx.pyx'
--- breezy/bzr/_knit_load_data_pyx.pyx	2018-07-03 17:23:58 +0000
+++ breezy/bzr/_knit_load_data_pyx.pyx	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Pyrex extensions to knit parsing."""
 
-from __future__ import absolute_import
-
 import sys
 
 from .knit import KnitCorrupt

=== modified file 'breezy/bzr/_str_helpers.pxd'
--- breezy/bzr/_str_helpers.pxd	2018-07-12 01:43:49 +0000
+++ breezy/bzr/_str_helpers.pxd	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Trivial string helpers for use in other cython modules."""
 
-from __future__ import absolute_import
-
 cdef extern from "python-compat.h":
     object PyBytes_FromStringAndSize (char *, Py_ssize_t)
     object PyBytes_InternFromStringAndSize (char *, Py_ssize_t)

=== modified file 'breezy/bzr/branch.py'
--- breezy/bzr/branch.py	2020-02-18 03:11:01 +0000
+++ breezy/bzr/branch.py	2020-02-21 03:58:42 +0000
@@ -15,8 +15,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
+from io import BytesIO
 import sys
 
 from ..lazy_import import lazy_import
@@ -52,11 +51,6 @@
     only_raises,
     )
 from ..lock import _RelockDebugMixin, LogicalLockResult
-from ..sixish import (
-    BytesIO,
-    text_type,
-    viewitems,
-    )
 from ..trace import (
     mutter,
     )
@@ -285,7 +279,7 @@
         if url is None:
             self._transport.delete('parent')
         else:
-            if isinstance(url, text_type):
+            if isinstance(url, str):
                 url = url.encode('utf-8')
             self._transport.put_bytes('parent', url + b'\n',
                                       mode=self.controldir._get_file_mode())
@@ -554,7 +548,7 @@
         """
         s = BytesIO()
         writer = rio.RioWriter(s)
-        for file_id, (branch_location, tree_path) in viewitems(info_dict):
+        for file_id, (branch_location, tree_path) in info_dict.items():
             stanza = rio.Stanza(file_id=file_id,
                                 branch_location=branch_location)
             if tree_path is not None:
@@ -655,10 +649,7 @@
         if stacked_url is None:
             raise errors.NotStacked(self)
         # TODO(jelmer): Clean this up for pad.lv/1696545
-        if sys.version_info[0] == 2:
-            return stacked_url.encode('utf-8')
-        else:
-            return stacked_url
+        return stacked_url
 
     def get_rev_id(self, revno, history=None):
         """Find the revision id of the specified revno."""

=== modified file 'breezy/bzr/btree_index.py'
--- breezy/bzr/btree_index.py	2018-11-11 15:40:12 +0000
+++ breezy/bzr/btree_index.py	2020-02-18 01:57:45 +0000
@@ -17,7 +17,7 @@
 
 """B+Tree indices"""
 
-from __future__ import absolute_import, division
+from io import BytesIO
 
 from ..lazy_import import lazy_import
 lazy_import(globals(), """
@@ -41,13 +41,6 @@
     index,
     )
 from .index import _OPTION_NODE_REFS, _OPTION_KEY_ELEMENTS, _OPTION_LEN
-from ..sixish import (
-    BytesIO,
-    map,
-    range,
-    viewitems,
-    viewvalues,
-    )
 
 
 _BTSIGNATURE = b"B+Tree Graph Index 2\n"
@@ -562,13 +555,13 @@
         if self._nodes_by_key is None:
             nodes_by_key = {}
             if self.reference_lists:
-                for key, (references, value) in viewitems(self._nodes):
+                for key, (references, value) in self._nodes.items():
                     key_dict = nodes_by_key
                     for subkey in key[:-1]:
                         key_dict = key_dict.setdefault(subkey, {})
                     key_dict[key[-1]] = key, value, references
             else:
-                for key, (references, value) in viewitems(self._nodes):
+                for key, (references, value) in self._nodes.items():
                     key_dict = nodes_by_key
                     for subkey in key[:-1]:
                         key_dict = key_dict.setdefault(subkey, {})
@@ -970,7 +963,7 @@
     def _cache_leaf_values(self, nodes):
         """Cache directly from key => value, skipping the btree."""
         if self._leaf_value_cache is not None:
-            for node in viewvalues(nodes):
+            for node in nodes.values():
                 for key, value in node.all_items():
                     if key in self._leaf_value_cache:
                         # Don't add the rest of the keys, we've seen this node

=== modified file 'breezy/bzr/bundle/__init__.py'
--- breezy/bzr/bundle/__init__.py	2019-06-30 10:50:40 +0000
+++ breezy/bzr/bundle/__init__.py	2020-02-18 01:57:45 +0000
@@ -13,5 +13,3 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-from __future__ import absolute_import

=== modified file 'breezy/bzr/bundle/apply_bundle.py'
--- breezy/bzr/bundle/apply_bundle.py	2019-06-30 10:50:40 +0000
+++ breezy/bzr/bundle/apply_bundle.py	2020-02-18 01:57:45 +0000
@@ -18,8 +18,6 @@
 This contains functionality for installing bundles into repositories
 """
 
-from __future__ import absolute_import
-
 from ... import ui
 from ...i18n import gettext
 from ...merge import Merger

=== modified file 'breezy/bzr/bundle/bundle_data.py'
--- breezy/bzr/bundle/bundle_data.py	2020-02-09 17:10:01 +0000
+++ breezy/bzr/bundle/bundle_data.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Read in a bundle stream, and process it into a BundleReader object."""
 
-from __future__ import absolute_import
-
 import base64
 from io import BytesIO
 import os
@@ -42,9 +40,6 @@
     )
 from ...osutils import sha_string, sha_strings, pathjoin
 from ...revision import Revision, NULL_REVISION
-from ...sixish import (
-    viewitems,
-    )
 from ..testament import StrictTestament
 from ...trace import mutter, warning
 from ...tree import (
@@ -112,7 +107,7 @@
         revision_info.timestamp = revision.timestamp
         revision_info.message = revision.message.split('\n')
         revision_info.properties = [': '.join(p) for p in
-                                    viewitems(revision.properties)]
+                                    revision.properties.items()]
         return revision_info
 
 
@@ -260,7 +255,7 @@
 
         count = 0
         missing = {}
-        for revision_id, sha1 in viewitems(rev_to_sha):
+        for revision_id, sha1 in rev_to_sha.items():
             if repository.has_revision(revision_id):
                 testament = StrictTestament.from_revision(repository,
                                                           revision_id)
@@ -769,7 +764,7 @@
 
     def sorted_path_id(self):
         paths = []
-        for result in viewitems(self._new_id):
+        for result in self._new_id.items():
             paths.append(result)
         for id in self.base_tree.all_file_ids():
             try:

=== modified file 'breezy/bzr/bundle/commands.py'
--- breezy/bzr/bundle/commands.py	2020-01-11 17:50:28 +0000
+++ breezy/bzr/bundle/commands.py	2020-02-18 01:57:45 +0000
@@ -21,7 +21,7 @@
 and for applying a changeset.
 """
 
-from __future__ import absolute_import
+from io import BytesIO
 
 from ... import (
     errors,
@@ -40,10 +40,6 @@
 """)
 
 from ...commands import Command
-from ...sixish import (
-    BytesIO,
-    viewitems,
-    )
 
 
 class cmd_bundle_info(Command):
@@ -81,7 +77,7 @@
             if file_id is not None:
                 file_ids.add(file_id)
         self.outf.write(gettext('Records\n'))
-        for kind, records in sorted(viewitems(by_kind)):
+        for kind, records in sorted(by_kind.items()):
             multiparent = sum(1 for b, m, k, r, f in records if
                               len(m.get('parents', [])) > 1)
             self.outf.write(gettext('{0}: {1} ({2} multiparent)\n').format(

=== modified file 'breezy/bzr/bundle/serializer/__init__.py'
--- breezy/bzr/bundle/serializer/__init__.py	2019-06-30 10:50:40 +0000
+++ breezy/bzr/bundle/serializer/__init__.py	2020-02-18 01:57:45 +0000
@@ -17,9 +17,8 @@
 """Serializer factory for reading and writing bundles.
 """
 
-from __future__ import absolute_import
-
 import base64
+from io import BytesIO
 import re
 
 from .... import (
@@ -28,9 +27,6 @@
     )
 from ....diff import internal_diff
 from ....revision import NULL_REVISION
-from ....sixish import (
-    BytesIO,
-    )
 # For backwards-compatibility
 from ....timestamp import unpack_highres_date, format_highres_date
 

=== modified file 'breezy/bzr/bundle/serializer/v08.py'
--- breezy/bzr/bundle/serializer/v08.py	2019-09-27 00:55:53 +0000
+++ breezy/bzr/bundle/serializer/v08.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 """Serializer factory for reading and writing bundles.
 """
 
-from __future__ import absolute_import
-
 from .... import (
     errors,
     ui,
@@ -34,7 +32,6 @@
     )
 from ....diff import internal_diff
 from ....revision import NULL_REVISION
-from ....sixish import text_type
 from ...testament import StrictTestament
 from ....timestamp import (
     format_highres_date,
@@ -166,7 +163,7 @@
             f.write(b': ')
             f.write(value)
             f.write(b'\n')
-        elif isinstance(value, text_type):
+        elif isinstance(value, str):
             f.write(b': ')
             f.write(value.encode('utf-8'))
             f.write(b'\n')

=== modified file 'breezy/bzr/bundle/serializer/v09.py'
--- breezy/bzr/bundle/serializer/v09.py	2019-09-21 15:10:27 +0000
+++ breezy/bzr/bundle/serializer/v09.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from . import _get_bundle_header
 from .v08 import BundleSerializerV08, BundleReader
 from ..bundle_data import BundleInfo

=== modified file 'breezy/bzr/bundle/serializer/v4.py'
--- breezy/bzr/bundle/serializer/v4.py	2020-02-09 02:41:42 +0000
+++ breezy/bzr/bundle/serializer/v4.py	2020-02-18 01:57:45 +0000
@@ -14,9 +14,10 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import bz2
+from io import (
+    BytesIO,
+    )
 import re
 
 from .... import (
@@ -38,10 +39,6 @@
     )
 from .. import bundle_data, serializer as bundle_serializer
 from ....i18n import ngettext
-from ....sixish import (
-    BytesIO,
-    viewitems,
-    )
 
 
 class _MPDiffInventoryGenerator(_mod_versionedfile._MPDiffGenerator):
@@ -335,7 +332,7 @@
         text_keys = []
         altered_fileids = self.repository.fileids_altered_by_revision_ids(
             self.revision_ids)
-        for file_id, revision_ids in viewitems(altered_fileids):
+        for file_id, revision_ids in altered_fileids.items():
             for revision_id in revision_ids:
                 text_keys.append((file_id, revision_id))
         self._add_mp_records_keys('file', self.repository.texts, text_keys)

=== modified file 'breezy/bzr/bzrdir.py'
--- breezy/bzr/bzrdir.py	2020-02-18 03:11:01 +0000
+++ breezy/bzr/bzrdir.py	2020-02-21 03:58:42 +0000
@@ -25,15 +25,14 @@
 objects returned.
 """
 
-from __future__ import absolute_import
-
 import sys
 
 from ..lazy_import import lazy_import
 lazy_import(globals(), """
+import contextlib
+
 from breezy import (
     branch as _mod_branch,
-    cleanup,
     lockable_files,
     lockdir,
     osutils,
@@ -61,7 +60,6 @@
 from breezy.i18n import gettext
 """)
 
-from ..sixish import viewitems
 from ..trace import (
     mutter,
     note,
@@ -379,7 +377,7 @@
             when working locally.
         :return: The created control directory
         """
-        with cleanup.ExitStack() as stack:
+        with contextlib.ExitStack() as stack:
             fetch_spec_factory = fetch.FetchSpecFactory()
             if revision_id is not None:
                 fetch_spec_factory.add_revision_ids([revision_id])
@@ -1153,7 +1151,7 @@
 
     def check_support_status(self, allow_unsupported, recommend_upgrade=True,
                              basedir=None):
-        for name, necessity in viewitems(self.features):
+        for name, necessity in self.features.items():
             if name in self._present_features:
                 continue
             if necessity == b"optional":
@@ -1193,7 +1191,7 @@
         """
         lines = [self.get_format_string()]
         lines.extend([(item[1] + b" " + item[0] + b"\n")
-                      for item in sorted(viewitems(self.features))])
+                      for item in sorted(self.features.items())])
         return b"".join(lines)
 
     @classmethod

=== modified file 'breezy/bzr/check.py'
--- breezy/bzr/check.py	2018-11-17 16:53:10 +0000
+++ breezy/bzr/check.py	2020-02-18 01:57:45 +0000
@@ -47,17 +47,12 @@
   indicating that the revision was found/not found.
 """
 
-from __future__ import absolute_import
-
 from .. import (
     ui,
     )
 from ..branch import Branch
 from ..check import Check
 from ..revision import NULL_REVISION
-from ..sixish import (
-    viewitems,
-    )
 from ..trace import note
 from ..workingtree import WorkingTree
 from ..i18n import gettext
@@ -119,7 +114,7 @@
                 # landing].
                 distances = set()
                 existences = set()
-                for ref, wantlist in viewitems(callback_refs):
+                for ref, wantlist in callback_refs.items():
                     wanting_items.update(wantlist)
                     kind, value = ref
                     if kind == 'trees':
@@ -132,7 +127,7 @@
                         raise AssertionError(
                             'unknown ref kind for ref %s' % ref)
                 node_distances = repo.get_graph().find_lefthand_distances(distances)
-                for key, distance in viewitems(node_distances):
+                for key, distance in node_distances.items():
                     refs[('lefthand-distance', key)] = distance
                     if key in existences and distance > 0:
                         refs[('revision-existence', key)] = True
@@ -218,7 +213,7 @@
             note(gettext('%6d revisions missing parents in ancestry'),
                  len(self.missing_parent_links))
             if verbose:
-                for link, linkers in viewitems(self.missing_parent_links):
+                for link, linkers in self.missing_parent_links.items():
                     note(gettext('      %s should be in the ancestry for:'),
                          link.decode('utf-8'))
                     for linker in linkers:
@@ -314,7 +309,7 @@
         wrongs, unused_versions = weave_checker.check_file_version_parents(
             self.repository.texts)
         self.checked_weaves = weave_checker.file_ids
-        for text_key, (stored_parents, correct_parents) in viewitems(wrongs):
+        for text_key, (stored_parents, correct_parents) in wrongs.items():
             # XXX not ready for id join/split operations.
             weave_id = text_key[0]
             revision_id = text_key[-1]

=== modified file 'breezy/bzr/chk_map.py'
--- breezy/bzr/chk_map.py	2018-11-16 13:30:12 +0000
+++ breezy/bzr/chk_map.py	2020-02-18 01:57:45 +0000
@@ -37,8 +37,6 @@
 
 """
 
-from __future__ import absolute_import
-
 import heapq
 import threading
 
@@ -50,11 +48,6 @@
     static_tuple,
     trace,
     )
-from ..sixish import (
-    viewitems,
-    viewvalues,
-    )
-from ..sixish import PY3
 from ..static_tuple import StaticTuple
 
 # approx 4MB
@@ -191,10 +184,7 @@
     def _dump_tree(self, include_keys=False, encoding='utf-8'):
         """Return the tree in a string representation."""
         self._ensure_root()
-        if PY3:
-            def decode(x): return x.decode(encoding)
-        else:
-            def decode(x): return x
+        def decode(x): return x.decode(encoding)
         res = self._dump_tree_node(self._root_node, prefix=b'', indent='',
                                    decode=decode, include_keys=include_keys)
         res.append('')  # Give a trailing '\n'
@@ -216,11 +206,11 @@
         if isinstance(node, InternalNode):
             # Trigger all child nodes to get loaded
             list(node._iter_nodes(self._store))
-            for prefix, sub in sorted(viewitems(node._items)):
+            for prefix, sub in sorted(node._items.items()):
                 result.extend(self._dump_tree_node(sub, prefix, indent + '  ',
                                                    decode=decode, include_keys=include_keys))
         else:
-            for key, value in sorted(viewitems(node._items)):
+            for key, value in sorted(node._items.items()):
                 # Don't use prefix nor indent here to line up when used in
                 # tests in conjunction with assertEqualDiff
                 result.append('      %r %r' % (
@@ -260,7 +250,7 @@
         result._root_node.set_maximum_size(maximum_size)
         result._root_node._key_width = key_width
         delta = []
-        for key, value in viewitems(initial_value):
+        for key, value in initial_value.items():
             delta.append((None, key, value))
         root_key = result.apply_delta(delta)
         return root_key
@@ -273,9 +263,9 @@
         node._key_width = key_width
         as_st = StaticTuple.from_sequence
         node._items = dict((as_st(key), val)
-                           for key, val in viewitems(initial_value))
+                           for key, val in initial_value.items())
         node._raw_size = sum(node._key_value_len(key, value)
-                             for key, value in viewitems(node._items))
+                             for key, value in node._items.items())
         node._len = len(node._items)
         node._compute_search_prefix()
         node._compute_serialised_prefix()
@@ -339,7 +329,7 @@
             node = a_map._get_node(node)
             if isinstance(node, LeafNode):
                 path = (node._key, path)
-                for key, value in viewitems(node._items):
+                for key, value in node._items.items():
                     # For a LeafNode, the key is a serialized_key, rather than
                     # a search_key, but the heap is using search_keys
                     search_key = node._search_key_func(key)
@@ -347,12 +337,12 @@
             else:
                 # type(node) == InternalNode
                 path = (node._key, path)
-                for prefix, child in viewitems(node._items):
+                for prefix, child in node._items.items():
                     heapq.heappush(pending, (prefix, None, child, path))
 
         def process_common_internal_nodes(self_node, basis_node):
-            self_items = set(viewitems(self_node._items))
-            basis_items = set(viewitems(basis_node._items))
+            self_items = set(self_node._items.items())
+            basis_items = set(basis_node._items.items())
             path = (self_node._key, None)
             for prefix, child in self_items - basis_items:
                 heapq.heappush(self_pending, (prefix, None, child, path))
@@ -361,8 +351,8 @@
                 heapq.heappush(basis_pending, (prefix, None, child, path))
 
         def process_common_leaf_nodes(self_node, basis_node):
-            self_items = set(viewitems(self_node._items))
-            basis_items = set(viewitems(basis_node._items))
+            self_items = set(self_node._items.items())
+            basis_items = set(basis_node._items.items())
             path = (self_node._key, None)
             for key, value in self_items - basis_items:
                 prefix = self._search_key_func(key)
@@ -779,15 +769,14 @@
                     # Short items, we need to match based on a prefix
                     filters.setdefault(len(key), set()).add(key)
             if filters:
-                filters_itemview = viewitems(filters)
-                for item in viewitems(self._items):
+                filters_itemview = filters.items()
+                for item in self._items.items():
                     for length, length_filter in filters_itemview:
                         if item[0][:length] in length_filter:
                             yield item
                             break
         else:
-            for item in viewitems(self._items):
-                yield item
+            yield from self._items.items()
 
     def _key_value_len(self, key, value):
         # TODO: Should probably be done without actually joining the key, but
@@ -848,7 +837,7 @@
         common_prefix = self._search_prefix
         split_at = len(common_prefix) + 1
         result = {}
-        for key, value in viewitems(self._items):
+        for key, value in self._items.items():
             search_key = self._search_key(key)
             prefix = search_key[:split_at]
             # TODO: Generally only 1 key can be exactly the right length,
@@ -881,7 +870,7 @@
                 for split, node in node_details:
                     new_node.add_node(split, node)
                 result[prefix] = new_node
-        return common_prefix, list(viewitems(result))
+        return common_prefix, list(result.items())
 
     def map(self, store, key, value):
         """Map key to value."""
@@ -916,7 +905,7 @@
         else:
             lines.append(b'%s\n' % (self._common_serialised_prefix,))
             prefix_len = len(self._common_serialised_prefix)
-        for key, value in sorted(viewitems(self._items)):
+        for key, value in sorted(self._items.items()):
             # Always add a final newline
             value_lines = osutils.chunks_to_lines([value + b'\n'])
             serialized = b"%s\x00%d\n" % (self._serialise_key(key),
@@ -1081,7 +1070,7 @@
             # yielding all nodes, yield whatever we have, and queue up a read
             # for whatever we are missing
             shortcut = True
-            for prefix, node in viewitems(self._items):
+            for prefix, node in self._items.items():
                 if node.__class__ is StaticTuple:
                     keys[node] = (prefix, None)
                 else:
@@ -1157,8 +1146,8 @@
             else:
                 # The slow way. We walk every item in self._items, and check to
                 # see if there are any matches
-                length_filters_itemview = viewitems(length_filters)
-                for prefix, node in viewitems(self._items):
+                length_filters_itemview = length_filters.items()
+                for prefix, node in self._items.items():
                     node_key_filter = []
                     for length, length_filter in length_filters_itemview:
                         sub_prefix = prefix[:length]
@@ -1302,7 +1291,7 @@
         :param store: A VersionedFiles honouring the CHK extensions.
         :return: An iterable of the keys inserted by this operation.
         """
-        for node in viewvalues(self._items):
+        for node in self._items.values():
             if isinstance(node, StaticTuple):
                 # Never deserialised.
                 continue
@@ -1319,7 +1308,7 @@
             raise AssertionError("_search_prefix should not be None")
         lines.append(b'%s\n' % (self._search_prefix,))
         prefix_len = len(self._search_prefix)
-        for prefix, node in sorted(viewitems(self._items)):
+        for prefix, node in sorted(self._items.items()):
             if isinstance(node, StaticTuple):
                 key = node[0]
             else:
@@ -1361,7 +1350,7 @@
         if self._key is None:
             raise AssertionError("unserialised nodes have no refs.")
         refs = []
-        for value in viewvalues(self._items):
+        for value in self._items.values():
             if isinstance(value, StaticTuple):
                 refs.append(value)
             else:
@@ -1400,7 +1389,7 @@
             self._items[search_key] = unmapped
         if len(self._items) == 1:
             # this node is no longer needed:
-            return list(viewvalues(self._items))[0]
+            return list(self._items.values())[0]
         if isinstance(unmapped, InternalNode):
             return self
         if check_remap:
@@ -1450,7 +1439,7 @@
             if isinstance(node, InternalNode):
                 # Without looking at any leaf nodes, we are sure
                 return self
-            for key, value in viewitems(node._items):
+            for key, value in node._items.items():
                 if new_leaf._map_no_split(key, value):
                     return self
         trace.mutter("remap generated a new LeafNode")
@@ -1539,14 +1528,14 @@
                 #       indicate that we keep 100k prefix_refs around while
                 #       processing. They *should* be shorter lived than that...
                 #       It does cost us ~10s of processing time
-                prefix_refs = list(viewitems(node._items))
+                prefix_refs = list(node._items.items())
                 items = []
             else:
                 prefix_refs = []
                 # Note: We don't use a StaticTuple here. Profiling showed a
                 #       minor memory improvement (0.8MB out of 335MB peak 0.2%)
                 #       But a significant slowdown (15s / 145s, or 10%)
-                items = list(viewitems(node._items))
+                items = list(node._items.items())
             yield record, node, prefix_refs, items
 
     def _read_old_roots(self):

=== modified file 'breezy/bzr/chk_serializer.py'
--- breezy/bzr/chk_serializer.py	2020-01-31 10:39:02 +0000
+++ breezy/bzr/chk_serializer.py	2020-02-18 01:57:45 +0000
@@ -16,7 +16,9 @@
 
 """Serializer object for CHK based inventory storage."""
 
-from __future__ import absolute_import
+from io import (
+    BytesIO,
+    )
 
 from .. import lazy_import
 lazy_import.lazy_import(globals(),
@@ -34,9 +36,6 @@
 from . import (
     serializer,
     )
-from ..sixish import (
-    BytesIO,
-    )
 
 
 def _validate_properties(props, _decode=cache_utf8._utf8_decode):

=== modified file 'breezy/bzr/debug_commands.py'
--- breezy/bzr/debug_commands.py	2018-11-28 19:57:20 +0000
+++ breezy/bzr/debug_commands.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Debug commands for the bzr formats."""
 
-from __future__ import absolute_import
-
 from io import BytesIO
 
 from .. import (
@@ -32,7 +30,6 @@
     display_command,
     )
 from ..option import Option
-from ..sixish import PY3
 from . import (
     btree_index,
     )
@@ -118,18 +115,15 @@
                 refs_as_tuples = None
             else:
                 refs_as_tuples = static_tuple.as_tuples(refs)
-            if PY3:
-                if refs_as_tuples is not None:
-                    refs_as_tuples = tuple(
-                        tuple(tuple(r.decode('utf-8')
-                                    for r in t1) for t1 in t2)
-                        for t2 in refs_as_tuples)
-                as_tuple = (
-                    tuple([r.decode('utf-8') for r in node[1]]),
-                    node[2].decode('utf-8'),
-                    refs_as_tuples)
-            else:
-                as_tuple = (tuple(node[1]), node[2], refs_as_tuples)
+            if refs_as_tuples is not None:
+                refs_as_tuples = tuple(
+                    tuple(tuple(r.decode('utf-8')
+                                for r in t1) for t1 in t2)
+                    for t2 in refs_as_tuples)
+            as_tuple = (
+                tuple([r.decode('utf-8') for r in node[1]]),
+                node[2].decode('utf-8'),
+                refs_as_tuples)
             self.outf.write('%s\n' % (as_tuple,))
 
 

=== modified file 'breezy/bzr/dirstate.py'
--- breezy/bzr/dirstate.py	2019-09-21 17:08:09 +0000
+++ breezy/bzr/dirstate.py	2020-02-18 01:57:45 +0000
@@ -218,9 +218,8 @@
 
 """
 
-from __future__ import absolute_import
-
 import bisect
+import contextlib
 import errno
 import operator
 import os
@@ -235,7 +234,6 @@
     )
 from .. import (
     cache_utf8,
-    cleanup,
     config,
     debug,
     errors,
@@ -245,12 +243,6 @@
     trace,
     urlutils,
     )
-from ..sixish import (
-    range,
-    text_type,
-    viewitems,
-    viewvalues,
-    )
 from ..tree import TreeChange
 
 
@@ -501,7 +493,7 @@
         # you should never have files called . or ..; just add the directory
         # in the parent, or according to the special treatment for the root
         if basename == '.' or basename == '..':
-            raise errors.InvalidEntryName(path)
+            raise inventory.InvalidEntryName(path)
         # now that we've normalised, we need the correct utf8 path and
         # dirname and basename elements. This single encode and split should be
         # faster than three separate encodes.
@@ -999,7 +991,7 @@
             # Directories that need to be read
             pending_dirs = set()
             paths_to_search = set()
-            for entry_list in viewvalues(newly_found):
+            for entry_list in newly_found.values():
                 for dir_name_id, trees_info in entry_list:
                     found[dir_name_id] = trees_info
                     found_dir_names.add(dir_name_id[:2])
@@ -1312,7 +1304,7 @@
         result = DirState.initialize(dir_state_filename,
                                      sha1_provider=sha1_provider)
         try:
-            with cleanup.ExitStack() as exit_stack:
+            with contextlib.ExitStack() as exit_stack:
                 exit_stack.enter_context(tree.lock_read())
                 parent_ids = tree.get_parent_ids()
                 num_parents = len(parent_ids)
@@ -1423,8 +1415,8 @@
                                                fingerprint, new_child_path)
         self._check_delta_ids_absent(new_ids, delta, 0)
         try:
-            self._apply_removals(viewitems(removals))
-            self._apply_insertions(viewvalues(insertions))
+            self._apply_removals(removals.items())
+            self._apply_insertions(insertions.values())
             # Validate parents
             self._after_delta_check_parents(parents, 0)
         except errors.BzrError as e:
@@ -1964,7 +1956,7 @@
         #       higher level, because there either won't be anything on disk,
         #       or the thing on disk will be a file.
         fs_encoding = osutils._fs_enc
-        if isinstance(abspath, text_type):
+        if isinstance(abspath, str):
             # abspath is defined as the path to pass to lstat. readlink is
             # buggy in python < 2.6 (it doesn't encode unicode path into FS
             # encoding), so we need to encode ourselves knowing that unicode
@@ -2768,7 +2760,7 @@
         # --- end generation of full tree mappings
 
         # sort and output all the entries
-        new_entries = self._sort_entries(viewitems(by_path))
+        new_entries = self._sort_entries(by_path.items())
         self._entries_to_current_state(new_entries)
         self._parents = [rev_id for rev_id, tree in trees]
         self._ghosts = list(ghosts)
@@ -3348,7 +3340,7 @@
                 raise AssertionError(
                     "entry %r has no data for any tree." % (entry,))
         if self._id_index is not None:
-            for file_id, entry_keys in viewitems(self._id_index):
+            for file_id, entry_keys in self._id_index.items():
                 for entry_key in entry_keys:
                     # Check that the entry in the map is pointing to the same
                     # file_id

=== modified file 'breezy/bzr/fetch.py'
--- breezy/bzr/fetch.py	2020-01-30 16:09:00 +0000
+++ breezy/bzr/fetch.py	2020-02-18 01:57:45 +0000
@@ -22,8 +22,6 @@
 branch.
 """
 
-from __future__ import absolute_import
-
 import operator
 
 from ..lazy_import import lazy_import
@@ -42,9 +40,6 @@
     )
 from ..i18n import gettext
 from ..revision import NULL_REVISION
-from ..sixish import (
-    viewvalues,
-    )
 from ..trace import mutter
 
 
@@ -212,7 +207,7 @@
             revision_id = tree.get_file_revision(u'')
             revision_root[revision_id] = root_id
         # Find out which parents we don't already know root ids for
-        parents = set(viewvalues(parent_map))
+        parents = set(parent_map.values())
         parents.difference_update(revision_root)
         parents.discard(NULL_REVISION)
         # Limit to revisions present in the versionedfile

=== modified file 'breezy/bzr/fullhistory.py'
--- breezy/bzr/fullhistory.py	2020-01-18 04:16:23 +0000
+++ breezy/bzr/fullhistory.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Full history branch formats."""
 
-from __future__ import absolute_import
-
 from .. import (
     debug,
     errors,

=== modified file 'breezy/bzr/generate_ids.py'
--- breezy/bzr/generate_ids.py	2019-02-04 19:39:30 +0000
+++ breezy/bzr/generate_ids.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Common code for generating file or revision ids."""
 
-from __future__ import absolute_import
-
 from ..lazy_import import lazy_import
 lazy_import(globals(), """
 import time
@@ -31,7 +29,6 @@
 from .. import (
     lazy_regex,
     )
-from ..sixish import text_type
 
 # the regex removes any weird characters; we don't escape them
 # but rather just pull them out
@@ -71,7 +68,7 @@
 
     The uniqueness is supplied from _next_id_suffix.
     """
-    if isinstance(name, text_type):
+    if isinstance(name, str):
         name = name.encode('ascii', 'replace')
     # The real randomness is in the _next_id_suffix, the
     # rest of the identifier is just to be nice.

=== modified file 'breezy/bzr/groupcompress.py'
--- breezy/bzr/groupcompress.py	2020-02-09 02:20:11 +0000
+++ breezy/bzr/groupcompress.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Core compression logic for compressing streams of related files."""
 
-from __future__ import absolute_import
-
 import time
 import zlib
 
@@ -46,12 +44,6 @@
     )
 from .btree_index import BTreeBuilder
 from ..lru_cache import LRUSizeCache
-from ..sixish import (
-    indexbytes,
-    map,
-    range,
-    viewitems,
-    )
 from .versionedfile import (
     _KeyRefs,
     adapter_registry,
@@ -80,7 +72,7 @@
     # groupcompress ordering is approximately reverse topological,
     # properly grouped by file-id.
     per_prefix_map = {}
-    for key, value in viewitems(parent_map):
+    for key, value in parent_map.items():
         if isinstance(key, bytes) or len(key) == 1:
             prefix = b''
         else:
@@ -392,7 +384,7 @@
                 result.append((b'd', content_len, decomp_len, delta_info))
                 measured_len = 0
                 while delta_pos < content_len:
-                    c = indexbytes(delta_content, delta_pos)
+                    c = delta_content[delta_pos]
                     delta_pos += 1
                     if c & 0x80:  # Copy
                         (offset, length,
@@ -1632,7 +1624,7 @@
             # start with one key, recurse to its oldest parent, then grab
             # everything in the same group, etc.
             parent_map = dict((key, details[2]) for key, details in
-                              viewitems(locations))
+                              locations.items())
             for key in unadded_keys:
                 parent_map[key] = self._unadded_refs[key]
             parent_map.update(fallback_parent_map)
@@ -2090,10 +2082,10 @@
         if changed:
             result = []
             if self._parents:
-                for key, (value, node_refs) in viewitems(keys):
+                for key, (value, node_refs) in keys.items():
                     result.append((key, value, node_refs))
             else:
-                for key, (value, node_refs) in viewitems(keys):
+                for key, (value, node_refs) in keys.items():
                     result.append((key, value))
             records = result
         key_dependencies = self._key_dependencies

=== modified file 'breezy/bzr/groupcompress_repo.py'
--- breezy/bzr/groupcompress_repo.py	2020-01-30 18:07:32 +0000
+++ breezy/bzr/groupcompress_repo.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Repository formats using CHK inventories and groupcompress compression."""
 
-from __future__ import absolute_import
-
 import time
 
 from .. import (
@@ -59,10 +57,6 @@
 from ..bzr.vf_repository import (
     StreamSource,
     )
-from ..sixish import (
-    viewitems,
-    viewvalues,
-    )
 from ..static_tuple import StaticTuple
 
 
@@ -287,7 +281,7 @@
                 next_keys = set()
 
                 def handle_internal_node(node):
-                    for prefix, value in viewitems(node._items):
+                    for prefix, value in node._items.items():
                         # We don't want to request the same key twice, and we
                         # want to order it by the first time it is seen.
                         # Even further, we don't want to request a key which is
@@ -549,7 +543,7 @@
         ancestor_keys = revision_vf.get_parent_map(revision_vf.keys())
         # Strip keys back into revision_ids.
         ancestors = dict((k[0], tuple([p[0] for p in parents]))
-                         for k, parents in viewitems(ancestor_keys))
+                         for k, parents in ancestor_keys.items())
         del ancestor_keys
         # TODO: _generate_text_key_index should be much cheaper to generate from
         #       a chk repository, rather than the current implementation
@@ -671,7 +665,7 @@
                 if search_key_name is None:
                     # Find the name corresponding to the search_key_func
                     search_key_reg = chk_map.search_key_registry
-                    for search_key_name, func in viewitems(search_key_reg):
+                    for search_key_name, func in search_key_reg.items():
                         if func == chk_inv.id_to_entry._search_key_func:
                             break
                 canonical_inv = inventory.CHKInventory.from_inventory(
@@ -748,7 +742,7 @@
         # any present parent inventories, which may be used when calculating
         # deltas for streaming.
         all_inv_keys = set(corresponding_invs)
-        for parent_inv_keys in viewvalues(inv_parent_map):
+        for parent_inv_keys in inv_parent_map.values():
             all_inv_keys.update(parent_inv_keys)
         # Filter out ghost parents.
         all_inv_keys.intersection_update(

=== modified file 'breezy/bzr/index.py'
--- breezy/bzr/index.py	2018-11-18 19:48:57 +0000
+++ breezy/bzr/index.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Indexing facilities."""
 
-from __future__ import absolute_import
-
 __all__ = [
     'CombinedGraphIndex',
     'GraphIndex',
@@ -27,6 +25,7 @@
     ]
 
 from bisect import bisect_right
+from io import BytesIO
 import re
 
 from ..lazy_import import lazy_import
@@ -41,13 +40,6 @@
     debug,
     errors,
     )
-from ..sixish import (
-    BytesIO,
-    bytesintern,
-    viewvalues,
-    viewitems,
-    zip,
-    )
 from ..static_tuple import StaticTuple
 
 _HEADER_READV = (0, 200)
@@ -202,7 +194,7 @@
         if self._nodes_by_key is None:
             nodes_by_key = {}
             if self.reference_lists:
-                for key, (absent, references, value) in viewitems(self._nodes):
+                for key, (absent, references, value) in self._nodes.items():
                     if absent:
                         continue
                     key_dict = nodes_by_key
@@ -210,7 +202,7 @@
                         key_dict = key_dict.setdefault(subkey, {})
                     key_dict[key[-1]] = key, value, references
             else:
-                for key, (absent, references, value) in viewitems(self._nodes):
+                for key, (absent, references, value) in self._nodes.items():
                     if absent:
                         continue
                     key_dict = nodes_by_key
@@ -334,7 +326,7 @@
         # forward sorted by key. In future we may consider topological sorting,
         # at the cost of table scans for direct lookup, or a second index for
         # direct lookup
-        nodes = sorted(viewitems(self._nodes))
+        nodes = sorted(self._nodes.items())
         # if we do not prepass, we don't know how long it will be up front.
         expected_bytes = None
         # we only need to pre-pass if we have reference lists at all.
@@ -549,7 +541,7 @@
             stream.close()
         del lines[-1]
         _, _, _, trailers = self._parse_lines(lines, pos)
-        for key, absent, references, value in viewvalues(self._keys_by_offset):
+        for key, absent, references, value in self._keys_by_offset.values():
             if absent:
                 continue
             # resolve references:
@@ -580,7 +572,7 @@
                              % (ref_list_num, self.node_ref_lists))
         refs = set()
         nodes = self._nodes
-        for key, (value, ref_lists) in viewitems(nodes):
+        for key, (value, ref_lists) in nodes.items():
             ref_list = ref_lists[ref_list_num]
             refs.update([ref for ref in ref_list if ref not in nodes])
         return refs
@@ -589,13 +581,13 @@
         if self._nodes_by_key is None:
             nodes_by_key = {}
             if self.node_ref_lists:
-                for key, (value, references) in viewitems(self._nodes):
+                for key, (value, references) in self._nodes.items():
                     key_dict = nodes_by_key
                     for subkey in key[:-1]:
                         key_dict = key_dict.setdefault(subkey, {})
                     key_dict[key[-1]] = key, value, references
             else:
-                for key, value in viewitems(self._nodes):
+                for key, value in self._nodes.items():
                     key_dict = nodes_by_key
                     for subkey in key[:-1]:
                         key_dict = key_dict.setdefault(subkey, {})
@@ -618,10 +610,10 @@
         if self._nodes is None:
             self._buffer_all()
         if self.node_ref_lists:
-            for key, (value, node_ref_lists) in viewitems(self._nodes):
+            for key, (value, node_ref_lists) in self._nodes.items():
                 yield self, key, value, node_ref_lists
         else:
-            for key, value in viewitems(self._nodes):
+            for key, value in self._nodes.items():
                 yield self, key, value
 
     def _read_prefix(self, stream):
@@ -1161,8 +1153,7 @@
                 raise BadIndexData(self)
             # keys are tuples. Each element is a string that may occur many
             # times, so we intern them to save space. AB, RC, 200807
-            key = tuple([bytesintern(element)
-                         for element in elements[:self._key_length]])
+            key = tuple([element for element in elements[:self._key_length]])
             if first_key is None:
                 first_key = key
             absent, references, value = elements[-3:]
@@ -1673,11 +1664,11 @@
             trace.mutter_callsite(3,
                                   "iter_all_entries scales with size of history.")
         if self.reference_lists:
-            for key, (absent, references, value) in viewitems(self._nodes):
+            for key, (absent, references, value) in self._nodes.items():
                 if not absent:
                     yield self, key, value, references
         else:
-            for key, (absent, references, value) in viewitems(self._nodes):
+            for key, (absent, references, value) in self._nodes.items():
                 if not absent:
                     yield self, key, value
 
@@ -1910,7 +1901,7 @@
         if len(elements):
             dicts = [key_dict]
             while dicts:
-                values_view = viewvalues(dicts.pop())
+                values_view = dicts.pop().values()
                 # can't be empty or would not exist
                 value = next(iter(values_view))
                 if isinstance(value, dict):

=== modified file 'breezy/bzr/inventory.py'
--- breezy/bzr/inventory.py	2020-01-30 16:13:31 +0000
+++ breezy/bzr/inventory.py	2020-02-18 01:57:45 +0000
@@ -23,8 +23,6 @@
 # But those depend on its position within a particular inventory, and
 # it would be nice not to need to hold the backpointer here.
 
-from __future__ import absolute_import
-
 # This should really be an id randomly assigned when the tree is
 # created, but it's not for now.
 ROOT_ID = b"TREE_ROOT"
@@ -50,15 +48,18 @@
     osutils,
     trace,
     )
-from ..sixish import (
-    bytesintern,
-    text_type,
-    viewitems,
-    viewvalues,
-    )
 from ..static_tuple import StaticTuple
 
 
+class InvalidEntryName(errors.InternalBzrError):
+
+    _fmt = "Invalid entry name: %(name)s"
+
+    def __init__(self, name):
+        errors.BzrError.__init__(self)
+        self.name = name
+
+
 class InventoryEntry(object):
     """Description of a versioned file.
 
@@ -91,30 +92,30 @@
 
     >>> i = Inventory()
     >>> i.path2id('')
-    'TREE_ROOT'
+    b'TREE_ROOT'
     >>> i.add(InventoryDirectory(b'123', 'src', ROOT_ID))
-    InventoryDirectory('123', 'src', parent_id='TREE_ROOT', revision=None)
-    >>> i.add(InventoryFile(b'2323', 'hello.c', parent_id='123'))
-    InventoryFile('2323', 'hello.c', parent_id='123', sha1=None, len=None, revision=None)
+    InventoryDirectory(b'123', 'src', parent_id=b'TREE_ROOT', revision=None)
+    >>> i.add(InventoryFile(b'2323', 'hello.c', parent_id=b'123'))
+    InventoryFile(b'2323', 'hello.c', parent_id=b'123', sha1=None, len=None, revision=None)
     >>> shouldbe = {0: '', 1: 'src', 2: 'src/hello.c'}
     >>> for ix, j in enumerate(i.iter_entries()):
-    ...   print (j[0] == shouldbe[ix], j[1])
+    ...   print(j[0] == shouldbe[ix], j[1])
     ...
-    (True, InventoryDirectory('TREE_ROOT', u'', parent_id=None, revision=None))
-    (True, InventoryDirectory('123', 'src', parent_id='TREE_ROOT', revision=None))
-    (True, InventoryFile('2323', 'hello.c', parent_id='123', sha1=None, len=None, revision=None))
-    >>> i.add(InventoryFile('2324', 'bye.c', '123'))
-    InventoryFile('2324', 'bye.c', parent_id='123', sha1=None, len=None, revision=None)
-    >>> i.add(InventoryDirectory('2325', 'wibble', '123'))
-    InventoryDirectory('2325', 'wibble', parent_id='123', revision=None)
+    True InventoryDirectory(b'TREE_ROOT', '', parent_id=None, revision=None)
+    True InventoryDirectory(b'123', 'src', parent_id=b'TREE_ROOT', revision=None)
+    True InventoryFile(b'2323', 'hello.c', parent_id=b'123', sha1=None, len=None, revision=None)
+    >>> i.add(InventoryFile(b'2324', 'bye.c', b'123'))
+    InventoryFile(b'2324', 'bye.c', parent_id=b'123', sha1=None, len=None, revision=None)
+    >>> i.add(InventoryDirectory(b'2325', 'wibble', b'123'))
+    InventoryDirectory(b'2325', 'wibble', parent_id=b'123', revision=None)
     >>> i.path2id('src/wibble')
-    '2325'
-    >>> i.add(InventoryFile('2326', 'wibble.c', '2325'))
-    InventoryFile('2326', 'wibble.c', parent_id='2325', sha1=None, len=None, revision=None)
-    >>> i.get_entry('2326')
-    InventoryFile('2326', 'wibble.c', parent_id='2325', sha1=None, len=None, revision=None)
+    b'2325'
+    >>> i.add(InventoryFile(b'2326', 'wibble.c', b'2325'))
+    InventoryFile(b'2326', 'wibble.c', parent_id=b'2325', sha1=None, len=None, revision=None)
+    >>> i.get_entry(b'2326')
+    InventoryFile(b'2326', 'wibble.c', parent_id=b'2325', sha1=None, len=None, revision=None)
     >>> for path, entry in i.iter_entries():
-    ...     print path
+    ...     print(path)
     ...
     <BLANKLINE>
     src
@@ -218,13 +219,13 @@
         >>> e.name
         'hello.c'
         >>> e.file_id
-        '123'
+        b'123'
         >>> e = InventoryFile(b'123', 'src/hello.c', ROOT_ID)
         Traceback (most recent call last):
-        InvalidEntryName: Invalid entry name: src/hello.c
+        breezy.bzr.inventory.InvalidEntryName: Invalid entry name: src/hello.c
         """
         if u'/' in name:
-            raise errors.InvalidEntryName(name=name)
+            raise InvalidEntryName(name=name)
         if not isinstance(file_id, bytes):
             raise TypeError(file_id)
         self.file_id = file_id
@@ -417,7 +418,7 @@
         self.children = {}
 
     def sorted_children(self):
-        return sorted(viewitems(self.children))
+        return sorted(self.children.items())
 
     def kind_character(self):
         """See InventoryEntry.kind_character."""
@@ -666,8 +667,8 @@
 
         >>> i = Inventory()
         >>> e = i.add(InventoryDirectory(b'src-id', 'src', ROOT_ID))
-        >>> e = i.add(InventoryFile(b'foo-id', 'foo.c', parent_id='src-id'))
-        >>> print i.id2path(b'foo-id')
+        >>> e = i.add(InventoryFile(b'foo-id', 'foo.c', parent_id=b'src-id'))
+        >>> print(i.id2path(b'foo-id'))
         src/foo.c
 
         :raises NoSuchId: If file_id is not present in the inventory.
@@ -694,10 +695,9 @@
 
         # unrolling the recursive called changed the time from
         # 440ms/663ms (inline/total) to 116ms/116ms
-        children = sorted(viewitems(from_dir.children))
+        children = sorted(from_dir.children.items())
         if not recursive:
-            for name, ie in children:
-                yield name, ie
+            yield from children
             return
         children = deque(children)
         stack = [(u'', children)]
@@ -719,7 +719,7 @@
                     continue
 
                 # But do this child first
-                new_children = sorted(viewitems(ie.children))
+                new_children = sorted(ie.children.items())
                 new_children = deque(new_children)
                 stack.append((path, new_children))
                 # Break out of inner loop, so that we start outer loop with child
@@ -804,7 +804,7 @@
             cur_relpath, cur_dir = stack.pop()
 
             child_dirs = []
-            for child_name, child_ie in sorted(viewitems(cur_dir.children)):
+            for child_name, child_ie in sorted(cur_dir.children.items()):
 
                 child_relpath = cur_relpath + child_name
 
@@ -848,7 +848,7 @@
         accum = []
 
         def descend(dir_ie, dir_path):
-            kids = sorted(viewitems(dir_ie.children))
+            kids = sorted(dir_ie.children.items())
             for name, ie in kids:
                 child_path = osutils.pathjoin(dir_path, name)
                 accum.append((child_path, ie))
@@ -866,7 +866,7 @@
             or as list of elements.
         :return: tuple with ie, resolved elements and elements left to resolve
         """
-        if isinstance(relpath, (str, text_type)):
+        if isinstance(relpath, str):
             names = osutils.splitpath(relpath)
         else:
             names = relpath
@@ -903,7 +903,7 @@
 
         Returns None IFF the path is not found.
         """
-        if isinstance(relpath, (str, text_type)):
+        if isinstance(relpath, str):
             names = osutils.splitpath(relpath)
         else:
             names = relpath
@@ -1000,21 +1000,21 @@
 
     >>> inv = Inventory()
     >>> inv.add(InventoryFile(b'123-123', 'hello.c', ROOT_ID))
-    InventoryFile('123-123', 'hello.c', parent_id='TREE_ROOT', sha1=None, len=None, revision=None)
+    InventoryFile(b'123-123', 'hello.c', parent_id=b'TREE_ROOT', sha1=None, len=None, revision=None)
     >>> inv.get_entry(b'123-123').name
     'hello.c'
 
     Id's may be looked up from paths:
 
     >>> inv.path2id('hello.c')
-    '123-123'
+    b'123-123'
     >>> inv.has_id(b'123-123')
     True
 
     There are iterators over the contents:
 
     >>> [entry[0] for entry in inv.iter_entries()]
-    ['', u'hello.c']
+    ['', 'hello.c']
     """
 
     def __init__(self, root_id=ROOT_ID, revision_id=None):
@@ -1185,7 +1185,7 @@
         """
         if self.root is None:
             return ()
-        return iter(viewvalues(self._byid))
+        return self._byid.values()
 
     def __len__(self):
         """Returns number of entries."""
@@ -1196,7 +1196,7 @@
 
         >>> inv = Inventory()
         >>> inv.add(InventoryFile(b'123123', 'hello.c', ROOT_ID))
-        InventoryFile('123123', 'hello.c', parent_id='TREE_ROOT', sha1=None, len=None, revision=None)
+        InventoryFile(b'123123', 'hello.c', parent_id=b'TREE_ROOT', sha1=None, len=None, revision=None)
         >>> inv.get_entry(b'123123').name
         'hello.c'
         """
@@ -1223,7 +1223,7 @@
         self._byid[entry.file_id] = entry
         children = getattr(entry, 'children', {})
         if children is not None:
-            for child in viewvalues(children):
+            for child in children.values():
                 self._add_child(child)
         return entry
 
@@ -1279,7 +1279,7 @@
 
         >>> inv = Inventory()
         >>> inv.add(InventoryFile(b'123', 'foo.c', ROOT_ID))
-        InventoryFile('123', 'foo.c', parent_id='TREE_ROOT', sha1=None, len=None, revision=None)
+        InventoryFile(b'123', 'foo.c', parent_id=b'TREE_ROOT', sha1=None, len=None, revision=None)
         >>> inv.has_id(b'123')
         True
         >>> inv.delete(b'123')
@@ -1299,11 +1299,11 @@
         >>> i1 == i2
         True
         >>> i1.add(InventoryFile(b'123', 'foo', ROOT_ID))
-        InventoryFile('123', 'foo', parent_id='TREE_ROOT', sha1=None, len=None, revision=None)
+        InventoryFile(b'123', 'foo', parent_id=b'TREE_ROOT', sha1=None, len=None, revision=None)
         >>> i1 == i2
         False
         >>> i2.add(InventoryFile(b'123', 'foo', ROOT_ID))
-        InventoryFile('123', 'foo', parent_id='TREE_ROOT', sha1=None, len=None, revision=None)
+        InventoryFile(b'123', 'foo', parent_id=b'TREE_ROOT', sha1=None, len=None, revision=None)
         >>> i1 == i2
         True
         """
@@ -1374,7 +1374,7 @@
             ie = to_find_delete.pop()
             to_delete.append(ie.file_id)
             if ie.kind == 'directory':
-                to_find_delete.extend(viewvalues(ie.children))
+                to_find_delete.extend(ie.children.values())
         for file_id in reversed(to_delete):
             ie = self.get_entry(file_id)
             del self._byid[file_id]
@@ -1623,7 +1623,7 @@
         # to filter out empty names because of non rich-root...
         sections = data.split(b'\n')
         kind, file_id = sections[0].split(b': ')
-        return (sections[2], bytesintern(file_id), bytesintern(sections[3]))
+        return (sections[2], file_id, sections[3])
 
     def _bytes_to_entry(self, bytes):
         """Deserialise a serialised entry."""
@@ -1651,8 +1651,8 @@
             result.reference_revision = sections[4]
         else:
             raise ValueError("Not a serialised entry %r" % bytes)
-        result.file_id = bytesintern(result.file_id)
-        result.revision = bytesintern(sections[3])
+        result.file_id = result.file_id
+        result.revision = sections[3]
         if result.parent_id == b'':
             result.parent_id = None
         self._fileid_to_entry_cache[result.file_id] = result
@@ -1796,7 +1796,7 @@
                 continue
             # This loop could potentially be better by using the id_basename
             # map to just get the child file ids.
-            for child in viewvalues(entry.children):
+            for child in entry.children.values():
                 if child.file_id not in altered:
                     raise errors.InconsistentDelta(self.id2path(child.file_id),
                                                    child.file_id, "Child not deleted or reparented when "
@@ -1808,7 +1808,7 @@
             # re-keying, but its simpler to just output that as a delete+add
             # to spend less time calculating the delta.
             delta_list = []
-            for key, (old_key, value) in viewitems(parent_id_basename_delta):
+            for key, (old_key, value) in parent_id_basename_delta.items():
                 if value is not None:
                     delta_list.append((old_key, key, value))
                 else:
@@ -1855,11 +1855,11 @@
                 raise errors.BzrError('Duplicate key in inventory: %r\n%r'
                                       % (key, bytes))
             info[key] = value
-        revision_id = bytesintern(info[b'revision_id'])
-        root_id = bytesintern(info[b'root_id'])
-        search_key_name = bytesintern(info.get(b'search_key_name', b'plain'))
-        parent_id_basename_to_file_id = bytesintern(info.get(
-            b'parent_id_basename_to_file_id', None))
+        revision_id = info[b'revision_id']
+        root_id = info[b'root_id']
+        search_key_name = info.get(b'search_key_name', b'plain')
+        parent_id_basename_to_file_id = info.get(
+            b'parent_id_basename_to_file_id', None)
         if not parent_id_basename_to_file_id.startswith(b'sha1:'):
             raise ValueError('parent_id_basename_to_file_id should be a sha1'
                              ' key not %r' % (parent_id_basename_to_file_id,))
@@ -2174,7 +2174,7 @@
     def path2id(self, relpath):
         """See CommonInventory.path2id()."""
         # TODO: perhaps support negative hits?
-        if isinstance(relpath, (str, text_type)):
+        if isinstance(relpath, str):
             names = osutils.splitpath(relpath)
         else:
             names = relpath

=== modified file 'breezy/bzr/inventory_delta.py'
--- breezy/bzr/inventory_delta.py	2020-02-09 01:16:06 +0000
+++ breezy/bzr/inventory_delta.py	2020-02-18 01:57:45 +0000
@@ -22,8 +22,6 @@
  - InventoryDeltaSerializer - object to read/write inventory deltas.
 """
 
-from __future__ import absolute_import
-
 __all__ = ['InventoryDeltaSerializer']
 
 from .. import errors

=== modified file 'breezy/bzr/inventorytree.py'
--- breezy/bzr/inventorytree.py	2020-01-30 18:43:58 +0000
+++ breezy/bzr/inventorytree.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 """Tree classes, representing directory at point in time.
 """
 
-from __future__ import absolute_import
-
 import os
 import re
 
@@ -53,9 +51,6 @@
     inventory as _mod_inventory,
     )
 """)
-from ..sixish import (
-    viewvalues,
-    )
 from ..tree import (
     FileTimestampUnavailable,
     InterTree,
@@ -249,7 +244,7 @@
             ie = self._path2ie(path)
             if ie.kind != 'directory':
                 raise errors.NotADirectory(path)
-            return iter(viewvalues(ie.children))
+            return ie.children.values()
 
     def _get_plan_merge_data(self, path, other, base):
         from . import versionedfile
@@ -509,7 +504,7 @@
     def get_inventory_delta(self):
         # GZ 2016-06-05: Returning view would probably be fine but currently
         # Inventory.apply_delta is documented as requiring a list of changes.
-        return list(viewvalues(self._invdelta))
+        return list(self._invdelta.values())
 
     def _get_ie(self, inv_path):
         """Retrieve the most up to date inventory entry for a path.

=== modified file 'breezy/bzr/knit.py'
--- breezy/bzr/knit.py	2020-01-30 18:07:32 +0000
+++ breezy/bzr/knit.py	2020-02-18 01:57:45 +0000
@@ -51,9 +51,8 @@
 
 """
 
-from __future__ import absolute_import
-
 import operator
+from io import BytesIO
 import os
 
 from ..lazy_import import lazy_import
@@ -95,12 +94,6 @@
     sha_strings,
     split_lines,
     )
-from ..sixish import (
-    BytesIO,
-    range,
-    viewitems,
-    viewvalues,
-    )
 from ..bzr.versionedfile import (
     _KeyRefs,
     AbsentContentFactory,
@@ -954,7 +947,7 @@
                 next_keys.add(compression_parent)
         build_keys = next_keys
     return sum(index_memo[2]
-               for index_memo in viewvalues(all_build_index_memos))
+               for index_memo in all_build_index_memos.values())
 
 
 class KnitVersionedFiles(VersionedFilesWithFallbacks):
@@ -1287,7 +1280,7 @@
             build_details = self._index.get_build_details(pending_components)
             current_components = set(pending_components)
             pending_components = set()
-            for key, details in viewitems(build_details):
+            for key, details in build_details.items():
                 (index_memo, compression_parent, parents,
                  record_details) = details
                 if compression_parent is not None:
@@ -1394,7 +1387,7 @@
                 # key = component_id, r = record_details, i_m = index_memo,
                 # n = next
                 records = [(key, i_m) for key, (r, i_m, n)
-                           in viewitems(position_map)]
+                           in position_map.items()]
                 # Sort by the index memo, so that we request records from the
                 # same pack file together, and in forward-sorted order
                 records.sort(key=operator.itemgetter(1))
@@ -1526,7 +1519,7 @@
             # map from key to
             # (record_details, access_memo, compression_parent_key)
             positions = dict((key, self._build_details_to_components(details))
-                             for key, details in viewitems(build_details))
+                             for key, details in build_details.items())
         absent_keys = keys.difference(set(positions))
         # There may be more absent keys : if we're missing the basis component
         # and are trying to include the delta closure.
@@ -1641,7 +1634,7 @@
         missing = set(keys)
         record_map = self._get_record_map(missing, allow_missing=True)
         result = {}
-        for key, details in viewitems(record_map):
+        for key, details in record_map.items():
             if key not in missing:
                 continue
             # record entry 2 is the 'digest'.
@@ -1871,7 +1864,7 @@
                 # we need key, position, length
                 key_records = []
                 build_details = self._index.get_build_details(keys)
-                for key, details in viewitems(build_details):
+                for key, details in build_details.items():
                     if key in keys:
                         key_records.append((key, details[0]))
                 records_iter = enumerate(self._read_records_iter(key_records))
@@ -2281,8 +2274,8 @@
         # one line with next ('' for None)
         # one line with byte count of the record bytes
         # the record bytes
-        for key, (record_bytes, (method, noeol), next) in viewitems(
-                self._raw_record_map):
+        for key, (record_bytes, (method, noeol), next) in (
+                self._raw_record_map.items()):
             key_bytes = b'\x00'.join(key)
             parents = self.global_map.get(key, None)
             if parents is None:
@@ -3012,10 +3005,10 @@
                 del keys[key]
         result = []
         if self._parents:
-            for key, (value, node_refs) in viewitems(keys):
+            for key, (value, node_refs) in keys.items():
                 result.append((key, value, node_refs))
         else:
-            for key, (value, node_refs) in viewitems(keys):
+            for key, (value, node_refs) in keys.items():
                 result.append((key, value))
         self._add_callback(result)
         if missing_compression_parents:
@@ -3406,7 +3399,7 @@
             self._all_build_details.update(build_details)
             # new_nodes = self._vf._index._get_entries(this_iteration)
             pending = set()
-            for key, details in viewitems(build_details):
+            for key, details in build_details.items():
                 (index_memo, compression_parent, parent_keys,
                  record_details) = details
                 self._parent_map[key] = parent_keys

=== modified file 'breezy/bzr/knitpack_repo.py'
--- breezy/bzr/knitpack_repo.py	2020-02-18 00:46:00 +0000
+++ breezy/bzr/knitpack_repo.py	2020-02-21 03:58:42 +0000
@@ -16,8 +16,6 @@
 
 """Knit-based pack repository formats."""
 
-from __future__ import absolute_import
-
 from .. import (
     errors,
     )
@@ -70,10 +68,6 @@
     PackRepository,
     RepositoryPackCollection,
     )
-from ..sixish import (
-    viewitems,
-    zip
-    )
 from ..bzr.vf_repository import (
     StreamSource,
     )
@@ -653,7 +647,7 @@
             request_groups[index].append((key, value))
         record_index = 0
         pb.update("Copied record", record_index, len(nodes))
-        for index, items in viewitems(request_groups):
+        for index, items in request_groups.items():
             pack_readv_requests = []
             for key, value in items:
                 # ---- KnitGraphIndex.get_position
@@ -745,7 +739,7 @@
         fileid_revisions = repo._find_file_ids_from_xml_inventory_lines(
             inv_lines, self.revision_keys)
         text_filter = []
-        for fileid, file_revids in viewitems(fileid_revisions):
+        for fileid, file_revids in fileid_revisions.items():
             text_filter.extend([(fileid, file_revid)
                                 for file_revid in file_revids])
         self._text_filter = text_filter
@@ -944,7 +938,7 @@
                 request_groups[index] = []
             request_groups[index].append((key, value, references))
         result = []
-        for index, items in viewitems(request_groups):
+        for index, items in request_groups.items():
             pack_readv_requests = []
             for key, value, references in items:
                 # ---- KnitGraphIndex.get_position

=== modified file 'breezy/bzr/knitrepo.py'
--- breezy/bzr/knitrepo.py	2020-01-11 17:50:28 +0000
+++ breezy/bzr/knitrepo.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from ..lazy_import import lazy_import
 lazy_import(globals(), """
 import itertools

=== modified file 'breezy/bzr/pack.py'
--- breezy/bzr/pack.py	2020-02-09 02:41:42 +0000
+++ breezy/bzr/pack.py	2020-02-18 01:57:45 +0000
@@ -20,14 +20,10 @@
 doc/developers/container-format.txt.
 """
 
-from __future__ import absolute_import
-
+from io import BytesIO
 import re
 
 from .. import errors
-from ..sixish import (
-    BytesIO,
-    )
 
 
 FORMAT_ONE = b"Bazaar pack format 1 (introduced in 0.18)"

=== modified file 'breezy/bzr/pack_repo.py'
--- breezy/bzr/pack_repo.py	2020-02-09 02:41:42 +0000
+++ breezy/bzr/pack_repo.py	2020-02-18 01:57:45 +0000
@@ -14,17 +14,15 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import re
 import sys
 
 from ..lazy_import import lazy_import
 lazy_import(globals(), """
+import contextlib
 import time
 
 from breezy import (
-    cleanup,
     config,
     debug,
     graph,
@@ -60,10 +58,6 @@
     MetaDirRepository,
     RepositoryFormatMetaDir,
     )
-from ..sixish import (
-    reraise,
-    viewitems,
-    )
 from ..bzr.vf_repository import (
     MetaDirVersionedFileRepository,
     MetaDirVersionedFileRepositoryFormat,
@@ -1337,7 +1331,7 @@
 
         # do a two-way diff against our original content
         current_nodes = set()
-        for name, sizes in viewitems(self._names):
+        for name, sizes in self._names.items():
             current_nodes.add(
                 (name, b' '.join(b'%d' % size for size in sizes)))
 
@@ -1550,7 +1544,7 @@
         # FIXME: just drop the transient index.
         # forget what names there are
         if self._new_pack is not None:
-            with cleanup.ExitStack() as stack:
+            with contextlib.ExitStack() as stack:
                 stack.callback(setattr, self, '_new_pack', None)
                 # If we aborted while in the middle of finishing the write
                 # group, _remove_pack_indices could fail because the indexes are
@@ -1560,7 +1554,7 @@
                                ignore_missing=True)
                 self._new_pack.abort()
         for resumed_pack in self._resumed_packs:
-            with cleanup.ExitStack() as stack:
+            with contextlib.ExitStack() as stack:
                 # See comment in previous finally block.
                 stack.callback(self._remove_pack_indices, resumed_pack,
                                ignore_missing=True)
@@ -2099,4 +2093,4 @@
                 is_error = True
         if is_error:
             # GZ 2017-03-27: No real reason this needs the original traceback.
-            reraise(*retry_exc.exc_info)
+            raise retry_exc.exc_info[1]

=== modified file 'breezy/bzr/reconcile.py'
--- breezy/bzr/reconcile.py	2020-01-25 14:58:19 +0000
+++ breezy/bzr/reconcile.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Reconcilers are able to fix some potential data errors in a branch."""
 
-from __future__ import absolute_import
-
 __all__ = [
     'BranchReconciler',
     'KnitReconciler',
@@ -26,7 +24,6 @@
     ]
 
 from .. import (
-    cleanup,
     errors,
     revision as _mod_revision,
     ui,

=== modified file 'breezy/bzr/remote.py'
--- breezy/bzr/remote.py	2020-02-19 04:50:09 +0000
+++ breezy/bzr/remote.py	2020-02-21 03:58:42 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import bz2
 import os
 import re
@@ -59,13 +57,6 @@
 from .inventory import Inventory
 from .inventorytree import InventoryRevisionTree
 from ..lockable_files import LockableFiles
-from ..sixish import (
-    get_unbound_function,
-    map,
-    text_type,
-    viewitems,
-    viewvalues,
-    )
 from .smart import client, vfs, repository as smart_repo
 from .smart.client import _SmartClient
 from ..revision import NULL_REVISION
@@ -719,7 +710,7 @@
             raise errors.UnexpectedSmartServerResponse(response)
         body = bencode.bdecode(handler.read_body_bytes())
         ret = {}
-        for name, value in viewitems(body):
+        for name, value in body.items():
             name = name.decode('utf-8')
             ret[name] = self._open_branch(name, value[0], value[1],
                                           possible_transports=possible_transports,
@@ -913,12 +904,10 @@
     def _path_for_remote_call(self, client):
         """Return the path to be used for this bzrdir in a remote call."""
         remote_path = client.remote_path_from_transport(self.root_transport)
-        if sys.version_info[0] == 3:
-            remote_path = remote_path.decode('utf-8')
+        remote_path = remote_path.decode('utf-8')
         base_url, segment_parameters = urlutils.split_segment_parameters_raw(
             remote_path)
-        if sys.version_info[0] == 3:
-            base_url = base_url.encode('utf-8')
+        base_url = base_url.encode('utf-8')
         return base_url
 
     def get_branch_transport(self, branch_format, name=None):
@@ -2184,7 +2173,7 @@
     def revision_ids_to_search_result(self, result_set):
         """Convert a set of revision ids to a graph SearchResult."""
         result_parents = set()
-        for parents in viewvalues(self.get_graph().get_parent_map(result_set)):
+        for parents in self.get_graph().get_parent_map(result_set).values():
             result_parents.update(parents)
         included_keys = result_set.intersection(result_parents)
         start_keys = result_set.difference(included_keys)
@@ -2316,7 +2305,7 @@
                 if not absent:
                     break
                 desired_files = [(key[0], key[1], identifier)
-                                 for identifier, key in viewitems(absent)]
+                                 for identifier, key in absent.items()]
                 for (identifier, bytes_iterator) in fallback.iter_files_bytes(desired_files):
                     del absent[identifier]
                     yield identifier, bytes_iterator
@@ -2363,7 +2352,7 @@
             # There is one other "bug" which is that ghosts in
             # get_revision_graph() are not returned at all. But we won't worry
             # about that for now.
-            for node_id, parent_ids in viewitems(rg):
+            for node_id, parent_ids in rg.items():
                 if parent_ids == ():
                     rg[node_id] = (NULL_REVISION,)
             rg[NULL_REVISION] = ()
@@ -3415,9 +3404,8 @@
         self._ensure_real()
         if isinstance(self._custom_format, bzrbranch.BranchFormatMetadir):
             branch_class = self._custom_format._branch_class()
-            heads_to_fetch_impl = get_unbound_function(
-                branch_class.heads_to_fetch)
-            if heads_to_fetch_impl is get_unbound_function(branch.Branch.heads_to_fetch):
+            heads_to_fetch_impl = branch_class.heads_to_fetch
+            if heads_to_fetch_impl is branch.Branch.heads_to_fetch:
                 return True
         return False
 
@@ -3693,9 +3681,7 @@
             return self._real_branch.get_stacked_on_url()
         if response[0] != b'ok':
             raise errors.UnexpectedSmartServerResponse(response)
-        if sys.version_info[0] == 3:
-            return response[1].decode('utf-8')
-        return response[1]
+        return response[1].decode('utf-8')
 
     def set_stacked_on_url(self, url):
         branch.Branch.set_stacked_on_url(self, url)
@@ -4009,7 +3995,7 @@
             return self._vfs_set_parent_location(url)
         try:
             call_url = url or u''
-            if isinstance(call_url, text_type):
+            if isinstance(call_url, str):
                 call_url = call_url.encode('utf-8')
             response = self._call(b'Branch.set_parent_location',
                                   self._remote_path(), self._lock_token, self._repo_lock_token,
@@ -4317,7 +4303,7 @@
     def _set_config_option(self, value, name, section):
         if isinstance(value, (bool, int)):
             value = str(value)
-        elif isinstance(value, (text_type, str)):
+        elif isinstance(value, str):
             pass
         else:
             raise TypeError(value)
@@ -4337,9 +4323,9 @@
     def _serialize_option_dict(self, option_dict):
         utf8_dict = {}
         for key, value in option_dict.items():
-            if isinstance(key, text_type):
+            if isinstance(key, str):
                 key = key.encode('utf8')
-            if isinstance(value, text_type):
+            if isinstance(value, str):
                 value = value.encode('utf8')
             utf8_dict[key] = value
         return bencode.bencode(utf8_dict)

=== modified file 'breezy/bzr/repository.py'
--- breezy/bzr/repository.py	2018-11-17 16:53:10 +0000
+++ breezy/bzr/repository.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import itertools
 
 from . import (
@@ -32,9 +30,6 @@
     Repository,
     RepositoryFormat,
     )
-from ..sixish import (
-    viewvalues,
-    )
 
 
 class MetaDirRepository(Repository):
@@ -94,8 +89,8 @@
         :return: set of revisions that are parents of revision_ids which are
             not part of revision_ids themselves
         """
-        parent_ids = set(itertools.chain.from_iterable(viewvalues(
-            self.get_parent_map(revision_ids))))
+        parent_ids = set(itertools.chain.from_iterable(
+            self.get_parent_map(revision_ids).values()))
         parent_ids.difference_update(revision_ids)
         parent_ids.discard(_mod_revision.NULL_REVISION)
         return parent_ids

=== modified file 'breezy/bzr/serializer.py'
--- breezy/bzr/serializer.py	2020-01-31 10:39:02 +0000
+++ breezy/bzr/serializer.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Inventory/revision serialization."""
 
-from __future__ import absolute_import
-
 from .. import registry
 
 

=== modified file 'breezy/bzr/smart/__init__.py'
--- breezy/bzr/smart/__init__.py	2018-11-10 17:52:47 +0000
+++ breezy/bzr/smart/__init__.py	2020-02-18 01:57:45 +0000
@@ -33,8 +33,6 @@
 
 """
 
-from __future__ import absolute_import
-
 # TODO: A plain integer from query_version is too simple; should give some
 # capabilities too?
 

=== modified file 'breezy/bzr/smart/branch.py'
--- breezy/bzr/smart/branch.py	2020-01-19 14:49:03 +0000
+++ breezy/bzr/smart/branch.py	2020-02-18 01:57:45 +0000
@@ -16,15 +16,12 @@
 
 """Server-side branch related request implmentations."""
 
-from __future__ import absolute_import
-
 from ... import (
     bencode,
     errors,
     revision as _mod_revision,
     )
 from ...controldir import ControlDir
-from ...sixish import text_type
 from .request import (
     FailedSmartServerResponse,
     SmartServerRequest,
@@ -254,7 +251,7 @@
             return self.do_tip_change_with_locked_branch(branch, *args)
         except errors.TipChangeRejected as e:
             msg = e.msg
-            if isinstance(msg, text_type):
+            if isinstance(msg, str):
                 msg = msg.encode('utf-8')
             return FailedSmartServerResponse((b'TipChangeRejected', msg))
 

=== modified file 'breezy/bzr/smart/bzrdir.py'
--- breezy/bzr/smart/bzrdir.py	2018-11-11 04:08:32 +0000
+++ breezy/bzr/smart/bzrdir.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Server-side bzrdir related request implmentations."""
 
-from __future__ import absolute_import
-
 from ... import (
     bencode,
     branch,
@@ -35,7 +33,6 @@
 from ...controldir import (
     network_format_registry,
     )
-from ...sixish import PY3
 from .request import (
     FailedSmartServerResponse,
     SmartServerRequest,
@@ -483,10 +480,7 @@
     def parse_NoneString(self, arg):
         if not arg:
             return None
-        if PY3:
-            return arg.decode('utf-8')
-        else:
-            return arg
+        return arg.decode('utf-8')
 
     def _serialize_NoneTrueFalse(self, arg):
         if arg is False:

=== modified file 'breezy/bzr/smart/client.py'
--- breezy/bzr/smart/client.py	2018-11-11 04:08:32 +0000
+++ breezy/bzr/smart/client.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from ... import lazy_import
 lazy_import.lazy_import(globals(), """
 from breezy.bzr.smart import request as _mod_request

=== modified file 'breezy/bzr/smart/medium.py'
--- breezy/bzr/smart/medium.py	2019-07-28 22:59:46 +0000
+++ breezy/bzr/smart/medium.py	2020-02-18 01:57:45 +0000
@@ -24,8 +24,6 @@
 breezy/transport/smart/__init__.py.
 """
 
-from __future__ import absolute_import
-
 import errno
 import io
 import os

=== modified file 'breezy/bzr/smart/message.py'
--- breezy/bzr/smart/message.py	2018-11-22 22:15:05 +0000
+++ breezy/bzr/smart/message.py	2020-02-18 01:57:45 +0000
@@ -14,20 +14,19 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 try:
     from collections.abc import deque
 except ImportError:  # python < 3.7
     from collections import deque
 
+from io import (
+    BytesIO,
+    )
+
 from ... import (
     debug,
     errors,
     )
-from ...sixish import (
-    BytesIO,
-    )
 from ...trace import mutter
 
 

=== modified file 'breezy/bzr/smart/packrepository.py'
--- breezy/bzr/smart/packrepository.py	2018-11-11 04:08:32 +0000
+++ breezy/bzr/smart/packrepository.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 """Server-side pack repository related request implmentations."""
 
 from .request import (

=== modified file 'breezy/bzr/smart/ping.py'
--- breezy/bzr/smart/ping.py	2020-01-11 17:50:28 +0000
+++ breezy/bzr/smart/ping.py	2020-02-18 01:57:45 +0000
@@ -16,11 +16,8 @@
 
 """Ping plugin for brz."""
 
-from __future__ import absolute_import
-
 from ...commands import Command
 from ...lazy_import import lazy_import
-from ...sixish import viewitems
 
 lazy_import(globals(), """
 from breezy.bzr.smart.client import _SmartClient
@@ -54,5 +51,5 @@
         if getattr(handler, 'headers', None) is not None:
             headers = {
                 k.decode('utf-8'): v.decode('utf-8')
-                for (k, v) in viewitems(handler.headers)}
+                for (k, v) in handler.headers.items()}
             self.outf.write('Headers: %r\n' % (headers,))

=== modified file 'breezy/bzr/smart/protocol.py'
--- breezy/bzr/smart/protocol.py	2019-03-06 14:03:19 +0000
+++ breezy/bzr/smart/protocol.py	2020-02-18 01:57:45 +0000
@@ -18,19 +18,15 @@
 client and server.
 """
 
-from __future__ import absolute_import
-
 try:
     from collections.abc import deque
 except ImportError:  # python < 3.7
     from collections import deque
 
+from io import BytesIO
 import struct
 import sys
-try:
-    import _thread
-except ImportError:
-    import thread as _thread
+import _thread
 import time
 
 import breezy
@@ -39,12 +35,7 @@
     errors,
     osutils,
     )
-from ...sixish import (
-    BytesIO,
-    reraise,
-)
 from . import message, request
-from ...sixish import text_type
 from ...trace import log_exception_quietly, mutter
 from ...bencode import bdecode_as_tuple, bencode
 
@@ -75,7 +66,7 @@
 def _encode_tuple(args):
     """Encode the tuple args to a bytestream."""
     for arg in args:
-        if isinstance(arg, text_type):
+        if isinstance(arg, str):
             raise TypeError(args)
     return b'\x01'.join(args) + b'\n'
 
@@ -1135,7 +1126,7 @@
         self._write_func(b's')
         utf8_args = []
         for arg in args:
-            if isinstance(arg, text_type):
+            if isinstance(arg, str):
                 utf8_args.append(arg.encode('utf8'))
             else:
                 utf8_args.append(arg)
@@ -1393,8 +1384,9 @@
                 self._write_structure((b'error',))
                 self._write_end()
                 self._medium_request.finished_writing()
+                (exc_type, exc_val, exc_tb) = exc_info
                 try:
-                    reraise(*exc_info)
+                    raise exc_val
                 finally:
                     del exc_info
             else:

=== modified file 'breezy/bzr/smart/repository.py'
--- breezy/bzr/smart/repository.py	2020-01-30 16:08:42 +0000
+++ breezy/bzr/smart/repository.py	2020-02-18 01:57:45 +0000
@@ -16,15 +16,10 @@
 
 """Server-side repository related request implementations."""
 
-from __future__ import absolute_import
-
 import bz2
 import itertools
 import os
-try:
-    import queue
-except ImportError:
-    import Queue as queue
+import queue
 import sys
 import tempfile
 import threading
@@ -45,9 +40,6 @@
     vf_search,
     )
 from ..bzrdir import BzrDir
-from ...sixish import (
-    reraise,
-)
 from .request import (
     FailedSmartServerResponse,
     SmartServerRequest,
@@ -919,8 +911,9 @@
         if self.insert_thread is not None:
             self.insert_thread.join()
         if not self.insert_ok:
+            (exc_type, exc_val, exc_tb) = self.insert_exception
             try:
-                reraise(*self.insert_exception)
+                raise exc_val
             finally:
                 del self.insert_exception
         write_group_tokens, missing_keys = self.insert_result

=== modified file 'breezy/bzr/smart/request.py'
--- breezy/bzr/smart/request.py	2020-01-18 02:42:17 +0000
+++ breezy/bzr/smart/request.py	2020-02-18 01:57:45 +0000
@@ -26,18 +26,13 @@
       of times during a request).
 """
 
-from __future__ import absolute_import
-
 # XXX: The class names are a little confusing: the protocol will instantiate a
 # SmartServerRequestHandler, whose dispatch_command method creates an instance
 # of a SmartServerRequest subclass.
 
 
 import threading
-try:
-    from _thread import get_ident
-except ImportError:  # Python < 3
-    from thread import get_ident
+from _thread import get_ident
 
 from ... import (
     branch as _mod_branch,
@@ -49,7 +44,6 @@
     trace,
     urlutils,
     )
-from ...sixish import text_type
 from ...lazy_import import lazy_import
 lazy_import(globals(), """
 from breezy.bzr import bzrdir
@@ -449,7 +443,7 @@
         # If it is a DecodeError, than most likely we are starting
         # with a plain string
         str_or_unicode = err.object
-        if isinstance(str_or_unicode, text_type):
+        if isinstance(str_or_unicode, str):
             # XXX: UTF-8 might have \x01 (our protocol v1 and v2 seperator
             # byte) in it, so this encoding could cause broken responses.
             # Newer clients use protocol v3, so will be fine.

=== modified file 'breezy/bzr/smart/server.py'
--- breezy/bzr/smart/server.py	2018-11-11 04:08:32 +0000
+++ breezy/bzr/smart/server.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Server for smart-server protocol."""
 
-from __future__ import absolute_import
-
 import errno
 import os.path
 import socket
@@ -435,10 +433,7 @@
         self.transport = transport
 
     def _get_stdin_stdout(self):
-        if sys.version_info[0] < 3:
-            return sys.stdin, sys.stdout
-        else:
-            return sys.stdin.buffer, sys.stdout.buffer
+        return sys.stdin.buffer, sys.stdout.buffer
 
     def _make_smart_server(self, host, port, inet, timeout):
         if timeout is None:

=== modified file 'breezy/bzr/smart/signals.py'
--- breezy/bzr/smart/signals.py	2018-11-11 04:08:32 +0000
+++ breezy/bzr/smart/signals.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Signal handling for the smart server code."""
 
-from __future__ import absolute_import
-
 import signal
 import weakref
 

=== modified file 'breezy/bzr/smart/vfs.py'
--- breezy/bzr/smart/vfs.py	2018-11-17 16:53:10 +0000
+++ breezy/bzr/smart/vfs.py	2020-02-18 01:57:45 +0000
@@ -24,8 +24,6 @@
 protocol, as implemented in bzr 0.11 and later.
 """
 
-from __future__ import absolute_import
-
 import os
 
 from ... import urlutils

=== modified file 'breezy/bzr/testament.py'
--- breezy/bzr/testament.py	2019-01-01 21:23:40 +0000
+++ breezy/bzr/testament.py	2020-02-18 01:57:45 +0000
@@ -59,8 +59,6 @@
 * the testament uses unix line-endings (\n)
 """
 
-from __future__ import absolute_import
-
 # XXX: At the moment, clients trust that the graph described in a weave
 # is accurate, but that's not covered by the testament.  Perhaps the best
 # fix is when verifying a revision to make sure that every file mentioned
@@ -78,7 +76,6 @@
     contains_linebreaks,
     sha_strings,
     )
-from ..sixish import text_type
 from ..tree import Tree
 
 
@@ -163,7 +160,7 @@
     def _escape_path(self, path):
         if contains_linebreaks(path):
             raise ValueError(path)
-        if not isinstance(path, text_type):
+        if not isinstance(path, str):
             # TODO(jelmer): Clean this up for pad.lv/1696545
             path = path.decode('ascii')
         return path.replace(u'\\', u'/').replace(u' ', u'\\ ')
@@ -245,7 +242,7 @@
     def _escape_path(self, path):
         if contains_linebreaks(path):
             raise ValueError(path)
-        if not isinstance(path, text_type):
+        if not isinstance(path, str):
             # TODO(jelmer): Clean this up for pad.lv/1696545
             path = path.decode('ascii')
         if path == u'':

=== modified file 'breezy/bzr/textinv.py'
--- breezy/bzr/textinv.py	2018-11-11 04:08:32 +0000
+++ breezy/bzr/textinv.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from .errors import BzrError
 from .inventory import Inventory
 

=== modified file 'breezy/bzr/versionedfile.py'
--- breezy/bzr/versionedfile.py	2020-02-09 01:27:02 +0000
+++ breezy/bzr/versionedfile.py	2020-02-18 01:57:45 +0000
@@ -16,9 +16,8 @@
 
 """Versioned text file storage api."""
 
-from __future__ import absolute_import
-
 from copy import copy
+from io import BytesIO
 import itertools
 import os
 import struct
@@ -46,12 +45,6 @@
     errors,
     )
 from ..registry import Registry
-from ..sixish import (
-    BytesIO,
-    viewitems,
-    viewvalues,
-    zip,
-    )
 from ..textmerge import TextMerge
 
 
@@ -327,7 +320,7 @@
         refcounts = {}
         setdefault = refcounts.setdefault
         just_parents = set()
-        for child_key, parent_keys in viewitems(parent_map):
+        for child_key, parent_keys in parent_map.items():
             if not parent_keys:
                 # parent_keys may be None if a given VersionedFile claims to
                 # not support graph operations.
@@ -1179,7 +1172,7 @@
             this_parent_map = self.get_parent_map(pending)
             parent_map.update(this_parent_map)
             pending = set(itertools.chain.from_iterable(
-                viewvalues(this_parent_map)))
+                this_parent_map.values()))
             pending.difference_update(parent_map)
         kg = _mod_graph.KnownGraph(parent_map)
         return kg
@@ -1393,11 +1386,11 @@
         """
         prefixes = self._partition_keys(keys)
         result = {}
-        for prefix, suffixes in viewitems(prefixes):
+        for prefix, suffixes in prefixes.items():
             path = self._mapper.map(prefix)
             vf = self._get_vf(path)
             parent_map = vf.get_parent_map(suffixes)
-            for key, parents in viewitems(parent_map):
+            for key, parents in parent_map.items():
                 result[prefix + (key,)] = tuple(
                     prefix + (parent,) for parent in parents)
         return result
@@ -1449,7 +1442,7 @@
     def _iter_keys_vf(self, keys):
         prefixes = self._partition_keys(keys)
         sha1s = {}
-        for prefix, suffixes in viewitems(prefixes):
+        for prefix, suffixes in prefixes.items():
             path = self._mapper.map(prefix)
             vf = self._get_vf(path)
             yield prefix, suffixes, vf
@@ -1459,7 +1452,7 @@
         sha1s = {}
         for prefix, suffixes, vf in self._iter_keys_vf(keys):
             vf_sha1s = vf.get_sha1s(suffixes)
-            for suffix, sha1 in viewitems(vf_sha1s):
+            for suffix, sha1 in vf_sha1s.items():
                 sha1s[prefix + (suffix,)] = sha1
         return sha1s
 
@@ -1659,7 +1652,7 @@
         result.update(
             _mod_graph.StackedParentsProvider(
                 self._providers).get_parent_map(keys))
-        for key, parents in viewitems(result):
+        for key, parents in result.items():
             if parents == ():
                 result[key] = (revision.NULL_REVISION,)
         return result
@@ -1838,7 +1831,7 @@
 
     def get_parent_map(self, keys):
         """See VersionedFiles.get_parent_map."""
-        parent_view = viewitems(self._get_parent_map(k for (k,) in keys))
+        parent_view = self._get_parent_map(k for (k,) in keys).items()
         return dict(((k,), tuple((p,) for p in v)) for k, v in parent_view)
 
     def get_sha1s(self, keys):
@@ -1995,7 +1988,7 @@
     # gc-optimal ordering is approximately reverse topological,
     # properly grouped by file-id.
     per_prefix_map = {}
-    for item in viewitems(parent_map):
+    for item in parent_map.items():
         key = item[0]
         if isinstance(key, bytes) or len(key) == 1:
             prefix = b''
@@ -2064,4 +2057,4 @@
             self._satisfy_refs_for_key(key)
 
     def get_referrers(self):
-        return set(itertools.chain.from_iterable(viewvalues(self.refs)))
+        return set(itertools.chain.from_iterable(self.refs.values()))

=== modified file 'breezy/bzr/vf_repository.py'
--- breezy/bzr/vf_repository.py	2020-02-09 01:16:06 +0000
+++ breezy/bzr/vf_repository.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,7 @@
 
 """Repository formats built around versioned files."""
 
-from __future__ import absolute_import
-
+from io import BytesIO
 
 from ..lazy_import import lazy_import
 lazy_import(globals(), """
@@ -77,12 +76,6 @@
     RepositoryFormatMetaDir,
     )
 
-from ..sixish import (
-    BytesIO,
-    range,
-    viewitems,
-    viewvalues,
-    )
 
 from ..trace import (
     mutter
@@ -422,7 +415,7 @@
         seen_root = False  # Is the root in the basis delta?
         inv_delta = self._basis_delta
         modified_rev = self._new_revision_id
-        for change, head_candidates in viewvalues(changes):
+        for change, head_candidates in changes.values():
             if change.versioned[1]:  # versioned in target.
                 # Several things may be happening here:
                 # We may have a fork in the per-file graph
@@ -1056,7 +1049,7 @@
         referrers = frozenset(r[0] for r in key_deps.get_referrers())
         file_ids = self.fileids_altered_by_revision_ids(referrers)
         missing_texts = set()
-        for file_id, version_ids in viewitems(file_ids):
+        for file_id, version_ids in file_ids.items():
             missing_texts.update(
                 (file_id, version_id) for version_id in version_ids)
         present_texts = self.texts.get_parent_map(missing_texts)
@@ -1232,7 +1225,7 @@
         """
         parent_map = self.revisions.get_parent_map(revision_keys)
         parent_keys = set(itertools.chain.from_iterable(
-            viewvalues(parent_map)))
+            parent_map.values()))
         parent_keys.difference_update(revision_keys)
         parent_keys.discard(_mod_revision.NULL_REVISION)
         return parent_keys
@@ -1312,7 +1305,7 @@
         # a cache of the text keys to allow reuse; costs a dict of all the
         # keys, but saves a 2-tuple for every child of a given key.
         text_key_cache = {}
-        for text_key, valid in viewitems(text_key_references):
+        for text_key, valid in text_key_references.items():
             if not valid:
                 invalid_keys.add(text_key)
             else:
@@ -1417,7 +1410,7 @@
         file_ids = self.fileids_altered_by_revision_ids(revision_ids, inv_w)
         count = 0
         num_file_ids = len(file_ids)
-        for file_id, altered_versions in viewitems(file_ids):
+        for file_id, altered_versions in file_ids.items():
             if pb is not None:
                 pb.update(gettext("Fetch texts"), count, num_file_ids)
             count += 1
@@ -1631,8 +1624,8 @@
                 raise ValueError('get_parent_map(None) is not valid')
             else:
                 query_keys.append((revision_id,))
-        for (revision_id,), parent_keys in viewitems(
-                self.revisions.get_parent_map(query_keys)):
+        for (revision_id,), parent_keys in (
+                self.revisions.get_parent_map(query_keys)).items():
             if parent_keys:
                 result[revision_id] = tuple([parent_revid
                                              for (parent_revid,) in parent_keys])
@@ -1657,8 +1650,8 @@
 
     def revision_ids_to_search_result(self, result_set):
         """Convert a set of revision ids to a graph SearchResult."""
-        result_parents = set(itertools.chain.from_iterable(viewvalues(
-            self.get_graph().get_parent_map(result_set))))
+        result_parents = set(itertools.chain.from_iterable(
+            self.get_graph().get_parent_map(result_set).values()))
         included_keys = result_set.intersection(result_parents)
         start_keys = result_set.difference(included_keys)
         exclude_keys = result_parents.difference(result_set)
@@ -2099,7 +2092,7 @@
             raise AssertionError(
                 'cannot copy revisions to fill in missing deltas %s' % (
                     keys['revisions'],))
-        for substream_kind, keys in viewitems(keys):
+        for substream_kind, keys in keys.items():
             vf = getattr(self.from_repository, substream_kind)
             if vf is None and keys:
                 raise AssertionError(
@@ -2582,8 +2575,8 @@
         source may be not have _fallback_repositories even though it is
         stacked.)
         """
-        parent_revs = set(itertools.chain.from_iterable(viewvalues(
-            parent_map)))
+        parent_revs = set(itertools.chain.from_iterable(
+            parent_map.values()))
         present_parents = self.source.get_parent_map(parent_revs)
         absent_parents = parent_revs.difference(present_parents)
         parent_invs_keys_for_stacking = self.source.inventories.get_parent_map(
@@ -2915,7 +2908,7 @@
         # commit to determine parents. There is a latent/real bug here where
         # the parents inserted are not those commit would do - in particular
         # they are not filtered by heads(). RBC, AB
-        for revision, tree in viewitems(parent_trees):
+        for revision, tree in parent_trees.items():
             try:
                 path = tree.id2path(ie.file_id)
             except errors.NoSuchId:

=== modified file 'breezy/bzr/vf_search.py'
--- breezy/bzr/vf_search.py	2018-11-11 04:08:32 +0000
+++ breezy/bzr/vf_search.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Searching in versioned file repositories."""
 
-from __future__ import absolute_import
-
 import itertools
 
 from .. import (
@@ -31,9 +29,6 @@
     Graph,
     invert_parent_map,
     )
-from ..sixish import (
-    viewvalues,
-    )
 
 
 class AbstractSearchResult(object):
@@ -386,7 +381,7 @@
     # start_set is all the keys in the cache
     start_set = set(parent_map)
     # result set is all the references to keys in the cache
-    result_parents = set(itertools.chain.from_iterable(viewvalues(parent_map)))
+    result_parents = set(itertools.chain.from_iterable(parent_map.values()))
     stop_keys = result_parents.difference(start_set)
     # We don't need to send ghosts back to the server as a position to
     # stop either.
@@ -424,14 +419,14 @@
             next_revs = next(s)
         except StopIteration:
             break
-        for parents in viewvalues(s._current_parents):
+        for parents in s._current_parents.values():
             f_heads = heads.intersection(parents)
             if f_heads:
                 found_heads.update(f_heads)
         stop_keys = exclude_keys.intersection(next_revs)
         if stop_keys:
             s.stop_searching_any(stop_keys)
-    for parents in viewvalues(s._current_parents):
+    for parents in s._current_parents.values():
         f_heads = heads.intersection(parents)
         if f_heads:
             found_heads.update(f_heads)

=== modified file 'breezy/bzr/weave.py'
--- breezy/bzr/weave.py	2020-01-30 16:08:42 +0000
+++ breezy/bzr/weave.py	2020-02-18 01:57:45 +0000
@@ -18,8 +18,6 @@
 
 """Weave - storage of related text file versions"""
 
-from __future__ import absolute_import
-
 # XXX: If we do weaves this way, will a merge still behave the same
 # way if it's done in a different order?  That's a pretty desirable
 # property.
@@ -67,6 +65,7 @@
 # FIXME: the conflict markers should be *7* characters
 
 from copy import copy
+from io import BytesIO
 import os
 import patiencediff
 
@@ -85,9 +84,6 @@
     )
 from ..osutils import dirname, sha, sha_strings, split_lines
 from ..revision import NULL_REVISION
-from ..sixish import (
-    BytesIO,
-    )
 from ..trace import mutter
 from .versionedfile import (
     AbsentContentFactory,

=== modified file 'breezy/bzr/weavefile.py'
--- breezy/bzr/weavefile.py	2018-11-11 04:08:32 +0000
+++ breezy/bzr/weavefile.py	2020-02-18 01:57:45 +0000
@@ -34,10 +34,6 @@
 line contains a newline, or ',' if not.
 """
 
-from __future__ import absolute_import
-
-from ..sixish import bytesintern
-
 # TODO: When extracting a single version it'd be enough to just pass
 # an iterator returning the weave lines...  We don't really need to
 # deserialize it into memory.
@@ -164,5 +160,5 @@
         elif l == b'}\n':
             w._weave.append((b'}', None))
         else:
-            w._weave.append((bytesintern(l[0:1]), int(l[2:].decode('ascii'))))
+            w._weave.append((l[0:1], int(l[2:].decode('ascii'))))
     return w

=== modified file 'breezy/bzr/workingtree.py'
--- breezy/bzr/workingtree.py	2020-01-30 16:13:31 +0000
+++ breezy/bzr/workingtree.py	2020-02-18 01:57:45 +0000
@@ -30,8 +30,6 @@
 """
 
 
-from __future__ import absolute_import
-
 from bisect import bisect_left
 import breezy
 try:
@@ -39,6 +37,7 @@
 except ImportError:  # python < 3.7
     from collections import deque
 import errno
+from io import BytesIO
 import itertools
 import operator
 import os
@@ -51,9 +50,9 @@
 
 from .. import lazy_import
 lazy_import.lazy_import(globals(), """
+import contextlib
 from breezy import (
     cache_utf8,
-    cleanup,
     conflicts as _mod_conflicts,
     globbing,
     ignores,
@@ -73,10 +72,6 @@
     )
 from ..lock import LogicalLockResult
 from .inventorytree import InventoryRevisionTree, MutableInventoryTree
-from ..sixish import (
-    BytesIO,
-    text_type,
-    )
 from ..trace import mutter, note
 from ..tree import (
     get_canonical_path,
@@ -384,7 +379,7 @@
         :force: Delete files and directories, even if they are changed and
             even if the directories are not empty.
         """
-        if isinstance(files, (str, text_type)):
+        if isinstance(files, str):
             files = [files]
 
         inv_delta = []
@@ -1028,7 +1023,7 @@
         :param from_dir: start from this directory or None for the root
         :param recursive: whether to recurse into subdirectories or not
         """
-        with cleanup.ExitStack() as exit_stack:
+        with contextlib.ExitStack() as exit_stack:
             exit_stack.enter_context(self.lock_read())
             if from_dir is None and include_root is True:
                 yield ('', 'V', 'directory', self.root_inventory.root)
@@ -1197,7 +1192,7 @@
         if to_dir is None:
             raise TypeError('You must supply a target directory')
         # check destination directory
-        if isinstance(from_paths, (str, text_type)):
+        if isinstance(from_paths, str):
             raise ValueError()
         with self.lock_tree_write():
             to_abs = self.abspath(to_dir)

=== modified file 'breezy/bzr/workingtree_3.py'
--- breezy/bzr/workingtree_3.py	2019-06-29 13:16:26 +0000
+++ breezy/bzr/workingtree_3.py	2020-02-18 01:57:45 +0000
@@ -18,8 +18,6 @@
 
 """
 
-from __future__ import absolute_import
-
 import errno
 
 from . import (

=== modified file 'breezy/bzr/workingtree_4.py'
--- breezy/bzr/workingtree_4.py	2020-02-08 22:40:33 +0000
+++ breezy/bzr/workingtree_4.py	2020-02-18 01:57:45 +0000
@@ -22,20 +22,18 @@
 WorkingTree.open(dir).
 """
 
-from __future__ import absolute_import
-
 from io import BytesIO
 import os
 
 from ..lazy_import import lazy_import
 lazy_import(globals(), """
+import contextlib
 import errno
 import stat
 
 from breezy import (
     branch as _mod_branch,
     cache_utf8,
-    cleanup,
     controldir,
     debug,
     filters as _mod_filters,
@@ -74,9 +72,6 @@
     realpath,
     safe_unicode,
     )
-from ..sixish import (
-    viewitems,
-    )
 from ..transport import get_transport_from_path
 from ..transport.local import LocalTransport
 from ..tree import (
@@ -700,7 +695,7 @@
 
             # GZ 2017-03-28: The rollbacks variable was shadowed in the loop below
             # missing those added here, but there's also no test coverage for this.
-            rollbacks = cleanup.ExitStack()
+            rollbacks = contextlib.ExitStack()
 
             def move_one(old_entry, from_path_utf8, minikind, executable,
                          fingerprint, packed_stat, size,
@@ -1044,7 +1039,7 @@
                     raise errors.PathsNotVersionedError(
                         [p.decode('utf-8') for p in paths])
 
-        for dir_name_id, trees_info in viewitems(found):
+        for dir_name_id, trees_info in found.items():
             for index in search_indexes:
                 if trees_info[index][0] not in (b'r', b'a'):
                     found_ids.add(dir_name_id[2])

=== modified file 'breezy/bzr/xml5.py'
--- breezy/bzr/xml5.py	2020-01-31 02:49:47 +0000
+++ breezy/bzr/xml5.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from .. import (
     cache_utf8,
     errors,

=== modified file 'breezy/bzr/xml6.py'
--- breezy/bzr/xml6.py	2018-05-13 02:18:13 +0000
+++ breezy/bzr/xml6.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from . import xml8
 
 

=== modified file 'breezy/bzr/xml7.py'
--- breezy/bzr/xml7.py	2018-11-10 17:52:47 +0000
+++ breezy/bzr/xml7.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from . import (
     xml6,
     )

=== modified file 'breezy/bzr/xml8.py'
--- breezy/bzr/xml8.py	2020-01-31 10:39:02 +0000
+++ breezy/bzr/xml8.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from io import BytesIO
 
 from .. import (
@@ -36,7 +34,6 @@
     unpack_inventory_flat,
     )
 from ..revision import Revision
-from ..sixish import unichr
 from ..errors import BzrError
 
 
@@ -56,7 +53,7 @@
     except KeyError:
         if not code.startswith(b'#'):
             raise
-        return unichr(int(code[1:])).encode('utf8')
+        return chr(int(code[1:])).encode('utf8')
 
 
 _unescape_re = lazy_regex.lazy_compile(b'\\&([^;]*);')

=== modified file 'breezy/bzr/xml_serializer.py'
--- breezy/bzr/xml_serializer.py	2020-01-31 10:39:02 +0000
+++ breezy/bzr/xml_serializer.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """XML externalization support."""
 
-from __future__ import absolute_import
-
 # "XML is like violence: if it doesn't solve your problem, you aren't
 # using enough of it." -- various
 
@@ -49,7 +47,6 @@
     errors,
     lazy_regex,
     )
-from ..sixish import text_type, bytesintern
 from . import (
     inventory,
     serializer,
@@ -144,10 +141,10 @@
     # This is fairly optimized because we know what cElementTree does, this is
     # not meant as a generic function for all cases. Because it is possible for
     # an 8-bit string to not be ascii or valid utf8.
-    if a_str.__class__ is text_type:
+    if a_str.__class__ is str:
         return _encode_utf8(a_str)
     else:
-        return bytesintern(a_str)
+        return a_str
 
 
 _utf8_re = lazy_regex.lazy_compile(b'[&<>\'\"]|[\x80-\xff]+')
@@ -206,7 +203,7 @@
     # to check if None, rather than try/KeyError
     text = _map.get(unicode_or_utf8_str)
     if text is None:
-        if isinstance(unicode_or_utf8_str, text_type):
+        if isinstance(unicode_or_utf8_str, str):
             # The alternative policy is to do a regular UTF8 encoding
             # and then escape only XML meta characters.
             # Performance is equivalent once you use cache_utf8. *However*

=== modified file 'breezy/bzr_distutils.py'
--- breezy/bzr_distutils.py	2018-11-11 04:08:32 +0000
+++ breezy/bzr_distutils.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 
 """build_mo command for setup.py"""
 
-from __future__ import absolute_import
-
 from distutils import log
 from distutils.core import Command
 from distutils.dep_util import newer

=== modified file 'breezy/cache_utf8.py'
--- breezy/cache_utf8.py	2018-11-11 04:08:32 +0000
+++ breezy/cache_utf8.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 
 """Some functions to enable caching the conversion between unicode to utf8"""
 
-from __future__ import absolute_import
-
 import codecs
 
 _utf8_encode = codecs.utf_8_encode

=== modified file 'breezy/cethread.py'
--- breezy/cethread.py	2018-11-12 01:41:38 +0000
+++ breezy/cethread.py	2020-02-18 01:57:45 +0000
@@ -14,15 +14,9 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import sys
 import threading
 
-from .sixish import (
-    reraise,
-)
-
 
 class CatchingExceptionThread(threading.Thread):
     """A thread that keeps track of exceptions.
@@ -145,7 +139,7 @@
             if (self.ignored_exceptions is None
                     or not self.ignored_exceptions(exc_value)):
                 # Raise non ignored exceptions
-                reraise(exc_class, exc_value, exc_tb)
+                raise exc_value
 
     def pending_exception(self):
         """Raise the caught exception.

=== modified file 'breezy/check.py'
--- breezy/check.py	2019-07-07 20:43:57 +0000
+++ breezy/check.py	2020-02-18 01:57:45 +0000
@@ -34,10 +34,9 @@
   indicating that the revision was found/not found.
 """
 
-from __future__ import absolute_import
+import contextlib
 
 from . import (
-    cleanup,
     errors,
     )
 from .controldir import ControlDir
@@ -101,7 +100,7 @@
     except errors.NotBranchError:
         base_tree = branch = repo = None
 
-    with cleanup.ExitStack() as exit_stack:
+    with contextlib.ExitStack() as exit_stack:
         needed_refs = {}
         if base_tree is not None:
             # If the tree is a lightweight checkout we won't see it in

=== modified file 'breezy/chunk_writer.py'
--- breezy/chunk_writer.py	2018-11-12 01:41:38 +0000
+++ breezy/chunk_writer.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """ChunkWriter: write compressed data out with a fixed upper bound."""
 
-from __future__ import absolute_import
-
 import zlib
 from zlib import Z_FINISH, Z_SYNC_FLUSH
 

=== modified file 'breezy/clean_tree.py'
--- breezy/clean_tree.py	2018-11-11 04:08:32 +0000
+++ breezy/clean_tree.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import errno
 import os
 import shutil

=== removed file 'breezy/cleanup.py'
--- breezy/cleanup.py	2019-07-07 17:17:45 +0000
+++ breezy/cleanup.py	1970-01-01 00:00:00 +0000
@@ -1,203 +0,0 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Helpers for managing cleanup functions and the errors they might raise.
-
-This currently just contains a copy of contextlib.ExitStack, available
-even on older versions of Python.
-"""
-
-from __future__ import absolute_import
-
-from collections import deque
-import sys
-
-
-try:
-    from contextlib import ExitStack
-except ImportError:
-    # Copied from the Python standard library on Python 3.4.
-    # Copyright: Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008,
-    #   2009, 2010, 2011 Python Software Foundation
-    #
-    # PYTHON SOFTWARE FOUNDATION LICENSE VERSION 2
-    # --------------------------------------------
-    # .
-    # 1. This LICENSE AGREEMENT is between the Python Software Foundation
-    # ("PSF"), and the Individual or Organization ("Licensee") accessing and
-    # otherwise using this software ("Python") in source or binary form and
-    # its associated documentation.
-    # .
-    # 2. Subject to the terms and conditions of this License Agreement, PSF hereby
-    # grants Licensee a nonexclusive, royalty-free, world-wide license to reproduce,
-    # analyze, test, perform and/or display publicly, prepare derivative works,
-    # distribute, and otherwise use Python alone or in any derivative version,
-    # provided, however, that PSF's License Agreement and PSF's notice of copyright,
-    # i.e., "Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010,
-    # 2011 Python Software Foundation; All Rights Reserved" are retained in Python
-    # alone or in any derivative version prepared by Licensee.
-    # .
-    # 3. In the event Licensee prepares a derivative work that is based on
-    # or incorporates Python or any part thereof, and wants to make
-    # the derivative work available to others as provided herein, then
-    # Licensee hereby agrees to include in any such work a brief summary of
-    # the changes made to Python.
-    # .
-    # 4. PSF is making Python available to Licensee on an "AS IS"
-    # basis.  PSF MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR
-    # IMPLIED.  BY WAY OF EXAMPLE, BUT NOT LIMITATION, PSF MAKES NO AND
-    # DISCLAIMS ANY REPRESENTATION OR WARRANTY OF MERCHANTABILITY OR FITNESS
-    # FOR ANY PARTICULAR PURPOSE OR THAT THE USE OF PYTHON WILL NOT
-    # INFRINGE ANY THIRD PARTY RIGHTS.
-    # .
-    # 5. PSF SHALL NOT BE LIABLE TO LICENSEE OR ANY OTHER USERS OF PYTHON
-    # FOR ANY INCIDENTAL, SPECIAL, OR CONSEQUENTIAL DAMAGES OR LOSS AS
-    # A RESULT OF MODIFYING, DISTRIBUTING, OR OTHERWISE USING PYTHON,
-    # OR ANY DERIVATIVE THEREOF, EVEN IF ADVISED OF THE POSSIBILITY THEREOF.
-    # .
-    # 6. This License Agreement will automatically terminate upon a material
-    # breach of its terms and conditions.
-    # .
-    # 7. Nothing in this License Agreement shall be deemed to create any
-    # relationship of agency, partnership, or joint venture between PSF and
-    # Licensee.  This License Agreement does not grant permission to use PSF
-    # trademarks or trade name in a trademark sense to endorse or promote
-    # products or services of Licensee, or any third party.
-    # .
-    # 8. By copying, installing or otherwise using Python, Licensee
-    # agrees to be bound by the terms and conditions of this License
-    # Agreement.
-
-    def _reraise_with_existing_context(exc_details):
-        # Use 3 argument raise in Python 2,
-        # but use exec to avoid SyntaxError in Python 3
-        exc_type, exc_value, exc_tb = exc_details
-        exec("raise exc_type, exc_value, exc_tb")
-
-
-    # Inspired by discussions on http://bugs.python.org/issue13585
-    class ExitStack(object):
-        """Context manager for dynamic management of a stack of exit callbacks
-
-        For example:
-
-            with ExitStack() as stack:
-                files = [stack.enter_context(open(fname)) for fname in filenames]
-                # All opened files will automatically be closed at the end of
-                # the with statement, even if attempts to open files later
-                # in the list raise an exception
-
-        """
-        def __init__(self):
-            self._exit_callbacks = deque()
-
-        def pop_all(self):
-            """Preserve the context stack by transferring it to a new instance"""
-            new_stack = type(self)()
-            new_stack._exit_callbacks = self._exit_callbacks
-            self._exit_callbacks = deque()
-            return new_stack
-
-        def _push_cm_exit(self, cm, cm_exit):
-            """Helper to correctly register callbacks to __exit__ methods"""
-            def _exit_wrapper(*exc_details):
-                return cm_exit(cm, *exc_details)
-            _exit_wrapper.__self__ = cm
-            self.push(_exit_wrapper)
-
-        def push(self, exit):
-            """Registers a callback with the standard __exit__ method signature
-
-            Can suppress exceptions the same way __exit__ methods can.
-
-            Also accepts any object with an __exit__ method (registering a call
-            to the method instead of the object itself)
-            """
-            # We use an unbound method rather than a bound method to follow
-            # the standard lookup behaviour for special methods
-            _cb_type = type(exit)
-            try:
-                exit_method = _cb_type.__exit__
-            except AttributeError:
-                # Not a context manager, so assume its a callable
-                self._exit_callbacks.append(exit)
-            else:
-                self._push_cm_exit(exit, exit_method)
-            return exit # Allow use as a decorator
-
-        def callback(self, callback, *args, **kwds):
-            """Registers an arbitrary callback and arguments.
-
-            Cannot suppress exceptions.
-            """
-            def _exit_wrapper(exc_type, exc, tb):
-                callback(*args, **kwds)
-            # We changed the signature, so using @wraps is not appropriate, but
-            # setting __wrapped__ may still help with introspection
-            _exit_wrapper.__wrapped__ = callback
-            self.push(_exit_wrapper)
-            return callback # Allow use as a decorator
-
-        def enter_context(self, cm):
-            """Enters the supplied context manager
-
-            If successful, also pushes its __exit__ method as a callback and
-            returns the result of the __enter__ method.
-            """
-            # We look up the special methods on the type to match the with statement
-            _cm_type = type(cm)
-            _exit = _cm_type.__exit__
-            result = _cm_type.__enter__(cm)
-            self._push_cm_exit(cm, _exit)
-            return result
-
-        def close(self):
-            """Immediately unwind the context stack"""
-            self.__exit__(None, None, None)
-
-        def __enter__(self):
-            return self
-
-        def __exit__(self, *exc_details):
-            received_exc = exc_details[0] is not None
-
-            # We manipulate the exception state so it behaves as though
-            # we were actually nesting multiple with statements
-            frame_exc = sys.exc_info()[1]
-            def _make_context_fixer(frame_exc):
-                return lambda new_exc, old_exc: None
-            _fix_exception_context = _make_context_fixer(frame_exc)
-
-            # Callbacks are invoked in LIFO order to match the behaviour of
-            # nested context managers
-            suppressed_exc = False
-            pending_raise = False
-            while self._exit_callbacks:
-                cb = self._exit_callbacks.pop()
-                try:
-                    if cb(*exc_details):
-                        suppressed_exc = True
-                        pending_raise = False
-                        exc_details = (None, None, None)
-                except:
-                    new_exc_details = sys.exc_info()
-                    # simulate the stack of exceptions by setting the context
-                    _fix_exception_context(new_exc_details[1], exc_details[1])
-                    pending_raise = True
-                    exc_details = new_exc_details
-            if pending_raise:
-                _reraise_with_existing_context(exc_details)
-            return received_exc and suppressed_exc

=== modified file 'breezy/cmd_test_script.py'
--- breezy/cmd_test_script.py	2018-11-11 04:08:32 +0000
+++ breezy/cmd_test_script.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 This module should be importable even if testtools aren't available.
 """
 
-from __future__ import absolute_import
-
 import os
 
 from . import (

=== modified file 'breezy/cmd_version_info.py'
--- breezy/cmd_version_info.py	2020-01-11 17:41:33 +0000
+++ breezy/cmd_version_info.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Commands for generating snapshot information about a brz tree."""
 
-from __future__ import absolute_import
-
 from .lazy_import import lazy_import
 
 lazy_import(globals(), """
@@ -34,7 +32,6 @@
     )
 from .commands import Command
 from .option import Option, RegistryOption
-from .sixish import text_type
 
 
 def _parse_version_info_format(format):
@@ -87,7 +84,7 @@
                             help='Include the revision-history.'),
                      Option('include-file-revisions',
                             help='Include the last revision for each file.'),
-                     Option('template', type=text_type,
+                     Option('template', type=str,
                             help='Template for the output.'),
                      'revision',
                      ]

=== modified file 'breezy/cmdline.py'
--- breezy/cmdline.py	2018-11-12 01:41:38 +0000
+++ breezy/cmdline.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 configuring_bazaar.txt.
 """
 
-from __future__ import absolute_import
-
 import re
 
 

=== modified file 'breezy/colordiff.py'
--- breezy/colordiff.py	2020-01-31 02:31:42 +0000
+++ breezy/colordiff.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import re
 import sys
 from os.path import expanduser

=== modified file 'breezy/commands.py'
--- breezy/commands.py	2020-02-07 01:01:54 +0000
+++ breezy/commands.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 # TODO: Define arguments by objects, rather than just using names.
 # Those objects can specify the expected type of the argument, which
 # would help with validation and shell completion.  They could also provide
@@ -23,6 +21,7 @@
 
 # TODO: Specific "examples" property on commands for consistent formatting.
 
+import contextlib
 import os
 import sys
 
@@ -38,7 +37,6 @@
 
 import breezy
 from breezy import (
-    cleanup,
     cmdline,
     debug,
     trace,
@@ -52,9 +50,6 @@
 from .option import Option
 from .plugin import disable_plugins, load_plugins, plugin_name
 from . import errors, registry
-from .sixish import (
-    string_types,
-    )
 
 
 class BzrOptionError(errors.BzrCommandError):
@@ -716,7 +711,7 @@
         r = Option.STD_OPTIONS.copy()
         std_names = set(r)
         for o in self.takes_options:
-            if isinstance(o, string_types):
+            if isinstance(o, str):
                 o = option.Option.OPTIONS[o]
             r[o.name] = o
             if o.name in std_names:
@@ -783,7 +778,7 @@
             for hook in Command.hooks['pre_command']:
                 hook(self)
             try:
-                with cleanup.ExitStack() as self._exit_stack:
+                with contextlib.ExitStack() as self._exit_stack:
                     return class_run(*args, **kwargs)
             finally:
                 for hook in Command.hooks['post_command']:
@@ -1264,11 +1259,8 @@
     try:
         # ensure all arguments are unicode strings
         for a in argv:
-            if not isinstance(a, string_types):
+            if not isinstance(a, str):
                 raise ValueError('not native str or unicode: %r' % (a,))
-            if isinstance(a, bytes):
-                # For Python 2 only allow ascii native strings
-                a = a.decode('ascii')
             new_argv.append(a)
     except (ValueError, UnicodeDecodeError):
         raise errors.BzrError("argv should be list of unicode strings.")

=== modified file 'breezy/commit.py'
--- breezy/commit.py	2019-09-21 17:08:09 +0000
+++ breezy/commit.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 # The newly committed revision is going to have a shape corresponding
 # to that of the working tree.  Files that are not in the
 # working tree and that were in the predecessor are reported as
@@ -57,7 +55,7 @@
     ui,
     )
 from .branch import Branch
-from .cleanup import ExitStack
+from contextlib import ExitStack
 import breezy.config
 from .errors import (BzrError,
                      ConflictsInTree,

=== modified file 'breezy/commit_signature_commands.py'
--- breezy/commit_signature_commands.py	2019-05-29 03:22:34 +0000
+++ breezy/commit_signature_commands.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Command that signs unsigned commits by the current user. """
 
-from __future__ import absolute_import
-
 from . import (
     controldir,
     errors,
@@ -28,7 +26,6 @@
 from .commands import Command
 from .option import Option
 from .i18n import gettext, ngettext
-from .sixish import text_type
 
 
 class cmd_sign_my_commits(Command):
@@ -102,7 +99,7 @@
                help='Comma separated list of GPG key patterns which are'
                ' acceptable for verification.',
                short_name='k',
-               type=text_type,),
+               type=str,),
         'revision',
         'verbose',
         ]

=== modified file 'breezy/config.py'
--- breezy/config.py	2019-07-07 18:58:10 +0000
+++ breezy/config.py	2020-02-18 01:57:45 +0000
@@ -74,11 +74,11 @@
 up=pull
 """
 
-from __future__ import absolute_import
 import os
 import sys
 
 import configobj
+from io import BytesIO
 
 import breezy
 from .lazy_import import lazy_import
@@ -115,13 +115,6 @@
     lazy_regex,
     registry,
     )
-from .sixish import (
-    binary_type,
-    BytesIO,
-    PY3,
-    string_types,
-    text_type,
-    )
 
 
 CHECK_IF_POSSIBLE = 0
@@ -258,19 +251,6 @@
                      % signature_string)
 
 
-def _has_decode_bug():
-    """True if configobj will fail to decode to unicode on Python 2."""
-    if PY3:
-        return False
-    conf = configobj.ConfigObj()
-    decode = getattr(conf, "_decode", None)
-    if decode:
-        result = decode(b"\xc2\xa7", "utf-8")
-        if isinstance(result[0], str):
-            return True
-    return False
-
-
 def _has_triplequote_bug():
     """True if triple quote logic is reversed, see lp:710410."""
     conf = configobj.ConfigObj()
@@ -288,12 +268,6 @@
                                         interpolation=False,
                                         **kwargs)
 
-    if _has_decode_bug():
-        def _decode(self, infile, encoding):
-            if isinstance(infile, str) and encoding:
-                return infile.decode(encoding).splitlines(True)
-            return super(ConfigObj, self)._decode(infile, encoding)
-
     if _has_triplequote_bug():
         def _get_triple_quote(self, value):
             quot = super(ConfigObj, self)._get_triple_quote(value)
@@ -520,7 +494,7 @@
             otherwise.
         """
         l = self.get_user_option(option_name, expand=expand)
-        if isinstance(l, string_types):
+        if isinstance(l, str):
             # A single value, most probably the user forgot (or didn't care to
             # add) the final ','
             l = [l]
@@ -563,8 +537,6 @@
         """
         v = os.environ.get('BRZ_EMAIL')
         if v:
-            if not PY3:
-                v = v.decode(osutils.get_user_encoding())
             return v
         v = self._get_user_id()
         if v:
@@ -730,7 +702,7 @@
         return conf
 
     def _create_from_string(self, str_or_unicode, save):
-        if isinstance(str_or_unicode, text_type):
+        if isinstance(str_or_unicode, str):
             str_or_unicode = str_or_unicode.encode('utf-8')
         self._content = BytesIO(str_or_unicode)
         # Some tests use in-memory configs, some other always need the config
@@ -2129,7 +2101,7 @@
                 raise AssertionError(
                     'Only empty lists are supported as default values')
             self.default = u','
-        elif isinstance(default, (binary_type, text_type, bool, int, float)):
+        elif isinstance(default, (bytes, str, bool, int, float)):
             # Rely on python to convert strings, booleans and integers
             self.default = u'%s' % (default,)
         elif callable(default):
@@ -2176,8 +2148,6 @@
             try:
                 # If the env variable is defined, its value takes precedence
                 value = os.environ[var]
-                if not PY3:
-                    value = value.decode(osutils.get_user_encoding())
                 break
             except KeyError:
                 continue
@@ -2189,8 +2159,6 @@
             try:
                 # If the env variable is defined, its value is the default one
                 value = os.environ[var]
-                if not PY3:
-                    value = value.decode(osutils.get_user_encoding())
                 break
             except KeyError:
                 continue
@@ -2198,7 +2166,7 @@
             # Otherwise, fallback to the value defined at registration
             if callable(self.default):
                 value = self.default()
-                if not isinstance(value, text_type):
+                if not isinstance(value, str):
                     raise AssertionError(
                         "Callable default value for '%s' should be unicode"
                         % (self.name))
@@ -2283,7 +2251,7 @@
             invalid=invalid, unquote=False)
 
     def from_unicode(self, unicode_str):
-        if not isinstance(unicode_str, string_types):
+        if not isinstance(unicode_str, str):
             raise TypeError
         # Now inject our string directly as unicode. All callers got their
         # value from configobj, so values that need to be quoted are already
@@ -2291,7 +2259,7 @@
         _list_converter_config.reset()
         _list_converter_config._parse([u"list=%s" % (unicode_str,)])
         maybe_list = _list_converter_config['list']
-        if isinstance(maybe_list, string_types):
+        if isinstance(maybe_list, str):
             if maybe_list:
                 # A single value, most probably the user forgot (or didn't care
                 # to add) the final ','
@@ -2323,7 +2291,7 @@
         self.registry = registry
 
     def from_unicode(self, unicode_str):
-        if not isinstance(unicode_str, string_types):
+        if not isinstance(unicode_str, str):
             raise TypeError
         try:
             return self.registry.get(unicode_str)
@@ -3082,7 +3050,7 @@
             self._config_obj.list_values = False
 
     def unquote(self, value):
-        if value and isinstance(value, string_types):
+        if value and isinstance(value, str):
             # _unquote doesn't handle None nor empty strings nor anything that
             # is not a string, really.
             value = self._config_obj._unquote(value)
@@ -3499,7 +3467,7 @@
             # None or ends up being None during expansion or conversion.
             if val is not None:
                 if expand:
-                    if isinstance(val, string_types):
+                    if isinstance(val, str):
                         val = self._expand_options_in_string(val)
                     else:
                         trace.warning('Cannot expand "%s":'
@@ -3906,7 +3874,7 @@
         # http://pad.lv/788991 -- vila 20101115
         commands.Option('scope', help='Reduce the scope to the specified'
                         ' configuration file.',
-                        type=text_type),
+                        type=str),
         commands.Option('all',
                         help='Display all the defined values for the matching options.',
                         ),

=== modified file 'breezy/conflicts.py'
--- breezy/conflicts.py	2020-01-11 17:41:33 +0000
+++ breezy/conflicts.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 # TODO: 'brz resolve' should accept a directory name and work from that
 # point down
 
-from __future__ import absolute_import
-
 import os
 import re
 
@@ -42,7 +40,6 @@
     option,
     registry,
     )
-from .sixish import text_type
 
 
 CONFLICT_SUFFIXES = ('.THIS', '.BASE', '.OTHER')
@@ -77,7 +74,7 @@
                     continue
                 self.outf.write(conflict.path + '\n')
             else:
-                self.outf.write(text_type(conflict) + '\n')
+                self.outf.write(str(conflict) + '\n')
 
 
 resolve_action_registry = registry.Registry()
@@ -154,7 +151,7 @@
                     before - after)
                 trace.note(gettext('Remaining conflicts:'))
                 for conflict in tree.conflicts():
-                    trace.note(text_type(conflict))
+                    trace.note(str(conflict))
                 return 1
             else:
                 trace.note(gettext('All conflicts resolved.'))
@@ -289,7 +286,7 @@
     def to_strings(self):
         """Generate strings for the provided conflicts"""
         for conflict in self:
-            yield text_type(conflict)
+            yield str(conflict)
 
     def remove_files(self, tree):
         """Remove the THIS, BASE and OTHER files for listed conflicts"""
@@ -362,7 +359,7 @@
         self.path = path
         # the factory blindly transfers the Stanza values to __init__ and
         # Stanza is purely a Unicode api.
-        if isinstance(file_id, text_type):
+        if isinstance(file_id, str):
             file_id = cache_utf8.encode(file_id)
         self.file_id = osutils.safe_file_id(file_id)
 
@@ -736,7 +733,7 @@
         self.conflict_path = conflict_path
         # the factory blindly transfers the Stanza values to __init__,
         # so they can be unicode.
-        if isinstance(conflict_file_id, text_type):
+        if isinstance(conflict_file_id, str):
             conflict_file_id = cache_utf8.encode(conflict_file_id)
         self.conflict_file_id = osutils.safe_file_id(conflict_file_id)
 

=== modified file 'breezy/controldir.py'
--- breezy/controldir.py	2020-02-18 03:11:01 +0000
+++ breezy/controldir.py	2020-02-21 03:58:42 +0000
@@ -22,8 +22,6 @@
 
 """
 
-from __future__ import absolute_import
-
 from .lazy_import import lazy_import
 lazy_import(globals(), """
 import textwrap

=== modified file 'breezy/counted_lock.py'
--- breezy/counted_lock.py	2018-11-18 19:48:57 +0000
+++ breezy/counted_lock.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Counted lock class"""
 
-from __future__ import absolute_import
-
 from . import (
     errors,
     )

=== modified file 'breezy/crash.py'
--- breezy/crash.py	2019-06-16 01:03:51 +0000
+++ breezy/crash.py	2020-02-18 01:57:45 +0000
@@ -36,14 +36,13 @@
 -Dno_apport.
 """
 
-from __future__ import absolute_import
-
 # for interactive testing, try the 'brz assert-fail' command
 # or see http://code.launchpad.net/~mbp/bzr/bzr-fail
 #
 # to test with apport it's useful to set
 # export APPORT_IGNORE_OBSOLETE_PACKAGES=1
 
+from io import StringIO
 import os
 import platform
 import pprint
@@ -58,9 +57,6 @@
     plugin,
     trace,
     )
-from .sixish import (
-    StringIO,
-    )
 
 
 def report_bug(exc_info, stderr):

=== modified file 'breezy/debug.py'
--- breezy/debug.py	2017-07-30 16:59:50 +0000
+++ breezy/debug.py	2020-02-18 01:57:45 +0000
@@ -23,8 +23,6 @@
 for a list of the available options.
 """
 
-from __future__ import absolute_import
-
 debug_flags = set()
 
 

=== modified file 'breezy/decorators.py'
--- breezy/decorators.py	2018-07-24 21:11:49 +0000
+++ breezy/decorators.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from . import trace
 
 

=== modified file 'breezy/delta.py'
--- breezy/delta.py	2019-09-21 23:05:12 +0000
+++ breezy/delta.py	2020-02-18 01:57:45 +0000
@@ -14,15 +14,12 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
+from io import StringIO
 
 from breezy import (
     osutils,
     trace,
     )
-from .sixish import (
-    StringIO,
-    )
 from .tree import TreeChange
 
 

=== modified file 'breezy/diff.py'
--- breezy/diff.py	2020-01-11 17:41:33 +0000
+++ breezy/diff.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
+import contextlib
 import difflib
 import os
 import re
@@ -29,7 +28,6 @@
 import tempfile
 
 from breezy import (
-    cleanup,
     controldir,
     osutils,
     textfile,
@@ -47,7 +45,6 @@
 from .registry import (
     Registry,
     )
-from .sixish import text_type
 from .trace import mutter, note, warning
 from .tree import FileTimestampUnavailable
 
@@ -519,7 +516,7 @@
         context = DEFAULT_CONTEXT_AMOUNT
     if format_cls is None:
         format_cls = DiffTree
-    with cleanup.ExitStack() as exit_stack:
+    with contextlib.ExitStack() as exit_stack:
         exit_stack.enter_context(old_tree.lock_read())
         if extra_trees is not None:
             for tree in extra_trees:
@@ -802,7 +799,7 @@
         if sys.platform == 'win32':  # Popen doesn't accept unicode on win32
             command_encoded = []
             for c in command:
-                if isinstance(c, text_type):
+                if isinstance(c, str):
                     command_encoded.append(c.encode('mbcs'))
                 else:
                     command_encoded.append(c)

=== modified file 'breezy/directory_service.py'
--- breezy/directory_service.py	2019-03-02 22:31:28 +0000
+++ breezy/directory_service.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 to true URLs.  Examples include lp:urls and per-user location aliases.
 """
 
-from __future__ import absolute_import
-
 from . import (
     errors,
     registry,

=== modified file 'breezy/doc/__init__.py'
--- breezy/doc/__init__.py	2017-05-23 14:08:03 +0000
+++ breezy/doc/__init__.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 for man page generation.
 """
 
-from __future__ import absolute_import
-
 
 def load_tests(loader, basic_tests, pattern):
     suite = loader.suiteClass()

=== modified file 'breezy/doc/api/__init__.py'
--- breezy/doc/api/__init__.py	2017-05-23 14:08:03 +0000
+++ breezy/doc/api/__init__.py	2020-02-18 01:57:45 +0000
@@ -24,8 +24,6 @@
 For details on specific apis, see pydoc on the api, or read the source.
 """
 
-from __future__ import absolute_import
-
 import doctest
 import os
 

=== modified file 'breezy/doc/api/branch.txt'
--- breezy/doc/api/branch.txt	2018-02-17 03:16:35 +0000
+++ breezy/doc/api/branch.txt	2020-02-07 02:14:30 +0000
@@ -26,7 +26,7 @@
 A branch has a history of revisions on it:
 
    >>> new_branch.last_revision()
-   'null:'
+   b'null:'
 
 We need to write some more documentation, showing
 push and pull operations. Cloning might also be nice.

=== modified file 'breezy/doc_generate/__init__.py'
--- breezy/doc_generate/__init__.py	2017-05-30 21:42:49 +0000
+++ breezy/doc_generate/__init__.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import datetime
 import os
 

=== modified file 'breezy/doc_generate/autodoc_bash_completion.py'
--- breezy/doc_generate/autodoc_bash_completion.py	2018-11-11 04:08:32 +0000
+++ breezy/doc_generate/autodoc_bash_completion.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 "bash_completion.py - create bash completion script from built-in brz help"
 
-from __future__ import absolute_import
-
 import breezy
 import breezy.help
 import breezy.commands

=== modified file 'breezy/doc_generate/autodoc_man.py'
--- breezy/doc_generate/autodoc_man.py	2018-11-11 04:08:32 +0000
+++ breezy/doc_generate/autodoc_man.py	2020-02-18 01:57:45 +0000
@@ -21,8 +21,6 @@
   * add command aliases
 """
 
-from __future__ import absolute_import
-
 PLUGINS_TO_DOCUMENT = ["launchpad"]
 
 import textwrap

=== modified file 'breezy/doc_generate/autodoc_rstx.py'
--- breezy/doc_generate/autodoc_rstx.py	2019-01-03 01:23:19 +0000
+++ breezy/doc_generate/autodoc_rstx.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 Written by the Bazaar/Breezy community.
 """
 
-from __future__ import absolute_import
-
 import time
 
 import breezy

=== modified file 'breezy/doc_generate/conf.py'
--- breezy/doc_generate/conf.py	2018-11-18 21:24:22 +0000
+++ breezy/doc_generate/conf.py	2020-02-18 01:57:45 +0000
@@ -6,8 +6,6 @@
 # All configuration values have a default; values that are commented out
 # serve to show the default.
 
-from __future__ import absolute_import
-
 # FIXME: better move the content of doc/en/conf.py here and cleanup the result
 # -- vila 20100428
 

=== modified file 'breezy/email_message.py'
--- breezy/email_message.py	2018-11-11 04:08:32 +0000
+++ breezy/email_message.py	2020-02-18 01:57:45 +0000
@@ -16,28 +16,14 @@
 
 """A convenience class around email.Message and email.MIMEMultipart."""
 
-from __future__ import absolute_import
-
-try:
-    from email.message import Message
-    from email.header import Header
-    from email.mime.multipart import MIMEMultipart
-    from email.mime.text import MIMEText
-    from email.utils import formataddr, parseaddr
-except ImportError:   # python < 3
-    from email import (
-        Header,
-        Message,
-        MIMEMultipart,
-        MIMEText,
-        )
-    from email.Utils import formataddr, parseaddr
+from email.message import Message
+from email.header import Header
+from email.mime.multipart import MIMEMultipart
+from email.mime.text import MIMEText
+from email.utils import formataddr, parseaddr
 from . import __version__ as _breezy_version
 from .errors import BzrBadParameterNotUnicode
 from .osutils import safe_unicode
-from .sixish import (
-    text_type,
-    )
 from .smtp_connection import SMTPConnection
 
 
@@ -70,7 +56,7 @@
         self._body = body
         self._parts = []
 
-        if isinstance(to_address, (bytes, text_type)):
+        if isinstance(to_address, (bytes, str)):
             to_address = [to_address]
 
         to_addresses = []
@@ -180,7 +166,7 @@
         :param address: An unicode string, or UTF-8 byte string.
         :return: A possibly RFC2047-encoded string.
         """
-        if not isinstance(address, (str, text_type)):
+        if not isinstance(address, str):
             raise BzrBadParameterNotUnicode(address)
         # Can't call Header over all the address, because that encodes both the
         # name and the email address, which is not permitted by RFCs.
@@ -204,7 +190,7 @@
         # avoid base64 when it's not necessary in order to be most compatible
         # with the capabilities of the receiving side, we check with encode()
         # and decode() whether the body is actually ascii-only.
-        if isinstance(string_, text_type):
+        if isinstance(string_, str):
             try:
                 return (string_.encode('ascii'), 'ascii')
             except UnicodeEncodeError:

=== modified file 'breezy/errors.py'
--- breezy/errors.py	2020-01-11 17:41:33 +0000
+++ breezy/errors.py	2020-02-18 01:57:45 +0000
@@ -17,11 +17,6 @@
 """Exceptions for bzr, and reporting of them.
 """
 
-from __future__ import absolute_import
-
-from .sixish import (
-    PY3,
-    )
 
 # TODO: is there any value in providing the .args field used by standard
 # python exceptions?   A list of values with no names seems less useful
@@ -108,13 +103,7 @@
                getattr(self, '_fmt', None),
                err)
 
-    if PY3:
-        __str__ = _format
-    else:
-        def __str__(self):
-            return self._format().encode('utf-8')
-
-        __unicode__ = _format
+    __str__ = _format
 
     def __repr__(self):
         return '%s(%s)' % (self.__class__.__name__, str(self))
@@ -182,15 +171,6 @@
         self.transport = transport
 
 
-class InvalidEntryName(InternalBzrError):
-
-    _fmt = "Invalid entry name: %(name)s"
-
-    def __init__(self, name):
-        BzrError.__init__(self)
-        self.name = name
-
-
 class InvalidRevisionNumber(BzrError):
 
     _fmt = "Invalid revision number %(revno)s"

=== modified file 'breezy/estimate_compressed_size.py'
--- breezy/estimate_compressed_size.py	2018-11-11 04:08:32 +0000
+++ breezy/estimate_compressed_size.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Code to estimate the entropy of content"""
 
-from __future__ import absolute_import
-
 import zlib
 
 

=== modified file 'breezy/export.py'
--- breezy/export.py	2019-01-13 18:33:39 +0000
+++ breezy/export.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 """Export trees to tarballs, non-controlled directories, zipfiles, etc.
 """
 
-from __future__ import absolute_import
-
 import errno
 import os
 import sys

=== modified file 'breezy/export_pot.py'
--- breezy/export_pot.py	2020-02-07 00:50:28 +0000
+++ breezy/export_pot.py	2020-02-18 01:57:45 +0000
@@ -26,8 +26,6 @@
 is also left to that stage of the process.
 """
 
-from __future__ import absolute_import
-
 import inspect
 import os
 import sys
@@ -40,7 +38,6 @@
     option,
     plugin as _mod_plugin,
     )
-from .sixish import PY3
 from .trace import (
     mutter,
     note,
@@ -159,8 +156,6 @@
             "msgstr \"\"\n"
             "\n".format(
                 path=path, lineno=lineno, comment=comment, msg=_normalize(s)))
-        if not PY3:
-            line = line.decode('utf-8')
         self.outf.write(line)
 
     def poentry_in_context(self, context, string, comment=None):

=== modified file 'breezy/externalcommand.py'
--- breezy/externalcommand.py	2018-11-11 04:08:32 +0000
+++ breezy/externalcommand.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 # TODO: Perhaps rather than mapping options and arguments back and
 # forth, we should just pass in the whole argv, and allow
 # ExternalCommands to handle it differently to internal commands?

=== modified file 'breezy/fetch_ghosts.py'
--- breezy/fetch_ghosts.py	2019-06-29 19:54:32 +0000
+++ breezy/fetch_ghosts.py	2020-02-18 01:57:45 +0000
@@ -14,9 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
+import contextlib
 
-from . import cleanup
 from .branch import Branch
 from .trace import note
 from .errors import NoSuchRevision, BzrCommandError
@@ -43,7 +42,7 @@
 
     def run(self):
         lock_other = self.this_branch.base != self.other_branch.base
-        with cleanup.ExitStack() as exit_stack:
+        with contextlib.ExitStack() as exit_stack:
             exit_stack.enter_context(self.this_branch.lock_write())
             if lock_other:
                 exit_stack.enter_context(self.other_branch.lock_read())

=== modified file 'breezy/fifo_cache.py'
--- breezy/fifo_cache.py	2018-11-11 04:08:32 +0000
+++ breezy/fifo_cache.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """A simple first-in-first-out (FIFO) cache."""
 
-from __future__ import absolute_import, division
-
 from collections import deque
 
 

=== modified file 'breezy/filter_tree.py'
--- breezy/filter_tree.py	2020-01-10 01:40:18 +0000
+++ breezy/filter_tree.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 """Content-filtered view of any tree.
 """
 
-from __future__ import absolute_import
-
 from io import BytesIO
 
 from . import (

=== modified file 'breezy/filters/__init__.py'
--- breezy/filters/__init__.py	2020-01-30 17:54:42 +0000
+++ breezy/filters/__init__.py	2020-02-18 01:57:45 +0000
@@ -38,7 +38,6 @@
 Note that context is currently only supported for write converters.
 """
 
-from __future__ import absolute_import
 
 from io import (
     BytesIO,

=== modified file 'breezy/filters/eol.py'
--- breezy/filters/eol.py	2018-11-11 04:08:32 +0000
+++ breezy/filters/eol.py	2020-02-18 01:57:45 +0000
@@ -19,9 +19,6 @@
 See bzr help eol for details.
 """
 
-from __future__ import absolute_import
-
-
 import re
 import sys
 

=== modified file 'breezy/foreign.py'
--- breezy/foreign.py	2020-01-11 17:50:28 +0000
+++ breezy/foreign.py	2020-02-18 01:57:45 +0000
@@ -16,9 +16,6 @@
 
 """Foreign branch utilities."""
 
-from __future__ import absolute_import
-
-
 from .branch import (
     Branch,
     )

=== modified file 'breezy/git/__init__.py'
--- breezy/git/__init__.py	2020-01-12 13:56:10 +0000
+++ breezy/git/__init__.py	2020-02-18 01:57:45 +0000
@@ -22,8 +22,6 @@
 
 """A GIT branch and repository format implementation for bzr."""
 
-from __future__ import absolute_import
-
 import os
 import sys
 

=== modified file 'breezy/git/annotate.py'
--- breezy/git/annotate.py	2020-02-09 01:27:02 +0000
+++ breezy/git/annotate.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Annotate."""
 
-from __future__ import absolute_import
-
 from dulwich.object_store import (
     tree_lookup_path,
     )

=== modified file 'breezy/git/branch.py'
--- breezy/git/branch.py	2020-02-19 06:17:02 +0000
+++ breezy/git/branch.py	2020-02-21 03:58:42 +0000
@@ -17,8 +17,8 @@
 
 """An adapter between a Git Branch and a Bazaar Branch"""
 
-from __future__ import absolute_import
 
+import contextlib
 from io import BytesIO
 from collections import defaultdict
 
@@ -35,7 +35,6 @@
 
 from .. import (
     branch,
-    cleanup,
     config,
     controldir,
     errors,
@@ -50,10 +49,6 @@
 from ..revision import (
     NULL_REVISION,
     )
-from ..sixish import (
-    text_type,
-    viewitems,
-    )
 from ..tag import (
     Tags,
     InterTags,
@@ -239,7 +234,7 @@
             master = None
         else:
             master = self.target.branch.get_master_branch()
-        with cleanup.ExitStack() as es:
+        with contextlib.ExitStack() as es:
             if master is not None:
                 es.enter_context(master.lock_write())
             updates, conflicts = self._merge_to(
@@ -327,7 +322,7 @@
 
     def _set_tag_dict(self, to_dict):
         extra = set(self.refs.allkeys())
-        for k, revid in viewitems(to_dict):
+        for k, revid in to_dict.items():
             name = tag_name_to_ref(k)
             if name in extra:
                 extra.remove(name)
@@ -849,7 +844,7 @@
         :return: iterator over (ref_name, tag_name, peeled_sha1, unpeeled_sha1)
         """
         refs = self.repository.controldir.get_refs_container()
-        for ref_name, unpeeled in viewitems(refs.as_dict()):
+        for ref_name, unpeeled in refs.as_dict().items():
             try:
                 tag_name = ref_to_tag_name(ref_name)
             except (ValueError, UnicodeDecodeError):
@@ -857,7 +852,7 @@
             peeled = refs.get_peeled(ref_name)
             if peeled is None:
                 peeled = unpeeled
-            if not isinstance(tag_name, text_type):
+            if not isinstance(tag_name, str):
                 raise TypeError(tag_name)
             yield (ref_name, tag_name, peeled, unpeeled)
 
@@ -1101,7 +1096,7 @@
         if local and not bound_location:
             raise errors.LocalRequiresBoundBranch()
         source_is_master = False
-        with cleanup.ExitStack() as es:
+        with contextlib.ExitStack() as es:
             es.enter_context(self.source.lock_read())
             if bound_location:
                 # bound_location comes from a config file, some care has to be
@@ -1192,8 +1187,8 @@
                     raise errors.DivergedBranches(self.source, self.target)
             refs = {self.target.ref: new_ref}
             result.new_revid = stop_revision
-            for name, sha in viewitems(
-                    self.source.repository._git.refs.as_dict(b"refs/tags")):
+            for name, sha in (
+                    self.source.repository._git.refs.as_dict(b"refs/tags").items()):
                 if tag_selector and not tag_selector(name):
                     continue
                 if sha not in self.source.repository._git:
@@ -1358,7 +1353,7 @@
         if fetch_tags is None:
             c = self.source.get_config_stack()
             fetch_tags = c.get('branch.fetch_tags')
-        for name, revid in viewitems(self.source.tags.get_tag_dict()):
+        for name, revid in self.source.tags.get_tag_dict().items():
             if self.source.repository.has_revision(revid):
                 ref = tag_name_to_ref(name)
                 if not check_ref_format(ref):
@@ -1395,7 +1390,7 @@
             # updated that hasn't actually been updated.
             return False
         # FIXME: Check for diverged branches
-        for ref, (git_sha, revid) in viewitems(new_refs):
+        for ref, (git_sha, revid) in new_refs.items():
             if ref_equals(ret, ref, git_sha, revid):
                 # Already up to date
                 if git_sha is None:
@@ -1434,7 +1429,7 @@
             stop_revision = self.source.last_revision()
         ret = []
         if fetch_tags:
-            for k, v in viewitems(self.source.tags.get_tag_dict()):
+            for k, v in self.source.tags.get_tag_dict().items():
                 ret.append((None, v))
         ret.append((None, stop_revision))
         try:

=== modified file 'breezy/git/cache.py'
--- breezy/git/cache.py	2019-06-16 01:03:51 +0000
+++ breezy/git/cache.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Map from Git sha's to Bazaar objects."""
 
-from __future__ import absolute_import
-
 from dulwich.objects import (
     sha_to_hex,
     hex_to_sha,
@@ -41,11 +39,6 @@
     index as _mod_index,
     versionedfile,
     )
-from ..sixish import (
-    viewitems,
-    viewkeys,
-    viewvalues,
-    )
 from ..transport import (
     get_transport_from_path,
     )
@@ -336,7 +329,7 @@
     def lookup_git_sha(self, sha):
         if not isinstance(sha, bytes):
             raise TypeError(sha)
-        for entry in viewvalues(self._by_sha[sha]):
+        for entry in self._by_sha[sha].values():
             yield entry
 
     def lookup_tree_id(self, fileid, revision):
@@ -346,13 +339,13 @@
         return self._by_revid[revid]
 
     def revids(self):
-        for key, entries in viewitems(self._by_sha):
-            for (type, type_data) in viewvalues(entries):
+        for key, entries in self._by_sha.items():
+            for (type, type_data) in entries.values():
                 if type == "commit":
                     yield type_data[0]
 
     def sha1s(self):
-        return viewkeys(self._by_sha)
+        return self._by_sha.keys()
 
 
 class SqliteCacheUpdater(CacheUpdater):
@@ -711,10 +704,7 @@
         return ret
 
     def _keys(self):
-        try:
-            return self.db.keys()
-        except AttributeError:  # python < 3
-            return self.db.iterkeys()
+        return self.db.keys()
 
     def revids(self):
         """List the revision ids known."""

=== modified file 'breezy/git/commands.py'
--- breezy/git/commands.py	2020-01-20 00:51:05 +0000
+++ breezy/git/commands.py	2020-02-18 01:57:45 +0000
@@ -21,8 +21,6 @@
 
 """Git-specific subcommands for Bazaar."""
 
-from __future__ import absolute_import
-
 import breezy.bzr  # noqa: F401
 from breezy import controldir
 from ..commands import (
@@ -33,10 +31,6 @@
     Option,
     RegistryOption,
     )
-from ..sixish import (
-    text_type,
-    viewitems,
-    )
 
 
 class cmd_git_import(Command):
@@ -141,7 +135,7 @@
         mapping = source_repo.get_mapping()
         result = interrepo.fetch()
         with ui.ui_factory.nested_progress_bar() as pb:
-            for i, (name, sha) in enumerate(viewitems(result.refs)):
+            for i, (name, sha) in enumerate(result.refs.items()):
                 try:
                     branch_name = ref_to_branch_name(name)
                 except ValueError:
@@ -186,7 +180,7 @@
     takes_args = ["sha1?"]
     takes_options = [Option('directory',
                             short_name='d',
-                            help='Location of repository.', type=text_type),
+                            help='Location of repository.', type=str),
                      Option('pretty', help='Pretty-print objects.')]
     encoding_type = 'exact'
 
@@ -247,7 +241,7 @@
         object_store = get_object_store(repo)
         with object_store.lock_read():
             refs = get_refs_container(controldir, object_store)
-            for k, v in sorted(viewitems(refs.as_dict())):
+            for k, v in sorted(refs.as_dict().items()):
                 self.outf.write("%s -> %s\n" %
                                 (k.decode('utf-8'), v.decode('utf-8')))
 
@@ -304,7 +298,7 @@
 
     takes_options = [Option('directory',
                             short_name='d',
-                            help='Location of repository.', type=text_type)]
+                            help='Location of repository.', type=str)]
     takes_args = ['target', 'package']
 
     def run(self, target, package, directory='.'):

=== modified file 'breezy/git/commit.py'
--- breezy/git/commit.py	2020-01-30 15:48:47 +0000
+++ breezy/git/commit.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Support for committing in native Git working trees."""
 
-from __future__ import absolute_import
-
 from dulwich.index import (
     commit_tree,
     )
@@ -39,9 +37,6 @@
 from ..repository import (
     CommitBuilder,
     )
-from ..sixish import (
-    viewitems,
-    )
 
 from dulwich.objects import (
     Blob,
@@ -155,12 +150,11 @@
 
     def finish_inventory(self):
         # eliminate blobs that were removed
-        self._blobs = {k: v for (k, v) in viewitems(
-            self._blobs) if v is not None}
+        self._blobs = {k: v for (k, v) in self._blobs.items() if v is not None}
 
     def _iterblobs(self):
         return ((path, sha, mode) for (path, (mode, sha))
-                in viewitems(self._blobs))
+                in self._blobs.items())
 
     def commit(self, message):
         self._validate_unicode_text(message, 'commit message')

=== modified file 'breezy/git/config.py'
--- breezy/git/config.py	2020-03-21 23:20:27 +0000
+++ breezy/git/config.py	2020-03-22 01:35:14 +0000
@@ -16,8 +16,6 @@
 
 """Config file handling for Git."""
 
-from __future__ import absolute_import
-
 from .. import (
     config,
     )

=== modified file 'breezy/git/dir.py'
--- breezy/git/dir.py	2020-02-19 04:50:09 +0000
+++ breezy/git/dir.py	2020-02-21 03:58:42 +0000
@@ -17,20 +17,15 @@
 
 """An adapter between a Git control dir and a Bazaar ControlDir."""
 
-from __future__ import absolute_import
+import contextlib
 
 from .. import (
     branch as _mod_branch,
-    cleanup,
     errors as brz_errors,
     trace,
     osutils,
     urlutils,
     )
-from ..sixish import (
-    PY3,
-    viewitems,
-    )
 from ..transport import (
     do_catching_redirections,
     get_transport_from_path,
@@ -192,7 +187,7 @@
         else:
             wt = None
         if recurse == 'down':
-            with cleanup.ExitStack() as stack:
+            with contextlib.ExitStack() as stack:
                 basis = None
                 if wt is not None:
                     basis = wt.basis_tree()
@@ -251,7 +246,7 @@
             determine_wants = interrepo.determine_wants_all
         (pack_hint, _, refs) = interrepo.fetch_objects(determine_wants,
                                                        mapping=default_mapping)
-        for name, val in viewitems(refs):
+        for name, val in refs.items():
             target_git_repo.refs[name] = val
         result_dir = self.__class__(transport, target_git_repo, format)
         if revision_id is not None:
@@ -567,8 +562,6 @@
             else:
                 base_url = urlutils.local_path_to_url(
                     commondir.decode(osutils._fs_enc)).rstrip('/.git/') + '/'
-            if not PY3:
-                params = {k: v.encode('utf-8') for (k, v) in viewitems(params)}
             return urlutils.join_segment_parameters(base_url, params)
         return None
 

=== modified file 'breezy/git/directory.py'
--- breezy/git/directory.py	2019-02-09 02:59:15 +0000
+++ breezy/git/directory.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Directory service for gitorious."""
 
-from __future__ import absolute_import
-
 from .. import transport
 
 transport.register_urlparse_netloc_protocol('github')

=== modified file 'breezy/git/errors.py'
--- breezy/git/errors.py	2019-11-03 00:17:16 +0000
+++ breezy/git/errors.py	2020-02-18 01:57:45 +0000
@@ -15,11 +15,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-
 """A grouping of Exceptions for bzr-git"""
 
-from __future__ import absolute_import
-
 from dulwich import errors as git_errors
 
 from .. import errors as brz_errors

=== modified file 'breezy/git/fetch.py'
--- breezy/git/fetch.py	2020-02-09 17:10:01 +0000
+++ breezy/git/fetch.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Fetching from git into bzr."""
 
-from __future__ import absolute_import
-
 from dulwich.objects import (
     Commit,
     Tag,
@@ -51,7 +49,6 @@
     NULL_REVISION,
     )
 from ..bzr.inventorytree import InventoryRevisionTree
-from ..sixish import text_type
 from ..bzr.testament import (
     StrictTestament3,
     )
@@ -218,7 +215,7 @@
     :param lookup_object: Lookup a git object by its SHA1
     :return: Inventory delta, as list
     """
-    if not isinstance(path, text_type):
+    if not isinstance(path, str):
         raise TypeError(path)
     ret = []
     for name, mode, hexsha in base_tree.iteritems():

=== modified file 'breezy/git/filegraph.py'
--- breezy/git/filegraph.py	2019-10-20 23:33:25 +0000
+++ breezy/git/filegraph.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """File graph access."""
 
-from __future__ import absolute_import
-
 import stat
 
 from dulwich.errors import (

=== modified file 'breezy/git/git-remote-bzr'
--- breezy/git/git-remote-bzr	2020-01-31 17:43:44 +0000
+++ breezy/git/git-remote-bzr	2020-02-07 02:14:30 +0000
@@ -32,8 +32,6 @@
 import breezy
 breezy.initialize()
 
-from breezy.sixish import PY3
-
 from breezy.plugin import load_plugins
 load_plugins()
 
@@ -48,7 +46,4 @@
 (shortname, url) = args
 
 helper = RemoteHelper(open_local_dir(), shortname, open_remote_dir(url))
-if PY3:
-    helper.process(sys.stdin.buffer, sys.stdout.buffer)
-else:
-    helper.process(sys.stdin, sys.stdout)
+helper.process(sys.stdin.buffer, sys.stdout.buffer)

=== modified file 'breezy/git/git_remote_helper.py'
--- breezy/git/git_remote_helper.py	2020-01-31 17:43:44 +0000
+++ breezy/git/git_remote_helper.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 
 """Remote helper for git for accessing bzr repositories."""
 
-from __future__ import absolute_import
-
 CAPABILITIES = ["fetch", "option", "push"]
 
 import os
@@ -29,7 +27,6 @@
 from ..controldir import ControlDir
 from ..errors import NotBranchError, NoRepositoryPresent
 from ..repository import InterRepository
-from ..sixish import viewitems
 from ..transport import get_transport_from_path
 
 from . import (
@@ -121,7 +118,7 @@
         object_store = get_object_store(repo)
         with object_store.lock_read():
             refs = get_refs_container(self.remote_dir, object_store)
-            for ref, git_sha1 in viewitems(refs.as_dict()):
+            for ref, git_sha1 in refs.as_dict().items():
                 ref = ref.replace(b"~", b"_")
                 outf.write(b"%s %s\n" % (git_sha1, ref))
             outf.write(b"\n")

=== modified file 'breezy/git/help.py'
--- breezy/git/help.py	2018-03-26 22:28:24 +0000
+++ breezy/git/help.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Help information."""
 
-from __future__ import absolute_import
-
 help_git = """Using Bazaar with Git.
 
 The bzr-git plugin provides support for using Bazaar with local and remote

=== modified file 'breezy/git/hg.py'
--- breezy/git/hg.py	2018-11-11 04:08:32 +0000
+++ breezy/git/hg.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Compatibility for hg-git."""
 
-from __future__ import absolute_import
-
 import urllib
 
 

=== modified file 'breezy/git/interrepo.py'
--- breezy/git/interrepo.py	2020-02-18 03:11:01 +0000
+++ breezy/git/interrepo.py	2020-02-21 03:58:42 +0000
@@ -16,8 +16,6 @@
 
 """InterRepository operations."""
 
-from __future__ import absolute_import
-
 from io import BytesIO
 import itertools
 
@@ -52,10 +50,6 @@
 from ..revision import (
     NULL_REVISION,
     )
-from ..sixish import (
-    viewitems,
-    viewvalues,
-    )
 from .. import (
     config,
     trace,
@@ -229,7 +223,7 @@
                         new_stop_revids.append(revid)
                 stop_revids = set()
                 parent_map = graph.get_parent_map(new_stop_revids)
-                for parent_revids in viewvalues(parent_map):
+                for parent_revids in parent_map.values():
                     stop_revids.update(parent_revids)
                 pb.update("determining revisions to fetch", len(missing))
         return graph.iter_topo_order(missing)
@@ -272,7 +266,7 @@
                  for (git_sha, bzr_revid) in new_refs.values()
                  if git_sha is None or not git_sha.startswith(SYMREF)],
                 lossy=lossy)
-            for name, (gitid, revid) in viewitems(new_refs):
+            for name, (gitid, revid) in new_refs.items():
                 if gitid is None:
                     try:
                         gitid = revidmap[revid][0]
@@ -362,9 +356,9 @@
         def git_update_refs(old_refs):
             ret = {}
             self.old_refs = {
-                k: (v, None) for (k, v) in viewitems(old_refs)}
+                k: (v, None) for (k, v) in old_refs.items()}
             new_refs = update_refs(self.old_refs)
-            for name, (gitid, revid) in viewitems(new_refs):
+            for name, (gitid, revid) in new_refs.items():
                 if gitid is None:
                     git_sha = self.source_store._lookup_revision_sha1(revid)
                     gitid = unpeel_map.re_unpeel_tag(
@@ -415,12 +409,12 @@
 
         def determine_wants(refs):
             unpeel_lookup = {}
-            for k, v in viewitems(refs):
+            for k, v in refs.items():
                 if k.endswith(ANNOTATED_TAG_SUFFIX):
                     unpeel_lookup[v] = refs[k[:-len(ANNOTATED_TAG_SUFFIX)]]
             potential = set([unpeel_lookup.get(w, w) for w in wants])
             if include_tags:
-                for k, sha in viewitems(refs):
+                for k, sha in refs.items():
                     if k.endswith(ANNOTATED_TAG_SUFFIX):
                         continue
                     try:
@@ -463,8 +457,8 @@
             if if_present_ids is not None:
                 todo.update(if_present_ids)
         result_set = todo.difference(self.target.all_revision_ids())
-        result_parents = set(itertools.chain.from_iterable(viewvalues(
-            self.source.get_graph().get_parent_map(result_set))))
+        result_parents = set(itertools.chain.from_iterable(
+            self.source.get_graph().get_parent_map(result_set).values()))
         included_keys = result_set.intersection(result_parents)
         start_keys = result_set.difference(included_keys)
         exclude_keys = result_parents.difference(result_set)
@@ -489,7 +483,7 @@
 
     def determine_wants_all(self, refs):
         potential = set()
-        for k, v in viewitems(refs):
+        for k, v in refs.items():
             # For non-git target repositories, only worry about peeled
             if v == ZERO_SHA:
                 continue
@@ -563,7 +557,7 @@
         all_revs = self.target.all_revision_ids()
         parent_map = self.target.get_parent_map(all_revs)
         all_parents = set()
-        for values in viewvalues(parent_map):
+        for values in parent_map.values():
             all_parents.update(values)
         return set(all_revs) - all_parents
 
@@ -647,12 +641,12 @@
 
         def determine_wants(heads):
             old_refs = dict([(k, (v, None))
-                             for (k, v) in viewitems(heads.as_dict())])
+                             for (k, v) in heads.as_dict().items()])
             new_refs = update_refs(old_refs)
             ref_changes.update(new_refs)
-            return [sha1 for (sha1, bzr_revid) in viewvalues(new_refs)]
+            return [sha1 for (sha1, bzr_revid) in new_refs.values()]
         self.fetch_objects(determine_wants, lossy=lossy)
-        for k, (git_sha, bzr_revid) in viewitems(ref_changes):
+        for k, (git_sha, bzr_revid) in ref_changes.items():
             self.target._git.refs[k] = git_sha
         new_refs = self.target.controldir.get_refs_container()
         return None, old_refs, new_refs
@@ -706,7 +700,7 @@
     def get_determine_wants_branches(self, branches, include_tags=False):
         def determine_wants(refs):
             ret = []
-            for name, value in viewitems(refs):
+            for name, value in refs.items():
                 if value == ZERO_SHA:
                     continue
 

=== modified file 'breezy/git/mapping.py'
--- breezy/git/mapping.py	2019-10-28 01:38:39 +0000
+++ breezy/git/mapping.py	2020-02-18 01:57:45 +0000
@@ -18,8 +18,6 @@
 
 """Converters, etc for going between Bazaar and Git ids."""
 
-from __future__ import absolute_import
-
 import base64
 import stat
 
@@ -39,11 +37,6 @@
     NULL_REVISION,
     Revision,
     )
-from ..sixish import (
-    PY3,
-    text_type,
-    viewitems,
-    )
 from .errors import (
     NoPushSupport,
     )
@@ -175,7 +168,7 @@
     def generate_file_id(self, path):
         # Git paths are just bytestrings
         # We must just hope they are valid UTF-8..
-        if isinstance(path, text_type):
+        if isinstance(path, str):
             path = path.encode("utf-8")
         if path == b"":
             return ROOT_ID
@@ -191,8 +184,7 @@
     def revid_as_refname(self, revid):
         if not isinstance(revid, bytes):
             raise TypeError(revid)
-        if PY3:
-            revid = revid.decode('utf-8')
+        revid = revid.decode('utf-8')
         quoted_revid = urlutils.quote(revid)
         return b"refs/bzr/" + quoted_revid.encode('utf-8')
 
@@ -252,11 +244,11 @@
         (message, renames, branch, extra) = extract_hg_metadata(message)
         if branch is not None:
             rev.properties[u'hg:extra:branch'] = branch
-        for name, value in viewitems(extra):
+        for name, value in extra.items():
             rev.properties[u'hg:extra:' + name] = base64.b64encode(value)
         if renames:
             rev.properties[u'hg:renames'] = base64.b64encode(bencode.bencode(
-                [(new, old) for (old, new) in viewitems(renames)]))
+                [(new, old) for (old, new) in renames.items()]))
         return message
 
     def _extract_bzr_metadata(self, rev, message):
@@ -347,7 +339,7 @@
                  u'commit-timezone-neg-utc', u'git-implicit-encoding',
                  u'git-gpg-signature', u'git-explicit-encoding',
                  u'author-timestamp', u'file-modes'])
-            for k, v in viewitems(rev.properties):
+            for k, v in rev.properties.items():
                 if k not in mapping_properties:
                     metadata.properties[k] = v
         if not lossy and metadata:
@@ -574,7 +566,7 @@
 def symlink_to_blob(symlink_target):
     from dulwich.objects import Blob
     blob = Blob()
-    if isinstance(symlink_target, text_type):
+    if isinstance(symlink_target, str):
         symlink_target = symlink_target.encode('utf-8')
     blob.data = symlink_target
     return blob

=== modified file 'breezy/git/memorytree.py'
--- breezy/git/memorytree.py	2019-06-29 15:50:22 +0000
+++ breezy/git/memorytree.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Git Memory Trees."""
 
-from __future__ import absolute_import
-
 import os
 import posixpath
 import stat

=== modified file 'breezy/git/object_store.py'
--- breezy/git/object_store.py	2020-02-09 17:10:01 +0000
+++ breezy/git/object_store.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Map from Git sha's to Bazaar objects."""
 
-from __future__ import absolute_import
-
 from dulwich.objects import (
     Blob,
     Commit,
@@ -46,7 +44,6 @@
 from ..revision import (
     NULL_REVISION,
     )
-from ..sixish import viewitems
 from ..tree import InterTree
 from ..bzr.testament import (
     StrictTestament3,
@@ -400,7 +397,7 @@
 
     def __iter__(self):
         return ((self.store[object_id], path) for (object_id, path) in
-                viewitems(self.objects))
+                self.objects.items())
 
 
 class BazaarObjectStore(BaseObjectStore):

=== modified file 'breezy/git/pristine_tar.py'
--- breezy/git/pristine_tar.py	2018-11-11 14:23:06 +0000
+++ breezy/git/pristine_tar.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Support for pristine tar deltas."""
 
-from __future__ import absolute_import
-
 from base64 import (
     standard_b64decode,
     )

=== modified file 'breezy/git/push.py'
--- breezy/git/push.py	2018-11-11 14:23:06 +0000
+++ breezy/git/push.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Basic push implementation."""
 
-from __future__ import absolute_import
-
 from ..push import (
     PushResult,
     )

=== modified file 'breezy/git/refs.py'
--- breezy/git/refs.py	2018-11-11 14:23:06 +0000
+++ breezy/git/refs.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Conversion between refs and Bazaar revision pointers."""
 
-from __future__ import absolute_import
-
 from dulwich.refs import (
     ANNOTATED_TAG_SUFFIX,
     LOCAL_BRANCH_PREFIX,

=== modified file 'breezy/git/remote.py'
--- breezy/git/remote.py	2020-02-21 06:28:55 +0000
+++ breezy/git/remote.py	2020-03-07 14:46:08 +0000
@@ -16,8 +16,6 @@
 
 """Remote dirs, repositories and branches."""
 
-from __future__ import absolute_import
-
 import gzip
 from io import BytesIO
 import re
@@ -50,10 +48,6 @@
     )
 from ..revision import NULL_REVISION
 from ..revisiontree import RevisionTree
-from ..sixish import (
-    text_type,
-    viewitems,
-    )
 from ..transport import (
     Transport,
     register_urlparse_netloc_protocol,
@@ -123,12 +117,8 @@
 import select
 import tempfile
 
-try:
-    import urllib.parse as urlparse
-    from urllib.parse import splituser
-except ImportError:
-    import urlparse
-    from urllib import splituser
+import urllib.parse as urlparse
+from urllib.parse import splituser
 
 # urlparse only supports a limited number of schemes by default
 register_urlparse_netloc_protocol('git')
@@ -599,7 +589,7 @@
                         source, self.open_branch(name, nascent_ok=True))
             ret[actual_refname] = new_sha
             if fetch_tags:
-                for tagname, revid in viewitems(source.tags.get_tag_dict()):
+                for tagname, revid in source.tags.get_tag_dict().items():
                     if tag_selector and not tag_selector(tagname):
                         continue
                     if lossy:
@@ -1009,7 +999,7 @@
             if peeled is None:
                 # Let's just hope it's a commit
                 peeled = unpeeled
-            if not isinstance(tag_name, text_type):
+            if not isinstance(tag_name, str):
                 raise TypeError(tag_name)
             yield (ref_name, tag_name, peeled, unpeeled)
 

=== modified file 'breezy/git/repository.py'
--- breezy/git/repository.py	2020-01-30 15:48:47 +0000
+++ breezy/git/repository.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """An adapter between a Git Repository and a Bazaar Branch"""
 
-from __future__ import absolute_import
-
 from .. import (
     check,
     errors,
@@ -34,10 +32,6 @@
 from ..foreign import (
     ForeignRepository,
     )
-from ..sixish import (
-    viewitems,
-    viewvalues,
-    )
 
 from .commit import (
     GitCommitBuilder,
@@ -298,7 +292,7 @@
         for (file_id, revision_id, identifier) in desired_files:
             per_revision.setdefault(revision_id, []).append(
                 (file_id, identifier))
-        for revid, files in viewitems(per_revision):
+        for revid, files in per_revision.items():
             try:
                 (commit_id, mapping) = self.lookup_bzr_revision_id(revid)
             except errors.NoSuchRevision:
@@ -410,7 +404,7 @@
                     this_parent_map[revid] = parents
             parent_map.update(this_parent_map)
             pending = set()
-            for values in viewvalues(this_parent_map):
+            for values in this_parent_map.values():
                 pending.update(values)
             pending = pending.difference(parent_map)
         return _mod_graph.KnownGraph(parent_map)

=== modified file 'breezy/git/revspec.py'
--- breezy/git/revspec.py	2019-06-02 05:13:10 +0000
+++ breezy/git/revspec.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Custom revision specifier for Subversion."""
 
-from __future__ import absolute_import
-
 # Please note that imports are delayed as much as possible here since
 # if DWIM revspecs are supported this module is imported by __init__.py.
 

=== modified file 'breezy/git/roundtrip.py'
--- breezy/git/roundtrip.py	2019-06-29 15:50:22 +0000
+++ breezy/git/roundtrip.py	2020-02-18 01:57:45 +0000
@@ -45,8 +45,6 @@
   * TreeSupplement
 """
 
-from __future__ import absolute_import
-
 from .. import osutils
 
 from io import BytesIO

=== modified file 'breezy/git/send.py'
--- breezy/git/send.py	2019-10-20 15:03:13 +0000
+++ breezy/git/send.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 
 """Support in "brz send" for git-am style patches."""
 
-from __future__ import absolute_import
-
 import time
 from .. import __version__ as brz_version
 from .. import (

=== modified file 'breezy/git/server.py'
--- breezy/git/server.py	2018-11-11 14:23:06 +0000
+++ breezy/git/server.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from dulwich.server import TCPGitServer
 
 import sys

=== modified file 'breezy/git/tests/__init__.py'
--- breezy/git/tests/__init__.py	2020-01-24 00:06:05 +0000
+++ breezy/git/tests/__init__.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """The basic test suite for bzr-git."""
 
-from __future__ import absolute_import
-
 from io import BytesIO
 
 import time

=== modified file 'breezy/git/tests/test_blackbox.py'
--- breezy/git/tests/test_blackbox.py	2020-03-21 20:56:33 +0000
+++ breezy/git/tests/test_blackbox.py	2020-03-22 01:35:14 +0000
@@ -17,8 +17,6 @@
 
 """Black-box tests for bzr-git."""
 
-from __future__ import absolute_import
-
 from dulwich.repo import (
     Repo as GitRepo,
     )

=== modified file 'breezy/git/tests/test_branch.py'
--- breezy/git/tests/test_branch.py	2020-01-24 00:06:05 +0000
+++ breezy/git/tests/test_branch.py	2020-02-18 01:57:45 +0000
@@ -18,8 +18,6 @@
 
 """Tests for interfacing with a Git Branch"""
 
-from __future__ import absolute_import
-
 import dulwich
 from dulwich.objects import (
     Commit,

=== modified file 'breezy/git/tests/test_builder.py'
--- breezy/git/tests/test_builder.py	2018-11-11 04:08:32 +0000
+++ breezy/git/tests/test_builder.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Test our ability to build up test repositories"""
 
-from __future__ import absolute_import
-
 from io import BytesIO
 
 from dulwich.repo import Repo as GitRepo

=== modified file 'breezy/git/tests/test_cache.py'
--- breezy/git/tests/test_cache.py	2018-11-11 04:08:32 +0000
+++ breezy/git/tests/test_cache.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Tests for GitShaMap."""
 
-from __future__ import absolute_import
-
 from dulwich.objects import (
     Blob,
     Commit,

=== modified file 'breezy/git/tests/test_dir.py'
--- breezy/git/tests/test_dir.py	2019-12-26 13:20:45 +0000
+++ breezy/git/tests/test_dir.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Test the GitDir class"""
 
-from __future__ import absolute_import
-
 from dulwich.repo import Repo as GitRepo
 import os
 

=== modified file 'breezy/git/tests/test_fetch.py'
--- breezy/git/tests/test_fetch.py	2020-01-24 02:05:10 +0000
+++ breezy/git/tests/test_fetch.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Tests from fetching from git into bzr."""
 
-from __future__ import absolute_import
-
 from dulwich.objects import (
     Blob,
     Tag,

=== modified file 'breezy/git/tests/test_git_remote_helper.py'
--- breezy/git/tests/test_git_remote_helper.py	2020-01-31 17:43:44 +0000
+++ breezy/git/tests/test_git_remote_helper.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 
 """Tests for the git remote helper."""
 
-from __future__ import absolute_import
-
 from io import BytesIO
 import os
 import subprocess

=== modified file 'breezy/git/tests/test_mapping.py'
--- breezy/git/tests/test_mapping.py	2019-10-28 01:38:39 +0000
+++ breezy/git/tests/test_mapping.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Tests for mapping."""
 
-from __future__ import absolute_import
-
 from ...revision import (
     Revision,
     )

=== modified file 'breezy/git/tests/test_object_store.py'
--- breezy/git/tests/test_object_store.py	2019-05-28 23:34:07 +0000
+++ breezy/git/tests/test_object_store.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Tests for bzr-git's object store."""
 
-from __future__ import absolute_import
-
 import os
 import shutil
 import stat

=== modified file 'breezy/git/tests/test_pristine_tar.py'
--- breezy/git/tests/test_pristine_tar.py	2018-11-11 04:08:32 +0000
+++ breezy/git/tests/test_pristine_tar.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Tests for pristine tar extraction code."""
 
-from __future__ import absolute_import
-
 from base64 import standard_b64encode
 
 from ..pristine_tar import (

=== modified file 'breezy/git/tests/test_push.py'
--- breezy/git/tests/test_push.py	2018-11-11 04:08:32 +0000
+++ breezy/git/tests/test_push.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Tests for pushing revisions from Bazaar into Git."""
 
-from __future__ import absolute_import
-
 from ...controldir import (
     format_registry,
     )

=== modified file 'breezy/git/tests/test_refs.py'
--- breezy/git/tests/test_refs.py	2018-11-11 04:08:32 +0000
+++ breezy/git/tests/test_refs.py	2020-02-18 01:57:45 +0000
@@ -18,8 +18,6 @@
 
 """Tests for ref handling."""
 
-from __future__ import absolute_import
-
 from ... import tests
 
 from ..object_store import BazaarObjectStore

=== modified file 'breezy/git/tests/test_remote.py'
--- breezy/git/tests/test_remote.py	2020-02-08 18:51:59 +0000
+++ breezy/git/tests/test_remote.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Test the smart client."""
 
-from __future__ import absolute_import
-
 from io import BytesIO
 
 import os

=== modified file 'breezy/git/tests/test_repository.py'
--- breezy/git/tests/test_repository.py	2019-06-29 13:16:26 +0000
+++ breezy/git/tests/test_repository.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Tests for interfacing with a Git Repository"""
 
-from __future__ import absolute_import
-
 import dulwich
 from dulwich.repo import (
     Repo as GitRepo,

=== modified file 'breezy/git/tests/test_revspec.py'
--- breezy/git/tests/test_revspec.py	2019-02-03 01:42:11 +0000
+++ breezy/git/tests/test_revspec.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Test the git revision specifiers."""
 
-from __future__ import absolute_import
-
 from ...tests import TestCase
 
 from ..revspec import (

=== modified file 'breezy/git/tests/test_roundtrip.py'
--- breezy/git/tests/test_roundtrip.py	2019-06-29 15:50:22 +0000
+++ breezy/git/tests/test_roundtrip.py	2020-02-18 01:57:45 +0000
@@ -18,8 +18,6 @@
 
 """Tests for roundtripping text parsing."""
 
-from __future__ import absolute_import
-
 from ...tests import TestCase
 
 from ..roundtrip import (

=== modified file 'breezy/git/tests/test_server.py'
--- breezy/git/tests/test_server.py	2018-11-11 04:08:32 +0000
+++ breezy/git/tests/test_server.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Test for git server."""
 
-from __future__ import absolute_import
-
 from dulwich.client import TCPGitClient
 from dulwich.repo import Repo
 import threading

=== modified file 'breezy/git/tests/test_transportgit.py'
--- breezy/git/tests/test_transportgit.py	2019-11-03 12:38:45 +0000
+++ breezy/git/tests/test_transportgit.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Tests for bzr-git's object store."""
 
-from __future__ import absolute_import
-
 from dulwich.objects import Blob
 from dulwich.tests.test_object_store import PackBasedObjectStoreTests
 from dulwich.tests.utils import make_object

=== modified file 'breezy/git/tests/test_unpeel_map.py'
--- breezy/git/tests/test_unpeel_map.py	2018-11-11 04:08:32 +0000
+++ breezy/git/tests/test_unpeel_map.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Tests for the unpeel map."""
 
-from __future__ import absolute_import
-
 from io import BytesIO
 
 from ...tests import (

=== modified file 'breezy/git/tests/test_urls.py'
--- breezy/git/tests/test_urls.py	2018-11-16 23:19:12 +0000
+++ breezy/git/tests/test_urls.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Tests for url handling."""
 
-from __future__ import absolute_import
-
 from ...tests import TestCase
 from ..urls import (
     git_url_to_bzr_url,

=== modified file 'breezy/git/tests/test_workingtree.py'
--- breezy/git/tests/test_workingtree.py	2020-01-19 15:14:16 +0000
+++ breezy/git/tests/test_workingtree.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Tests for Git working trees."""
 
-from __future__ import absolute_import
-
 import os
 import stat
 

=== modified file 'breezy/git/transportgit.py'
--- breezy/git/transportgit.py	2019-12-26 13:20:45 +0000
+++ breezy/git/transportgit.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """A Git repository implementation that uses a Bazaar transport."""
 
-from __future__ import absolute_import
-
 from io import BytesIO
 
 import os

=== modified file 'breezy/git/tree.py'
--- breezy/git/tree.py	2020-02-08 22:40:33 +0000
+++ breezy/git/tree.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Git Trees."""
 
-from __future__ import absolute_import
-
 from collections import deque
 import errno
 from io import BytesIO
@@ -66,10 +64,6 @@
     CURRENT_REVISION,
     NULL_REVISION,
     )
-from ..sixish import (
-    text_type,
-    viewitems,
-    )
 
 from .mapping import (
     mode_is_executable,
@@ -1310,7 +1304,7 @@
                     key = (posixpath.dirname(path), path)
                     if key not in ret and self.is_versioned(path):
                         ret[key] = self._get_dir_ie(path, self.path2id(key[0]))
-            return ((path, ie) for ((_, path), ie) in sorted(viewitems(ret)))
+            return ((path, ie) for ((_, path), ie) in sorted(ret.items()))
 
     def iter_references(self):
         if self.supports_tree_reference():
@@ -1325,9 +1319,9 @@
                                 posixpath.basename(path).strip("/"), parent_id)
 
     def _get_file_ie(self, name, path, value, parent_id):
-        if not isinstance(name, text_type):
+        if not isinstance(name, str):
             raise TypeError(name)
-        if not isinstance(path, text_type):
+        if not isinstance(path, str):
             raise TypeError(path)
         if not isinstance(value, tuple) or len(value) != 10:
             raise TypeError(value)

=== modified file 'breezy/git/unpeel_map.py'
--- breezy/git/unpeel_map.py	2019-06-29 19:54:32 +0000
+++ breezy/git/unpeel_map.py	2020-02-18 01:57:45 +0000
@@ -16,7 +16,6 @@
 
 """Unpeel map storage."""
 
-from __future__ import absolute_import
 
 from collections import defaultdict
 from io import BytesIO

=== modified file 'breezy/git/urls.py'
--- breezy/git/urls.py	2018-11-16 23:19:12 +0000
+++ breezy/git/urls.py	2020-02-18 01:57:45 +0000
@@ -16,7 +16,6 @@
 
 """URL Conversion."""
 
-from __future__ import absolute_import
 
 from .. import urlutils
 from .refs import (

=== modified file 'breezy/git/workingtree.py'
--- breezy/git/workingtree.py	2020-02-18 03:11:01 +0000
+++ breezy/git/workingtree.py	2020-02-21 03:58:42 +0000
@@ -17,8 +17,6 @@
 
 """An adapter between a Git index and a Bazaar Working Tree"""
 
-from __future__ import absolute_import
-
 import itertools
 from collections import defaultdict
 import errno
@@ -73,7 +71,6 @@
     BadReferenceTarget,
     MutableTree,
     )
-from ..sixish import text_type
 
 
 from .dir import (
@@ -534,7 +531,7 @@
                               recurse_nested=False):
         if from_dir is None:
             from_dir = u""
-        if not isinstance(from_dir, text_type):
+        if not isinstance(from_dir, str):
             raise TypeError(from_dir)
         encoded_from_dir = self.abspath(from_dir).encode(osutils._fs_enc)
         for (dirpath, dirnames, filenames) in os.walk(encoded_from_dir):

=== modified file 'breezy/globbing.py'
--- breezy/globbing.py	2019-02-15 17:41:17 +0000
+++ breezy/globbing.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 expressions.
 """
 
-from __future__ import absolute_import
-
 import re
 
 from . import (

=== modified file 'breezy/gpg.py'
--- breezy/gpg.py	2019-06-16 19:53:27 +0000
+++ breezy/gpg.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """GPG signing and checking logic."""
 
-from __future__ import absolute_import
-
 import os
 
 from breezy.lazy_import import lazy_import
@@ -37,9 +35,6 @@
 from . import (
     errors,
     )
-from .sixish import (
-    text_type,
-    )
 
 # verification results
 SIGNATURE_VALID = 0
@@ -243,7 +238,7 @@
             raise GpgNotInstalled(
                 'Set create_signatures=no to disable creating signatures.')
 
-        if isinstance(content, text_type):
+        if isinstance(content, str):
             raise errors.BzrBadParameterUnicode('content')
 
         plain_text = gpg.Data(content)

=== modified file 'breezy/graph.py'
--- breezy/graph.py	2019-03-06 14:03:19 +0000
+++ breezy/graph.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import time
 
 from . import (
@@ -25,10 +23,6 @@
     revision,
     trace,
     )
-from .sixish import (
-    viewitems,
-    viewvalues,
-    )
 
 STEP_UNIQUE_SEARCHER_EVERY = 5
 
@@ -343,7 +337,7 @@
         """
         parent_map = self._parents_provider.get_parent_map(keys)
         parent_child = {}
-        for child, parents in sorted(viewitems(parent_map)):
+        for child, parents in sorted(parent_map.items()):
             for parent in parents:
                 parent_child.setdefault(parent, []).append(child)
         return parent_child
@@ -654,7 +648,7 @@
         # TODO: it might be possible to collapse searchers faster when they
         #       only have *some* search tips in common.
         next_unique_searchers = []
-        for searchers in viewvalues(unique_search_tips):
+        for searchers in unique_search_tips.values():
             if len(searchers) == 1:
                 # Searching unique tips, go for it
                 next_unique_searchers.append(searchers[0])
@@ -843,7 +837,7 @@
                          for c in candidate_heads)
         active_searchers = dict(searchers)
         # skip over the actual candidate for each searcher
-        for searcher in viewvalues(active_searchers):
+        for searcher in active_searchers.values():
             next(searcher)
         # The common walker finds nodes that are common to two or more of the
         # input keys, so that we don't access all history when a currently
@@ -886,11 +880,11 @@
                     # some searcher has encountered our known common nodes:
                     # just stop it
                     ancestor_set = {ancestor}
-                    for searcher in viewvalues(searchers):
+                    for searcher in searchers.values():
                         searcher.stop_searching_any(ancestor_set)
                 else:
                     # or it may have been just reached by all the searchers:
-                    for searcher in viewvalues(searchers):
+                    for searcher in searchers.values():
                         if ancestor not in searcher.seen:
                             break
                     else:
@@ -898,7 +892,7 @@
                         # making it be known as a descendant of all candidates,
                         # so we can stop searching it, and any seen ancestors
                         new_common.add(ancestor)
-                        for searcher in viewvalues(searchers):
+                        for searcher in searchers.values():
                             seen_ancestors =\
                                 searcher.find_seen_ancestors([ancestor])
                             searcher.stop_searching_any(seen_ancestors)
@@ -1021,7 +1015,7 @@
             processed.update(pending)
             next_map = self.get_parent_map(pending)
             next_pending = set()
-            for item in viewitems(next_map):
+            for item in next_map.items():
                 yield item
                 next_pending.update(p for p in item[1] if p not in processed)
             ghosts = pending.difference(next_map)
@@ -1259,7 +1253,7 @@
         # for revision in revisions.intersection(descendants):
         # simple_ancestors.difference_update(descendants[revision])
         # return simple_ancestors
-        for revision, parent_ids in viewitems(parent_map):
+        for revision, parent_ids in parent_map.items():
             if parent_ids is None:
                 continue
             for parent_id in parent_ids:
@@ -1466,7 +1460,7 @@
         seen.update(revisions)
         parent_map = self._parents_provider.get_parent_map(revisions)
         found_revisions.update(parent_map)
-        for rev_id, parents in viewitems(parent_map):
+        for rev_id, parents in parent_map.items():
             if parents is None:
                 continue
             new_found_parents = [p for p in parents if p not in seen]
@@ -1509,7 +1503,7 @@
             all_parents = []
             # We don't care if it is a ghost, since it can't be seen if it is
             # a ghost
-            for parent_ids in viewvalues(parent_map):
+            for parent_ids in parent_map.values():
                 all_parents.extend(parent_ids)
             next_pending = all_seen.intersection(
                 all_parents).difference(seen_ancestors)
@@ -1555,14 +1549,14 @@
                     stop_rev_references[parent_id] += 1
             # if only the stopped revisions reference it, the ref count will be
             # 0 after this loop
-            for parents in viewvalues(self._current_parents):
+            for parents in self._current_parents.values():
                 for parent_id in parents:
                     try:
                         stop_rev_references[parent_id] -= 1
                     except KeyError:
                         pass
             stop_parents = set()
-            for rev_id, refs in viewitems(stop_rev_references):
+            for rev_id, refs in stop_rev_references.items():
                 if refs == 0:
                     stop_parents.add(rev_id)
             self._next_query.difference_update(stop_parents)
@@ -1598,7 +1592,7 @@
 def invert_parent_map(parent_map):
     """Given a map from child => parents, create a map of parent=>children"""
     child_map = {}
-    for child, parents in viewitems(parent_map):
+    for child, parents in parent_map.items():
         for p in parents:
             # Any given parent is likely to have only a small handful
             # of children, many will have only one. So we avoid mem overhead of
@@ -1650,7 +1644,7 @@
     # Will not have any nodes removed, even though you do have an
     # 'uninteresting' linear D->B and E->C
     children = {}
-    for child, parents in viewitems(parent_map):
+    for child, parents in parent_map.items():
         children.setdefault(child, [])
         for p in parents:
             children.setdefault(p, []).append(child)

=== modified file 'breezy/grep.py'
--- breezy/grep.py	2019-02-04 01:01:24 +0000
+++ breezy/grep.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
+from io import BytesIO
 import re
 
 from .lazy_import import lazy_import
@@ -40,9 +39,6 @@
     RevisionSpec_revid,
     RevisionSpec_revno,
     )
-from .sixish import (
-    BytesIO,
-    )
 
 _user_encoding = osutils.get_user_encoding()
 

=== modified file 'breezy/hashcache.py'
--- breezy/hashcache.py	2018-11-18 00:25:19 +0000
+++ breezy/hashcache.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 # TODO: Up-front, stat all files in order and remove those which are deleted or
 # out-of-date.  Don't actually re-read them until they're needed.  That ought
 # to bring all the inodes into core so that future stats to them are fast, and
@@ -41,10 +39,6 @@
     osutils,
     trace,
     )
-from .sixish import (
-    text_type,
-    viewitems,
-    )
 
 
 FP_MTIME_COLUMN = 1
@@ -97,7 +91,7 @@
             parameters and returns a stack of ContentFilters.
             If None, no content filtering is performed.
         """
-        if not isinstance(root, text_type):
+        if not isinstance(root, str):
             raise ValueError("Base dir for hashcache must be text")
         self.root = root
         self.hit_count = 0
@@ -131,7 +125,7 @@
         # Stat in inode order as optimisation for at least linux.
         def inode_order(path_and_cache):
             return path_and_cache[1][1][3]
-        for path, cache_val in sorted(viewitems(self._cache), key=inode_order):
+        for path, cache_val in sorted(self._cache.items(), key=inode_order):
             abspath = osutils.pathjoin(self.root, path)
             fp = self._fingerprint(abspath)
             self.stat_count += 1
@@ -223,7 +217,7 @@
                                    new_mode=self._mode) as outf:
             outf.write(CACHE_HEADER)
 
-            for path, c in viewitems(self._cache):
+            for path, c in self._cache.items():
                 line_info = [path.encode('utf-8'), b'// ', c[0], b' ']
                 line_info.append(b'%d %d %d %d %d %d' % c[1])
                 line_info.append(b'\n')

=== modified file 'breezy/help.py'
--- breezy/help.py	2018-11-11 04:08:32 +0000
+++ breezy/help.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 # TODO: Some way to get a list of external commands (defined by shell
 # scripts) so that they can be included in the help listing as well.
 # It should be enough to just list the plugin directory and look for

=== modified file 'breezy/help_topics/__init__.py'
--- breezy/help_topics/__init__.py	2019-09-01 15:33:59 +0000
+++ breezy/help_topics/__init__.py	2020-02-18 01:57:45 +0000
@@ -33,8 +33,6 @@
 rendering on the screen naturally.
 """
 
-from __future__ import absolute_import
-
 import breezy
 from breezy import (
     config,

=== modified file 'breezy/hooks.py'
--- breezy/hooks.py	2018-11-11 04:08:32 +0000
+++ breezy/hooks.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Support for plugin hooking logic."""
 
-from __future__ import absolute_import
-
 from . import (
     errors,
     registry,

=== modified file 'breezy/i18n.py'
--- breezy/i18n.py	2018-11-12 01:41:38 +0000
+++ breezy/i18n.py	2020-02-18 01:57:45 +0000
@@ -22,8 +22,6 @@
 
 """i18n and l10n support for Bazaar."""
 
-from __future__ import absolute_import
-
 import gettext as _gettext
 import os
 import sys
@@ -141,24 +139,17 @@
 
     :param base: plugins can specify their own local directory
     """
-    if sys.version_info > (3,):
-        decode_path = str
-    else:
-        fs_enc = sys.getfilesystemencoding()
-
-        def decode_path(path):
-            return path.decode(fs_enc)
     if getattr(sys, 'frozen', False):
         if base is None:
-            base = os.path.dirname(decode_path(sys.executable))
+            base = os.path.dirname(sys.executable)
         return os.path.join(base, u'locale')
     else:
         if base is None:
-            base = os.path.dirname(decode_path(__file__))
+            base = os.path.dirname(__file__)
         dirpath = os.path.realpath(os.path.join(base, u'locale'))
         if os.path.exists(dirpath):
             return dirpath
-    return os.path.join(decode_path(sys.prefix), u"share", u"locale")
+    return os.path.join(sys.prefix, u"share", u"locale")
 
 
 def _check_win32_locale():

=== modified file 'breezy/identitymap.py'
--- breezy/identitymap.py	2017-05-22 00:56:52 +0000
+++ breezy/identitymap.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """This module provides an IdentityMap."""
 
-from __future__ import absolute_import
-
 from . import (
     errors,
     )

=== modified file 'breezy/ignores.py'
--- breezy/ignores.py	2020-01-11 17:41:33 +0000
+++ breezy/ignores.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Lists of ignore files, etc."""
 
-from __future__ import absolute_import
-
 import errno
 from io import BytesIO
 import os

=== modified file 'breezy/info.py'
--- breezy/info.py	2019-11-19 18:10:28 +0000
+++ breezy/info.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 __all__ = ['show_bzrdir_info']
 
 from io import StringIO

=== modified file 'breezy/inter.py'
--- breezy/inter.py	2017-08-29 13:25:07 +0000
+++ breezy/inter.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Inter-object utility class."""
 
-from __future__ import absolute_import
-
 from .errors import BzrError
 from .lock import LogicalLockResult
 

=== removed file 'breezy/intset.py'
--- breezy/intset.py	2018-11-11 04:08:32 +0000
+++ breezy/intset.py	1970-01-01 00:00:00 +0000
@@ -1,217 +0,0 @@
-# Copyright (C) 2005 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-from __future__ import absolute_import
-
-# Author: Martin Pool <mbp@canonical.com>
-
-
-# Somewhat surprisingly, it turns out that this is much slower than
-# simply storing the ints in a set() type.  Python's performance model
-# is very different to that of C.
-
-
-class IntSet(Exception):
-    """Faster set-like class storing only whole numbers.
-
-    Despite the name this stores long integers happily, but negative
-    values are not allowed.
-
-    >>> a = IntSet([0, 2, 5])
-    >>> bool(a)
-    True
-    >>> 2 in a
-    True
-    >>> 4 in a
-    False
-    >>> a.add(4)
-    >>> 4 in a
-    True
-
-    >>> b = IntSet()
-    >>> not b
-    True
-    >>> b.add(10)
-    >>> 10 in a
-    False
-    >>> a.update(b)
-    >>> 10 in a
-    True
-    >>> a.update(range(5))
-    >>> 3 in a
-    True
-
-    Being a set, duplicates are ignored:
-    >>> a = IntSet()
-    >>> a.add(10)
-    >>> a.add(10)
-    >>> 10 in a
-    True
-    >>> list(a)
-    [10]
-
-    """
-    __slots__ = ['_val']
-
-    def __init__(self, values=None, bitmask=0):
-        """Create a new intset.
-
-        values
-            If specified, an initial collection of values.
-        """
-        self._val = bitmask
-        if values is not None:
-            self.update(values)
-
-    def __bool__(self):
-        """IntSets are false if empty, otherwise True.
-
-        >>> bool(IntSet())
-        False
-
-        >>> bool(IntSet([0]))
-        True
-        """
-        return bool(self._val)
-
-    __nonzero__ = __bool__
-
-    def __len__(self):
-        """Number of elements in set.
-
-        >>> len(IntSet(xrange(20000)))
-        20000
-        """
-        v = self._val
-        c = 0
-        while v:
-            if v & 1:
-                c += 1
-            v = v >> 1
-        return c
-
-    def __and__(self, other):
-        """Set intersection.
-
-        >>> a = IntSet(range(10))
-        >>> len(a)
-        10
-        >>> b = a & a
-        >>> b == a
-        True
-        >>> a = a & IntSet([5, 7, 11, 13])
-        >>> list(a)
-        [5, 7]
-        """
-        if not isinstance(other, IntSet):
-            raise NotImplementedError(type(other))
-        return IntSet(bitmask=(self._val & other._val))
-
-    def __or__(self, other):
-        """Set union.
-
-        >>> a = IntSet(range(10)) | IntSet([5, 15, 25])
-        >>> len(a)
-        12
-        """
-        if not isinstance(other, IntSet):
-            raise NotImplementedError(type(other))
-        return IntSet(bitmask=(self._val | other._val))
-
-    def __eq__(self, other):
-        """Comparison.
-
-        >>> IntSet(range(3)) == IntSet([2, 0, 1])
-        True
-        """
-        if isinstance(other, IntSet):
-            return self._val == other._val
-        else:
-            return False
-
-    def __ne__(self, other):
-        return not self.__eq__(other)
-
-    def __contains__(self, i):
-        return self._val & (1 << i)
-
-    def __iter__(self):
-        """Return contents of set.
-
-        >>> list(IntSet())
-        []
-        >>> list(IntSet([0, 1, 5, 7]))
-        [0, 1, 5, 7]
-        """
-        v = self._val
-        o = 0
-        # XXX: This is a bit slow
-        while v:
-            if v & 1:
-                yield o
-            v = v >> 1
-            o = o + 1
-
-    def update(self, to_add):
-        """Add all the values from the sequence or intset to_add"""
-        if isinstance(to_add, IntSet):
-            self._val |= to_add._val
-        else:
-            for i in to_add:
-                self._val |= (1 << i)
-
-    def add(self, to_add):
-        self._val |= (1 << to_add)
-
-    def remove(self, to_remove):
-        """Remove one value from the set.
-
-        Raises KeyError if the value is not present.
-
-        >>> a = IntSet([10])
-        >>> a.remove(9)
-        Traceback (most recent call last):
-          File "/usr/lib/python2.4/doctest.py", line 1243, in __run
-            compileflags, 1) in test.globs
-          File "<doctest __main__.IntSet.remove[1]>", line 1, in ?
-            a.remove(9)
-        KeyError: 9
-        >>> a.remove(10)
-        >>> not a
-        True
-        """
-        m = 1 << to_remove
-        if not self._val & m:
-            raise KeyError(to_remove)
-        self._val ^= m
-
-    def set_remove(self, to_remove):
-        """Remove all values that exist in to_remove.
-
-        >>> a = IntSet(range(10))
-        >>> b = IntSet([2,3,4,7,12])
-        >>> a.set_remove(b)
-        >>> list(a)
-        [0, 1, 5, 6, 8, 9]
-        >>> a.set_remove([1,2,5])
-        >>> list(a)
-        [0, 6, 8, 9]
-        """
-        if not isinstance(to_remove, IntSet):
-            self.set_remove(IntSet(to_remove))
-            return
-        intersect = self._val & to_remove._val
-        self._val ^= intersect

=== modified file 'breezy/iterablefile.py'
--- breezy/iterablefile.py	2018-11-12 01:41:38 +0000
+++ breezy/iterablefile.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 
 class IterableFileBase(object):
     """Create a file-like object from any iterable"""
@@ -29,8 +27,8 @@
 
     def read_n(self, length):
         """
-        >>> IterableFileBase(['This ', 'is ', 'a ', 'test.']).read_n(8)
-        'This is '
+        >>> IterableFileBase([b'This ', b'is ', b'a ', b'test.']).read_n(8)
+        b'This is '
         """
         def test_length(result):
             if len(result) >= length:
@@ -41,11 +39,11 @@
 
     def read_to(self, sequence, length=None):
         """
-        >>> f = IterableFileBase(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.'])
-        >>> f.read_to('\\n')
-        'Th\\n'
-        >>> f.read_to('\\n')
-        'is is \\n'
+        >>> f = IterableFileBase([b'Th\\nis ', b'is \\n', b'a ', b'te\\nst.'])
+        >>> f.read_to(b'\\n')
+        b'Th\\n'
+        >>> f.read_to(b'\\n')
+        b'is is \\n'
         """
         def test_contents(result):
             if length is not None:
@@ -79,8 +77,8 @@
 
     def read_all(self):
         """
-        >>> IterableFileBase(['This ', 'is ', 'a ', 'test.']).read_all()
-        'This is a test.'
+        >>> IterableFileBase([b'This ', b'is ', b'a ', b'test.']).read_all()
+        b'This is a test.'
         """
         def no_stop(result):
             return None
@@ -88,12 +86,12 @@
 
     def push_back(self, contents):
         """
-        >>> f = IterableFileBase(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.'])
-        >>> f.read_to('\\n')
-        'Th\\n'
-        >>> f.push_back("Sh")
+        >>> f = IterableFileBase([b'Th\\nis ', b'is \\n', b'a ', b'te\\nst.'])
+        >>> f.read_to(b'\\n')
+        b'Th\\n'
+        >>> f.push_back(b"Sh")
         >>> f.read_all()
-        'Shis is \\na te\\nst.'
+        b'Shis is \\na te\\nst.'
         """
         self._buffer = contents + self._buffer
 
@@ -121,7 +119,7 @@
 
     def close(self):
         """
-        >>> f = IterableFile(['This ', 'is ', 'a ', 'test.'])
+        >>> f = IterableFile([b'This ', b'is ', b'a ', b'test.'])
         >>> f.closed
         False
         >>> f.close()
@@ -158,18 +156,18 @@
     def __next__(self):
         """Implementation of the iterator protocol's next()
 
-        >>> f = IterableFile(['This \\n', 'is ', 'a ', 'test.'])
+        >>> f = IterableFile([b'This \\n', b'is ', b'a ', b'test.'])
         >>> next(f)
-        'This \\n'
+        b'This \\n'
         >>> f.close()
         >>> next(f)
         Traceback (most recent call last):
         ValueError: File is closed.
-        >>> f = IterableFile(['This \\n', 'is ', 'a ', 'test.\\n'])
-        >>> next(f)
-        'This \\n'
-        >>> next(f)
-        'is a test.\\n'
+        >>> f = IterableFile([b'This \\n', b'is ', b'a ', b'test.\\n'])
+        >>> next(f)
+        b'This \\n'
+        >>> next(f)
+        b'is a test.\\n'
         >>> next(f)
         Traceback (most recent call last):
         StopIteration
@@ -181,9 +179,9 @@
 
     def __iter__(self):
         """
-        >>> list(IterableFile(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.']))
-        ['Th\\n', 'is is \\n', 'a te\\n', 'st.']
-        >>> f = IterableFile(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.'])
+        >>> list(IterableFile([b'Th\\nis ', b'is \\n', b'a ', b'te\\nst.']))
+        [b'Th\\n', b'is is \\n', b'a te\\n', b'st.']
+        >>> f = IterableFile([b'Th\\nis ', b'is \\n', b'a ', b'te\\nst.'])
         >>> f.close()
         >>> list(f)
         Traceback (most recent call last):
@@ -193,12 +191,12 @@
 
     def read(self, length=None):
         """
-        >>> IterableFile(['This ', 'is ', 'a ', 'test.']).read()
-        'This is a test.'
-        >>> f = IterableFile(['This ', 'is ', 'a ', 'test.'])
+        >>> IterableFile([b'This ', b'is ', b'a ', b'test.']).read()
+        b'This is a test.'
+        >>> f = IterableFile([b'This ', b'is ', b'a ', b'test.'])
         >>> f.read(10)
-        'This is a '
-        >>> f = IterableFile(['This ', 'is ', 'a ', 'test.'])
+        b'This is a '
+        >>> f = IterableFile([b'This ', b'is ', b'a ', b'test.'])
         >>> f.close()
         >>> f.read(10)
         Traceback (most recent call last):
@@ -215,13 +213,13 @@
         Read characters until a sequence is found, with optional max size.
         The specified sequence, if found, will be included in the result
 
-        >>> f = IterableFile(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.'])
-        >>> f.read_to('i')
-        'Th\\ni'
-        >>> f.read_to('i')
-        's i'
+        >>> f = IterableFile([b'Th\\nis ', b'is \\n', b'a ', b'te\\nst.'])
+        >>> f.read_to(b'i')
+        b'Th\\ni'
+        >>> f.read_to(b'i')
+        b's i'
         >>> f.close()
-        >>> f.read_to('i')
+        >>> f.read_to(b'i')
         Traceback (most recent call last):
         ValueError: File is closed.
         """
@@ -230,11 +228,11 @@
 
     def readline(self, size=None):
         """
-        >>> f = IterableFile(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.'])
+        >>> f = IterableFile([b'Th\\nis ', b'is \\n', b'a ', b'te\\nst.'])
         >>> f.readline()
-        'Th\\n'
+        b'Th\\n'
         >>> f.readline(4)
-        'is i'
+        b'is i'
         >>> f.close()
         >>> f.readline()
         Traceback (most recent call last):
@@ -244,10 +242,10 @@
 
     def readlines(self, sizehint=None):
         """
-        >>> f = IterableFile(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.'])
+        >>> f = IterableFile([b'Th\\nis ', b'is \\n', b'a ', b'te\\nst.'])
         >>> f.readlines()
-        ['Th\\n', 'is is \\n', 'a te\\n', 'st.']
-        >>> f = IterableFile(['Th\\nis ', 'is \\n', 'a ', 'te\\nst.'])
+        [b'Th\\n', b'is is \\n', b'a te\\n', b'st.']
+        >>> f = IterableFile([b'Th\\nis ', b'is \\n', b'a ', b'te\\nst.'])
         >>> f.close()
         >>> f.readlines()
         Traceback (most recent call last):

=== modified file 'breezy/lazy_import.py'
--- breezy/lazy_import.py	2020-01-11 17:41:33 +0000
+++ breezy/lazy_import.py	2020-02-18 01:57:45 +0000
@@ -41,8 +41,6 @@
 to inherit from them).
 """
 
-from __future__ import absolute_import
-
 from .errors import BzrError, InternalBzrError
 
 

=== modified file 'breezy/lazy_regex.py'
--- breezy/lazy_regex.py	2018-11-16 19:09:31 +0000
+++ breezy/lazy_regex.py	2020-02-18 01:57:45 +0000
@@ -24,8 +24,6 @@
 be used by existing Python modules that create regexs.
 """
 
-from __future__ import absolute_import
-
 import re
 
 from . import errors

=== modified file 'breezy/library_state.py'
--- breezy/library_state.py	2020-02-21 22:54:31 +0000
+++ breezy/library_state.py	2020-03-22 01:35:14 +0000
@@ -16,18 +16,18 @@
 
 """The core state needed to make use of bzr is managed here."""
 
-from __future__ import absolute_import
-
 __all__ = [
     'BzrLibraryState',
     ]
 
 
+import contextlib
+
+
 import breezy
 from .lazy_import import lazy_import
 lazy_import(globals(), """
 from breezy import (
-    cleanup,
     config,
     osutils,
     symbol_versioning,
@@ -89,7 +89,7 @@
         # isolation within the same interpreter.  It's not reached on normal
         # in-process run_bzr calls.  If it's broken, we expect that
         # TestRunBzrSubprocess may fail.
-        self.exit_stack = cleanup.ExitStack()
+        self.exit_stack = contextlib.ExitStack()
 
         if breezy.version_info[3] == 'final':
             self.exit_stack.callback(

=== modified file 'breezy/location.py'
--- breezy/location.py	2019-11-17 03:58:40 +0000
+++ breezy/location.py	2020-02-18 01:57:45 +0000
@@ -17,18 +17,12 @@
 
 """UI location string handling."""
 
-from __future__ import absolute_import
-
 import re
 
 from . import (
     urlutils,
     )
 from .hooks import Hooks
-from .sixish import (
-    PY3,
-    string_types,
-    )
 
 
 class LocationHooks(Hooks):
@@ -102,7 +96,7 @@
     :raise InvalidURL: If the location is already a URL, but not valid.
     :return: Byte string with resulting URL
     """
-    if not isinstance(location, string_types):
+    if not isinstance(location, str):
         raise AssertionError("location not a byte or unicode string")
 
     if location.startswith(':pserver:'):
@@ -120,8 +114,7 @@
                 path=location, extra='URLs must be properly escaped')
         location = urlutils.local_path_to_url(location)
     else:
-        if PY3:
-            location = location.decode('ascii')
+        location = location.decode('ascii')
 
     if location.startswith("file:") and not location.startswith("file://"):
         return urlutils.join(urlutils.local_path_to_url("."), location[5:])

=== modified file 'breezy/lock.py'
--- breezy/lock.py	2019-06-16 15:37:44 +0000
+++ breezy/lock.py	2020-02-18 01:57:45 +0000
@@ -33,8 +33,6 @@
 unlock() method.
 """
 
-from __future__ import absolute_import
-
 import contextlib
 import errno
 import os

=== modified file 'breezy/lockable_files.py'
--- breezy/lockable_files.py	2020-01-11 17:41:33 +0000
+++ breezy/lockable_files.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from .lazy_import import lazy_import
 lazy_import(globals(), """
 from breezy import (

=== modified file 'breezy/lockdir.py'
--- breezy/lockdir.py	2019-06-16 01:03:51 +0000
+++ breezy/lockdir.py	2020-02-18 01:57:45 +0000
@@ -98,8 +98,6 @@
 but helps protect against colliding host names.
 """
 
-from __future__ import absolute_import
-
 
 # TODO: We sometimes have the problem that our attempt to rename '1234' to
 # 'held' fails because the transport server moves into an existing directory,
@@ -139,10 +137,6 @@
     )
 from .i18n import gettext
 from .osutils import format_delta, rand_chars, get_host_name
-from .sixish import (
-    PY3,
-    text_type,
-    )
 from .trace import mutter, note
 
 
@@ -302,7 +296,7 @@
                     ui.ui_factory.show_user_warning(
                         'locks_steal_dead',
                         lock_url=urlutils.join(self.transport.base, self.path),
-                        other_holder_info=text_type(other_holder))
+                        other_holder_info=str(other_holder))
                     self.force_break(other_holder)
                     self._trace("stole lock from dead holder")
                     return
@@ -406,7 +400,7 @@
             if ui.ui_factory.confirm_action(
                 u"Break %(lock_info)s",
                 'breezy.lockdir.break',
-                    dict(lock_info=text_type(holder_info))):
+                    dict(lock_info=str(holder_info))):
                 result = self.force_break(holder_info)
                 ui.ui_factory.show_message(
                     "Broke lock %s" % result.lock_url)
@@ -730,16 +724,13 @@
         """Return a debugging representation of this object."""
         return "%s(%r)" % (self.__class__.__name__, self.info_dict)
 
-    def __unicode__(self):
+    def __str__(self):
         """Return a user-oriented description of this object."""
         d = self.to_readable_dict()
         return (gettext(
             u'held by %(user)s on %(hostname)s (process #%(pid)s), '
             u'acquired %(time_ago)s') % d)
 
-    if PY3:
-        __str__ = __unicode__
-
     def to_readable_dict(self):
         """Turn the holder info into a dict of human-readable attributes.
 

=== modified file 'breezy/log.py'
--- breezy/log.py	2020-02-09 17:10:01 +0000
+++ breezy/log.py	2020-02-18 01:57:45 +0000
@@ -47,9 +47,8 @@
 all the changes since the previous revision that touched hello.c.
 """
 
-from __future__ import absolute_import
-
 import codecs
+from io import BytesIO
 import itertools
 import re
 import sys
@@ -84,12 +83,10 @@
     get_terminal_encoding,
     terminal_width,
     )
-from .sixish import (
-    BytesIO,
-    range,
-    zip,
+from .tree import (
+    find_previous_path,
+    InterTree,
     )
-from .tree import InterTree
 
 
 def find_touching_revisions(repository, last_revision, last_tree, last_path):

=== modified file 'breezy/lru_cache.py'
--- breezy/lru_cache.py	2018-11-11 04:08:32 +0000
+++ breezy/lru_cache.py	2020-02-18 01:57:45 +0000
@@ -16,15 +16,9 @@
 
 """A simple least-recently-used (LRU) cache."""
 
-from __future__ import absolute_import, division
-
 from . import (
     trace,
     )
-from .sixish import (
-    viewitems,
-    viewkeys,
-    )
 
 
 _null_key = object()
@@ -136,11 +130,11 @@
         :return: An unordered list of keys that are currently cached.
         """
         # GZ 2016-06-04: Maybe just make this return the view?
-        return list(viewkeys(self._cache))
+        return list(self._cache.keys())
 
     def as_dict(self):
         """Get a new dict with the same key:value pairs as the cache"""
-        return dict((k, n.value) for k, n in viewitems(self._cache))
+        return dict((k, n.value) for k, n in self._cache.items())
 
     def cleanup(self):
         """Clear the cache until it shrinks to the requested size.

=== modified file 'breezy/lsprof.py'
--- breezy/lsprof.py	2018-11-12 01:41:38 +0000
+++ breezy/lsprof.py	2020-02-18 01:57:45 +0000
@@ -3,8 +3,6 @@
 # I made one modification to profile so that it returns a pair
 # instead of just the Stats object
 
-from __future__ import absolute_import
-
 import codecs
 try:
     import cPickle as pickle
@@ -13,10 +11,7 @@
 import operator
 import os
 import sys
-try:
-    import _thread
-except ImportError:
-    import thread as _thread
+import _thread
 import threading
 from _lsprof import Profiler, profiler_entry
 

=== modified file 'breezy/mail_client.py'
--- breezy/mail_client.py	2019-06-29 19:54:32 +0000
+++ breezy/mail_client.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import errno
 import os
 import subprocess
@@ -32,10 +30,6 @@
     urlutils,
     registry,
     )
-from .sixish import (
-    PY3,
-    text_type,
-    )
 
 mail_client_registry = registry.Registry()
 
@@ -235,8 +229,6 @@
         :param  u:  possible unicode string.
         :return:    encoded string if u is unicode, u itself otherwise.
         """
-        if not PY3 and isinstance(u, text_type):
-            return u.encode(osutils.get_user_encoding(), 'replace')
         return u
 
     def _encode_path(self, path, kind):
@@ -248,11 +240,6 @@
                         path itself otherwise.
         :raise:         UnableEncodePath.
         """
-        if not PY3 and isinstance(path, text_type):
-            try:
-                return path.encode(osutils.get_user_encoding())
-            except UnicodeEncodeError:
-                raise errors.UnableEncodePath(path, kind)
         return path
 
 

=== modified file 'breezy/memorytree.py'
--- breezy/memorytree.py	2019-10-14 00:25:24 +0000
+++ breezy/memorytree.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 See MemoryTree for more details.
 """
 
-from __future__ import absolute_import
-
 import os
 import stat
 

=== modified file 'breezy/merge.py'
--- breezy/merge.py	2020-01-25 13:08:09 +0000
+++ breezy/merge.py	2020-02-18 01:57:45 +0000
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
+import contextlib
 
 from .lazy_import import lazy_import
 lazy_import(globals(), """
@@ -22,7 +22,6 @@
 
 from breezy import (
     branch as _mod_branch,
-    cleanup,
     conflicts as _mod_conflicts,
     debug,
     graph as _mod_graph,
@@ -49,9 +48,6 @@
     hooks,
     registry,
     )
-from .sixish import (
-    viewitems,
-    )
 # TODO: Report back as changes are merged in
 
 
@@ -447,7 +443,7 @@
     def _add_parent(self):
         new_parents = self.this_tree.get_parent_ids() + [self.other_rev_id]
         new_parent_trees = []
-        with cleanup.ExitStack() as stack:
+        with contextlib.ExitStack() as stack:
             for revision_id in new_parents:
                 try:
                     tree = self.revision_tree(revision_id)
@@ -654,7 +650,7 @@
         return merge
 
     def do_merge(self):
-        with cleanup.ExitStack() as stack:
+        with contextlib.ExitStack() as stack:
             stack.enter_context(self.this_tree.lock_tree_write())
             if self.base_tree is not None:
                 stack.enter_context(self.base_tree.lock_read())
@@ -757,7 +753,7 @@
             self.do_merge()
 
     def do_merge(self):
-        with cleanup.ExitStack() as stack:
+        with contextlib.ExitStack() as stack:
             stack.enter_context(self.working_tree.lock_tree_write())
             stack.enter_context(self.this_tree.lock_read())
             stack.enter_context(self.base_tree.lock_read())
@@ -2255,7 +2251,7 @@
         filtered_parent_map = {}
         child_map = {}
         tails = []
-        for key, parent_keys in viewitems(parent_map):
+        for key, parent_keys in parent_map.items():
             culled_parent_keys = [p for p in parent_keys if p in parent_map]
             if not culled_parent_keys:
                 tails.append(key)

=== modified file 'breezy/merge3.py'
--- breezy/merge3.py	2019-03-02 21:46:18 +0000
+++ breezy/merge3.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 # mbp: "you know that thing where cvs gives you conflict markers?"
 # s: "i hate that."
 

=== modified file 'breezy/merge_directive.py'
--- breezy/merge_directive.py	2020-01-11 17:41:33 +0000
+++ breezy/merge_directive.py	2020-02-18 01:57:45 +0000
@@ -14,16 +14,15 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import base64
+import contextlib
+from io import BytesIO
 import re
 
 from . import lazy_import
 lazy_import.lazy_import(globals(), """
 from breezy import (
     branch as _mod_branch,
-    cleanup,
     diff,
     email_message,
     gpg,
@@ -44,9 +43,6 @@
 from . import (
     errors,
     )
-from .sixish import (
-    BytesIO,
-    )
 
 
 class MergeRequestBodyParams(object):
@@ -599,7 +595,7 @@
         If the message is not supplied, the message from revision_id will be
         used for the commit.
         """
-        with cleanup.ExitStack() as exit_stack:
+        with contextlib.ExitStack() as exit_stack:
             exit_stack.enter_context(repository.lock_write())
             t_revision_id = revision_id
             if revision_id == b'null:':

=== modified file 'breezy/mergeable.py'
--- breezy/mergeable.py	2020-01-11 17:41:33 +0000
+++ breezy/mergeable.py	2020-02-18 01:57:45 +0000
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
+from io import BytesIO
 
 from .lazy_import import lazy_import
 lazy_import(globals(), """
@@ -30,9 +30,6 @@
 from . import (
     errors,
     )
-from .sixish import (
-    BytesIO,
-    )
 from .trace import note
 
 

=== modified file 'breezy/mergetools.py'
--- breezy/mergetools.py	2018-11-12 01:41:38 +0000
+++ breezy/mergetools.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Utility functions for managing external merge tools such as kdiff3."""
 
-from __future__ import absolute_import
-
 import os
 import shutil
 import subprocess

=== modified file 'breezy/missing.py'
--- breezy/missing.py	2019-06-26 20:58:23 +0000
+++ breezy/missing.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Display what revisions are missing in 'other' from 'this' and vice versa."""
 
-from __future__ import absolute_import
-
 from . import (
     errors,
     log,

=== modified file 'breezy/msgeditor.py'
--- breezy/msgeditor.py	2019-06-16 01:03:51 +0000
+++ breezy/msgeditor.py	2020-02-18 01:57:45 +0000
@@ -16,9 +16,11 @@
 
 """Commit message editor support."""
 
-from __future__ import absolute_import
-
 import codecs
+from io import (
+    BytesIO,
+    StringIO,
+    )
 import os
 from subprocess import call
 import sys
@@ -34,10 +36,6 @@
     )
 from .errors import BzrError
 from .hooks import Hooks
-from .sixish import (
-    BytesIO,
-    StringIO,
-    )
 
 
 class BadCommitMessageEncoding(BzrError):

=== modified file 'breezy/multiparent.py'
--- breezy/multiparent.py	2020-01-11 17:41:33 +0000
+++ breezy/multiparent.py	2020-02-18 01:57:45 +0000
@@ -14,9 +14,10 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import errno
+from io import (
+    BytesIO,
+    )
 import os
 
 from .lazy_import import lazy_import
@@ -35,10 +36,6 @@
     errors,
     )
 from .i18n import gettext
-from .sixish import (
-    BytesIO,
-    range,
-    )
 
 
 def topo_iter_keys(vf, keys=None):

=== modified file 'breezy/multiwalker.py'
--- breezy/multiwalker.py	2019-06-02 18:43:25 +0000
+++ breezy/multiwalker.py	2020-02-18 01:57:45 +0000
@@ -17,18 +17,11 @@
 """Walk multiple trees simultaneously.
 """
 
-from __future__ import absolute_import
-
 from . import (
     errors,
     osutils,
     )
 
-from .sixish import (
-    text_type,
-    viewvalues,
-    )
-
 
 class MultiWalker(object):
     """Walk multiple trees simultaneously, getting combined results."""
@@ -94,10 +87,10 @@
         # This is stolen from _dirstate_helpers_py.py, only switching it to
         # Unicode objects. Consider using encode_utf8() and then using the
         # optimized versions, or maybe writing optimized unicode versions.
-        if not isinstance(path1, text_type):
+        if not isinstance(path1, str):
             raise TypeError("'path1' must be a unicode string, not %s: %r"
                             % (type(path1), path1))
-        if not isinstance(path2, text_type):
+        if not isinstance(path2, str):
             raise TypeError("'path2' must be a unicode string, not %s: %r"
                             % (type(path2), path2))
         return (MultiWalker._path_to_key(path1) <
@@ -247,7 +240,7 @@
         #       might ensure better ordering, in case a caller strictly
         #       requires parents before children.
         for idx, other_extra in enumerate(self._others_extra):
-            others = sorted(viewvalues(other_extra),
+            others = sorted(other_extra.values(),
                             key=lambda x: self._path_to_key(x[0]))
             for other_path, other_ie in others:
                 file_id = other_ie.file_id

=== modified file 'breezy/mutabletree.py'
--- breezy/mutabletree.py	2019-06-17 23:01:58 +0000
+++ breezy/mutabletree.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 See MutableTree for more details.
 """
 
-from __future__ import absolute_import
-
 from . import (
     errors,
     hooks,
@@ -29,9 +27,6 @@
     tree,
     )
 
-from .sixish import (
-    text_type,
-    )
 
 
 class BadReferenceTarget(errors.InternalBzrError):
@@ -101,12 +96,12 @@
 
         TODO: Perhaps callback with the ids and paths as they're added.
         """
-        if isinstance(files, (str, text_type)):
+        if isinstance(files, str):
             # XXX: Passing a single string is inconsistent and should be
             # deprecated.
             if not (ids is None or isinstance(ids, bytes)):
                 raise AssertionError()
-            if not (kinds is None or isinstance(kinds, (str, text_type))):
+            if not (kinds is None or isinstance(kinds, str)):
                 raise AssertionError()
             files = [files]
             if ids is not None:

=== modified file 'breezy/option.py'
--- breezy/option.py	2019-06-15 19:09:08 +0000
+++ breezy/option.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 # TODO: For things like --diff-prefix, we want a way to customize the display
 # of the option argument.
 
-from __future__ import absolute_import
-
 import optparse
 import re
 
@@ -27,9 +25,6 @@
     registry as _mod_registry,
     revisionspec,
     )
-from .sixish import (
-    text_type,
-    )
 
 
 class BadOptionValue(errors.BzrError):
@@ -111,7 +106,7 @@
     >>> _parse_change_str('123..124')
     Traceback (most recent call last):
       ...
-    RangeInChangeOption: Option --change does not accept revision ranges
+    breezy.errors.RangeInChangeOption: Option --change does not accept revision ranges
     """
     revs = _parse_revision_str(revstr)
     if len(revs) > 1:
@@ -564,9 +559,9 @@
                short_name='c',
                param_name='revision',
                help='Select changes introduced by the specified revision. See also "help revisionspec".')
-_global_option('directory', short_name='d', type=text_type,
+_global_option('directory', short_name='d', type=str,
                help='Branch to operate on, instead of working directory.')
-_global_option('file', type=text_type, short_name='F')
+_global_option('file', type=str, short_name='F')
 _global_registry_option('log-format', "Use specified log format.",
                         lazy_registry=('breezy.log', 'log_formatter_registry'),
                         value_switches=True, title='Log format',
@@ -574,7 +569,7 @@
 _global_registry_option('merge-type', 'Select a particular merge algorithm.',
                         lazy_registry=('breezy.merge', 'merge_type_registry'),
                         value_switches=True, title='Merge algorithm')
-_global_option('message', type=text_type,
+_global_option('message', type=str,
                short_name='m',
                help='Message string.')
 _global_option('null', short_name='0',

=== modified file 'breezy/osutils.py'
--- breezy/osutils.py	2019-10-13 22:53:02 +0000
+++ breezy/osutils.py	2020-02-21 04:28:46 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import errno
 import os
 import re
@@ -52,11 +50,6 @@
 from breezy.i18n import gettext
 """)
 
-from .sixish import (
-    PY3,
-    text_type,
-    )
-
 from hashlib import (
     md5,
     sha1 as sha,
@@ -91,14 +84,7 @@
 
 
 def get_unicode_argv():
-    if PY3:
-        return sys.argv[1:]
-    try:
-        user_encoding = get_user_encoding()
-        return [a.decode(user_encoding) for a in sys.argv[1:]]
-    except UnicodeDecodeError:
-        raise errors.BzrError(gettext("Parameter {0!r} encoding is unsupported by {1} "
-                                      "application locale.").format(a, user_encoding))
+    return sys.argv[1:]
 
 
 def make_readonly(filename):
@@ -331,14 +317,7 @@
     Note that posix systems use arbitrary byte strings for filesystem objects,
     so a path that raises BadFilenameEncoding here may still be accessible.
     """
-    val = os.environ.get(key, None)
-    if PY3 or val is None:
-        return val
-    try:
-        return val.decode(_fs_enc)
-    except UnicodeDecodeError:
-        # GZ 2011-12-12:Ideally want to include `key` in the exception message
-        raise errors.BadFilenameEncoding(val, _fs_enc)
+    return os.environ.get(key, None)
 
 
 def _posix_get_home_dir():
@@ -354,15 +333,7 @@
 
 def _posix_getuser_unicode():
     """Get username from environment or password database as unicode"""
-    name = getpass.getuser()
-    if PY3:
-        return name
-    user_encoding = get_user_encoding()
-    try:
-        return name.decode(user_encoding)
-    except UnicodeDecodeError:
-        raise errors.BzrError("Encoding of username %r is unsupported by %s "
-                              "application locale." % (name, user_encoding))
+    return getpass.getuser()
 
 
 def _win32_fixdrive(path):
@@ -447,10 +418,7 @@
     return _rename_wrapper
 
 
-if sys.version_info > (3,):
-    _getcwd = os.getcwd
-else:
-    _getcwd = os.getcwdu
+_getcwd = os.getcwd
 
 
 # Default rename wraps os.rename()
@@ -738,12 +706,8 @@
 
 # GZ 2017-09-16: Makes sense in general for hexdigest() result to be text, but
 # used as bytes through most interfaces so encode with this wrapper.
-if PY3:
-    def _hexdigest(hashobj):
-        return hashobj.hexdigest().encode()
-else:
-    def _hexdigest(hashobj):
-        return hashobj.hexdigest()
+def _hexdigest(hashobj):
+    return hashobj.hexdigest().encode()
 
 
 def sha_file(f):
@@ -895,7 +859,7 @@
     (date_fmt, tt, offset_str) = \
         _format_date(t, offset, timezone, date_fmt, show_offset)
     date_str = time.strftime(date_fmt, tt)
-    if not isinstance(date_str, text_type):
+    if not isinstance(date_str, str):
         date_str = date_str.decode(get_user_encoding(), 'replace')
     return date_str + offset_str
 
@@ -1012,10 +976,7 @@
     """
     s = ''
     for raw_byte in rand_bytes(num):
-        if not PY3:
-            s += ALNUM[ord(raw_byte) % 36]
-        else:
-            s += ALNUM[raw_byte % 36]
+        s += ALNUM[raw_byte % 36]
     return s
 
 
@@ -1322,22 +1283,21 @@
 
     abs_base = abspath(base)
     current = abs_base
-    _listdir = os.listdir
 
     # use an explicit iterator so we can easily consume the rest on early exit.
     bit_iter = iter(rel.split('/'))
     for bit in bit_iter:
         lbit = bit.lower()
         try:
-            next_entries = _listdir(current)
+            next_entries = scandir(current)
         except OSError:  # enoent, eperm, etc
             # We can't find this in the filesystem, so just append the
             # remaining bits.
             current = pathjoin(current, bit, *list(bit_iter))
             break
-        for look in next_entries:
-            if lbit == look.lower():
-                current = pathjoin(current, look)
+        for entry in next_entries:
+            if lbit == entry.name.lower():
+                current = entry.path
                 break
         else:
             # got to the end, nothing matched, so we just return the
@@ -1376,7 +1336,7 @@
     Otherwise it is decoded from the the filesystem's encoding. If decoding
     fails, a errors.BadFilenameEncoding exception is raised.
     """
-    if isinstance(filename, text_type):
+    if isinstance(filename, str):
         return filename
     try:
         return filename.decode(_fs_enc)
@@ -1391,7 +1351,7 @@
     Otherwise it is decoded from utf-8. If decoding fails, the exception is
     wrapped in a BzrBadParameterNotUnicode exception.
     """
-    if isinstance(unicode_or_utf8_string, text_type):
+    if isinstance(unicode_or_utf8_string, str):
         return unicode_or_utf8_string
     try:
         return unicode_or_utf8_string.decode('utf8')
@@ -1730,8 +1690,6 @@
         if orig_val is not None:
             del os.environ[env_variable]
     else:
-        if not PY3 and isinstance(value, text_type):
-            value = value.encode(get_user_encoding())
         os.environ[env_variable] = value
     return orig_val
 
@@ -1753,6 +1711,14 @@
 _WIN32_ERROR_DIRECTORY = 267  # Similar to errno.ENOTDIR
 
 
+try:
+    scandir = os.scandir
+except AttributeError:  # Python < 3
+    lazy_import(globals(), """\
+from scandir import scandir
+""")
+
+
 def _is_error_enotdir(e):
     """Check if this exception represents ENOTDIR.
 
@@ -1812,10 +1778,7 @@
     # depending on top and prefix - i.e. ./foo and foo as a pair leads to
     # potentially confusing output. We should make this more robust - but
     # not at a speed cost. RBC 20060731
-    _lstat = os.lstat
     _directory = _directory_kind
-    _listdir = os.listdir
-    _kind_from_mode = file_kind_from_stat_mode
     pending = [(safe_unicode(prefix), "", _directory, None, safe_unicode(top))]
     while pending:
         # 0 - relpath, 1- basename, 2- kind, 3- stat, 4-toppath
@@ -1827,18 +1790,18 @@
         top_slash = top + u'/'
 
         dirblock = []
-        append = dirblock.append
         try:
-            names = sorted(map(decode_filename, _listdir(top)))
+            for entry in scandir(top):
+                name = decode_filename(entry.name)
+                statvalue = entry.stat(follow_symlinks=False)
+                kind = file_kind_from_stat_mode(statvalue.st_mode)
+                dirblock.append((relprefix + name, name, kind, statvalue, entry.path))
         except OSError as e:
             if not _is_error_enotdir(e):
                 raise
-        else:
-            for name in names:
-                abspath = top_slash + name
-                statvalue = _lstat(abspath)
-                kind = _kind_from_mode(statvalue.st_mode)
-                append((relprefix + name, name, kind, statvalue, abspath))
+        except UnicodeDecodeError as e:
+            raise errors.BadFilenameEncoding(e.object, _fs_enc)
+        dirblock.sort()
         yield (relroot, top), dirblock
 
         # push the user specified dirs from dirblock
@@ -1954,9 +1917,6 @@
         def _fs_decode(s): return s.decode(_fs_enc)
 
         def _fs_encode(s): return s.encode(_fs_enc)
-        _lstat = os.lstat
-        _listdir = os.listdir
-        _kind_from_mode = file_kind_from_stat_mode
 
         if prefix:
             relprefix = prefix + b'/'
@@ -1966,16 +1926,16 @@
 
         dirblock = []
         append = dirblock.append
-        for name_native in _listdir(top.encode('utf-8')):
+        for entry in scandir(safe_utf8(top)):
             try:
-                name = _fs_decode(name_native)
+                name = _fs_decode(entry.name)
             except UnicodeDecodeError:
                 raise errors.BadFilenameEncoding(
-                    relprefix + name_native, _fs_enc)
+                    relprefix + entry.name, _fs_enc)
+            abspath = top_slash + name
             name_utf8 = _utf8_encode(name)[0]
-            abspath = top_slash + name
-            statvalue = _lstat(abspath)
-            kind = _kind_from_mode(statvalue.st_mode)
+            statvalue = entry.stat(follow_symlinks=False)
+            kind = file_kind_from_stat_mode(statvalue.st_mode)
             append((relprefix + name_utf8, name_utf8, kind, statvalue, abspath))
         return sorted(dirblock)
 
@@ -2126,9 +2086,7 @@
         return win32utils.get_host_name()
     else:
         import socket
-        if PY3:
-            return socket.gethostname()
-        return socket.gethostname().decode(get_user_encoding())
+        return socket.gethostname()
 
 
 # We must not read/write any more than 64k at a time from/to a socket so we
@@ -2713,7 +2671,4 @@
     return _FILESYSTEM_FINDER.find(path)
 
 
-if PY3:
-    perf_counter = time.perf_counter
-else:
-    perf_counter = time.clock
+perf_counter = time.perf_counter

=== modified file 'breezy/patch.py'
--- breezy/patch.py	2019-12-22 12:06:17 +0000
+++ breezy/patch.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 """Diff and patch functionality"""
 
 import errno

=== modified file 'breezy/patches.py'
--- breezy/patches.py	2019-12-28 14:10:36 +0000
+++ breezy/patches.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from .errors import (
     BzrError,
     )

=== modified file 'breezy/plugin.py'
--- breezy/plugin.py	2020-01-11 17:41:33 +0000
+++ breezy/plugin.py	2020-02-18 01:57:45 +0000
@@ -34,8 +34,6 @@
 plugins.
 """
 
-from __future__ import absolute_import
-
 import os
 import re
 import sys
@@ -63,10 +61,7 @@
 
 _MODULE_PREFIX = "breezy.plugins."
 
-if __debug__ or sys.version_info > (3,):
-    COMPILED_EXT = ".pyc"
-else:
-    COMPILED_EXT = ".pyo"
+COMPILED_EXT = ".pyc"
 
 
 def disable_plugins(state=None):

=== modified file 'breezy/plugins/__init__.py'
--- breezy/plugins/__init__.py	2017-06-02 23:43:00 +0000
+++ breezy/plugins/__init__.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Pseudo-namespace package for breezy plugins."""
 
-from __future__ import absolute_import
-
 from breezy.plugin import extend_path
 
 __path__ = extend_path(__path__, __name__)

=== modified file 'breezy/plugins/bash_completion/__init__.py'
--- breezy/plugins/bash_completion/__init__.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/bash_completion/__init__.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 __doc__ = """Generate a shell function for bash command line completion.
 
 This plugin provides a command called bash-completion that generates a

=== modified file 'breezy/plugins/bash_completion/bashcomp.py'
--- breezy/plugins/bash_completion/bashcomp.py	2020-01-31 17:43:44 +0000
+++ breezy/plugins/bash_completion/bashcomp.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from ... import (
     cmdline,
     commands,
@@ -26,9 +24,6 @@
     option,
     plugin,
 )
-from ...sixish import (
-    text_type,
-    )
 import breezy
 import re
 import sys
@@ -428,13 +423,13 @@
     """
 
     takes_options = [
-        option.Option("function-name", short_name="f", type=text_type, argname="name",
+        option.Option("function-name", short_name="f", type=str, argname="name",
                       help="Name of the generated function (default: _brz)"),
         option.Option("function-only", short_name="o", type=None,
                       help="Generate only the shell function, don't enable it"),
         option.Option("debug", type=None, hidden=True,
                       help="Enable shell code useful for debugging"),
-        option.ListOption("plugin", type=text_type, argname="name",
+        option.ListOption("plugin", type=str, argname="name",
                           # param_name="selected_plugins", # doesn't work, bug #387117
                           help="Enable completions for the selected plugin"
                           + " (default: all plugins)"),

=== modified file 'breezy/plugins/changelog_merge/__init__.py'
--- breezy/plugins/changelog_merge/__init__.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/changelog_merge/__init__.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 __doc__ = """Merge hook for GNU-format ChangeLog files
 
 To enable this plugin, add a section to your locations.conf

=== modified file 'breezy/plugins/changelog_merge/changelog_merge.py'
--- breezy/plugins/changelog_merge/changelog_merge.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/changelog_merge/changelog_merge.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Merge logic for changelog_merge plugin."""
 
-from __future__ import absolute_import
-
 import difflib
 
 from ... import (

=== modified file 'breezy/plugins/commitfromnews/__init__.py'
--- breezy/plugins/commitfromnews/__init__.py	2019-10-13 16:49:05 +0000
+++ breezy/plugins/commitfromnews/__init__.py	2020-02-18 01:57:45 +0000
@@ -33,8 +33,6 @@
 including sections from a NEWS or ChangeLog file.
 """
 
-from __future__ import absolute_import
-
 from ... import version_info  # noqa: F401
 from ... import hooks
 from ...config import (

=== modified file 'breezy/plugins/commitfromnews/committemplate.py'
--- breezy/plugins/commitfromnews/committemplate.py	2019-03-02 21:46:18 +0000
+++ breezy/plugins/commitfromnews/committemplate.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Logic to create commit templates."""
 
-from __future__ import absolute_import
-
 import patiencediff
 
 from ... import bugtracker, osutils

=== modified file 'breezy/plugins/commitfromnews/tests/__init__.py'
--- breezy/plugins/commitfromnews/tests/__init__.py	2019-10-27 18:22:53 +0000
+++ breezy/plugins/commitfromnews/tests/__init__.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Tests for commitfromnews."""
 
-from __future__ import absolute_import
-
 
 def load_tests(loader, basic_tests, pattern):
     testmod_names = [

=== modified file 'breezy/plugins/commitfromnews/tests/test_committemplate.py'
--- breezy/plugins/commitfromnews/tests/test_committemplate.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/commitfromnews/tests/test_committemplate.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Tests for the commit template creation."""
 
-from __future__ import absolute_import
-
 from ... import commitfromnews
 from .... import (
     config,

=== modified file 'breezy/plugins/commitfromnews/tests/test_msgeditor.py'
--- breezy/plugins/commitfromnews/tests/test_msgeditor.py	2017-06-13 00:17:21 +0000
+++ breezy/plugins/commitfromnews/tests/test_msgeditor.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Tests for msg editor interactions.."""
 
-from __future__ import absolute_import
-
 from ... import commitfromnews
 from .... import msgeditor
 from ....tests import TestCaseWithTransport

=== modified file 'breezy/plugins/cvs/__init__.py'
--- breezy/plugins/cvs/__init__.py	2019-12-22 13:21:36 +0000
+++ breezy/plugins/cvs/__init__.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 Currently limited to referencing tools for migration.
 """
 
-from __future__ import absolute_import
-
 from ... import version_info  # noqa: F401
 
 from ... import (

=== modified file 'breezy/plugins/darcs/__init__.py'
--- breezy/plugins/darcs/__init__.py	2019-11-06 01:31:41 +0000
+++ breezy/plugins/darcs/__init__.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 Currently only tells the user to use fastimport/fastexport.
 """
 
-from __future__ import absolute_import
-
 from ... import version_info  # noqa: F401
 from breezy import (
     controldir,

=== modified file 'breezy/plugins/email/__init__.py'
--- breezy/plugins/email/__init__.py	2019-10-13 16:49:05 +0000
+++ breezy/plugins/email/__init__.py	2020-02-18 01:57:45 +0000
@@ -64,8 +64,6 @@
   revision_mail_headers=X-Cheese: to the rescue!
 """
 
-from __future__ import absolute_import
-
 from ... import version_info  # noqa: F401
 from ...config import option_registry
 

=== modified file 'breezy/plugins/email/emailer.py'
--- breezy/plugins/email/emailer.py	2019-06-29 19:54:32 +0000
+++ breezy/plugins/email/emailer.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from __future__ import absolute_import
-
 import subprocess
 import tempfile
 
@@ -80,7 +78,7 @@
 
         # We must use StringIO.StringIO because we want a Unicode string that
         # we can pass to send_email and have that do the proper encoding.
-        from ...sixish import StringIO
+        from io import StringIO
         outf = StringIO()
 
         _body = self.config.get('post_commit_body')
@@ -137,7 +135,7 @@
 
         # We can use a StringIO because show_diff_trees should only write
         # 8-bit strings. It is an error to write a Unicode string here.
-        from ...sixish import StringIO
+        from io import StringIO
         diff_content = StringIO()
         diff_options = self.config.get('post_commit_diffoptions')
         show_diff_trees(tree_old, tree_new, diff_content, None, diff_options)

=== modified file 'breezy/plugins/fastimport/__init__.py'
--- breezy/plugins/fastimport/__init__.py	2019-10-13 16:49:05 +0000
+++ breezy/plugins/fastimport/__init__.py	2020-02-18 01:57:45 +0000
@@ -54,8 +54,6 @@
 page on Launchpad, https://launchpad.net/bzr-fastimport.
 """
 
-from __future__ import absolute_import
-
 from ... import version_info  # noqa: F401
 from ...commands import plugin_cmds
 

=== modified file 'breezy/plugins/fastimport/branch_mapper.py'
--- breezy/plugins/fastimport/branch_mapper.py	2018-07-03 23:54:50 +0000
+++ breezy/plugins/fastimport/branch_mapper.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 """An object that maps git ref names to bzr branch names.  Note that it is not
 used to map git ref names to bzr tag names."""
 
-from __future__ import absolute_import
-
 import re
 
 

=== modified file 'breezy/plugins/fastimport/branch_updater.py'
--- breezy/plugins/fastimport/branch_updater.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/fastimport/branch_updater.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 
 """An object that updates a bunch of branches based on data imported."""
 
-from __future__ import absolute_import
-
 from operator import itemgetter
 
 from ... import errors, osutils, transport

=== modified file 'breezy/plugins/fastimport/bzr_commit_handler.py'
--- breezy/plugins/fastimport/bzr_commit_handler.py	2019-09-22 13:03:16 +0000
+++ breezy/plugins/fastimport/bzr_commit_handler.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 
 """CommitHandlers that build and save revisions & their inventories."""
 
-from __future__ import absolute_import
-
 from ... import (
     debug,
     errors,

=== modified file 'breezy/plugins/fastimport/cache_manager.py'
--- breezy/plugins/fastimport/cache_manager.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/fastimport/cache_manager.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 
 """A manager of caches."""
 
-from __future__ import absolute_import
-
 import atexit
 import os
 import shutil

=== modified file 'breezy/plugins/fastimport/cmds.py'
--- breezy/plugins/fastimport/cmds.py	2018-11-26 20:50:51 +0000
+++ breezy/plugins/fastimport/cmds.py	2020-02-18 01:57:45 +0000
@@ -15,14 +15,9 @@
 
 """Fastimport/fastexport commands."""
 
-from __future__ import absolute_import
-
 from ... import controldir
 from ...commands import Command
 from ...option import Option, RegistryOption
-from ...sixish import (
-    text_type,
-    )
 
 
 from . import (
@@ -242,10 +237,10 @@
     _see_also = ['fast-export', 'fast-import-filter', 'fast-import-info']
     takes_args = ['source', 'destination?']
     takes_options = ['verbose',
-                     Option('user-map', type=text_type,
+                     Option('user-map', type=str,
                             help="Path to file containing a map of user-ids.",
                             ),
-                     Option('info', type=text_type,
+                     Option('info', type=str,
                             help="Path to file containing caching hints.",
                             ),
                      Option('trees',
@@ -271,10 +266,10 @@
                                                 experimental="Enable experimental features.",
                                                 value_switches=True, enum_switch=False,
                                                 ),
-                     Option('import-marks', type=text_type,
+                     Option('import-marks', type=str,
                             help="Import marks from file."
                             ),
-                     Option('export-marks', type=text_type,
+                     Option('export-marks', type=str,
                             help="Export marks to file."
                             ),
                      RegistryOption('format',
@@ -322,7 +317,7 @@
                     user_map=user_map)
 
     def _generate_info(self, source):
-        from ...sixish import StringIO
+        from io import StringIO
         from fastimport import parser
         from fastimport.errors import ParsingError
         from ...errors import BzrCommandError
@@ -448,20 +443,20 @@
     _see_also = ['fast-import', 'fast-import-filter']
     takes_args = ['source?', 'destination?']
     takes_options = ['verbose', 'revision',
-                     Option('git-branch', short_name='b', type=text_type,
+                     Option('git-branch', short_name='b', type=str,
                             argname='FILE',
                             help='Name of the git branch to create (default=master).'
                             ),
                      Option('checkpoint', type=int, argname='N',
                             help="Checkpoint every N revisions (default=10000)."
                             ),
-                     Option('marks', type=text_type, argname='FILE',
+                     Option('marks', type=str, argname='FILE',
                             help="Import marks from and export marks to file."
                             ),
-                     Option('import-marks', type=text_type, argname='FILE',
+                     Option('import-marks', type=str, argname='FILE',
                             help="Import marks from file."
                             ),
-                     Option('export-marks', type=text_type, argname='FILE',
+                     Option('export-marks', type=str, argname='FILE',
                             help="Export marks to file."
                             ),
                      Option('plain',

=== modified file 'breezy/plugins/fastimport/exporter.py'
--- breezy/plugins/fastimport/exporter.py	2020-01-26 04:41:46 +0000
+++ breezy/plugins/fastimport/exporter.py	2020-02-18 01:57:45 +0000
@@ -41,16 +41,11 @@
 
 """Core engine for the fast-export command."""
 
-from __future__ import absolute_import
-
 # TODO: if a new_git_branch below gets merged repeatedly, the tip of the branch
 # is not updated (because the parent of commit is already merged, so we don't
 # set new_git_branch to the previously used name)
 
-try:
-    from email.utils import parseaddr
-except ImportError:  # python < 3
-    from email.Utils import parseaddr
+from email.utils import parseaddr
 import sys
 import time
 import re
@@ -66,11 +61,6 @@
     progress,
     trace,
     )
-from ...sixish import (
-    int2byte,
-    PY3,
-    viewitems,
-    )
 
 from . import (
     helpers,
@@ -140,13 +130,14 @@
     :param refname: refname to rewrite
     :return: new refname
     """
+    import struct
     new_refname = re.sub(
         # '/.' in refname or startswith '.'
         br"/\.|^\."
         # '..' in refname
         br"|\.\."
         # ord(c) < 040
-        br"|[" + b"".join([int2byte(x) for x in range(0o40)]) + br"]"
+        br"|[" + b"".join([bytes([x]) for x in range(0o40)]) + br"]"
         # c in '\177 ~^:?*['
         br"|[\177 ~^:?*[]"
         # last char in "/."
@@ -319,10 +310,7 @@
                   time_required)
 
     def print_cmd(self, cmd):
-        if PY3:
-            self.outf.write(b"%s\n" % cmd)
-        else:
-            self.outf.write(b"%r\n" % cmd)
+        self.outf.write(b"%s\n" % cmd)
 
     def _save_marks(self):
         if self.export_marks_file:
@@ -651,7 +639,7 @@
         return path
 
     def emit_tags(self):
-        for tag, revid in viewitems(self.branch.tags.get_tag_dict()):
+        for tag, revid in self.branch.tags.get_tag_dict().items():
             try:
                 mark = self.revid_to_mark[revid]
             except KeyError:

=== modified file 'breezy/plugins/fastimport/helpers.py'
--- breezy/plugins/fastimport/helpers.py	2019-03-18 04:31:21 +0000
+++ breezy/plugins/fastimport/helpers.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 
 """Miscellaneous useful stuff."""
 
-from __future__ import absolute_import
-
 import stat
 
 from ... import (

=== modified file 'breezy/plugins/fastimport/idmapfile.py'
--- breezy/plugins/fastimport/idmapfile.py	2018-07-03 23:54:50 +0000
+++ breezy/plugins/fastimport/idmapfile.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 
 """Routines for saving and loading the id-map file."""
 
-from __future__ import absolute_import
-
 import os
 
 

=== modified file 'breezy/plugins/fastimport/marks_file.py'
--- breezy/plugins/fastimport/marks_file.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/fastimport/marks_file.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 
 """Routines for reading/writing a marks file."""
 
-from __future__ import absolute_import
-
 from ...trace import warning
 
 

=== modified file 'breezy/plugins/fastimport/processors/__init__.py'
--- breezy/plugins/fastimport/processors/__init__.py	2017-05-24 14:51:33 +0000
+++ breezy/plugins/fastimport/processors/__init__.py	2020-02-18 01:57:45 +0000
@@ -14,5 +14,3 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 """Actual import processors."""
-
-from __future__ import absolute_import

=== modified file 'breezy/plugins/fastimport/processors/generic_processor.py'
--- breezy/plugins/fastimport/processors/generic_processor.py	2019-12-01 16:21:41 +0000
+++ breezy/plugins/fastimport/processors/generic_processor.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 
 """Import processor that supports all Bazaar repository formats."""
 
-from __future__ import absolute_import
-
 
 import time
 from .... import (

=== modified file 'breezy/plugins/fastimport/revision_store.py'
--- breezy/plugins/fastimport/revision_store.py	2020-01-19 13:47:29 +0000
+++ breezy/plugins/fastimport/revision_store.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 
 """An abstraction of a repository providing just the bits importing needs."""
 
-from __future__ import absolute_import
-
 from io import BytesIO
 
 from ... import (

=== modified file 'breezy/plugins/fastimport/tests/__init__.py'
--- breezy/plugins/fastimport/tests/__init__.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/fastimport/tests/__init__.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Tests for bzr-fastimport."""
 
-from __future__ import absolute_import
-
 from .... import errors as bzr_errors
 from ....tests import TestLoader
 from ....tests.features import Feature

=== modified file 'breezy/plugins/fastimport/tests/test_branch_mapper.py'
--- breezy/plugins/fastimport/tests/test_branch_mapper.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/fastimport/tests/test_branch_mapper.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 
 """Test the BranchMapper methods."""
 
-from __future__ import absolute_import
-
 from .... import tests
 
 from .. import (

=== modified file 'breezy/plugins/fastimport/tests/test_commands.py'
--- breezy/plugins/fastimport/tests/test_commands.py	2019-12-01 16:14:53 +0000
+++ breezy/plugins/fastimport/tests/test_commands.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 
 """Test the command implementations."""
 
-from __future__ import absolute_import
-
 import os
 import re
 import tempfile

=== modified file 'breezy/plugins/fastimport/tests/test_exporter.py'
--- breezy/plugins/fastimport/tests/test_exporter.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/fastimport/tests/test_exporter.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 
 """Test the exporter."""
 
-from __future__ import absolute_import
-
 import os
 import tempfile
 import gzip

=== modified file 'breezy/plugins/fastimport/tests/test_generic_processor.py'
--- breezy/plugins/fastimport/tests/test_generic_processor.py	2019-12-26 13:20:45 +0000
+++ breezy/plugins/fastimport/tests/test_generic_processor.py	2020-02-18 01:57:45 +0000
@@ -13,8 +13,6 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-from __future__ import absolute_import
-
 import time
 
 from .... import (

=== modified file 'breezy/plugins/fastimport/tests/test_head_tracking.py'
--- breezy/plugins/fastimport/tests/test_head_tracking.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/fastimport/tests/test_head_tracking.py	2020-02-18 01:57:45 +0000
@@ -15,9 +15,7 @@
 
 """Test tracking of heads"""
 
-from __future__ import absolute_import
-
-from ....sixish import StringIO
+from io import StringIO
 
 from fastimport import (
     commands,

=== modified file 'breezy/plugins/fastimport/tests/test_revision_store.py'
--- breezy/plugins/fastimport/tests/test_revision_store.py	2019-09-21 23:05:12 +0000
+++ breezy/plugins/fastimport/tests/test_revision_store.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 
 """Direct tests of the revision_store classes."""
 
-from __future__ import absolute_import
-
 from .... import (
     branch,
     errors,

=== modified file 'breezy/plugins/fastimport/user_mapper.py'
--- breezy/plugins/fastimport/user_mapper.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/fastimport/user_mapper.py	2020-02-18 01:57:45 +0000
@@ -13,12 +13,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-from __future__ import absolute_import
-
-try:
-    from email.utils import parseaddr
-except ImportError:
-    from email.Utils import parseaddr
+from email.utils import parseaddr
 
 
 class UserMapper(object):

=== modified file 'breezy/plugins/flake8/__init__.py'
--- breezy/plugins/flake8/__init__.py	2019-08-22 21:54:14 +0000
+++ breezy/plugins/flake8/__init__.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 """
 
 
-from __future__ import absolute_import
-
 from breezy.errors import BzrError, DependencyNotPresent
 
 

=== modified file 'breezy/plugins/fossil/__init__.py'
--- breezy/plugins/fossil/__init__.py	2019-11-09 16:27:41 +0000
+++ breezy/plugins/fossil/__init__.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 Currently only tells the user that Fossil is not supported.
 """
 
-from __future__ import absolute_import
-
 from ... import version_info  # noqa: F401
 
 from ... import (

=== modified file 'breezy/plugins/hg/__init__.py'
--- breezy/plugins/hg/__init__.py	2020-01-12 13:56:10 +0000
+++ breezy/plugins/hg/__init__.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 Currently only tells the user that Mercurial is not supported.
 """
 
-from __future__ import absolute_import
-
 from ... import (
     controldir,
     errors,

=== modified file 'breezy/plugins/launchpad/__init__.py'
--- breezy/plugins/launchpad/__init__.py	2019-02-14 19:18:27 +0000
+++ breezy/plugins/launchpad/__init__.py	2020-02-19 03:16:24 +0000
@@ -30,15 +30,8 @@
     launchpad-login: Show or set the Launchpad user ID
     launchpad-open: Open a Launchpad branch page in your web browser
 
-As well as the following deprecated command:
-
-    lp-propose-merge: Propose merging a branch on Launchpad
-         (deprecated in favour of the more generic 'brz propose-merge')
-
 """
 
-from __future__ import absolute_import
-
 # The XMLRPC server address can be overridden by setting the environment
 # variable $BRZ_LP_XMLRPC_URL
 
@@ -62,7 +55,6 @@
     ("cmd_launchpad_open", ["lp-open"]),
     ("cmd_launchpad_login", ["lp-login"]),
     ("cmd_launchpad_logout", ["lp-logout"]),
-    ("cmd_lp_propose_merge", ["lp-submit", "lp-propose"]),
         ("cmd_lp_find_proposal", [])]:
     plugin_cmds.register_lazy(klsname, aliases,
                               "breezy.plugins.launchpad.cmds")

=== modified file 'breezy/plugins/launchpad/account.py'
--- breezy/plugins/launchpad/account.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/launchpad/account.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 than once for each place that needs to take it into account.
 """
 
-from __future__ import absolute_import
-
 from ... import (
     errors,
     trace,

=== modified file 'breezy/plugins/launchpad/cmds.py'
--- breezy/plugins/launchpad/cmds.py	2019-02-10 03:34:06 +0000
+++ breezy/plugins/launchpad/cmds.py	2020-02-19 03:16:24 +0000
@@ -16,8 +16,6 @@
 
 """Launchpad plugin commands."""
 
-from __future__ import absolute_import
-
 from ... import (
     branch as _mod_branch,
     controldir,
@@ -35,9 +33,6 @@
     Option,
     ListOption,
     )
-from ...sixish import (
-    text_type,
-    )
 
 
 class cmd_launchpad_open(Command):
@@ -167,70 +162,6 @@
                 old_username)
 
 
-class cmd_lp_propose_merge(Command):
-    __doc__ = """Propose merging a branch on Launchpad.
-
-    This will open your usual editor to provide the initial comment.  When it
-    has created the proposal, it will open it in your default web browser.
-
-    The branch will be proposed to merge into SUBMIT_BRANCH.  If SUBMIT_BRANCH
-    is not supplied, the remembered submit branch will be used.  If no submit
-    branch is remembered, the development focus will be used.
-
-    By default, the SUBMIT_BRANCH's review team will be requested to review
-    the merge proposal.  This can be overriden by specifying --review (-R).
-    The parameter the launchpad account name of the desired reviewer.  This
-    may optionally be followed by '=' and the review type.  For example:
-
-      brz lp-propose-merge --review jrandom --review review-team=qa
-
-    This will propose a merge,  request "jrandom" to perform a review of
-    unspecified type, and request "review-team" to perform a "qa" review.
-    """
-
-    hidden = True
-    takes_options = [Option('staging',
-                            help='Propose the merge on staging.'),
-                     Option('message', short_name='m', type=text_type,
-                            help='Commit message.'),
-                     Option('approve',
-                            help=('Mark the proposal as approved immediately, '
-                                  'setting the approved revision to tip.')),
-                     Option('fixes', 'The bug this proposal fixes.', str),
-                     ListOption('review', short_name='R', type=text_type,
-                                help='Requested reviewer and optional type.')]
-
-    takes_args = ['submit_branch?']
-
-    aliases = ['lp-submit', 'lp-propose']
-
-    def run(self, submit_branch=None, review=None, staging=False,
-            message=None, approve=False, fixes=None):
-        from . import lp_propose
-        tree, branch, relpath = controldir.ControlDir.open_containing_tree_or_branch(
-            '.')
-        if review is None:
-            reviews = None
-        else:
-            reviews = []
-            for review in review:
-                if '=' in review:
-                    reviews.append(review.split('=', 2))
-                else:
-                    reviews.append((review, ''))
-            if submit_branch is None:
-                submit_branch = branch.get_submit_branch()
-        if submit_branch is None:
-            target = None
-        else:
-            target = _mod_branch.Branch.open(submit_branch)
-        proposer = lp_propose.Proposer(tree, branch, target, message,
-                                       reviews, staging, approve=approve,
-                                       fixes=fixes)
-        proposer.check_proposal()
-        proposer.create_proposal()
-
-
 class cmd_lp_find_proposal(Command):
 
     __doc__ = """Find the proposal to merge this revision.

=== modified file 'breezy/plugins/launchpad/lp_api.py'
--- breezy/plugins/launchpad/lp_api.py	2019-11-19 18:10:28 +0000
+++ breezy/plugins/launchpad/lp_api.py	2020-02-18 01:57:45 +0000
@@ -16,24 +16,16 @@
 
 """Tools for dealing with the Launchpad API."""
 
-from __future__ import absolute_import
-
 # Importing this module will be expensive, since it imports launchpadlib and
 # its dependencies. However, our plan is to only load this module when it is
 # needed by a command that uses it.
 
 
 import re
-try:
-    from urllib.parse import (
-        urlparse,
-        urlunparse,
-        )
-except ImportError:  # python < 3
-    from urlparse import (
-        urlparse,
-        urlunparse,
-        )
+from urllib.parse import (
+    urlparse,
+    urlunparse,
+    )
 
 from ... import (
     branch,

=== modified file 'breezy/plugins/launchpad/lp_directory.py'
--- breezy/plugins/launchpad/lp_directory.py	2019-11-19 18:10:28 +0000
+++ breezy/plugins/launchpad/lp_directory.py	2020-02-18 01:57:45 +0000
@@ -16,16 +16,8 @@
 
 """Directory lookup that uses Launchpad."""
 
-from __future__ import absolute_import
-
-try:
-    from urllib.parse import urlsplit
-except ImportError:  # python < 3
-    from urlparse import urlsplit
-try:
-    from xmlrpc.client import Fault
-except ImportError:  # Python < 3
-    from xmlrpclib import Fault
+from urllib.parse import urlsplit
+from xmlrpc.client import Fault
 
 from ... import (
     debug,

=== modified file 'breezy/plugins/launchpad/lp_propose.py'
--- breezy/plugins/launchpad/lp_propose.py	2019-06-15 12:04:34 +0000
+++ breezy/plugins/launchpad/lp_propose.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from ... import (
     errors,
     hooks,

=== modified file 'breezy/plugins/launchpad/lp_registration.py'
--- breezy/plugins/launchpad/lp_registration.py	2019-11-19 18:10:28 +0000
+++ breezy/plugins/launchpad/lp_registration.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from io import BytesIO
 import os
 import socket
@@ -24,22 +22,13 @@
 except ImportError:
     from urlparse import urlsplit, urlunsplit  # noqa: F401
 import urllib
-try:
-    from xmlrpc.client import (
-        __version__ as xmlrpc_version,
-        Fault,
-        ProtocolError,
-        ServerProxy,
-        Transport,
-        )
-except ImportError:  # python < 3
-    from xmlrpclib import (
-        __version__ as xmlrpc_version,
-        Fault,
-        ProtocolError,
-        Transport,
-        ServerProxy,
-        )
+from xmlrpc.client import (
+    __version__ as xmlrpc_version,
+    Fault,
+    ProtocolError,
+    ServerProxy,
+    Transport,
+    )
 
 from ... import (
     errors,

=== modified file 'breezy/plugins/launchpad/test_lp_directory.py'
--- breezy/plugins/launchpad/test_lp_directory.py	2019-11-19 20:09:18 +0000
+++ breezy/plugins/launchpad/test_lp_directory.py	2020-02-07 02:14:30 +0000
@@ -18,11 +18,8 @@
 
 import os
 
-try:
-    from xmlrpc.client import Fault
-    from http.client import parse_headers
-except ImportError:  # python < 3
-    from xmlrpclib import Fault
+from xmlrpc.client import Fault
+from http.client import parse_headers
 
 import breezy
 from ... import (
@@ -32,7 +29,6 @@
     )
 from ...branch import Branch
 from ...directory_service import directories
-from ...sixish import PY3
 from ...tests import (
     features,
     ssl_certs,
@@ -428,10 +424,7 @@
     def handle_one_request(self):
         tcs = self.server.test_case_server
         requestline = self.rfile.readline()
-        if PY3:
-            parse_headers(self.rfile)
-        else:
-            self.MessageClass(self.rfile, 0)
+        parse_headers(self.rfile)
         if requestline.startswith(b'POST'):
             # The body should be a single line (or we don't know where it ends
             # and we don't want to issue a blocking read)

=== modified file 'breezy/plugins/launchpad/test_lp_service.py'
--- breezy/plugins/launchpad/test_lp_service.py	2019-11-19 20:09:18 +0000
+++ breezy/plugins/launchpad/test_lp_service.py	2020-02-07 02:14:30 +0000
@@ -17,10 +17,7 @@
 """Tests for selection of the right Launchpad service by environment"""
 
 import os
-try:
-    from xmlrpc.client import Fault
-except ImportError:  # python < 3
-    from xmlrpclib import Fault
+from xmlrpc.client import Fault
 
 from .lp_registration import (
     InvalidURL,

=== modified file 'breezy/plugins/launchpad/test_register.py'
--- breezy/plugins/launchpad/test_register.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/launchpad/test_register.py	2020-02-07 02:14:30 +0000
@@ -16,18 +16,11 @@
 
 from io import BytesIO
 
-try:
-    from xmlrpc.client import (
-        loads as xmlrpc_loads,
-        Transport,
-        )
-except ImportError:  # python < 3
-    from xmlrpclib import (
-        loads as xmlrpc_loads,
-        Transport,
-        )
+from xmlrpc.client import (
+    loads as xmlrpc_loads,
+    Transport,
+    )
 
-from ...sixish import PY3
 from ...tests import TestCaseWithTransport
 
 # local import
@@ -111,23 +104,17 @@
             raise AssertionError()
         return InstrumentedXMLRPCConnection(test)
 
-    if PY3:
-        def send_request(self, host, handler_path, request_body,
-                         verbose=None):
-            self.connected_host = host
-            test = self.testcase
-            self.got_request = True
-            unpacked, method = xmlrpc_loads(request_body)
-            if None in unpacked:
-                raise AssertionError(
-                    "xmlrpc result %r shouldn't contain None" % (unpacked,))
-            self.sent_params = unpacked
-            return InstrumentedXMLRPCConnection(test)
-    else:
-        def send_request(self, connection, handler_path, request_body,
-                         verbose=None):
-            test = self.testcase
-            self.got_request = True
+    def send_request(self, host, handler_path, request_body,
+                     verbose=None):
+        self.connected_host = host
+        test = self.testcase
+        self.got_request = True
+        unpacked, method = xmlrpc_loads(request_body)
+        if None in unpacked:
+            raise AssertionError(
+                "xmlrpc result %r shouldn't contain None" % (unpacked,))
+        self.sent_params = unpacked
+        return InstrumentedXMLRPCConnection(test)
 
     def send_host(self, conn, host):
         pass

=== modified file 'breezy/plugins/launchpad/uris.py'
--- breezy/plugins/launchpad/uris.py	2019-10-27 00:30:00 +0000
+++ breezy/plugins/launchpad/uris.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Launchpad URIs."""
 
-from __future__ import absolute_import
-
 
 # We use production as the default because edge has been deprecated circa
 # 2010-11 (see bug https://bugs.launchpad.net/bzr/+bug/583667)

=== modified file 'breezy/plugins/mtn/__init__.py'
--- breezy/plugins/mtn/__init__.py	2019-11-06 01:31:41 +0000
+++ breezy/plugins/mtn/__init__.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 Currently only tells the user that Monotone is not supported.
 """
 
-from __future__ import absolute_import
-
 from ... import version_info  # noqa: F401
 
 from ... import (

=== modified file 'breezy/plugins/netrc_credential_store/__init__.py'
--- breezy/plugins/netrc_credential_store/__init__.py	2020-01-11 17:41:33 +0000
+++ breezy/plugins/netrc_credential_store/__init__.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 __doc__ = """Use ~/.netrc as a credential store for authentication.conf."""
 
 # Since we are a built-in plugin we share the breezy version

=== modified file 'breezy/plugins/netrc_credential_store/tests/test_netrc.py'
--- breezy/plugins/netrc_credential_store/tests/test_netrc.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/netrc_credential_store/tests/test_netrc.py	2020-02-07 02:14:30 +0000
@@ -14,15 +14,13 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from io import BytesIO
 from .... import (
     config,
     errors,
     osutils,
     tests,
     )
-from ....sixish import (
-    BytesIO,
-    )
 
 from ... import netrc_credential_store
 

=== modified file 'breezy/plugins/news_merge/__init__.py'
--- breezy/plugins/news_merge/__init__.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/news_merge/__init__.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 __doc__ = """Merge hook for bzr's NEWS file.
 
 To enable this plugin, add a section to your branch.conf or location.conf

=== modified file 'breezy/plugins/news_merge/news_merge.py'
--- breezy/plugins/news_merge/news_merge.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/news_merge/news_merge.py	2020-02-18 01:57:45 +0000
@@ -16,9 +16,6 @@
 
 """Merge logic for news_merge plugin."""
 
-from __future__ import absolute_import
-
-
 from .parser import simple_parse_lines
 from ... import merge, merge3
 

=== modified file 'breezy/plugins/news_merge/parser.py'
--- breezy/plugins/news_merge/parser.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/news_merge/parser.py	2020-02-18 01:57:45 +0000
@@ -24,9 +24,6 @@
 simple_parse's docstring).
 """
 
-from __future__ import absolute_import
-
-
 def simple_parse_lines(lines):
     """Same as simple_parse, but takes an iterable of strs rather than a single
     str.

=== modified file 'breezy/plugins/po_merge/__init__.py'
--- breezy/plugins/po_merge/__init__.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/po_merge/__init__.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 __doc__ = """Merge hook for ``.po`` files.
 
 To enable this plugin, add a section to your branch.conf or location.conf

=== modified file 'breezy/plugins/po_merge/po_merge.py'
--- breezy/plugins/po_merge/po_merge.py	2018-11-21 03:20:30 +0000
+++ breezy/plugins/po_merge/po_merge.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Merge logic for po_merge plugin."""
 
-from __future__ import absolute_import
-
 from ... import (
     config,
     merge,

=== modified file 'breezy/plugins/propose/__init__.py'
--- breezy/plugins/propose/__init__.py	2019-10-27 13:45:49 +0000
+++ breezy/plugins/propose/__init__.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Management of hosted branches."""
 
-from __future__ import absolute_import
-
 from ... import version_info  # noqa: F401
 from ...commands import plugin_cmds
 

=== modified file 'breezy/plugins/propose/cmds.py'
--- breezy/plugins/propose/cmds.py	2020-03-07 13:30:38 +0000
+++ breezy/plugins/propose/cmds.py	2020-03-07 14:46:08 +0000
@@ -16,8 +16,6 @@
 
 """Propose command implementations."""
 
-from __future__ import absolute_import
-
 from io import StringIO
 
 from ... import (
@@ -36,7 +34,6 @@
     Option,
     RegistryOption,
     )
-from ...sixish import text_type
 from ...trace import note
 from ... import (
     propose as _mod_propose,
@@ -139,7 +136,7 @@
             'hoster',
             help='Use the hoster.',
             lazy_registry=('breezy.plugins.propose.propose', 'hosters')),
-        ListOption('reviewers', short_name='R', type=text_type,
+        ListOption('reviewers', short_name='R', type=str,
                    help='Requested reviewers.'),
         Option('name', help='Name of the new remote branch.', type=str),
         Option('description', help='Description of the change.', type=str),
@@ -148,7 +145,7 @@
         Option(
             'commit-message',
             help='Set commit message for merge, if supported', type=str),
-        ListOption('labels', short_name='l', type=text_type,
+        ListOption('labels', short_name='l', type=str,
                    help='Labels to apply.'),
         Option('no-allow-lossy',
                help='Allow fallback to lossy push, if necessary.'),

=== modified file 'breezy/plugins/propose/github.py'
--- breezy/plugins/propose/github.py	2020-03-07 15:19:13 +0000
+++ breezy/plugins/propose/github.py	2020-03-07 15:47:50 +0000
@@ -16,8 +16,6 @@
 
 """Support for GitHub."""
 
-from __future__ import absolute_import
-
 import json
 import os
 
@@ -47,7 +45,6 @@
 from ...errors import InvalidHttpResponse, PermissionDenied
 from ...git.urls import git_url_to_bzr_url
 from ...i18n import gettext
-from ...sixish import PY3
 from ...trace import note
 from ...transport import get_transport
 from ...transport.http import default_user_agent
@@ -222,8 +219,6 @@
 
 
 def github_url_to_bzr_url(url, branch_name):
-    if not PY3:
-        branch_name = branch_name.encode('utf-8')
     return git_url_to_bzr_url(url, branch_name)
 
 

=== modified file 'breezy/plugins/propose/gitlabs.py'
--- breezy/plugins/propose/gitlabs.py	2020-03-14 16:44:17 +0000
+++ breezy/plugins/propose/gitlabs.py	2020-03-22 01:35:14 +0000
@@ -16,8 +16,6 @@
 
 """Support for GitLab."""
 
-from __future__ import absolute_import
-
 import json
 import os
 import time
@@ -30,7 +28,6 @@
     urlutils,
     )
 from ...git.urls import git_url_to_bzr_url
-from ...sixish import PY3
 from ...trace import mutter
 from ...transport import get_transport
 
@@ -265,8 +262,6 @@
 
 
 def gitlab_url_to_bzr_url(url, name):
-    if not PY3:
-        name = name.encode('utf-8')
     return git_url_to_bzr_url(url, branch=name)
 
 

=== modified file 'breezy/plugins/propose/launchpad.py'
--- breezy/plugins/propose/launchpad.py	2020-03-07 15:19:13 +0000
+++ breezy/plugins/propose/launchpad.py	2020-03-07 15:47:50 +0000
@@ -17,8 +17,6 @@
 
 """Support for Launchpad."""
 
-from __future__ import absolute_import
-
 import re
 import shutil
 import tempfile

=== removed file 'breezy/plugins/propose/status.txt'
--- breezy/plugins/propose/status.txt	2018-12-31 11:56:23 +0000
+++ breezy/plugins/propose/status.txt	1970-01-01 00:00:00 +0000
@@ -1,35 +0,0 @@
-Status
-======
-
-status: Open (Work In Progress) "wip"
-
- More work is being done by the original author; changes have not been merged
- and the merge proposal is not ready for review.
-
-status: Closed (Merged) "merged"
-
- The change has been merged. No further actions are expected.
-
- On Launchpad, this means that the merge proposal is frozen - the branch can
- be reused.
-
-status: Closed (Rejected) "rejected"
-
- The branch has been rejected. Changes were not merged. The branch and merge
- proposal should be kept around so we don't create a new branch proposal
- with the same changes.
-
- Requires human follow-up.
-
-status: Closed (Obsolete) "obsolete"
-
- Can happen e.g. when the changes are made independently by somebody else.
-
-status: Open (Waiting Review) "waiting-review"
-
- The merge proposal is ready and waiting for review from a reviewer.
-
-status: Open (Waiting Follow-up) "waiting-followup"
-
- The merge proposal is waiting for the original author to follow up to comments
- from a reviewer.

=== modified file 'breezy/plugins/quilt/__init__.py'
--- breezy/plugins/quilt/__init__.py	2019-06-15 11:47:16 +0000
+++ breezy/plugins/quilt/__init__.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 #    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 #
 
-from __future__ import absolute_import
-
 """Quilt patch integration.
 
 This plugin adds support for three configuration options:

=== modified file 'breezy/plugins/quilt/merge.py'
--- breezy/plugins/quilt/merge.py	2019-06-15 11:47:16 +0000
+++ breezy/plugins/quilt/merge.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 
 """Quilt patch handling."""
 
-from __future__ import absolute_import
-
 import shutil
 import tempfile
 

=== modified file 'breezy/plugins/quilt/quilt.py'
--- breezy/plugins/quilt/quilt.py	2019-08-31 10:25:20 +0000
+++ breezy/plugins/quilt/quilt.py	2020-02-18 01:57:45 +0000
@@ -18,8 +18,6 @@
 
 """Quilt patch handling."""
 
-from __future__ import absolute_import
-
 import os
 
 from ... import osutils

=== modified file 'breezy/plugins/quilt/tests/__init__.py'
--- breezy/plugins/quilt/tests/__init__.py	2019-06-15 11:47:16 +0000
+++ breezy/plugins/quilt/tests/__init__.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 #    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 #
 
-from __future__ import absolute_import
-
 from .... import tests
 
 from ....tests import (

=== modified file 'breezy/plugins/quilt/tests/test_merge.py'
--- breezy/plugins/quilt/tests/test_merge.py	2019-06-16 13:10:54 +0000
+++ breezy/plugins/quilt/tests/test_merge.py	2020-02-18 01:57:45 +0000
@@ -18,8 +18,6 @@
 
 """Tests for the merge_quilt code."""
 
-from __future__ import absolute_import
-
 import os
 import shutil
 

=== modified file 'breezy/plugins/quilt/tests/test_wrapper.py'
--- breezy/plugins/quilt/tests/test_wrapper.py	2019-11-18 04:21:00 +0000
+++ breezy/plugins/quilt/tests/test_wrapper.py	2020-02-18 01:57:45 +0000
@@ -18,8 +18,6 @@
 
 """Tests for the quilt code."""
 
-from __future__ import absolute_import
-
 import os
 
 from ..wrapper import (

=== modified file 'breezy/plugins/quilt/wrapper.py'
--- breezy/plugins/quilt/wrapper.py	2019-11-18 04:21:00 +0000
+++ breezy/plugins/quilt/wrapper.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 
 """Quilt patch handling."""
 
-from __future__ import absolute_import
-
 import errno
 import os
 import signal

=== modified file 'breezy/plugins/repodebug/__init__.py'
--- breezy/plugins/repodebug/__init__.py	2019-10-13 16:49:05 +0000
+++ breezy/plugins/repodebug/__init__.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 as hidden commands.
 """
 
-from __future__ import absolute_import
-
 from ... import version_info  # noqa: F401
 from ...commands import plugin_cmds
 

=== modified file 'breezy/plugins/repodebug/check_chk.py'
--- breezy/plugins/repodebug/check_chk.py	2018-11-07 21:17:53 +0000
+++ breezy/plugins/repodebug/check_chk.py	2020-02-18 01:57:45 +0000
@@ -18,8 +18,6 @@
 
 """
 
-from __future__ import absolute_import
-
 from ... import (
     controldir,
     commands,

=== modified file 'breezy/plugins/repodebug/chk_used_by.py'
--- breezy/plugins/repodebug/chk_used_by.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/repodebug/chk_used_by.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from ... import (
     controldir,
     static_tuple,

=== modified file 'breezy/plugins/repodebug/fetch_all_records.py'
--- breezy/plugins/repodebug/fetch_all_records.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/repodebug/fetch_all_records.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-from __future__ import print_function
 
 from ...controldir import ControlDir
 from ...commands import Command, Option

=== modified file 'breezy/plugins/repodebug/file_refs.py'
--- breezy/plugins/repodebug/file_refs.py	2018-05-27 18:00:21 +0000
+++ breezy/plugins/repodebug/file_refs.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from ... import (
     controldir,
     commands,

=== modified file 'breezy/plugins/repodebug/missing_keys_for_stacking_fixer.py'
--- breezy/plugins/repodebug/missing_keys_for_stacking_fixer.py	2019-05-29 03:22:34 +0000
+++ breezy/plugins/repodebug/missing_keys_for_stacking_fixer.py	2020-02-18 01:57:45 +0000
@@ -14,12 +14,9 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from ...controldir import ControlDir
 from ...commands import Command, Option
 from ... import errors
-from ...sixish import viewvalues
 from ...bzr.vf_search import PendingAncestryResult
 from ...repository import WriteGroup
 from ...revision import NULL_REVISION
@@ -65,7 +62,7 @@
             revs = raw_r.all_revision_ids()
             rev_parents = raw_r.get_graph().get_parent_map(revs)
             needed = set()
-            map(needed.update, viewvalues(rev_parents))
+            map(needed.update, rev_parents.values())
             needed.discard(NULL_REVISION)
             needed = set((rev,) for rev in needed)
             needed = needed - raw_r.inventories.keys()

=== modified file 'breezy/plugins/repodebug/repo_has_key.py'
--- breezy/plugins/repodebug/repo_has_key.py	2017-09-07 08:21:29 +0000
+++ breezy/plugins/repodebug/repo_has_key.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from ...controldir import ControlDir
 from ...commands import Command
 

=== modified file 'breezy/plugins/repodebug/repo_keys.py'
--- breezy/plugins/repodebug/repo_keys.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/repodebug/repo_keys.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from ... import controldir
 from ...commands import Command
 

=== modified file 'breezy/plugins/rewrite/__init__.py'
--- breezy/plugins/rewrite/__init__.py	2020-01-11 17:20:34 +0000
+++ breezy/plugins/rewrite/__init__.py	2020-02-18 01:57:45 +0000
@@ -21,8 +21,6 @@
 'rebase-continue' command or abort using the 'rebase-abort' command.
 """
 
-from __future__ import absolute_import
-
 from ... import errors
 from ...commands import plugin_cmds
 

=== modified file 'breezy/plugins/rewrite/commands.py'
--- breezy/plugins/rewrite/commands.py	2020-01-11 17:20:34 +0000
+++ breezy/plugins/rewrite/commands.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Bazaar command-line subcommands."""
 
-from __future__ import absolute_import
-
 from ...commands import (
     Command,
     display_command,

=== modified file 'breezy/plugins/rewrite/maptree.py'
--- breezy/plugins/rewrite/maptree.py	2020-01-19 13:47:29 +0000
+++ breezy/plugins/rewrite/maptree.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 """Map Tree."""
 
-from __future__ import absolute_import
-
 def map_file_ids(repository, old_parents, new_parents):
     """Try to determine the equivalent file ids in two sets of parents.
 

=== modified file 'breezy/plugins/rewrite/pseudonyms.py'
--- breezy/plugins/rewrite/pseudonyms.py	2020-01-11 17:20:34 +0000
+++ breezy/plugins/rewrite/pseudonyms.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Revision pseudonyms."""
 
-from __future__ import absolute_import
-
 from collections import defaultdict
 
 from breezy import (

=== modified file 'breezy/plugins/rewrite/rebase.py'
--- breezy/plugins/rewrite/rebase.py	2020-01-11 23:46:34 +0000
+++ breezy/plugins/rewrite/rebase.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Rebase."""
 
-from __future__ import absolute_import
-
 import os
 
 from ... import (

=== modified file 'breezy/plugins/rewrite/upgrade.py'
--- breezy/plugins/rewrite/upgrade.py	2020-01-11 17:20:34 +0000
+++ breezy/plugins/rewrite/upgrade.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Upgrading revisions made with older versions of the mapping."""
 
-from __future__ import absolute_import
-
 from ... import (
     osutils,
     trace,

=== modified file 'breezy/plugins/stats/__init__.py'
--- breezy/plugins/stats/__init__.py	2019-11-28 08:57:20 +0000
+++ breezy/plugins/stats/__init__.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 """A Simple bzr plugin to generate statistics about the history."""
 
-from __future__ import absolute_import
-
 from ... import _format_version_tuple, version_info
 
 __version__ = _format_version_tuple(version_info)

=== modified file 'breezy/plugins/stats/classify.py'
--- breezy/plugins/stats/classify.py	2019-11-28 08:57:20 +0000
+++ breezy/plugins/stats/classify.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 """Classify a commit based on the types of files it changed."""
 
-from __future__ import absolute_import
-
 import os.path
 
 from ... import urlutils

=== modified file 'breezy/plugins/stats/cmds.py'
--- breezy/plugins/stats/cmds.py	2019-12-23 00:34:25 +0000
+++ breezy/plugins/stats/cmds.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 """A Simple bzr plugin to generate statistics about the history."""
 
-from __future__ import absolute_import
-
 import operator
 
 from ... import (

=== modified file 'breezy/plugins/stats/test_blackbox.py'
--- breezy/plugins/stats/test_blackbox.py	2019-11-28 08:57:20 +0000
+++ breezy/plugins/stats/test_blackbox.py	2020-02-18 01:57:45 +0000
@@ -1,5 +1,3 @@
-from __future__ import absolute_import
-
 from ...tests import TestCaseWithTransport
 
 

=== modified file 'breezy/plugins/stats/test_classify.py'
--- breezy/plugins/stats/test_classify.py	2017-06-01 23:52:12 +0000
+++ breezy/plugins/stats/test_classify.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from __future__ import absolute_import
-
 from ...tests import TestCase
 from .classify import classify_filename
 

=== modified file 'breezy/plugins/stats/test_stats.py'
--- breezy/plugins/stats/test_stats.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/stats/test_stats.py	2020-02-18 01:57:45 +0000
@@ -1,5 +1,3 @@
-from __future__ import absolute_import
-
 from ...tests import TestCase, TestCaseWithTransport
 from ...revision import Revision
 from .cmds import get_revisions_and_committers, collapse_by_person

=== modified file 'breezy/plugins/svn/__init__.py'
--- breezy/plugins/svn/__init__.py	2020-01-13 00:27:14 +0000
+++ breezy/plugins/svn/__init__.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 Currently only tells the user that Subversion is not supported.
 """
 
-from __future__ import absolute_import
-
 from ... import version_info  # noqa: F401
 
 from ... import (

=== modified file 'breezy/plugins/upload/__init__.py'
--- breezy/plugins/upload/__init__.py	2018-11-18 19:48:57 +0000
+++ breezy/plugins/upload/__init__.py	2020-02-18 01:57:45 +0000
@@ -131,8 +131,6 @@
 
 """
 
-from __future__ import absolute_import
-
 # TODO: the chmod bits *can* be supported via the upload protocols
 # (i.e. poorly), but since the web developers use these protocols to upload
 # manually, it is expected that the associated web server is coherent with

=== modified file 'breezy/plugins/upload/cmds.py'
--- breezy/plugins/upload/cmds.py	2020-01-11 17:41:33 +0000
+++ breezy/plugins/upload/cmds.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """bzr-upload command implementations."""
 
-from __future__ import absolute_import
-
 from ... import (
     commands,
     config,
@@ -39,9 +37,6 @@
     )
 """)
 
-from ...sixish import (
-    text_type,
-    )
 
 auto_option = config.Option(
     'upload_auto', default=False, from_unicode=config.bool_from_store,
@@ -483,7 +478,7 @@
                       help='Branch to upload from, '
                       'rather than the one containing the working directory.',
                       short_name='d',
-                      type=text_type,
+                      type=str,
                       ),
         option.Option('auto',
                       'Trigger an upload from this branch whenever the tip '

=== modified file 'breezy/plugins/weave_fmt/__init__.py'
--- breezy/plugins/weave_fmt/__init__.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/weave_fmt/__init__.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 These were formats present in pre-1.0 version of Bazaar.
 """
 
-from __future__ import absolute_import
-
 # Since we are a built-in plugin we share the breezy version
 from ... import version_info  # noqa: F401
 

=== modified file 'breezy/plugins/weave_fmt/branch.py'
--- breezy/plugins/weave_fmt/branch.py	2020-01-18 04:16:23 +0000
+++ breezy/plugins/weave_fmt/branch.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Weave-era branch implementations."""
 
-from __future__ import absolute_import
-
 from ... import (
     errors,
     lockable_files,

=== modified file 'breezy/plugins/weave_fmt/bzrdir.py'
--- breezy/plugins/weave_fmt/bzrdir.py	2020-02-18 03:16:21 +0000
+++ breezy/plugins/weave_fmt/bzrdir.py	2020-02-21 03:58:42 +0000
@@ -16,8 +16,6 @@
 
 """Weave-era BzrDir formats."""
 
-from __future__ import absolute_import
-
 from io import BytesIO
 
 from ...bzr.bzrdir import (

=== modified file 'breezy/plugins/weave_fmt/repository.py'
--- breezy/plugins/weave_fmt/repository.py	2020-01-25 14:07:41 +0000
+++ breezy/plugins/weave_fmt/repository.py	2020-02-18 01:57:45 +0000
@@ -20,9 +20,8 @@
 ghosts.
 """
 
-from __future__ import absolute_import
-
 import gzip
+from io import BytesIO
 import os
 
 from ...lazy_import import lazy_import
@@ -58,10 +57,6 @@
 from ...bzr.repository import (
     RepositoryFormatMetaDir,
     )
-from ...sixish import (
-    BytesIO,
-    text_type,
-    )
 from .store.text import TextStore
 from ...bzr.versionedfile import (
     AbsentContentFactory,
@@ -88,7 +83,7 @@
         return xml5.serializer_v5
 
     def _escape(self, file_or_path):
-        if not isinstance(file_or_path, (str, text_type)):
+        if not isinstance(file_or_path, str):
             file_or_path = '/'.join(file_or_path)
         if file_or_path == '':
             return u''

=== modified file 'breezy/plugins/weave_fmt/store/__init__.py'
--- breezy/plugins/weave_fmt/store/__init__.py	2018-11-17 16:53:10 +0000
+++ breezy/plugins/weave_fmt/store/__init__.py	2020-02-18 01:57:45 +0000
@@ -24,8 +24,6 @@
 unique ID.
 """
 
-from __future__ import absolute_import
-
 import os
 
 from .... import (

=== modified file 'breezy/plugins/weave_fmt/store/text.py'
--- breezy/plugins/weave_fmt/store/text.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/weave_fmt/store/text.py	2020-02-18 01:57:45 +0000
@@ -20,16 +20,12 @@
 do any sort of delta compression.
 """
 
-from __future__ import absolute_import
-
 import gzip
+from io import BytesIO
 import os
 
 from .... import osutils
 from ....errors import BzrError, NoSuchFile, FileExists
-from ....sixish import (
-    BytesIO,
-    )
 from . import TransportStore
 from ....trace import mutter
 

=== modified file 'breezy/plugins/weave_fmt/store/versioned.py'
--- breezy/plugins/weave_fmt/store/versioned.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/weave_fmt/store/versioned.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 # XXX: Some consideration of the problems that might occur if there are
 # files whose id differs only in case.  That should probably be forbidden.
 

=== modified file 'breezy/plugins/weave_fmt/test_bzrdir.py'
--- breezy/plugins/weave_fmt/test_bzrdir.py	2019-09-21 23:05:12 +0000
+++ breezy/plugins/weave_fmt/test_bzrdir.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 For interface contract tests, see tests/per_bzr_dir.
 """
 
-from __future__ import absolute_import
-
 import os
 import sys
 

=== modified file 'breezy/plugins/weave_fmt/test_repository.py'
--- breezy/plugins/weave_fmt/test_repository.py	2019-09-01 15:33:59 +0000
+++ breezy/plugins/weave_fmt/test_repository.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,7 @@
 
 """
 
-from __future__ import absolute_import
-
+from io import BytesIO
 from stat import S_ISDIR
 import sys
 
@@ -39,9 +38,6 @@
 from ...bzr.serializer import (
     format_registry as serializer_format_registry,
     )
-from ...sixish import (
-    BytesIO,
-    )
 from ...tests import (
     TestCase,
     TestCaseWithTransport,

=== modified file 'breezy/plugins/weave_fmt/test_store.py'
--- breezy/plugins/weave_fmt/test_store.py	2018-11-11 04:08:32 +0000
+++ breezy/plugins/weave_fmt/test_store.py	2020-02-07 02:14:30 +0000
@@ -16,14 +16,12 @@
 
 """Test Store implementations."""
 
+from io import BytesIO
 import os
 import gzip
 
 from ... import errors as errors
 from ...errors import BzrError
-from ...sixish import (
-    BytesIO,
-    )
 from .store import TransportStore
 from .store.text import TextStore
 from .store.versioned import VersionedFileStore

=== modified file 'breezy/plugins/weave_fmt/test_workingtree.py'
--- breezy/plugins/weave_fmt/test_workingtree.py	2019-02-14 03:30:18 +0000
+++ breezy/plugins/weave_fmt/test_workingtree.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Tests for weave-era working tree formats."""
 
-from __future__ import absolute_import
-
 import os
 
 from ... import (

=== modified file 'breezy/plugins/weave_fmt/workingtree.py'
--- breezy/plugins/weave_fmt/workingtree.py	2019-07-27 22:47:49 +0000
+++ breezy/plugins/weave_fmt/workingtree.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,7 @@
 
 """Weave-era working tree objects."""
 
-from __future__ import absolute_import
-
+from io import BytesIO
 
 from ... import (
     conflicts as _mod_conflicts,
@@ -32,9 +31,6 @@
     xml5,
     )
 from ...mutabletree import MutableTree
-from ...sixish import (
-    BytesIO,
-    )
 from ...transport.local import LocalTransport
 from ...workingtree import (
     WorkingTreeFormat,

=== modified file 'breezy/plugins/weave_fmt/xml4.py'
--- breezy/plugins/weave_fmt/xml4.py	2020-01-31 02:56:40 +0000
+++ breezy/plugins/weave_fmt/xml4.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from ...bzr.xml_serializer import (
     Element,
     SubElement,

=== modified file 'breezy/plugins/zsh_completion/__init__.py'
--- breezy/plugins/zsh_completion/__init__.py	2019-10-05 12:22:19 +0000
+++ breezy/plugins/zsh_completion/__init__.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 __doc__ = """Generate a shell function for zsh command line completion.
 """
 

=== modified file 'breezy/plugins/zsh_completion/zshcomp.py'
--- breezy/plugins/zsh_completion/zshcomp.py	2020-01-31 17:43:44 +0000
+++ breezy/plugins/zsh_completion/zshcomp.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from ... import (
     cmdline,
     commands,
@@ -26,9 +24,6 @@
     option,
     plugin,
 )
-from ...sixish import (
-    text_type,
-    )
 import breezy
 import re
 import sys
@@ -266,11 +261,11 @@
     """
 
     takes_options = [
-        option.Option("function-name", short_name="f", type=text_type, argname="name",
+        option.Option("function-name", short_name="f", type=str, argname="name",
                       help="Name of the generated function (default: _brz)"),
         option.Option("debug", type=None, hidden=True,
                       help="Enable shell code useful for debugging"),
-        option.ListOption("plugin", type=text_type, argname="name",
+        option.ListOption("plugin", type=str, argname="name",
                           # param_name="selected_plugins", # doesn't work, bug #387117
                           help="Enable completions for the selected plugin"
                           + " (default: all plugins)"),

=== modified file 'breezy/progress.py'
--- breezy/progress.py	2018-11-12 01:41:38 +0000
+++ breezy/progress.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 will manage a conceptual stack of nested activities.
 """
 
-from __future__ import absolute_import
-
 import time
 import os
 

=== modified file 'breezy/propose.py'
--- breezy/propose.py	2020-03-07 15:19:13 +0000
+++ breezy/propose.py	2020-03-07 15:47:50 +0000
@@ -16,8 +16,6 @@
 
 """Helper functions for proposing merges."""
 
-from __future__ import absolute_import
-
 from . import (
     errors,
     hooks,

=== modified file 'breezy/push.py'
--- breezy/push.py	2019-06-29 19:54:32 +0000
+++ breezy/push.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """UI helper for the push command."""
 
-from __future__ import absolute_import
-
 from . import (
     branch as _mod_branch,
     controldir,

=== modified file 'breezy/pyutils.py'
--- breezy/pyutils.py	2018-11-11 04:08:32 +0000
+++ breezy/pyutils.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """General Python convenience functions."""
 
-from __future__ import absolute_import
-
 import sys
 
 

=== modified file 'breezy/reconcile.py'
--- breezy/reconcile.py	2019-06-02 02:35:46 +0000
+++ breezy/reconcile.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Reconcilers are able to fix some potential data errors in a branch."""
 
-from __future__ import absolute_import
-
 __all__ = [
     'reconcile',
     'Reconciler',

=== modified file 'breezy/reconfigure.py'
--- breezy/reconfigure.py	2019-06-26 20:58:23 +0000
+++ breezy/reconfigure.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 constructing a class or using a factory method on Reconfigure.
 """
 
-from __future__ import absolute_import
-
 
 from . import (
     branch,

=== modified file 'breezy/recordcounter.py'
--- breezy/recordcounter.py	2018-11-11 04:08:32 +0000
+++ breezy/recordcounter.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Record counting support for showing progress of revision fetch."""
 
-from __future__ import absolute_import
-
 
 class RecordCounter(object):
     """Container for maintains estimates of work requires for fetch.

=== modified file 'breezy/registry.py'
--- breezy/registry.py	2018-11-11 04:08:32 +0000
+++ breezy/registry.py	2020-02-18 01:57:45 +0000
@@ -16,12 +16,8 @@
 
 """Classes to provide name-to-object registry-like support."""
 
-from __future__ import absolute_import
-
 from .pyutils import get_named_object
 
-from .sixish import viewitems
-
 
 class _ObjectGetter(object):
     """Maintain a reference to an object, and return the object on request.
@@ -110,11 +106,11 @@
 
     def aliases(self):
         """Return a set of the format names which are aliases."""
-        return dict(viewitems(self._aliases))
+        return dict(self._aliases.items())
 
     def alias_map(self):
         ret = {}
-        for alias, target in viewitems(self._aliases):
+        for alias, target in self._aliases.items():
             ret.setdefault(target, []).append(alias)
         return ret
 

=== modified file 'breezy/rename_map.py'
--- breezy/rename_map.py	2019-06-15 12:04:34 +0000
+++ breezy/rename_map.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
+from io import BytesIO
 
 from . import (
     osutils,
@@ -23,11 +22,6 @@
     trace,
     )
 from .i18n import gettext
-from .sixish import (
-    BytesIO,
-    viewitems,
-    viewvalues,
-    )
 from .ui import ui_factory
 
 
@@ -107,7 +101,7 @@
             for num, path in enumerate(paths):
                 task.update(gettext('Determining hash hits'), num, len(paths))
                 hits = self.hitcounts(self.tree.get_file_lines(path))
-                all_hits.extend((v, path, k) for k, v in viewitems(hits))
+                all_hits.extend((v, path, k) for k, v in hits.items())
         return all_hits
 
     def file_match(self, paths):
@@ -146,7 +140,7 @@
                     break
                 required_parents.setdefault(path, []).append(child)
         require_ids = {}
-        for parent, children in viewitems(required_parents):
+        for parent, children in required_parents.items():
             child_file_ids = set()
             for child in children:
                 file_id = matches.get(child)
@@ -163,8 +157,8 @@
         parent directories.
         """
         all_hits = []
-        for file_id, file_id_children in viewitems(missing_parents):
-            for path, path_children in viewitems(required_parents):
+        for file_id, file_id_children in missing_parents.items():
+            for path, path_children in required_parents.items():
                 hits = len(path_children.intersection(file_id_children))
                 if hits > 0:
                     all_hits.append((hits, path, file_id))
@@ -239,9 +233,9 @@
 
     def _make_inventory_delta(self, matches):
         delta = []
-        file_id_matches = dict((f, p) for p, f in viewitems(matches))
+        file_id_matches = dict((f, p) for p, f in matches.items())
         file_id_query = []
-        for f in viewvalues(matches):
+        for f in matches.values():
             try:
                 file_id_query.append(self.tree.id2path(f))
             except errors.NoSuchId:

=== modified file 'breezy/repository.py'
--- breezy/repository.py	2020-01-20 00:03:54 +0000
+++ breezy/repository.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from .lazy_import import lazy_import
 lazy_import(globals(), """
 import time
@@ -40,10 +38,6 @@
 from .decorators import only_raises
 from .inter import InterObject
 from .lock import _RelockDebugMixin, LogicalLockResult
-from .sixish import (
-    text_type,
-    viewitems,
-    )
 from .trace import (
     log_exception_quietly, note, mutter, mutter_callsite, warning)
 
@@ -110,7 +104,7 @@
 
         if committer is None:
             self._committer = self._config_stack.get('email')
-        elif not isinstance(committer, text_type):
+        elif not isinstance(committer, str):
             self._committer = committer.decode()  # throw if non-ascii
         else:
             self._committer = committer
@@ -152,10 +146,10 @@
             raise ValueError('Invalid value for %s: %r' % (context, text))
 
     def _validate_revprops(self, revprops):
-        for key, value in viewitems(revprops):
+        for key, value in revprops.items():
             # We know that the XML serializers do not round trip '\r'
             # correctly, so refuse to accept them
-            if not isinstance(value, (text_type, str)):
+            if not isinstance(value, str):
                 raise ValueError('revision property (%s) is not a valid'
                                  ' (unicode) string: %r' % (key, value))
             # TODO(jelmer): Make this repository-format specific
@@ -1052,8 +1046,8 @@
             else:
                 query_keys.append((revision_id,))
         vf = self.revisions.without_fallbacks()
-        for (revision_id,), parent_keys in viewitems(
-                vf.get_parent_map(query_keys)):
+        for (revision_id,), parent_keys in (
+                vf.get_parent_map(query_keys).items()):
             if parent_keys:
                 result[revision_id] = tuple([parent_revid
                                              for (parent_revid,) in parent_keys])
@@ -1184,7 +1178,7 @@
         # weave repositories refuse to store revisionids that are non-ascii.
         if revision_id is not None:
             # weaves require ascii revision ids.
-            if isinstance(revision_id, text_type):
+            if isinstance(revision_id, str):
                 try:
                     revision_id.encode('ascii')
                 except UnicodeEncodeError:
@@ -1620,7 +1614,7 @@
     # Filter ghosts, and null:
     if _mod_revision.NULL_REVISION in revision_graph:
         del revision_graph[_mod_revision.NULL_REVISION]
-    for key, parents in viewitems(revision_graph):
+    for key, parents in revision_graph.items():
         revision_graph[key] = tuple(parent for parent in parents if parent
                                     in revision_graph)
     return revision_graph

=== modified file 'breezy/revision.py'
--- breezy/revision.py	2018-11-17 01:04:53 +0000
+++ breezy/revision.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 # TODO: Some kind of command-line display of revision properties:
 # perhaps show them in log -v and allow them as options to the commit command.
 
@@ -28,9 +26,6 @@
     errors,
     osutils,
     )
-from .sixish import (
-    text_type,
-    )
 
 NULL_REVISION = b"null:"
 CURRENT_REVISION = b"current:"
@@ -90,10 +85,10 @@
         """Verify that all revision properties are OK."""
         for name, value in self.properties.items():
             # GZ 2017-06-10: What sort of string are properties exactly?
-            not_text = not isinstance(name, (text_type, str))
+            not_text = not isinstance(name, str)
             if not_text or osutils.contains_whitespace(name):
                 raise ValueError("invalid property name %r" % name)
-            if not isinstance(value, (text_type, bytes)):
+            if not isinstance(value, (str, bytes)):
                 raise ValueError("invalid property value %r for %r" %
                                  (value, name))
 

=== modified file 'breezy/revisionspec.py'
--- breezy/revisionspec.py	2019-06-29 19:54:32 +0000
+++ breezy/revisionspec.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 
 from .lazy_import import lazy_import
 lazy_import(globals(), """
@@ -37,9 +35,6 @@
     registry,
     trace,
     )
-from .sixish import (
-    text_type,
-    )
 
 
 class RevisionInfo(object):
@@ -160,7 +155,7 @@
         """
         if spec is None:
             return RevisionSpec(None, _internal=True)
-        if not isinstance(spec, (str, text_type)):
+        if not isinstance(spec, str):
             raise TypeError("revision spec needs to be text")
         match = revspec_registry.get_prefix(spec)
         if match is not None:
@@ -471,7 +466,7 @@
         # self.spec comes straight from parsing the command line arguments,
         # so we expect it to be a Unicode string. Switch it to the internal
         # representation.
-        if isinstance(self.spec, text_type):
+        if isinstance(self.spec, str):
             return cache_utf8.encode(self.spec)
         return self.spec
 

=== modified file 'breezy/revisiontree.py'
--- breezy/revisiontree.py	2018-11-16 18:33:17 +0000
+++ breezy/revisiontree.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """RevisionTree - a Tree implementation backed by repository data for a revision."""
 
-from __future__ import absolute_import
-
 from io import BytesIO
 from . import (
     lock,

=== modified file 'breezy/rio.py'
--- breezy/rio.py	2018-11-11 04:08:32 +0000
+++ breezy/rio.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 # \subsection{\emph{rio} - simple text metaformat}
 #
 # \emph{r} stands for `restricted', `reproducible', or `rfc822-like'.
@@ -36,9 +34,6 @@
 
 from . import osutils
 from .iterablefile import IterableFile
-from .sixish import (
-    text_type,
-    )
 
 # XXX: some redundancy is allowing to write stanzas in isolation as well as
 # through a writer object.
@@ -139,7 +134,7 @@
             raise ValueError("invalid tag %r" % (tag,))
         if isinstance(value, bytes):
             value = value.decode('ascii')
-        elif isinstance(value, text_type):
+        elif isinstance(value, str):
             pass
         else:
             raise TypeError("invalid type for rio value: %r of type %s"

=== modified file 'breezy/rules.py'
--- breezy/rules.py	2019-06-16 01:03:51 +0000
+++ breezy/rules.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 See ``bzr help rules`` for details.
 """
 
-from __future__ import absolute_import
-
 import configobj
 
 from . import (

=== modified file 'breezy/send.py'
--- breezy/send.py	2019-06-29 19:54:32 +0000
+++ breezy/send.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import os
 import time
 

=== modified file 'breezy/shelf.py'
--- breezy/shelf.py	2019-06-22 11:16:17 +0000
+++ breezy/shelf.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import errno
 import re
 

=== modified file 'breezy/shelf_ui.py'
--- breezy/shelf_ui.py	2019-06-29 19:54:32 +0000
+++ breezy/shelf_ui.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
+import contextlib
 import patiencediff
 import shutil
 import sys
@@ -25,7 +24,6 @@
 
 from . import (
     builtins,
-    cleanup,
     delta,
     diff,
     errors,
@@ -458,7 +456,7 @@
 
     def run(self):
         """Perform the unshelving operation."""
-        with cleanup.ExitStack() as exit_stack:
+        with contextlib.ExitStack() as exit_stack:
             exit_stack.enter_context(self.tree.lock_tree_write())
             if self.read_shelf:
                 trace.note(gettext('Using changes with id "%d".') %

=== modified file 'breezy/shellcomplete.py'
--- breezy/shellcomplete.py	2018-11-11 04:08:32 +0000
+++ breezy/shellcomplete.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import sys
 
 

=== removed file 'breezy/sixish.py'
--- breezy/sixish.py	2018-11-10 17:52:47 +0000
+++ breezy/sixish.py	1970-01-01 00:00:00 +0000
@@ -1,62 +0,0 @@
-# Copyright (C) 2017 Bazaar hackers
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""
-Module to aid writing a Python dialect compatible with 2.7 and 3.4+.
-
-Initially pretty much just a subset of six while things get worked out.
-"""
-
-from __future__ import absolute_import
-
-from six import (
-    binary_type,
-    get_unbound_function,
-    indexbytes,
-    int2byte,
-    PY3,
-    reraise,
-    string_types,
-    text_type,
-    unichr,
-    viewitems,
-    viewkeys,
-    viewvalues,
-    )  # noqa: F401
-
-
-# The io module exists in Python 2.7 but lacks optimisation. Most uses are not
-# performance critical, but want to measure before switching from cStringIO.
-if PY3:
-    import io as _io
-    BytesIO = _io.BytesIO
-    StringIO = _io.StringIO
-    from builtins import range, map, zip
-else:
-    from cStringIO import StringIO as BytesIO  # noqa: F401
-    from StringIO import StringIO  # noqa: F401
-    from future_builtins import zip, map  # noqa: F401
-    range = xrange  # noqa: F821
-
-
-# GZ 2017-06-10: Work out if interning bits of inventory is behaviour we want
-# to retain outside of StaticTuple, if so need to implement for Python 3.
-if PY3:
-    def bytesintern(b):
-        """Dummy intern() function."""
-        return b
-else:
-    bytesintern = intern

=== modified file 'breezy/smtp_connection.py'
--- breezy/smtp_connection.py	2018-11-11 04:08:32 +0000
+++ breezy/smtp_connection.py	2020-02-18 01:57:45 +0000
@@ -16,12 +16,7 @@
 
 """A convenience class around smtplib."""
 
-from __future__ import absolute_import
-
-try:
-    from email.utils import getaddresses, parseaddr
-except ImportError:  # python < 3
-    from email.Utils import getaddresses, parseaddr
+from email.utils import getaddresses, parseaddr
 
 import errno
 import smtplib

=== modified file 'breezy/static_tuple.py'
--- breezy/static_tuple.py	2017-05-22 00:56:52 +0000
+++ breezy/static_tuple.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Interface thunk for a StaticTuple implementation."""
 
-from __future__ import absolute_import
-
 from . import debug
 
 try:

=== modified file 'breezy/status.py'
--- breezy/status.py	2019-06-29 19:50:18 +0000
+++ breezy/status.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import sys
 
 from . import (

=== modified file 'breezy/strace.py'
--- breezy/strace.py	2018-11-12 01:41:38 +0000
+++ breezy/strace.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Support for running strace against the current process."""
 
-from __future__ import absolute_import
-
 import os
 import signal
 import subprocess

=== modified file 'breezy/switch.py'
--- breezy/switch.py	2019-06-16 19:15:57 +0000
+++ breezy/switch.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 # Original author: David Allouche
 
 from . import (

=== modified file 'breezy/symbol_versioning.py'
--- breezy/symbol_versioning.py	2019-01-04 20:49:00 +0000
+++ breezy/symbol_versioning.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 The methods here allow for api symbol versioning.
 """
 
-from __future__ import absolute_import
-
 __all__ = ['deprecated_function',
            'deprecated_in',
            'deprecated_list',

=== modified file 'breezy/tag.py'
--- breezy/tag.py	2020-02-19 04:56:22 +0000
+++ breezy/tag.py	2020-02-21 03:58:42 +0000
@@ -22,9 +22,8 @@
   Branch.tags.add('name', 'value')
 """
 
-from __future__ import absolute_import
-
 from collections import defaultdict
+import contextlib
 import itertools
 import re
 import sys
@@ -34,9 +33,8 @@
 
 from .inter import InterObject
 from .registry import Registry
-from .sixish import text_type
+
 from . import (
-    cleanup,
     errors,
     )
 
@@ -220,7 +218,7 @@
             (tagname, source_target, dest_target), or None if no copying was
             done.
         """
-        with cleanup.ExitStack() as stack:
+        with contextlib.ExitStack() as stack:
             if self.source.branch == self.target.branch:
                 return {}, []
             if not self.source.branch.supports_tags():
@@ -322,7 +320,7 @@
     """
     def natural_sort_key(tag):
         return [f(s) for f, s in
-                zip(itertools.cycle((text_type.lower, int)),
+                zip(itertools.cycle((str.lower, int)),
                     re.split('([0-9]+)', tag[0]))]
     tags.sort(key=natural_sort_key)
 

=== modified file 'breezy/terminal.py'
--- breezy/terminal.py	2020-01-31 02:14:55 +0000
+++ breezy/terminal.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import os
 import sys
 

=== modified file 'breezy/tests/__init__.py'
--- breezy/tests/__init__.py	2020-02-06 04:21:58 +0000
+++ breezy/tests/__init__.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Testing framework extensions"""
 
-from __future__ import absolute_import
-
 # NOTE: Some classes in here use camelCaseNaming() rather than
 # underscore_naming().  That's for consistency with unittest; it's not the
 # general style of breezy.  Please continue that consistency when adding e.g.
@@ -94,12 +92,6 @@
 except ImportError:
     # lsprof not available
     pass
-from ..sixish import (
-    int2byte,
-    PY3,
-    string_types,
-    text_type,
-    )
 from ..bzr.smart import client, request
 from ..transport import (
     memory,
@@ -1331,14 +1323,14 @@
             return
         if message is None:
             message = "texts not equal:\n"
-        if a + ('\n' if isinstance(a, text_type) else b'\n') == b:
+        if a + ('\n' if isinstance(a, str) else b'\n') == b:
             message = 'first string is missing a final newline.\n'
-        if a == b + ('\n' if isinstance(b, text_type) else b'\n'):
+        if a == b + ('\n' if isinstance(b, str) else b'\n'):
             message = 'second string is missing a final newline.\n'
         raise AssertionError(message
                              + self._ndiff_strings(
-                                 a if isinstance(a, text_type) else a.decode(),
-                                 b if isinstance(b, text_type) else b.decode()))
+                                 a if isinstance(a, str) else a.decode(),
+                                 b if isinstance(b, str) else b.decode()))
 
     def assertEqualMode(self, mode, mode_test):
         self.assertEqual(mode, mode_test,
@@ -1556,7 +1548,7 @@
     def assertPathExists(self, path):
         """Fail unless path or paths, which may be abs or relative, exist."""
         # TODO(jelmer): Clean this up for pad.lv/1696545
-        if not isinstance(path, (bytes, str, text_type)):
+        if not isinstance(path, (bytes, str)):
             for p in path:
                 self.assertPathExists(p)
         else:
@@ -1565,7 +1557,7 @@
 
     def assertPathDoesNotExist(self, path):
         """Fail if path or paths, which may be abs or relative, exist."""
-        if not isinstance(path, (str, text_type)):
+        if not isinstance(path, (str, str)):
             for p in path:
                 self.assertPathDoesNotExist(p)
         else:
@@ -1940,12 +1932,8 @@
 
         self.log('run brz: %r', args)
 
-        if PY3:
-            self._last_cmd_stdout = stdout
-            self._last_cmd_stderr = stderr
-        else:
-            self._last_cmd_stdout = codecs.getwriter(encoding)(stdout)
-            self._last_cmd_stderr = codecs.getwriter(encoding)(stderr)
+        self._last_cmd_stdout = stdout
+        self._last_cmd_stderr = stderr
 
         old_ui_factory = ui.ui_factory
         ui.ui_factory = ui_testing.TestUIFactory(
@@ -2005,26 +1993,17 @@
         :keyword error_regexes: A list of expected error messages.  If
             specified they must be seen in the error output of the command.
         """
-        if isinstance(args, string_types):
+        if isinstance(args, str):
             args = shlex.split(args)
 
         if encoding is None:
             encoding = osutils.get_user_encoding()
 
-        if sys.version_info[0] == 2:
-            wrapped_stdout = stdout = ui_testing.BytesIOWithEncoding()
-            wrapped_stderr = stderr = ui_testing.BytesIOWithEncoding()
-            stdout.encoding = stderr.encoding = encoding
-
-            # FIXME: don't call into logging here
-            handler = trace.EncodedStreamHandler(
-                stderr, errors="replace")
-        else:
-            stdout = BytesIO()
-            stderr = BytesIO()
-            wrapped_stdout = TextIOWrapper(stdout, encoding)
-            wrapped_stderr = TextIOWrapper(stderr, encoding)
-            handler = logging.StreamHandler(wrapped_stderr)
+        stdout = BytesIO()
+        stderr = BytesIO()
+        wrapped_stdout = TextIOWrapper(stdout, encoding)
+        wrapped_stderr = TextIOWrapper(stderr, encoding)
+        handler = logging.StreamHandler(wrapped_stderr)
         handler.setLevel(logging.INFO)
 
         logger = logging.getLogger('')
@@ -2037,9 +2016,8 @@
         finally:
             logger.removeHandler(handler)
 
-        if PY3:
-            wrapped_stdout.flush()
-            wrapped_stderr.flush()
+        wrapped_stdout.flush()
+        wrapped_stderr.flush()
 
         out = stdout.getvalue()
         err = stderr.getvalue()
@@ -2088,24 +2066,16 @@
         :keyword error_regexes: A list of expected error messages.  If
             specified they must be seen in the error output of the command.
         """
-        if isinstance(args, string_types):
+        if isinstance(args, str):
             args = shlex.split(args)
 
         if encoding is None:
             encoding = osutils.get_user_encoding()
 
-        if sys.version_info[0] == 2:
-            stdout = ui_testing.BytesIOWithEncoding()
-            stderr = ui_testing.BytesIOWithEncoding()
-            stdout.encoding = stderr.encoding = encoding
-            # FIXME: don't call into logging here
-            handler = trace.EncodedStreamHandler(
-                stderr, errors="replace")
-        else:
-            stdout = ui_testing.StringIOWithEncoding()
-            stderr = ui_testing.StringIOWithEncoding()
-            stdout.encoding = stderr.encoding = encoding
-            handler = logging.StreamHandler(stream=stderr)
+        stdout = ui_testing.StringIOWithEncoding()
+        stderr = ui_testing.StringIOWithEncoding()
+        stdout.encoding = stderr.encoding = encoding
+        handler = logging.StreamHandler(stream=stderr)
         handler.setLevel(logging.INFO)
 
         logger = logging.getLogger('')
@@ -2190,7 +2160,7 @@
         if len(args) == 1:
             if isinstance(args[0], list):
                 args = args[0]
-            elif isinstance(args[0], (str, text_type)):
+            elif isinstance(args[0], str):
                 args = list(shlex.split(args[0]))
         else:
             raise ValueError("passing varargs to run_bzr_subprocess")
@@ -2395,18 +2365,12 @@
             if getattr(self, "_log_file", None) is not None:
                 stdout = self._log_file
             else:
-                if sys.version_info[0] == 2:
-                    stdout = BytesIO()
-                else:
-                    stdout = StringIO()
+                stdout = StringIO()
         if stderr is None:
             if getattr(self, "_log_file", None is not None):
                 stderr = self._log_file
             else:
-                if sys.version_info[0] == 2:
-                    stderr = BytesIO()
-                else:
-                    stderr = StringIO()
+                stderr = StringIO()
         real_stdin = sys.stdin
         real_stdout = sys.stdout
         real_stderr = sys.stderr
@@ -2818,8 +2782,6 @@
 
     def overrideEnvironmentForTesting(self):
         test_home_dir = self.test_home_dir
-        if not PY3 and isinstance(test_home_dir, text_type):
-            test_home_dir = test_home_dir.encode(sys.getfilesystemencoding())
         self.overrideEnv('HOME', test_home_dir)
         self.overrideEnv('BRZ_HOME', test_home_dir)
         self.overrideEnv('GNUPGHOME', os.path.join(test_home_dir, '.gnupg'))
@@ -2960,7 +2922,7 @@
         if transport is None or transport.is_readonly():
             transport = _mod_transport.get_transport_from_path(".")
         for name in shape:
-            self.assertIsInstance(name, (str, text_type))
+            self.assertIsInstance(name, str)
             if name[-1] == '/':
                 transport.mkdir(urlutils.escape(name[:-1]))
             else:
@@ -2980,7 +2942,7 @@
         """Assert whether path or paths are in the WorkingTree"""
         if tree is None:
             tree = workingtree.WorkingTree.open(root_path)
-        if not isinstance(path, (str, text_type)):
+        if not isinstance(path, str):
             for p in path:
                 self.assertInWorkingTree(p, tree=tree)
         else:
@@ -2991,7 +2953,7 @@
         """Assert whether path or paths are not in the WorkingTree"""
         if tree is None:
             tree = workingtree.WorkingTree.open(root_path)
-        if not isinstance(path, (str, text_type)):
+        if not isinstance(path, str):
             for p in path:
                 self.assertNotInWorkingTree(p, tree=tree)
         else:
@@ -3637,7 +3599,7 @@
                 # The traceback is formatted to a string and written in one go
                 # to avoid interleaving lines from multiple failing children.
                 tb = traceback.format_exc()
-                if isinstance(tb, text_type):
+                if isinstance(tb, str):
                     tb = tb.encode('utf-8')
                 try:
                     stream.write(tb)
@@ -4074,7 +4036,6 @@
         'breezy.tests.test_chk_serializer',
         'breezy.tests.test_chunk_writer',
         'breezy.tests.test_clean_tree',
-        'breezy.tests.test_cleanup',
         'breezy.tests.test_cmdline',
         'breezy.tests.test_commands',
         'breezy.tests.test_commit',
@@ -4310,28 +4271,23 @@
     # modules building their suite with loadTestsFromModuleNames
     suite.addTest(loader.loadTestsFromModuleNames(_test_suite_testmod_names()))
 
-    if not PY3:
-        suite.addTest(loader.loadTestsFromModuleNames(['breezy.doc']))
+    suite.addTest(loader.loadTestsFromModuleNames(['breezy.doc']))
 
-        # It's pretty much impossible to write readable doctests that work on
-        # both Python 2 and Python 3 because of their overreliance on
-        # consistent repr() return values.
-        # For now, just run doctests on Python 2 so we now they haven't broken.
-        for mod in _test_suite_modules_to_doctest():
-            if not interesting_module(mod):
-                # No tests to keep here, move along
-                continue
-            try:
-                # note that this really does mean "report only" -- doctest
-                # still runs the rest of the examples
-                doc_suite = IsolatedDocTestSuite(
-                    mod, optionflags=doctest.REPORT_ONLY_FIRST_FAILURE)
-            except ValueError as e:
-                print('**failed to get doctest for: %s\n%s' % (mod, e))
-                raise
-            if len(doc_suite._tests) == 0:
-                raise errors.BzrError("no doctests found in %s" % (mod,))
-            suite.addTest(doc_suite)
+    for mod in _test_suite_modules_to_doctest():
+        if not interesting_module(mod):
+            # No tests to keep here, move along
+            continue
+        try:
+            # note that this really does mean "report only" -- doctest
+            # still runs the rest of the examples
+            doc_suite = IsolatedDocTestSuite(
+                mod, optionflags=doctest.REPORT_ONLY_FIRST_FAILURE)
+        except ValueError as e:
+            print('**failed to get doctest for: %s\n%s' % (mod, e))
+            raise
+        if len(doc_suite._tests) == 0:
+            raise errors.BzrError("no doctests found in %s" % (mod,))
+        suite.addTest(doc_suite)
 
     default_encoding = sys.getdefaultencoding()
     for name, plugin in _mod_plugin.plugins().items():
@@ -4493,6 +4449,7 @@
     return new_test
 
 
+
 def permute_tests_for_extension(standard_tests, loader, py_module_name,
                                 ext_module_name):
     """Helper for permutating tests against an extension module.
@@ -4526,10 +4483,12 @@
     if feature.available():
         scenarios.append(('C', {'module': feature.module}))
     else:
-        # the compiled module isn't available, so we add a failing test
         class FailWithoutFeature(TestCase):
+            def id(self):
+                return ext_module_name + '.' + super(FailWithoutFeature, self).id()
             def test_fail(self):
                 self.requireFeature(feature)
+        # the compiled module isn't available, so we add a failing test
         suite.addTest(loader.loadTestsFromTestCase(FailWithoutFeature))
     result = multiply_tests(standard_tests, scenarios, suite)
     return result, feature
@@ -4588,7 +4547,7 @@
     for given encoding.
     """
     for i in range(128, 256):
-        char = int2byte(i)
+        char = bytes([i])
         try:
             char.decode(encoding)
         except UnicodeDecodeError:

=== modified file 'breezy/tests/blackbox/test_bisect.py'
--- breezy/tests/blackbox/test_bisect.py	2019-03-05 09:17:49 +0000
+++ breezy/tests/blackbox/test_bisect.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Tests of the 'brz bisect' command."""
 
-from __future__ import absolute_import
-
 import os
 import shutil
 import stat

=== modified file 'breezy/tests/blackbox/test_command_encoding.py'
--- breezy/tests/blackbox/test_command_encoding.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/blackbox/test_command_encoding.py	2020-02-07 02:14:30 +0000
@@ -18,7 +18,6 @@
 
 from .. import TestCaseWithMemoryTransport
 from ...commands import Command, register_command, plugin_cmds
-from ...sixish import PY3
 
 
 class cmd_echo_exact(Command):

=== modified file 'breezy/tests/blackbox/test_commit.py'
--- breezy/tests/blackbox/test_commit.py	2019-06-29 19:54:32 +0000
+++ breezy/tests/blackbox/test_commit.py	2020-02-07 02:14:30 +0000
@@ -31,7 +31,6 @@
     msgeditor,
     )
 from ...controldir import ControlDir
-from ...sixish import PY3
 from .. import (
     test_foreign,
     features,
@@ -147,7 +146,7 @@
         out, err = self.run_bzr(['commit', '-m', file_name])
         reflags = re.MULTILINE | re.DOTALL | re.UNICODE
         te = osutils.get_terminal_encoding()
-        self.assertContainsRe(err if PY3 else err.decode(te),
+        self.assertContainsRe(err,
                               u'The commit message is a file name:',
                               flags=reflags)
 
@@ -166,7 +165,7 @@
             out, err = self.run_bzr(['commit', '-m', file_name])
             reflags = re.MULTILINE | re.DOTALL | re.UNICODE
             te = osutils.get_terminal_encoding()
-            self.assertContainsRe(err if PY3 else err.decode(te, 'replace'),
+            self.assertContainsRe(err,
                                   u'The commit message is a file name:',
                                   flags=reflags)
         finally:
@@ -188,11 +187,7 @@
         tree.add(["f"])
         out, err = self.run_bzr_raw(["commit", "-m", "Wrong filename", u"\xa7"],
                                     encoding="iso-8859-5", retcode=3)
-        if not PY3:
-            self.expectFailure("Error messages are always written as UTF-8",
-                               self.assertNotContainsString, err, b"\xc2\xa7")
-        else:
-            self.assertNotContainsString(err, b"\xc2\xa7")
+        self.assertNotContainsString(err, b"\xc2\xa7")
         self.assertContainsRe(err, b"(?m)not versioned: \"\xfd\"$")
 
     def test_warn_about_forgotten_commit_message(self):

=== modified file 'breezy/tests/blackbox/test_conflicts.py'
--- breezy/tests/blackbox/test_conflicts.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/blackbox/test_conflicts.py	2020-02-07 02:14:30 +0000
@@ -19,7 +19,6 @@
     tests,
     workingtree,
     )
-from breezy.sixish import PY3
 from breezy.tests import script, features
 
 
@@ -98,7 +97,7 @@
         make_tree_with_conflicts(self, "branch", prefix=u"\xA7")
         out, err = self.run_bzr(["conflicts", "-d", "branch"],
                                 encoding=self.encoding)
-        self.assertEqual(out if PY3 else out.decode(self.encoding),
+        self.assertEqual(out,
                          u"Text conflict in \xA7_other_file\n"
                          u"Path conflict: \xA7dir3 / \xA7dir2\n"
                          u"Text conflict in \xA7file\n")
@@ -109,7 +108,7 @@
         make_tree_with_conflicts(self, "branch", prefix=u"\xA7")
         out, err = self.run_bzr(["conflicts", "-d", "branch", "--text"],
                                 encoding=self.encoding)
-        self.assertEqual(out if PY3 else out.decode(self.encoding),
+        self.assertEqual(out,
                          u"\xA7_other_file\n"
                          u"\xA7file\n")
         self.assertEqual(err, "")

=== modified file 'breezy/tests/blackbox/test_exceptions.py'
--- breezy/tests/blackbox/test_exceptions.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/blackbox/test_exceptions.py	2020-02-07 02:14:30 +0000
@@ -28,7 +28,6 @@
     repository,
     tests,
     )
-from breezy.sixish import PY3
 from breezy.bzr.groupcompress_repo import RepositoryFormat2a
 
 
@@ -45,26 +44,6 @@
         self.assertContainsRe(
             err, br'Bazaar has encountered an internal error')
 
-    def test_undecodable_argv(self):
-        """A user error must be reported if argv is not in the locale encoding
-
-        A subprocess with an environment ascii-only setting is used so the test
-        can run without worrying about the locale the test suite is using.
-        """
-        if os.name != "posix":
-            raise tests.TestNotApplicable("Needs system beholden to C locales")
-        if PY3:
-            raise tests.TestNotApplicable(
-                "Unable to pass argv to subprocess as bytes")
-        out, err = self.run_bzr_subprocess([b"\xa0"],
-                                           env_changes={
-                                               "LANG": "C", "LC_ALL": "C"},
-                                           universal_newlines=True,
-                                           retcode=errors.EXIT_ERROR)
-        self.assertContainsRe(err, br"^brz: ERROR: .*'\\xa0'.* unsupported",
-                              flags=re.MULTILINE)
-        self.assertEqual(out, b"")
-
     def test_utf8_default_fs_enc(self):
         """In the C locale brz treats a posix filesystem as UTF-8 encoded"""
         if os.name != "posix":
@@ -79,10 +58,7 @@
 
     def test_nonascii_optparse(self):
         """Reasonable error raised when non-ascii in option name on Python 2"""
-        if PY3:
-            error_re = u'no such option: -\xe4'
-        else:
-            error_re = 'Only ASCII permitted in option names'
+        error_re = u'no such option: -\xe4'
         out = self.run_bzr_error([error_re], ['st', u'-\xe4'])
 
 

=== modified file 'breezy/tests/blackbox/test_export.py'
--- breezy/tests/blackbox/test_export.py	2019-06-29 19:54:32 +0000
+++ breezy/tests/blackbox/test_export.py	2020-02-07 02:14:30 +0000
@@ -18,6 +18,7 @@
 """Black-box tests for brz export.
 """
 
+from io import BytesIO
 import os
 import stat
 import tarfile
@@ -30,9 +31,6 @@
     export,
     osutils,
     )
-from ...sixish import (
-    BytesIO,
-    )
 from .. import (
     features,
     TestCaseWithTransport,

=== modified file 'breezy/tests/blackbox/test_log.py'
--- breezy/tests/blackbox/test_log.py	2019-02-02 15:13:30 +0000
+++ breezy/tests/blackbox/test_log.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Black-box tests for brz log."""
 
-from __future__ import absolute_import
-
 
 import os
 
@@ -29,7 +27,6 @@
     osutils,
     tests,
     )
-from breezy.sixish import PY3
 from breezy.tests import (
     test_log,
     features,
@@ -785,12 +782,7 @@
             out, err = brz('log', encoding=encoding)
             if not fail:
                 # Make sure we wrote mu as we expected it to exist
-                if not PY3:
-                    self.assertNotEqual(-1, out.find(encoded_msg))
-                    out_unicode = out.decode(encoding)
-                else:
-                    out_unicode = out
-                self.assertNotEqual(-1, out_unicode.find(self._message))
+                self.assertNotEqual(-1, out.find(self._message))
             else:
                 self.assertNotEqual(-1, out.find('Message with ?'))
         finally:

=== modified file 'breezy/tests/blackbox/test_non_ascii.py'
--- breezy/tests/blackbox/test_non_ascii.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/blackbox/test_non_ascii.py	2020-02-07 02:14:30 +0000
@@ -24,7 +24,6 @@
     tests,
     urlutils,
     )
-from breezy.sixish import PY3
 from breezy.tests import EncodingAdapter
 from breezy.tests.scenarios import load_tests_apply_scenarios
 
@@ -43,11 +42,7 @@
 
         self.overrideAttr(osutils, '_cached_user_encoding', self.encoding)
         email = self.info['committer'] + ' <joe@foo.com>'
-        if sys.version_info[0] == 2:
-            self.overrideEnv('BRZ_EMAIL', email.encode(
-                osutils.get_user_encoding()))
-        else:
-            self.overrideEnv('BRZ_EMAIL', email)
+        self.overrideEnv('BRZ_EMAIL', email)
         self.create_base()
 
     def run_bzr_decode(self, args, encoding=None, fail=False, retcode=None,

=== modified file 'breezy/tests/blackbox/test_ping.py'
--- breezy/tests/blackbox/test_ping.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/blackbox/test_ping.py	2020-02-07 02:14:30 +0000
@@ -17,7 +17,6 @@
 """External tests of 'brz ping'"""
 
 import breezy
-from breezy.sixish import PY3
 from breezy import tests
 
 
@@ -33,12 +32,7 @@
         out, err = self.run_bzr(['ping', self.get_url('branch')])
         self.assertLength(1, self.hpss_calls)
         self.assertLength(1, self.hpss_connections)
-        if PY3:
-            self.assertEqual(out,
-                             "Response: (b'ok', b'2')\n"
-                             "Headers: {'Software version': '%s'}\n" % (breezy.version_string,))
-        else:
-            self.assertEqual(out,
-                             "Response: ('ok', '2')\n"
-                             "Headers: {u'Software version': u'%s'}\n" % (breezy.version_string,))
+        self.assertEqual(out,
+                         "Response: (b'ok', b'2')\n"
+                         "Headers: {'Software version': '%s'}\n" % (breezy.version_string,))
         self.assertEqual(err, "")

=== modified file 'breezy/tests/blackbox/test_plugins.py'
--- breezy/tests/blackbox/test_plugins.py	2018-07-07 15:06:42 +0000
+++ breezy/tests/blackbox/test_plugins.py	2020-02-07 02:14:30 +0000
@@ -22,7 +22,6 @@
 from ... import (
     commands,
     )
-from ...sixish import PY3
 from ..test_plugins import (
     BaseTestPlugins,
     )
@@ -32,10 +31,7 @@
 
     def run_bzr_utf8_out(self, *args, **kwargs):
         out, _ = self.run_bzr(*args, **kwargs)
-        if PY3:
-            return out
-        else:
-            return out.decode('utf-8')
+        return out
 
     def split_help_commands(self):
         help = {}

=== modified file 'breezy/tests/blackbox/test_send.py'
--- breezy/tests/blackbox/test_send.py	2019-07-25 22:19:30 +0000
+++ breezy/tests/blackbox/test_send.py	2020-02-07 02:14:30 +0000
@@ -15,6 +15,9 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from io import (
+    BytesIO,
+    )
 
 from ... import (
     branch,
@@ -23,9 +26,6 @@
     )
 from ...controldir import ControlDir
 from ...bzr.bundle import serializer
-from ...sixish import (
-    BytesIO,
-    )
 from ...transport import memory
 from .. import (
     scenarios,

=== modified file 'breezy/tests/blackbox/test_serve.py'
--- breezy/tests/blackbox/test_serve.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/blackbox/test_serve.py	2020-02-07 02:14:30 +0000
@@ -20,10 +20,7 @@
 import os
 import signal
 import sys
-try:
-    from _thread import interrupt_main
-except ImportError:  # Python < 3
-    from thread import interrupt_main
+from _thread import interrupt_main
 
 import threading
 

=== modified file 'breezy/tests/blackbox/test_shell_complete.py'
--- breezy/tests/blackbox/test_shell_complete.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/blackbox/test_shell_complete.py	2020-02-07 02:14:30 +0000
@@ -19,7 +19,6 @@
 """Black-box tests for 'brz shell-complete'."""
 
 from breezy.tests import TestCaseWithTransport
-from breezy.sixish import PY3
 
 
 class ShellCompleteTests(TestCaseWithTransport):

=== modified file 'breezy/tests/blackbox/test_status.py'
--- breezy/tests/blackbox/test_status.py	2019-08-11 13:33:45 +0000
+++ breezy/tests/blackbox/test_status.py	2020-02-07 02:14:30 +0000
@@ -23,6 +23,10 @@
 """
 
 import codecs
+from io import (
+    BytesIO,
+    StringIO,
+    )
 from os import mkdir, chdir, rmdir, unlink
 import sys
 
@@ -38,11 +42,6 @@
 import breezy.branch
 from ...osutils import pathjoin
 from ...revisionspec import RevisionSpec
-from ...sixish import (
-    BytesIO,
-    StringIO,
-    PY3,
-    )
 from ...status import show_tree_status
 from .. import TestCaseWithTransport, TestSkipped
 from ...workingtree import WorkingTree
@@ -805,6 +804,4 @@
 added:
   hell\u00d8
 """
-        if not PY3:
-            expected = expected.encode('latin-1')
         self.assertEqual(stdout, expected)

=== modified file 'breezy/tests/blackbox/test_tags.py'
--- breezy/tests/blackbox/test_tags.py	2019-06-15 18:57:07 +0000
+++ breezy/tests/blackbox/test_tags.py	2020-02-07 02:14:30 +0000
@@ -31,7 +31,6 @@
 from breezy.branch import (
     Branch,
     )
-from breezy.sixish import PY3
 from breezy.tests import (
     script,
     TestCaseWithTransport,
@@ -392,20 +391,12 @@
         b2.tags.set_tag(tagname, b'revid2')
         # push should give a warning about the tags
         out, err = self.run_bzr('push -d one two', encoding='utf-8')
-        if PY3:
-            self.assertContainsRe(out, 'Conflicting tags:\n.*' + tagname)
-        else:
-            self.assertContainsRe(
-                out, 'Conflicting tags:\n.*' + tagname.encode('utf-8'))
+        self.assertContainsRe(out, 'Conflicting tags:\n.*' + tagname)
         # pull should give a warning about the tags
         out, err = self.run_bzr('pull -d one two', encoding='utf-8',
                                 retcode=1)
-        if PY3:
-            self.assertContainsRe(out,
-                                  'Conflicting tags:\n.*' + tagname)
-        else:
-            self.assertContainsRe(out,
-                                  'Conflicting tags:\n.*' + tagname.encode('utf-8'))
+        self.assertContainsRe(out,
+                              'Conflicting tags:\n.*' + tagname)
         # merge should give a warning about the tags -- not implemented yet
         ## out, err = self.run_bzr('merge -d one two', encoding='utf-8')
         # self.assertContainsRe(out,

=== modified file 'breezy/tests/blackbox/test_testament.py'
--- breezy/tests/blackbox/test_testament.py	2019-10-27 00:49:13 +0000
+++ breezy/tests/blackbox/test_testament.py	2020-02-07 02:14:30 +0000
@@ -18,7 +18,6 @@
 
 import re
 
-from breezy.sixish import PY3
 from breezy.tests.test_testament import (
     osutils,
     REV_1_SHORT,

=== modified file 'breezy/tests/blackbox/test_version.py'
--- breezy/tests/blackbox/test_version.py	2019-06-16 19:53:27 +0000
+++ breezy/tests/blackbox/test_version.py	2020-02-07 02:14:30 +0000
@@ -21,7 +21,6 @@
 
 import breezy
 from breezy import osutils, trace
-from breezy.sixish import PY3
 from breezy.tests import (
     probe_unicode_in_user_encoding,
     TestCase,
@@ -96,10 +95,7 @@
             raise TestSkipped('Cannot find a unicode character that works in'
                               ' encoding %s' % (osutils.get_user_encoding(),))
 
-        if PY3:
-            self.overrideEnv('BRZ_HOME', uni_val)
-        else:
-            self.overrideEnv('BRZ_HOME', str_val)
+        self.overrideEnv('BRZ_HOME', uni_val)
         self.permit_source_tree_branch_repo()
         out = self.run_bzr_raw("version")[0]
         self.assertTrue(len(out) > 0)
@@ -147,10 +143,7 @@
                 "Test string %r unrepresentable in user encoding %s" % (
                     uni_val, enc))
         brz_log = os.path.join(self.test_base_dir, uni_val)
-        if PY3:
-            self.overrideEnv("BRZ_LOG", brz_log)
-        else:
-            self.overrideEnv("BRZ_LOG", brz_log.encode(enc))
+        self.overrideEnv("BRZ_LOG", brz_log)
         out, err = self.run_bzr_subprocess("version")
         uni_out = out.decode(enc)
         self.assertContainsRe(uni_out, u"(?m)^  Breezy log file: .*/\xa7$")

=== modified file 'breezy/tests/blackbox/test_version_info.py'
--- breezy/tests/blackbox/test_version_info.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/blackbox/test_version_info.py	2020-02-07 02:14:30 +0000
@@ -18,7 +18,6 @@
 
 import os
 
-from breezy.sixish import PY3
 from breezy.tests import TestCaseWithTransport
 from breezy.version_info_formats import VersionInfoBuilder
 

=== modified file 'breezy/tests/blackbox/test_whoami.py'
--- breezy/tests/blackbox/test_whoami.py	2019-06-16 17:36:59 +0000
+++ breezy/tests/blackbox/test_whoami.py	2020-02-07 02:14:30 +0000
@@ -23,7 +23,6 @@
     errors,
     tests,
     )
-from breezy.sixish import PY3
 
 from ..test_bedding import override_whoami
 
@@ -35,7 +34,7 @@
         self.assertEqual('', err)
         lines = out.splitlines()
         self.assertLength(1, lines)
-        if PY3 and isinstance(expected, bytes):
+        if isinstance(expected, bytes):
             expected = expected.decode(kwargs.get('encoding', 'ascii'))
         self.assertEqual(expected, lines[0].rstrip())
 

=== modified file 'breezy/tests/features.py'
--- breezy/tests/features.py	2019-05-28 21:46:09 +0000
+++ breezy/tests/features.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 """A collection of commonly used 'Features' to optionally run tests.
 """
 
-from __future__ import absolute_import
-
 import importlib
 import os
 import subprocess

=== modified file 'breezy/tests/file_utils.py'
--- breezy/tests/file_utils.py	2017-05-24 22:42:07 +0000
+++ breezy/tests/file_utils.py	2020-02-07 02:14:30 +0000
@@ -14,9 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from ..sixish import (
-    BytesIO,
-    )
+from io import BytesIO
 
 
 class FakeReadFile(object):

=== modified file 'breezy/tests/fixtures.py'
--- breezy/tests/fixtures.py	2018-11-12 01:41:38 +0000
+++ breezy/tests/fixtures.py	2020-02-07 02:14:30 +0000
@@ -37,7 +37,7 @@
     >>> n1 = next(gen)
     >>> n2 = next(gen)
     >>> type(n1)
-    <type 'unicode'>
+    <class 'str'>
     >>> n1 == n2
     False
     >>> n1.encode('ascii', 'replace') == n1

=== modified file 'breezy/tests/http_server.py'
--- breezy/tests/http_server.py	2018-11-12 01:41:38 +0000
+++ breezy/tests/http_server.py	2020-02-07 02:14:30 +0000
@@ -15,22 +15,15 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 import errno
-try:
-    import http.client as http_client
-    import http.server as http_server
-except ImportError:
-    import httplib as http_client
-    import SimpleHTTPServer as http_server
+import http.client as http_client
+import http.server as http_server
 import os
 import posixpath
 import random
 import re
 import socket
 import sys
-try:
-    from urlparse import urlparse
-except ImportError:
-    from urllib.parse import urlparse
+from urllib.parse import urlparse
 
 from .. import (
     osutils,
@@ -340,8 +333,6 @@
         # abandon query parameters
         path = urlparse(path)[2]
         path = posixpath.normpath(urlutils.unquote(path))
-        if sys.version_info[0] == 2:
-            path = path.decode('utf-8')
         words = path.split('/')
         path = self._cwd
         for num, word in enumerate(w for w in words if w):

=== modified file 'breezy/tests/http_utils.py'
--- breezy/tests/http_utils.py	2018-11-23 02:42:39 +0000
+++ breezy/tests/http_utils.py	2020-02-07 02:14:30 +0000
@@ -15,17 +15,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 import base64
+from io import BytesIO
 import re
-try:
-    from urllib.request import (
-        parse_http_list,
-        parse_keqv_list,
-        )
-except ImportError:  # python < 3
-    from urllib2 import (
-        parse_http_list,
-        parse_keqv_list,
-        )
+from urllib.request import (
+    parse_http_list,
+    parse_keqv_list,
+    )
 
 
 from .. import (
@@ -34,9 +29,6 @@
     tests,
     transport,
     )
-from ..sixish import (
-    BytesIO,
-    )
 from ..bzr.smart import (
     medium,
     )

=== modified file 'breezy/tests/matchers.py'
--- breezy/tests/matchers.py	2020-02-09 17:10:01 +0000
+++ breezy/tests/matchers.py	2020-02-13 23:57:28 +0000
@@ -45,10 +45,10 @@
 from breezy.bzr.smart.request import request_handlers as smart_request_handlers
 from breezy.bzr.smart import vfs
 """)
-from ..sixish import (
-    text_type,
+from ..tree import (
+    find_previous_path,
+    InterTree,
     )
-from ..tree import InterTree
 
 from testtools.matchers import Equals, Mismatch, Matcher
 
@@ -157,7 +157,7 @@
         """
         directories = []
         for entry in entries:
-            if isinstance(entry, (str, text_type)):
+            if isinstance(entry, str):
                 path = entry
             else:
                 path = entry[0]
@@ -177,7 +177,7 @@
 
     def match(self, tree):
         include_file_ids = self.entries and not isinstance(
-            self.entries[0], (str, text_type))
+            self.entries[0], str)
         actual = list(self.get_tree_layout(
             tree, include_file_ids=include_file_ids))
         if not tree.has_versioned_directories():

=== modified file 'breezy/tests/per_branch/test_branch.py'
--- breezy/tests/per_branch/test_branch.py	2020-01-20 00:03:54 +0000
+++ breezy/tests/per_branch/test_branch.py	2020-02-07 02:14:30 +0000
@@ -40,9 +40,6 @@
     branch as _mod_bzrbranch,
     remote,
     )
-from breezy.sixish import (
-    text_type,
-    )
 from breezy.tests import (
     per_branch,
     )
@@ -292,7 +289,7 @@
         branch = self.make_branch('bzr.dev')
         # An implicit nick name is set; what it is exactly depends on the
         # format.
-        self.assertIsInstance(branch.nick, text_type)
+        self.assertIsInstance(branch.nick, str)
         # Set the branch nick explicitly.
         branch.nick = u"Aaron's branch"
         # Because the nick has been set explicitly, the nick is now always

=== modified file 'breezy/tests/per_branch/test_check.py'
--- breezy/tests/per_branch/test_check.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/per_branch/test_check.py	2020-02-07 02:14:30 +0000
@@ -16,15 +16,13 @@
 
 """Tests for branch implementations - test check() functionality"""
 
+from io import BytesIO
 
 from ... import (
     errors,
     tests,
     ui,
 )
-from ...sixish import (
-    BytesIO,
-    )
 from . import TestCaseWithBranch
 
 

=== modified file 'breezy/tests/per_branch/test_push.py'
--- breezy/tests/per_branch/test_push.py	2019-06-29 19:54:32 +0000
+++ breezy/tests/per_branch/test_push.py	2020-02-07 02:14:30 +0000
@@ -16,6 +16,7 @@
 
 """Tests for branch.push behaviour."""
 
+from io import BytesIO
 import os
 
 from ... import (
@@ -33,9 +34,6 @@
 from ...bzr import (
     branch as bzrbranch,
     )
-from ...sixish import (
-    BytesIO,
-    )
 from ...bzr.smart import (
     client,
     )

=== modified file 'breezy/tests/per_foreign_vcs/test_branch.py'
--- breezy/tests/per_foreign_vcs/test_branch.py	2018-11-18 19:48:57 +0000
+++ breezy/tests/per_foreign_vcs/test_branch.py	2020-02-07 02:14:30 +0000
@@ -29,9 +29,6 @@
 from breezy.tests import (
     TestCaseWithTransport,
     )
-from breezy.sixish import (
-    text_type,
-    )
 
 
 class ForeignBranchFactory(object):
@@ -99,8 +96,8 @@
     def test__get_nick(self):
         """Make sure _get_nick is implemented and returns a string."""
         branch = self.make_branch()
-        self.assertIsInstance(branch._get_nick(local=False), text_type)
-        self.assertIsInstance(branch._get_nick(local=True), text_type)
+        self.assertIsInstance(branch._get_nick(local=False), str)
+        self.assertIsInstance(branch._get_nick(local=True), str)
 
     def test_null_revid_revno(self):
         """null: should return revno 0."""

=== modified file 'breezy/tests/per_interbranch/test_push.py'
--- breezy/tests/per_interbranch/test_push.py	2020-02-19 04:50:09 +0000
+++ breezy/tests/per_interbranch/test_push.py	2020-02-21 03:58:42 +0000
@@ -16,6 +16,8 @@
 
 """Tests for branch.push behaviour."""
 
+from io import BytesIO
+
 from testtools.matchers import (
     Equals,
     MatchesAny,
@@ -37,9 +39,6 @@
 from ...controldir import ControlDir
 from ...memorytree import MemoryTree
 from ...revision import NULL_REVISION
-from ...sixish import (
-    BytesIO,
-    )
 from ...bzr.smart.repository import SmartServerRepositoryGetParentMap
 from . import (
     TestCaseWithInterBranch,

=== modified file 'breezy/tests/per_repository/test_repository.py'
--- breezy/tests/per_repository/test_repository.py	2019-09-21 16:12:01 +0000
+++ breezy/tests/per_repository/test_repository.py	2020-02-07 02:14:30 +0000
@@ -16,6 +16,7 @@
 
 """Tests for repository implementations - tests a repository format."""
 
+from io import BytesIO
 import re
 
 from ... import (
@@ -42,11 +43,6 @@
 from ...bzr import (
     knitpack_repo,
     )
-from ...sixish import (
-    BytesIO,
-    text_type,
-    unichr,
-    )
 from .. import (
     per_repository,
     test_server,
@@ -421,7 +417,7 @@
             self.assertEqual(rev.message, message)
         # insist the class is unicode no matter what came in for
         # consistency.
-        self.assertIsInstance(rev.message, text_type)
+        self.assertIsInstance(rev.message, str)
 
     def test_commit_unicode_message(self):
         # a siple unicode message should be preserved
@@ -429,7 +425,7 @@
 
     def test_commit_unicode_control_characters(self):
         # a unicode message with control characters should roundtrip too.
-        unichars = [unichr(x) for x in range(256)]
+        unichars = [chr(x) for x in range(256)]
         # '\r' is not directly allowed anymore, as it used to be translated
         # into '\n' anyway
         unichars[ord('\r')] = u'\n'

=== modified file 'breezy/tests/per_repository_reference/test_get_record_stream.py'
--- breezy/tests/per_repository_reference/test_get_record_stream.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/per_repository_reference/test_get_record_stream.py	2020-02-07 02:14:30 +0000
@@ -22,7 +22,6 @@
 from breezy.bzr import (
     knit,
     )
-from breezy.sixish import int2byte
 from breezy.tests.per_repository_reference import (
     TestCaseWithExternalReferenceRepository,
     )
@@ -107,7 +106,7 @@
 
     def test_unordered_fetch_simple_split(self):
         self.make_simple_split()
-        keys = [(b'f-id', int2byte(r)) for r in bytearray(b'ABCDF')]
+        keys = [(b'f-id', bytes([r])) for r in bytearray(b'ABCDF')]
         self.stacked_repo.lock_read()
         self.addCleanup(self.stacked_repo.unlock)
         stream = self.stacked_repo.texts.get_record_stream(
@@ -122,7 +121,7 @@
 
     def test_unordered_fetch_complex_split(self):
         self.make_complex_split()
-        keys = [(b'f-id', int2byte(r)) for r in bytearray(b'ABCDEG')]
+        keys = [(b'f-id', bytes([r])) for r in bytearray(b'ABCDEG')]
         self.stacked_repo.lock_read()
         self.addCleanup(self.stacked_repo.unlock)
         stream = self.stacked_repo.texts.get_record_stream(
@@ -144,11 +143,11 @@
         # or, because E can be returned before B:
         #
         # A C E B D G
-        keys = [(b'f-id', int2byte(r)) for r in bytearray(b'ABCDEG')]
-        alt_1 = [(b'f-id', int2byte(r)) for r in bytearray(b'ACBDEG')]
-        alt_2 = [(b'f-id', int2byte(r)) for r in bytearray(b'ABCEDG')]
-        alt_3 = [(b'f-id', int2byte(r)) for r in bytearray(b'ACBEDG')]
-        alt_4 = [(b'f-id', int2byte(r)) for r in bytearray(b'ACEBDG')]
+        keys = [(b'f-id', bytes([r])) for r in bytearray(b'ABCDEG')]
+        alt_1 = [(b'f-id', bytes([r])) for r in bytearray(b'ACBDEG')]
+        alt_2 = [(b'f-id', bytes([r])) for r in bytearray(b'ABCEDG')]
+        alt_3 = [(b'f-id', bytes([r])) for r in bytearray(b'ACBEDG')]
+        alt_4 = [(b'f-id', bytes([r])) for r in bytearray(b'ACEBDG')]
         self.stacked_repo.lock_read()
         self.addCleanup(self.stacked_repo.unlock)
         stream = self.stacked_repo.texts.get_record_stream(
@@ -168,8 +167,8 @@
         # Topological ordering allows B & C and D & E to be returned with
         # either one first, so the required ordering is:
         # [A (B C) D F]
-        keys = [(b'f-id', int2byte(r)) for r in bytearray(b'ABCDF')]
-        alt_1 = [(b'f-id', int2byte(r)) for r in bytearray(b'ACBDF')]
+        keys = [(b'f-id', bytes([r])) for r in bytearray(b'ABCDF')]
+        alt_1 = [(b'f-id', bytes([r])) for r in bytearray(b'ACBDF')]
         self.stacked_repo.lock_read()
         self.addCleanup(self.stacked_repo.unlock)
         stream = self.stacked_repo.texts.get_record_stream(
@@ -190,11 +189,11 @@
         # or, because E can be returned before B:
         #
         # A C E B D G
-        keys = [(b'f-id', int2byte(r)) for r in bytearray(b'ABCDEG')]
-        alt_1 = [(b'f-id', int2byte(r)) for r in bytearray(b'ACBDEG')]
-        alt_2 = [(b'f-id', int2byte(r)) for r in bytearray(b'ABCEDG')]
-        alt_3 = [(b'f-id', int2byte(r)) for r in bytearray(b'ACBEDG')]
-        alt_4 = [(b'f-id', int2byte(r)) for r in bytearray(b'ACEBDG')]
+        keys = [(b'f-id', bytes([r])) for r in bytearray(b'ABCDEG')]
+        alt_1 = [(b'f-id', bytes([r])) for r in bytearray(b'ACBDEG')]
+        alt_2 = [(b'f-id', bytes([r])) for r in bytearray(b'ABCEDG')]
+        alt_3 = [(b'f-id', bytes([r])) for r in bytearray(b'ACBEDG')]
+        alt_4 = [(b'f-id', bytes([r])) for r in bytearray(b'ACEBDG')]
         self.stacked_repo.lock_read()
         self.addCleanup(self.stacked_repo.unlock)
         stream = self.stacked_repo.texts.get_record_stream(

=== modified file 'breezy/tests/per_transport.py'
--- breezy/tests/per_transport.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/per_transport.py	2020-02-07 02:14:30 +0000
@@ -20,6 +20,7 @@
 TransportTestProviderAdapter.
 """
 
+from io import BytesIO
 import os
 import stat
 import sys
@@ -39,10 +40,6 @@
                       TransportNotPossible,
                       )
 from ..osutils import getcwd
-from ..sixish import (
-    BytesIO,
-    zip,
-    )
 from ..bzr.smart import medium
 from . import (
     TestSkipped,

=== modified file 'breezy/tests/per_tree/test_test_trees.py'
--- breezy/tests/per_tree/test_test_trees.py	2020-01-10 01:40:18 +0000
+++ breezy/tests/per_tree/test_test_trees.py	2020-02-07 02:14:30 +0000
@@ -17,7 +17,6 @@
 """Tests for the test trees used by the per_tree tests."""
 
 from breezy import errors
-from breezy.sixish import text_type
 from breezy.tests import per_tree
 from breezy.tests import (
     TestNotApplicable,
@@ -323,7 +322,7 @@
 
         for expected, (path, ie) in zip(path_and_ids, path_entries):
             self.assertEqual(expected[0], path)  # Paths should match
-            self.assertIsInstance(path, text_type)
+            self.assertIsInstance(path, str)
             self.assertEqual(expected[1], ie.file_id)
             self.assertIsInstance(ie.file_id, bytes)
             self.assertEqual(expected[2], ie.parent_id)
@@ -393,7 +392,7 @@
         for (epath, efid, eparent, erev), (path, ie) in zip(path_and_ids,
                                                             path_entries):
             self.assertEqual(epath, path)  # Paths should match
-            self.assertIsInstance(path, text_type)
+            self.assertIsInstance(path, str)
             self.assertIsInstance(ie.file_id, bytes)
             if wt.supports_setting_file_ids():
                 self.assertEqual(efid, ie.file_id)

=== modified file 'breezy/tests/per_versionedfile.py'
--- breezy/tests/per_versionedfile.py	2020-01-30 18:07:32 +0000
+++ breezy/tests/per_versionedfile.py	2020-02-07 02:14:30 +0000
@@ -22,6 +22,7 @@
 # considered typical and check that it can be detected/corrected.
 
 from gzip import GzipFile
+from io import BytesIO
 import itertools
 
 from .. import (
@@ -45,10 +46,6 @@
     make_file_factory,
     make_pack_factory,
     )
-from ..sixish import (
-    BytesIO,
-    zip,
-    )
 from . import (
     TestCase,
     TestCaseWithMemoryTransport,

=== modified file 'breezy/tests/per_workingtree/test_eol_conversion.py'
--- breezy/tests/per_workingtree/test_eol_conversion.py	2020-01-30 17:54:42 +0000
+++ breezy/tests/per_workingtree/test_eol_conversion.py	2020-02-07 02:14:30 +0000
@@ -16,12 +16,10 @@
 
 """Tests for eol conversion."""
 
+from io import BytesIO
 import sys
 
 from ... import rules, status
-from ...sixish import (
-    BytesIO,
-    )
 from .. import TestSkipped
 from . import TestCaseWithWorkingTree
 from ...workingtree import WorkingTree

=== modified file 'breezy/tests/per_workingtree/test_parents.py'
--- breezy/tests/per_workingtree/test_parents.py	2018-12-18 20:55:37 +0000
+++ breezy/tests/per_workingtree/test_parents.py	2020-02-07 02:14:30 +0000
@@ -16,6 +16,7 @@
 
 """Tests of the parent related functions of WorkingTrees."""
 
+from io import BytesIO
 import os
 
 from ... import (
@@ -32,9 +33,6 @@
     InventoryRevisionTree,
     InventoryTree,
     )
-from ...sixish import (
-    BytesIO,
-    )
 from ...tests import TestNotApplicable
 from ..per_workingtree import TestCaseWithWorkingTree
 from .. import (

=== modified file 'breezy/tests/per_workingtree/test_smart_add.py'
--- breezy/tests/per_workingtree/test_smart_add.py	2018-11-21 03:20:30 +0000
+++ breezy/tests/per_workingtree/test_smart_add.py	2020-02-07 02:14:30 +0000
@@ -16,6 +16,7 @@
 
 """Test that we can use smart_add on all Tree implementations."""
 
+from io import StringIO
 import os
 import sys
 
@@ -28,9 +29,6 @@
     trace,
     workingtree,
     )
-from ...sixish import (
-    StringIO,
-    )
 from .. import (
     features,
     per_workingtree,

=== modified file 'breezy/tests/per_workingtree/test_workingtree.py'
--- breezy/tests/per_workingtree/test_workingtree.py	2020-01-19 15:24:07 +0000
+++ breezy/tests/per_workingtree/test_workingtree.py	2020-02-07 02:14:30 +0000
@@ -17,6 +17,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 import errno
+from io import StringIO
 import os
 
 from ... import (
@@ -41,9 +42,6 @@
 from ...bzr.inventory import Inventory
 from ...mutabletree import MutableTree
 from ...osutils import pathjoin, getcwd, has_symlinks
-from ...sixish import (
-    StringIO,
-    )
 from .. import (
     features,
     TestSkipped,

=== modified file 'breezy/tests/script.py'
--- breezy/tests/script.py	2018-11-18 19:48:57 +0000
+++ breezy/tests/script.py	2020-02-07 02:14:30 +0000
@@ -320,19 +320,10 @@
 
     def do_brz(self, test_case, input, args):
         encoding = osutils.get_user_encoding()
-        if sys.version_info[0] == 2:
-            stdout = ui_testing.BytesIOWithEncoding()
-            stderr = ui_testing.BytesIOWithEncoding()
-            stdout.encoding = stderr.encoding = encoding
-
-            # FIXME: don't call into logging here
-            handler = trace.EncodedStreamHandler(
-                stderr, errors="replace")
-        else:
-            stdout = ui_testing.StringIOWithEncoding()
-            stderr = ui_testing.StringIOWithEncoding()
-            stdout.encoding = stderr.encoding = encoding
-            handler = logging.StreamHandler(stderr)
+        stdout = ui_testing.StringIOWithEncoding()
+        stderr = ui_testing.StringIOWithEncoding()
+        stdout.encoding = stderr.encoding = encoding
+        handler = logging.StreamHandler(stderr)
         handler.setLevel(logging.INFO)
 
         logger = logging.getLogger('')

=== modified file 'breezy/tests/stub_sftp.py'
--- breezy/tests/stub_sftp.py	2020-02-03 22:40:36 +0000
+++ breezy/tests/stub_sftp.py	2020-02-07 02:14:30 +0000
@@ -22,10 +22,7 @@
 import os
 import paramiko
 import socket
-try:
-    import socketserver
-except ImportError:
-    import SocketServer as socketserver
+import socketserver
 import sys
 import time
 

=== modified file 'breezy/tests/test__btree_serializer.py'
--- breezy/tests/test__btree_serializer.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test__btree_serializer.py	2020-02-07 02:14:30 +0000
@@ -21,9 +21,6 @@
 import bisect
 
 from .. import tests
-from ..sixish import (
-    int2byte,
-    )
 
 from .test_btree_index import compiled_btreeparser_feature
 
@@ -60,7 +57,7 @@
         self.assertIs(None, self.module._py_unhexlify(as_hex))
 
     def test_to_hex(self):
-        raw_bytes = b''.join(map(int2byte, range(256)))
+        raw_bytes = bytes(range(256))
         for i in range(0, 240, 20):
             self.assertHexlify(raw_bytes[i:i + 20])
         self.assertHexlify(raw_bytes[240:] + raw_bytes[0:4])
@@ -70,7 +67,7 @@
         self.assertUnhexlify(b'123456789abcdef0123456789abcdef012345678')
         self.assertUnhexlify(b'0123456789ABCDEF0123456789ABCDEF01234567')
         self.assertUnhexlify(b'123456789ABCDEF0123456789ABCDEF012345678')
-        hex_chars = binascii.hexlify(b''.join(map(int2byte, range(256))))
+        hex_chars = binascii.hexlify(bytes(range(256)))
         for i in range(0, 480, 40):
             self.assertUnhexlify(hex_chars[i:i + 40])
         self.assertUnhexlify(hex_chars[480:] + hex_chars[0:8])

=== modified file 'breezy/tests/test__chk_map.py'
--- breezy/tests/test__chk_map.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test__chk_map.py	2020-02-07 02:14:30 +0000
@@ -22,7 +22,6 @@
 from ..bzr import (
     chk_map,
     )
-from ..sixish import int2byte
 from ..static_tuple import StaticTuple
 stuple = StaticTuple
 
@@ -65,9 +64,9 @@
         chars_used = set()
         for char_in in range(256):
             search_key = self.module._search_key_255(
-                stuple(int2byte(char_in),))
-            chars_used.update(map(int2byte, bytearray(search_key)))
-        all_chars = {int2byte(x) for x in range(256)}
+                stuple(bytes([char_in]),))
+            chars_used.update([bytes([x]) for x in search_key])
+        all_chars = {bytes([x]) for x in range(256)}
         unused_chars = all_chars.symmetric_difference(chars_used)
         self.assertEqual({b'\n'}, unused_chars)
 

=== modified file 'breezy/tests/test__groupcompress.py'
--- breezy/tests/test__groupcompress.py	2018-11-16 18:33:17 +0000
+++ breezy/tests/test__groupcompress.py	2020-02-07 02:14:30 +0000
@@ -27,9 +27,6 @@
 from .scenarios import (
     load_tests_apply_scenarios,
     )
-from ..sixish import (
-    indexbytes,
-    )
 from . import (
     features,
     )
@@ -470,7 +467,7 @@
         self.assertEqual(expected, data)
 
     def assertDecode(self, exp_offset, exp_length, exp_newpos, data, pos):
-        cmd = indexbytes(data, pos)
+        cmd = data[pos]
         pos += 1
         out = _groupcompress_py.decode_copy_instruction(data, cmd, pos)
         self.assertEqual((exp_offset, exp_length, exp_newpos), out)

=== modified file 'breezy/tests/test__rio.py'
--- breezy/tests/test__rio.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test__rio.py	2020-02-18 01:57:45 +0000
@@ -16,15 +16,10 @@
 
 """Tests for _rio_*."""
 
-from __future__ import absolute_import
-
 from .. import (
     rio,
     tests,
     )
-from ..sixish import (
-    text_type,
-    )
 
 
 def load_tests(loader, standard_tests, pattern):
@@ -56,11 +51,8 @@
         self.assertFalse(self.module._valid_tag(""))
 
     def test_unicode(self):
-        if text_type is str:
-            # When str is a unicode type, it is valid for a tag
-            self.assertTrue(self.module._valid_tag(u"foo"))
-        else:
-            self.assertRaises(TypeError, self.module._valid_tag, u"foo")
+        # When str is a unicode type, it is valid for a tag
+        self.assertTrue(self.module._valid_tag(u"foo"))
 
     def test_non_ascii_char(self):
         self.assertFalse(self.module._valid_tag("\xb5"))
@@ -76,7 +68,7 @@
         if s is not None:
             for tag, value in s.iter_pairs():
                 self.assertIsInstance(tag, str)
-                self.assertIsInstance(value, text_type)
+                self.assertIsInstance(value, str)
 
     def assertReadStanzaRaises(self, exception, line_iter):
         self.assertRaises(exception, self.module._read_stanza_utf8, line_iter)
@@ -132,7 +124,7 @@
         if s is not None:
             for tag, value in s.iter_pairs():
                 self.assertIsInstance(tag, str)
-                self.assertIsInstance(value, text_type)
+                self.assertIsInstance(value, str)
 
     def assertReadStanzaRaises(self, exception, line_iter):
         self.assertRaises(exception, self.module._read_stanza_unicode,

=== modified file 'breezy/tests/test__static_tuple.py'
--- breezy/tests/test__static_tuple.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test__static_tuple.py	2020-02-07 02:14:30 +0000
@@ -30,10 +30,6 @@
     static_tuple,
     tests,
     )
-from breezy.sixish import (
-    PY3,
-    text_type,
-    )
 from breezy.tests import (
     features,
     )
@@ -221,16 +217,6 @@
         # But not a subclass, because subint could introduce refcycles
         self.assertRaises(TypeError, self.module.StaticTuple, subint(2))
 
-    def test_holds_long(self):
-        if PY3:
-            self.skipTest("No long type on Python 3")
-        k1 = self.module.StaticTuple(2**65)
-
-        class sublong(long):
-            pass
-        # But not a subclass
-        self.assertRaises(TypeError, self.module.StaticTuple, sublong(1))
-
     def test_holds_float(self):
         k1 = self.module.StaticTuple(1.2)
 
@@ -248,7 +234,7 @@
     def test_holds_unicode(self):
         k1 = self.module.StaticTuple(u'\xb5')
 
-        class subunicode(text_type):
+        class subunicode(str):
             pass
         self.assertRaises(TypeError, self.module.StaticTuple,
                           subunicode(u'\xb5'))
@@ -295,7 +281,7 @@
 
     def check_strict_compare(self, k1, k2, mismatched_types):
         """True if on Python 3 and stricter comparison semantics are used."""
-        if PY3 and mismatched_types:
+        if mismatched_types:
             for op in ("ge", "gt", "le", "lt"):
                 self.assertRaises(TypeError, getattr(operator, op), k1, k2)
             return True

=== modified file 'breezy/tests/test_annotate.py'
--- breezy/tests/test_annotate.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_annotate.py	2020-02-07 02:14:30 +0000
@@ -17,15 +17,12 @@
 """Whitebox tests for annotate functionality."""
 
 import codecs
-from io import BytesIO
+from io import BytesIO, StringIO
 
 from .. import (
     annotate,
     tests,
     )
-from ..sixish import (
-    StringIO,
-    )
 from .ui_testing import StringIOWithEncoding
 
 

=== modified file 'breezy/tests/test_bad_files.py'
--- breezy/tests/test_bad_files.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_bad_files.py	2020-02-07 02:14:30 +0000
@@ -17,14 +17,12 @@
 
 """Tests being able to ignore bad filetypes."""
 
+from io import StringIO
 import os
 
 from .. import (
     errors,
     )
-from ..sixish import (
-    StringIO,
-    )
 from ..status import show_tree_status
 from . import TestCaseWithTransport
 from .features import (

=== modified file 'breezy/tests/test_bedding.py'
--- breezy/tests/test_bedding.py	2019-06-16 17:36:59 +0000
+++ breezy/tests/test_bedding.py	2020-02-07 02:14:30 +0000
@@ -20,9 +20,6 @@
 import os
 import sys
 
-from ..sixish import (
-    text_type,
-    )
 from .. import (
     bedding,
     osutils,
@@ -56,7 +53,7 @@
         self.assertEqual(bedding.config_dir(), self.brz_home)
 
     def test_config_dir_is_unicode(self):
-        self.assertIsInstance(bedding.config_dir(), text_type)
+        self.assertIsInstance(bedding.config_dir(), str)
 
     def test_config_path(self):
         self.assertEqual(bedding.config_path(),
@@ -84,7 +81,7 @@
         self.assertEqual(bedding.config_dir(), self.bzr_home)
 
     def test_config_dir_is_unicode(self):
-        self.assertIsInstance(bedding.config_dir(), text_type)
+        self.assertIsInstance(bedding.config_dir(), str)
 
     def test_config_path(self):
         self.assertEqual(bedding.config_path(),

=== modified file 'breezy/tests/test_bisect.py'
--- breezy/tests/test_bisect.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_bisect.py	2020-02-18 01:57:45 +0000
@@ -16,9 +16,7 @@
 
 "Test suite for the bzr bisect plugin."
 
-from __future__ import absolute_import
-
-from ..sixish import StringIO
+from io import StringIO
 import os
 import shutil
 

=== modified file 'breezy/tests/test_branch.py'
--- breezy/tests/test_branch.py	2020-01-19 03:22:04 +0000
+++ breezy/tests/test_branch.py	2020-02-07 02:14:30 +0000
@@ -22,6 +22,8 @@
 also see this file.
 """
 
+from io import StringIO
+
 from .. import (
     bedding,
     branch as _mod_branch,
@@ -40,9 +42,6 @@
     BzrBranch5,
     BzrBranchFormat5,
     )
-from ..sixish import (
-    StringIO,
-    )
 
 
 class TestErrors(tests.TestCase):

=== modified file 'breezy/tests/test_cache_utf8.py'
--- breezy/tests/test_cache_utf8.py	2018-11-23 03:06:01 +0000
+++ breezy/tests/test_cache_utf8.py	2020-02-07 02:14:30 +0000
@@ -19,7 +19,6 @@
 from .. import (
     cache_utf8,
     )
-from ..sixish import text_type
 from . import TestCase
 
 
@@ -109,7 +108,7 @@
         # objects.
         uni_x = cache_utf8.decode(x)
         self.assertEqual(u'simple text', uni_x)
-        self.assertIsInstance(uni_x, text_type)
+        self.assertIsInstance(uni_x, str)
 
         utf8_x = cache_utf8.encode(uni_x)
         self.assertIs(utf8_x, x)

=== removed file 'breezy/tests/test_cleanup.py'
--- breezy/tests/test_cleanup.py	2019-07-27 23:18:16 +0000
+++ breezy/tests/test_cleanup.py	1970-01-01 00:00:00 +0000
@@ -1,400 +0,0 @@
-# Copyright (C) 2009, 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-import re
-
-from ..cleanup import (
-    ExitStack,
-    )
-from ..sixish import PY3
-from .. import (
-    tests,
-    )
-
-from contextlib import contextmanager
-
-
-check_exception_chaining = PY3
-
-
-# Imported from contextlib2's test_contextlib2.py
-# Copyright: Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008,
-#   2009, 2010, 2011 Python Software Foundation
-#
-# PYTHON SOFTWARE FOUNDATION LICENSE VERSION 2
-# --------------------------------------------
-# .
-# 1. This LICENSE AGREEMENT is between the Python Software Foundation
-# ("PSF"), and the Individual or Organization ("Licensee") accessing and
-# otherwise using this software ("Python") in source or binary form and
-# its associated documentation.
-# .
-# 2. Subject to the terms and conditions of this License Agreement, PSF hereby
-# grants Licensee a nonexclusive, royalty-free, world-wide license to reproduce,
-# analyze, test, perform and/or display publicly, prepare derivative works,
-# distribute, and otherwise use Python alone or in any derivative version,
-# provided, however, that PSF's License Agreement and PSF's notice of copyright,
-# i.e., "Copyright (c) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010,
-# 2011 Python Software Foundation; All Rights Reserved" are retained in Python
-# alone or in any derivative version prepared by Licensee.
-# .
-# 3. In the event Licensee prepares a derivative work that is based on
-# or incorporates Python or any part thereof, and wants to make
-# the derivative work available to others as provided herein, then
-# Licensee hereby agrees to include in any such work a brief summary of
-# the changes made to Python.
-# .
-# 4. PSF is making Python available to Licensee on an "AS IS"
-# basis.  PSF MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR
-# IMPLIED.  BY WAY OF EXAMPLE, BUT NOT LIMITATION, PSF MAKES NO AND
-# DISCLAIMS ANY REPRESENTATION OR WARRANTY OF MERCHANTABILITY OR FITNESS
-# FOR ANY PARTICULAR PURPOSE OR THAT THE USE OF PYTHON WILL NOT
-# INFRINGE ANY THIRD PARTY RIGHTS.
-# .
-# 5. PSF SHALL NOT BE LIABLE TO LICENSEE OR ANY OTHER USERS OF PYTHON
-# FOR ANY INCIDENTAL, SPECIAL, OR CONSEQUENTIAL DAMAGES OR LOSS AS
-# A RESULT OF MODIFYING, DISTRIBUTING, OR OTHERWISE USING PYTHON,
-# OR ANY DERIVATIVE THEREOF, EVEN IF ADVISED OF THE POSSIBILITY THEREOF.
-# .
-# 6. This License Agreement will automatically terminate upon a material
-# breach of its terms and conditions.
-# .
-# 7. Nothing in this License Agreement shall be deemed to create any
-# relationship of agency, partnership, or joint venture between PSF and
-# Licensee.  This License Agreement does not grant permission to use PSF
-# trademarks or trade name in a trademark sense to endorse or promote
-# products or services of Licensee, or any third party.
-# .
-# 8. By copying, installing or otherwise using Python, Licensee
-# agrees to be bound by the terms and conditions of this License
-# Agreement.
-
-
-class TestExitStack(tests.TestCase):
-
-    def test_no_resources(self):
-        with ExitStack():
-            pass
-
-    def test_callback(self):
-        expected = [
-            ((), {}),
-            ((1,), {}),
-            ((1, 2), {}),
-            ((), dict(example=1)),
-            ((1,), dict(example=1)),
-            ((1, 2), dict(example=1)),
-        ]
-        result = []
-        def _exit(*args, **kwds):
-            """Test metadata propagation"""
-            result.append((args, kwds))
-        with ExitStack() as stack:
-            for args, kwds in reversed(expected):
-                if args and kwds:
-                    f = stack.callback(_exit, *args, **kwds)
-                elif args:
-                    f = stack.callback(_exit, *args)
-                elif kwds:
-                    f = stack.callback(_exit, **kwds)
-                else:
-                    f = stack.callback(_exit)
-                self.assertIs(f, _exit)
-        self.assertEqual(result, expected)
-
-    def test_push(self):
-        exc_raised = ZeroDivisionError
-        def _expect_exc(exc_type, exc, exc_tb):
-            self.assertIs(exc_type, exc_raised)
-        def _suppress_exc(*exc_details):
-            return True
-        def _expect_ok(exc_type, exc, exc_tb):
-            self.assertIsNone(exc_type)
-            self.assertIsNone(exc)
-            self.assertIsNone(exc_tb)
-        class ExitCM(object):
-            def __init__(self, check_exc):
-                self.check_exc = check_exc
-            def __enter__(self):
-                self.fail("Should not be called!")
-            def __exit__(self, *exc_details):
-                self.check_exc(*exc_details)
-        with ExitStack() as stack:
-            stack.push(_expect_ok)
-            cm = ExitCM(_expect_ok)
-            stack.push(cm)
-            stack.push(_suppress_exc)
-            cm = ExitCM(_expect_exc)
-            stack.push(cm)
-            stack.push(_expect_exc)
-            stack.push(_expect_exc)
-            1 / 0
-
-    def test_enter_context(self):
-        class TestCM(object):
-            def __enter__(self):
-                result.append(1)
-            def __exit__(self, *exc_details):
-                result.append(3)
-
-        result = []
-        cm = TestCM()
-        with ExitStack() as stack:
-            @stack.callback  # Registered first => cleaned up last
-            def _exit():
-                result.append(4)
-            self.assertIsNotNone(_exit)
-            stack.enter_context(cm)
-            result.append(2)
-        self.assertEqual(result, [1, 2, 3, 4])
-
-    def test_close(self):
-        result = []
-        with ExitStack() as stack:
-            @stack.callback
-            def _exit():
-                result.append(1)
-            self.assertIsNotNone(_exit)
-            stack.close()
-            result.append(2)
-        self.assertEqual(result, [1, 2])
-
-    def test_pop_all(self):
-        result = []
-        with ExitStack() as stack:
-            @stack.callback
-            def _exit():
-                result.append(3)
-            self.assertIsNotNone(_exit)
-            new_stack = stack.pop_all()
-            result.append(1)
-        result.append(2)
-        new_stack.close()
-        self.assertEqual(result, [1, 2, 3])
-
-    def test_exit_raise(self):
-        def _raise():
-            with ExitStack() as stack:
-                stack.push(lambda *exc: False)
-                1 / 0
-        self.assertRaises(ZeroDivisionError, _raise)
-
-    def test_exit_suppress(self):
-        with ExitStack() as stack:
-            stack.push(lambda *exc: True)
-            1 / 0
-
-    def test_exit_exception_chaining_reference(self):
-        # Sanity check to make sure that ExitStack chaining matches
-        # actual nested with statements
-        class RaiseExc:
-            def __init__(self, exc):
-                self.exc = exc
-            def __enter__(self):
-                return self
-            def __exit__(self, *exc_details):
-                raise self.exc
-
-        class RaiseExcWithContext:
-            def __init__(self, outer, inner):
-                self.outer = outer
-                self.inner = inner
-            def __enter__(self):
-                return self
-            def __exit__(self, *exc_details):
-                try:
-                    raise self.inner
-                except:
-                    raise self.outer
-
-        class SuppressExc:
-            def __enter__(self):
-                return self
-            def __exit__(self, *exc_details):
-                self.__class__.saved_details = exc_details
-                return True
-
-        try:
-            with RaiseExc(IndexError):
-                with RaiseExcWithContext(KeyError, AttributeError):
-                    with SuppressExc():
-                        with RaiseExc(ValueError):
-                            1 / 0
-        except IndexError as exc:
-            if check_exception_chaining:
-                self.assertIsInstance(exc.__context__, KeyError)
-                self.assertIsInstance(exc.__context__.__context__, AttributeError)
-                # Inner exceptions were suppressed
-                self.assertIsNone(exc.__context__.__context__.__context__)
-        else:
-            self.fail("Expected IndexError, but no exception was raised")
-        # Check the inner exceptions
-        inner_exc = SuppressExc.saved_details[1]
-        self.assertIsInstance(inner_exc, ValueError)
-        if check_exception_chaining:
-            self.assertIsInstance(inner_exc.__context__, ZeroDivisionError)
-
-    def test_exit_exception_chaining(self):
-        # Ensure exception chaining matches the reference behaviour
-        def raise_exc(exc):
-            raise exc
-
-        saved_details = [None]
-        def suppress_exc(*exc_details):
-            saved_details[0] = exc_details
-            return True
-
-        try:
-            with ExitStack() as stack:
-                stack.callback(raise_exc, IndexError)
-                stack.callback(raise_exc, KeyError)
-                stack.callback(raise_exc, AttributeError)
-                stack.push(suppress_exc)
-                stack.callback(raise_exc, ValueError)
-                1 / 0
-        except IndexError as exc:
-            if check_exception_chaining:
-                self.assertIsInstance(exc.__context__, KeyError)
-                self.assertIsInstance(exc.__context__.__context__, AttributeError)
-                # Inner exceptions were suppressed
-                self.assertIsNone(exc.__context__.__context__.__context__)
-        else:
-            self.fail("Expected IndexError, but no exception was raised")
-        # Check the inner exceptions
-        inner_exc = saved_details[0][1]
-        self.assertIsInstance(inner_exc, ValueError)
-        if check_exception_chaining:
-            self.assertIsInstance(inner_exc.__context__, ZeroDivisionError)
-
-    def test_exit_exception_non_suppressing(self):
-        # http://bugs.python.org/issue19092
-        def raise_exc(exc):
-            raise exc
-
-        def suppress_exc(*exc_details):
-            return True
-
-        try:
-            with ExitStack() as stack:
-                stack.callback(lambda: None)
-                stack.callback(raise_exc, IndexError)
-        except Exception as exc:
-            self.assertIsInstance(exc, IndexError)
-        else:
-            self.fail("Expected IndexError, but no exception was raised")
-
-        try:
-            with ExitStack() as stack:
-                stack.callback(raise_exc, KeyError)
-                stack.push(suppress_exc)
-                stack.callback(raise_exc, IndexError)
-        except Exception as exc:
-            self.assertIsInstance(exc, KeyError)
-        else:
-            self.fail("Expected KeyError, but no exception was raised")
-
-    def test_exit_exception_with_correct_context(self):
-        # http://bugs.python.org/issue20317
-        @contextmanager
-        def gets_the_context_right(exc):
-            try:
-                yield
-            finally:
-                raise exc
-
-        exc1 = Exception(1)
-        exc2 = Exception(2)
-        exc3 = Exception(3)
-        exc4 = Exception(4)
-
-        # The contextmanager already fixes the context, so prior to the
-        # fix, ExitStack would try to fix it *again* and get into an
-        # infinite self-referential loop
-        try:
-            with ExitStack() as stack:
-                stack.enter_context(gets_the_context_right(exc4))
-                stack.enter_context(gets_the_context_right(exc3))
-                stack.enter_context(gets_the_context_right(exc2))
-                raise exc1
-        except Exception as exc:
-            self.assertIs(exc, exc4)
-            if check_exception_chaining:
-                self.assertIs(exc.__context__, exc3)
-                self.assertIs(exc.__context__.__context__, exc2)
-                self.assertIs(exc.__context__.__context__.__context__, exc1)
-                self.assertIsNone(
-                    exc.__context__.__context__.__context__.__context__)
-
-    def test_exit_exception_with_existing_context(self):
-        # Addresses a lack of test coverage discovered after checking in a
-        # fix for issue 20317 that still contained debugging code.
-        def raise_nested(inner_exc, outer_exc):
-            try:
-                raise inner_exc
-            finally:
-                raise outer_exc
-        exc1 = Exception(1)
-        exc2 = Exception(2)
-        exc3 = Exception(3)
-        exc4 = Exception(4)
-        exc5 = Exception(5)
-        try:
-            with ExitStack() as stack:
-                stack.callback(raise_nested, exc4, exc5)
-                stack.callback(raise_nested, exc2, exc3)
-                raise exc1
-        except Exception as exc:
-            self.assertIs(exc, exc5)
-            if check_exception_chaining:
-                self.assertIs(exc.__context__, exc4)
-                self.assertIs(exc.__context__.__context__, exc3)
-                self.assertIs(exc.__context__.__context__.__context__, exc2)
-                self.assertIs(
-                    exc.__context__.__context__.__context__.__context__, exc1)
-                self.assertIsNone(
-                    exc.__context__.__context__.__context__.__context__.__context__)
-
-    def test_body_exception_suppress(self):
-        def suppress_exc(*exc_details):
-            return True
-        try:
-            with ExitStack() as stack:
-                stack.push(suppress_exc)
-                1 / 0
-        except IndexError as exc:
-            self.fail("Expected no exception, got IndexError")
-
-    def test_exit_exception_chaining_suppress(self):
-        with ExitStack() as stack:
-            stack.push(lambda *exc: True)
-            stack.push(lambda *exc: 1 / 0)
-            stack.push(lambda *exc: {}[1])
-
-    def test_excessive_nesting(self):
-        # The original implementation would die with RecursionError here
-        with ExitStack() as stack:
-            for i in range(10000):
-                stack.callback(int)
-
-    def test_instance_bypass(self):
-        class Example(object):
-            pass
-        cm = Example()
-        cm.__exit__ = object()
-        stack = ExitStack()
-        self.assertRaises(AttributeError, stack.enter_context, cm)
-        stack.push(cm)
-        # self.assertIs(stack._exit_callbacks[-1], cm)

=== modified file 'breezy/tests/test_config.py'
--- breezy/tests/test_config.py	2019-06-26 20:41:57 +0000
+++ breezy/tests/test_config.py	2020-02-07 02:14:30 +0000
@@ -17,6 +17,7 @@
 """Tests for finding and reading the bzr config file[s]."""
 
 from textwrap import dedent
+from io import BytesIO
 import os
 import sys
 import threading
@@ -43,10 +44,6 @@
 from ..bzr import (
     remote,
     )
-from ..sixish import (
-    BytesIO,
-    text_type,
-    )
 from ..transport import remote as transport_remote
 from . import (
     features,

=== modified file 'breezy/tests/test_conflicts.py'
--- breezy/tests/test_conflicts.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_conflicts.py	2020-02-07 02:14:30 +0000
@@ -24,7 +24,6 @@
     osutils,
     tests,
     )
-from ..sixish import text_type
 from . import (
     script,
     scenarios,
@@ -131,7 +130,7 @@
     scenarios = scenarios.multiply_scenarios(vary_by_conflicts())
 
     def test_stringification(self):
-        text = text_type(self.conflict)
+        text = str(self.conflict)
         self.assertContainsString(text, self.conflict.path)
         self.assertContainsString(text.lower(), "conflict")
         self.assertContainsString(repr(self.conflict),
@@ -142,14 +141,14 @@
         o = conflicts.Conflict.factory(**p.as_stanza().as_dict())
         self.assertEqual(o, p)
 
-        self.assertIsInstance(o.path, text_type)
+        self.assertIsInstance(o.path, str)
 
         if o.file_id is not None:
             self.assertIsInstance(o.file_id, bytes)
 
         conflict_path = getattr(o, 'conflict_path', None)
         if conflict_path is not None:
-            self.assertIsInstance(conflict_path, text_type)
+            self.assertIsInstance(conflict_path, str)
 
         conflict_file_id = getattr(o, 'conflict_file_id', None)
         if conflict_file_id is not None:
@@ -176,7 +175,7 @@
 
     def test_stringification(self):
         for text, o in zip(example_conflicts.to_strings(), example_conflicts):
-            self.assertEqual(text, text_type(o))
+            self.assertEqual(text, str(o))
 
 
 # FIXME: The shell-like tests should be converted to real whitebox tests... or

=== modified file 'breezy/tests/test_crash.py'
--- breezy/tests/test_crash.py	2019-06-16 01:03:51 +0000
+++ breezy/tests/test_crash.py	2020-02-07 02:14:30 +0000
@@ -16,6 +16,7 @@
 
 
 import doctest
+from io import StringIO
 import os
 import sys
 
@@ -27,9 +28,6 @@
     plugin,
     tests,
     )
-from ..sixish import (
-    StringIO,
-    )
 from . import features
 
 

=== modified file 'breezy/tests/test_delta.py'
--- breezy/tests/test_delta.py	2019-09-21 22:23:51 +0000
+++ breezy/tests/test_delta.py	2020-02-07 02:14:30 +0000
@@ -14,6 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from io import StringIO
 import os
 
 from .. import (
@@ -22,10 +23,6 @@
     tests,
     )
 from ..tree import TreeChange
-from ..sixish import (
-    PY3,
-    StringIO,
-    )
 
 
 class InstrumentedReporter(object):

=== modified file 'breezy/tests/test_diff.py'
--- breezy/tests/test_diff.py	2019-12-23 01:39:21 +0000
+++ breezy/tests/test_diff.py	2020-02-07 02:14:30 +0000
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+import contextlib
+from io import BytesIO
 import os
 import re
 import subprocess
@@ -21,7 +23,6 @@
 import tempfile
 
 from .. import (
-    cleanup,
     diff,
     errors,
     osutils,
@@ -30,10 +31,6 @@
     revisiontree,
     tests,
     )
-from ..sixish import (
-    BytesIO,
-    unichr,
-    )
 from ..tests import (
     features,
     EncodingAdapter,
@@ -1031,7 +1028,7 @@
 
     def call_gtabtd(self, path_list, revision_specs, old_url, new_url):
         """Call get_trees_and_branches_to_diff_locked."""
-        exit_stack = cleanup.ExitStack()
+        exit_stack = contextlib.ExitStack()
         self.addCleanup(exit_stack.close)
         return diff.get_trees_and_branches_to_diff_locked(
             path_list, revision_specs, old_url, new_url, exit_stack)

=== modified file 'breezy/tests/test_email_message.py'
--- breezy/tests/test_email_message.py	2018-11-16 13:30:12 +0000
+++ breezy/tests/test_email_message.py	2020-02-07 02:14:30 +0000
@@ -20,7 +20,6 @@
 from .. import __version__ as _breezy_version
 from ..email_message import EmailMessage
 from ..errors import BzrBadParameterNotUnicode
-from ..sixish import PY3, text_type
 from ..smtp_connection import SMTPConnection
 from .. import tests
 
@@ -68,19 +67,11 @@
 ''' % {'version': _breezy_version, 'boundary': BOUNDARY}
 
 
-def final_newline_or_not(msg):
-    if sys.version_info >= (2, 7, 6):
-        # Some internals of python's email module changed in an (minor)
-        # incompatible way: a final newline is appended in 2.7.6...
-        msg += '\n'
+def simple_multipart_message():
+    msg = _MULTIPART_HEAD + '--%s--\n' % BOUNDARY
     return msg
 
 
-def simple_multipart_message():
-    msg = _MULTIPART_HEAD + '--%s--' % BOUNDARY
-    return final_newline_or_not(msg)
-
-
 def complex_multipart_message(typ):
     msg = _MULTIPART_HEAD + '''\
 --%(boundary)s
@@ -95,8 +86,8 @@
 d
 e
 
---%(boundary)s--''' % {'boundary': BOUNDARY}
-    msg = final_newline_or_not(msg)
+--%(boundary)s--
+''' % {'boundary': BOUNDARY}
     return msg % (typ,)
 
 
@@ -170,14 +161,8 @@
     def test_address_to_encoded_header(self):
         def decode(s):
             """Convert a RFC2047-encoded string to a unicode string."""
-            if PY3:
-                return ''.join([chunk.decode(encoding or 'ascii')
-                                for chunk, encoding in decode_header(s)])
-            else:
-                # Cope with python2 stripping whitespace.
-                # https://bugs.python.org/issue1467619
-                return ' '.join([chunk.decode(encoding or 'ascii')
-                                 for chunk, encoding in decode_header(s)])
+            return ''.join([chunk.decode(encoding or 'ascii')
+                            for chunk, encoding in decode_header(s)])
 
         address = 'jrandom@example.com'
         encoded = EmailMessage.address_to_encoded_header(address)

=== modified file 'breezy/tests/test_errors.py'
--- breezy/tests/test_errors.py	2019-03-04 00:16:27 +0000
+++ breezy/tests/test_errors.py	2020-02-07 02:14:30 +0000
@@ -28,10 +28,6 @@
     tests,
     urlutils,
     )
-from ..sixish import (
-    PY3,
-    text_type,
-    )
 
 
 class TestErrors(tests.TestCase):
@@ -49,10 +45,7 @@
             init = getattr(c, '__init__', None)
             fmt = getattr(c, '_fmt', None)
             if init:
-                if PY3:
-                    args = inspect.getfullargspec(init)[0]
-                else:
-                    args = inspect.getargspec(init)[0]
+                args = inspect.getfullargspec(init)[0]
                 self.assertFalse('message' in args,
                                  ('Argument name "message" not allowed for '
                                   '"errors.%s.__init__"' % c.__name__))
@@ -365,7 +358,7 @@
         e = errors.DuplicateRecordNameError(b"n\xc3\xa5me")
         self.assertEqual(
             u"Container has multiple records with the same name: n\xe5me",
-            text_type(e))
+            str(e))
 
     def test_check_error(self):
         e = errors.BzrCheckError('example check failure')
@@ -409,7 +402,7 @@
         err = errors.TipChangeRejected(u'Unicode message\N{INTERROBANG}')
         self.assertEqual(
             u'Tip change rejected: Unicode message\N{INTERROBANG}',
-            text_type(err))
+            str(err))
 
     def test_error_from_smart_server(self):
         error_tuple = ('error', 'tuple')
@@ -508,10 +501,7 @@
         # Unicode error, because it tries to call str() on the string
         # returned from e.__str__(), and it has non ascii characters
         s = str(e)
-        if PY3:
-            self.assertEqual('Pass through \xb5 and bar', s)
-        else:
-            self.assertEqual('Pass through \xc2\xb5 and bar', s)
+        self.assertEqual('Pass through \xb5 and bar', s)
 
     def test_missing_format_string(self):
         e = ErrorWithNoFormat(param='randomvalue')

=== modified file 'breezy/tests/test_export.py'
--- breezy/tests/test_export.py	2019-01-13 17:32:22 +0000
+++ breezy/tests/test_export.py	2020-02-07 02:14:30 +0000
@@ -17,6 +17,7 @@
 """Tests for breezy.export."""
 
 import gzip
+from io import BytesIO
 import os
 import tarfile
 import time
@@ -29,9 +30,6 @@
     )
 from ..export import get_root_name
 from ..archive.tar import tarball_generator
-from ..sixish import (
-    BytesIO,
-    )
 from . import features
 
 

=== modified file 'breezy/tests/test_fetch_ghosts.py'
--- breezy/tests/test_fetch_ghosts.py	2018-05-22 02:05:12 +0000
+++ breezy/tests/test_fetch_ghosts.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from ..fetch_ghosts import GhostFetcher
 from . import TestCaseWithTransport
 

=== modified file 'breezy/tests/test_fifo_cache.py'
--- breezy/tests/test_fifo_cache.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_fifo_cache.py	2020-02-07 02:14:30 +0000
@@ -20,11 +20,6 @@
     fifo_cache,
     tests,
     )
-from ..sixish import (
-    viewitems,
-    viewkeys,
-    viewvalues,
-    )
 
 
 class TestFIFOCache(tests.TestCase):
@@ -39,9 +34,9 @@
         self.assertEqual(2, c.get(1))
         self.assertEqual(2, c.get(1, None))
         self.assertEqual([1], list(c))
-        self.assertEqual({1}, viewkeys(c))
-        self.assertEqual([(1, 2)], sorted(viewitems(c)))
-        self.assertEqual([2], sorted(viewvalues(c)))
+        self.assertEqual({1}, c.keys())
+        self.assertEqual([(1, 2)], sorted(c.items()))
+        self.assertEqual([2], sorted(c.values()))
         self.assertEqual({1: 2}, c)
 
     def test_cache_size(self):
@@ -58,9 +53,9 @@
         self.assertEqual(None, c.get(1))
         self.assertEqual(None, c.get(1, None))
         self.assertEqual([], list(c))
-        self.assertEqual(set(), viewkeys(c))
-        self.assertEqual([], list(viewitems(c)))
-        self.assertEqual([], list(viewvalues(c)))
+        self.assertEqual(set(), c.keys())
+        self.assertEqual([], list(c.items()))
+        self.assertEqual([], list(c.values()))
         self.assertEqual({}, c)
 
     def test_add_maintains_fifo(self):
@@ -69,16 +64,16 @@
         c[2] = 3
         c[3] = 4
         c[4] = 5
-        self.assertEqual({1, 2, 3, 4}, viewkeys(c))
+        self.assertEqual({1, 2, 3, 4}, c.keys())
         c[5] = 6
         # This should pop out the oldest entry
-        self.assertEqual({2, 3, 4, 5}, viewkeys(c))
+        self.assertEqual({2, 3, 4, 5}, c.keys())
         # Replacing an item doesn't change the stored keys
         c[2] = 7
-        self.assertEqual({2, 3, 4, 5}, viewkeys(c))
+        self.assertEqual({2, 3, 4, 5}, c.keys())
         # But it does change the position in the FIFO
         c[6] = 7
-        self.assertEqual({2, 4, 5, 6}, viewkeys(c))
+        self.assertEqual({2, 4, 5, 6}, c.keys())
         self.assertEqual([4, 5, 2, 6], list(c._queue))
 
     def test_default_after_cleanup_count(self):
@@ -90,10 +85,10 @@
         c[4] = 5
         c[5] = 6
         # So far, everything fits
-        self.assertEqual({1, 2, 3, 4, 5}, viewkeys(c))
+        self.assertEqual({1, 2, 3, 4, 5}, c.keys())
         c[6] = 7
         # But adding one more should shrink down to after_cleanup_count
-        self.assertEqual({3, 4, 5, 6}, viewkeys(c))
+        self.assertEqual({3, 4, 5, 6}, c.keys())
 
     def test_clear(self):
         c = fifo_cache.FIFOCache(5)
@@ -103,9 +98,9 @@
         c[4] = 5
         c[5] = 6
         c.cleanup()
-        self.assertEqual({2, 3, 4, 5}, viewkeys(c))
+        self.assertEqual({2, 3, 4, 5}, c.keys())
         c.clear()
-        self.assertEqual(set(), viewkeys(c))
+        self.assertEqual(set(), c.keys())
         self.assertEqual([], list(c._queue))
         self.assertEqual({}, c)
 
@@ -250,9 +245,9 @@
         self.assertEqual('2', c.get(1))
         self.assertEqual('2', c.get(1, None))
         self.assertEqual([1], list(c))
-        self.assertEqual({1}, viewkeys(c))
-        self.assertEqual([(1, '2')], sorted(viewitems(c)))
-        self.assertEqual(['2'], sorted(viewvalues(c)))
+        self.assertEqual({1}, c.keys())
+        self.assertEqual([(1, '2')], sorted(c.items()))
+        self.assertEqual(['2'], sorted(c.values()))
         self.assertEqual({1: '2'}, c)
         self.assertEqual(1024 * 1024, c.cache_size())
 
@@ -264,9 +259,9 @@
         self.assertEqual(None, c.get(1))
         self.assertEqual(None, c.get(1, None))
         self.assertEqual([], list(c))
-        self.assertEqual(set(), viewkeys(c))
-        self.assertEqual([], list(viewitems(c)))
-        self.assertEqual([], list(viewvalues(c)))
+        self.assertEqual(set(), c.keys())
+        self.assertEqual([], list(c.items()))
+        self.assertEqual([], list(c.values()))
         self.assertEqual({}, c)
 
     def test_add_maintains_fifo(self):

=== modified file 'breezy/tests/test_filters.py'
--- breezy/tests/test_filters.py	2020-01-30 17:54:42 +0000
+++ breezy/tests/test_filters.py	2020-02-07 02:14:30 +0000
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from io import BytesIO
+
 from .. import errors, filters
 from ..filters import (
     ContentFilter,
@@ -25,9 +27,6 @@
     internal_size_sha_file_byname,
     )
 from ..osutils import sha_string
-from ..sixish import (
-    BytesIO,
-    )
 from . import TestCase, TestCaseInTempDir
 
 

=== modified file 'breezy/tests/test_generate_docs.py'
--- breezy/tests/test_generate_docs.py	2018-06-24 13:18:43 +0000
+++ breezy/tests/test_generate_docs.py	2020-02-07 02:14:30 +0000
@@ -20,11 +20,9 @@
 and produce non-empty output.
 """
 
+from io import StringIO
 
 import breezy.commands
-from ..sixish import (
-    StringIO,
-    )
 from . import TestCase
 
 

=== modified file 'breezy/tests/test_gpg.py'
--- breezy/tests/test_gpg.py	2018-11-18 19:48:57 +0000
+++ breezy/tests/test_gpg.py	2020-02-07 02:14:30 +0000
@@ -17,6 +17,8 @@
 
 """Tests for signing and verifying blobs of data via gpg."""
 
+from io import BytesIO
+
 # import system imports here
 import sys
 
@@ -28,9 +30,6 @@
     trace,
     ui,
     )
-from ..sixish import (
-    BytesIO,
-    )
 from . import (
     TestCase,
     features,

=== modified file 'breezy/tests/test_grep.py'
--- breezy/tests/test_grep.py	2019-02-04 01:01:24 +0000
+++ breezy/tests/test_grep.py	2020-02-18 01:57:45 +0000
@@ -14,14 +14,11 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import os
 import re
 import unicodedata as ud
 
 from .. import tests, osutils
-from ..sixish import PY3
 from .._termcolor import color_string, FG
 
 from ..tests.features import (
@@ -390,22 +387,16 @@
 
         out, err = self.run_bzr(
             ['grep', '-r', 'last:1', '--null', 'line[1-3]'])
-        if not PY3:
-            out = out.decode('utf-8', 'ignore')
         nout = ud.normalize(u'NFC', out)
         self.assertEqual(nout, nref)
         self.assertEqual(len(out.splitlines()), 1)
 
         out, err = self.run_bzr(['grep', '-r', 'last:1', '-Z', 'line[1-3]'])
-        if not PY3:
-            out = out.decode('utf-8', 'ignore')
         nout = ud.normalize(u'NFC', out)
         self.assertEqual(nout, nref)
         self.assertEqual(len(out.splitlines()), 1)
 
         out, err = self.run_bzr(['grep', '-r', 'last:1', '--null', 'line'])
-        if not PY3:
-            out = out.decode('utf-8', 'ignore')
         nout = ud.normalize(u'NFC', out)
         self.assertEqual(nout, nref)
         self.assertEqual(len(out.splitlines()), 1)

=== modified file 'breezy/tests/test_http.py'
--- breezy/tests/test_http.py	2019-05-19 22:33:19 +0000
+++ breezy/tests/test_http.py	2020-02-07 02:14:30 +0000
@@ -23,12 +23,8 @@
 # TODO: Should be renamed to breezy.transport.http.tests?
 # TODO: What about renaming to breezy.tests.transport.http ?
 
-try:
-    from http.client import UnknownProtocol, parse_headers
-    from http.server import SimpleHTTPRequestHandler
-except ImportError:  # python < 3
-    from httplib import UnknownProtocol
-    from SimpleHTTPServer import SimpleHTTPRequestHandler
+from http.client import UnknownProtocol, parse_headers
+from http.server import SimpleHTTPRequestHandler
 import io
 import socket
 import sys
@@ -50,7 +46,6 @@
 from ..bzr import (
     remote as _mod_remote,
     )
-from ..sixish import PY3
 from . import (
     features,
     http_server,
@@ -1949,19 +1944,10 @@
     def _handle_one_request(self):
         tcs = self.server.test_case_server
         requestline = self.rfile.readline()
-        if PY3:
-            headers = parse_headers(self.rfile)
-            bytes_read = len(headers.as_bytes())
-            bytes_read += headers.as_bytes().count(b'\n')
-            bytes_read += len(requestline)
-        else:
-            headers = self.MessageClass(self.rfile, 0)
-            # We just read: the request, the headers, an empty line indicating the
-            # end of the headers.
-            bytes_read = len(requestline)
-            for line in headers.headers:
-                bytes_read += len(line)
-            bytes_read += len(b'\r\n')
+        headers = parse_headers(self.rfile)
+        bytes_read = len(headers.as_bytes())
+        bytes_read += headers.as_bytes().count(b'\n')
+        bytes_read += len(requestline)
         if requestline.startswith(b'POST'):
             # The body should be a single line (or we don't know where it ends
             # and we don't want to issue a blocking read)

=== modified file 'breezy/tests/test_http_response.py'
--- breezy/tests/test_http_response.py	2019-05-28 23:08:46 +0000
+++ breezy/tests/test_http_response.py	2020-02-07 02:14:30 +0000
@@ -37,24 +37,16 @@
   InvalidHttpResponse.
 """
 
-try:
-    import http.client as http_client
-except ImportError:  # python < 3 without future
-    import httplib as http_client
-
-try:
-    parse_headers = http_client.parse_headers
-except AttributeError:  # python 2
-    parse_headers = http_client.HTTPMessage
+from io import BytesIO
+
+import http.client as http_client
+
+parse_headers = http_client.parse_headers
 
 from .. import (
     errors,
     tests,
     )
-from ..sixish import (
-    BytesIO,
-    PY3,
-    )
 from ..transport.http import (
     response,
     HTTPConnection,
@@ -726,10 +718,7 @@
         # Get rid of the status line
         status_and_headers.readline()
         msg = parse_headers(status_and_headers)
-        if PY3:
-            return msg.get
-        else:
-            return msg.getheader
+        return msg.get
 
     def get_response(self, a_response):
         """Process a supplied response, and return the result."""

=== modified file 'breezy/tests/test_https_urllib.py'
--- breezy/tests/test_https_urllib.py	2019-05-11 18:38:21 +0000
+++ breezy/tests/test_https_urllib.py	2020-02-07 02:14:30 +0000
@@ -79,13 +79,6 @@
 
 class MatchHostnameTests(tests.TestCase):
 
-    def setUp(self):
-        super(MatchHostnameTests, self).setUp()
-        if sys.version_info < (2, 7, 9):
-            raise tests.TestSkipped(
-                'python version too old to provide proper'
-                ' https hostname verification')
-
     def test_no_certificate(self):
         self.assertRaises(ValueError,
                           ssl.match_hostname, {}, "example.com")

=== modified file 'breezy/tests/test_i18n.py'
--- breezy/tests/test_i18n.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_i18n.py	2020-02-07 02:14:30 +0000
@@ -24,7 +24,6 @@
     errors,
     workingtree,
     )
-from ..sixish import PY3
 
 
 class ZzzTranslations(object):
@@ -63,28 +62,16 @@
         t = trans.zzz('msg')
         self._check_exact(u'zz\xe5{{msg}}', t)
 
-        if PY3:
-            t = trans.gettext('msg')
-            self._check_exact(u'zz\xe5{{msg}}', t)
-
-            t = trans.ngettext('msg1', 'msg2', 0)
-            self._check_exact(u'zz\xe5{{msg2}}', t)
-            t = trans.ngettext('msg1', 'msg2', 2)
-            self._check_exact(u'zz\xe5{{msg2}}', t)
-
-            t = trans.ngettext('msg1', 'msg2', 1)
-            self._check_exact(u'zz\xe5{{msg1}}', t)
-        else:
-            t = trans.ugettext('msg')
-            self._check_exact(u'zz\xe5{{msg}}', t)
-
-            t = trans.ungettext('msg1', 'msg2', 0)
-            self._check_exact(u'zz\xe5{{msg2}}', t)
-            t = trans.ungettext('msg1', 'msg2', 2)
-            self._check_exact(u'zz\xe5{{msg2}}', t)
-
-            t = trans.ungettext('msg1', 'msg2', 1)
-            self._check_exact(u'zz\xe5{{msg1}}', t)
+        t = trans.gettext('msg')
+        self._check_exact(u'zz\xe5{{msg}}', t)
+
+        t = trans.ngettext('msg1', 'msg2', 0)
+        self._check_exact(u'zz\xe5{{msg2}}', t)
+        t = trans.ngettext('msg1', 'msg2', 2)
+        self._check_exact(u'zz\xe5{{msg2}}', t)
+
+        t = trans.ngettext('msg1', 'msg2', 1)
+        self._check_exact(u'zz\xe5{{msg1}}', t)
 
 
 class TestGetText(tests.TestCase):
@@ -164,11 +151,7 @@
             workingtree.WorkingTree.open('./foo')
         except errors.NotBranchError as e:
             err = str(e)
-        if PY3:
-            self.assertContainsRe(err, u"zz\xe5{{Not a branch: .*}}")
-        else:
-            self.assertContainsRe(
-                err, u"zz\xe5{{Not a branch: .*}}".encode('utf-8'))
+        self.assertContainsRe(err, u"zz\xe5{{Not a branch: .*}}")
 
     def test_topic_help_translation(self):
         """does topic help get translated?"""

=== modified file 'breezy/tests/test_ignores.py'
--- breezy/tests/test_ignores.py	2019-11-19 20:09:18 +0000
+++ breezy/tests/test_ignores.py	2020-02-07 02:14:30 +0000
@@ -16,15 +16,13 @@
 
 """Tests for handling of ignore files"""
 
+from io import BytesIO
 import os
 
 from .. import (
     bedding,
     ignores,
     )
-from ..sixish import (
-    BytesIO,
-    )
 from . import (
     TestCase,
     TestCaseInTempDir,

=== modified file 'breezy/tests/test_import_tariff.py'
--- breezy/tests/test_import_tariff.py	2019-03-02 21:46:18 +0000
+++ breezy/tests/test_import_tariff.py	2020-02-21 04:28:46 +0000
@@ -27,7 +27,6 @@
     )
 from ..controldir import ControlDir
 from ..bzr.smart import medium
-from ..sixish import PY3
 from ..transport import remote
 
 from . import (
@@ -104,12 +103,8 @@
 
         bad_modules = []
         for module_name in forbidden_imports:
-            if PY3:
-                if err.find("\nimport '%s' " % module_name) != -1:
-                    bad_modules.append(module_name)
-            else:
-                if err.find("\nimport %s " % module_name) != -1:
-                    bad_modules.append(module_name)
+            if err.find("\nimport '%s' " % module_name) != -1:
+                bad_modules.append(module_name)
 
         if bad_modules:
             self.fail("command loaded forbidden modules %r"
@@ -159,7 +154,7 @@
     def test_simple_local(self):
         # 'st' in a default format working tree shouldn't need many modules
         self.make_branch_and_tree('.')
-        self.run_command_check_imports(['st'], [
+        forbidden_modules = [
             'breezy.annotate',
             'breezy.atomicfile',
             'breezy.bugtracker',
@@ -194,10 +189,10 @@
             'socket',
             'smtplib',
             'tarfile',
-            'tempfile',
             'termios',
             'tty',
-            ] + old_format_modules)
+            ] + old_format_modules
+        self.run_command_check_imports(['st'], forbidden_modules)
         # TODO: similar test for repository-only operations, checking we avoid
         # loading wt-specific stuff
         #

=== modified file 'breezy/tests/test_index.py'
--- breezy/tests/test_index.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_index.py	2020-02-07 02:14:30 +0000
@@ -21,7 +21,6 @@
     tests,
     transport,
     )
-from ..sixish import int2byte
 from ..bzr import (
     index as _mod_index,
     )
@@ -309,7 +308,7 @@
         builder = _mod_index.GraphIndexBuilder()
         for bad_char in bytearray(b'\t\n\x0b\x0c\r\x00 '):
             self.assertRaises(_mod_index.BadIndexKey, builder.add_node,
-                              (b'a%skey' % int2byte(bad_char), ), b'data')
+                              (b'a%skey' % bytes([bad_char]), ), b'data')
         self.assertRaises(_mod_index.BadIndexKey, builder.add_node,
                           (), b'data')
         self.assertRaises(_mod_index.BadIndexKey, builder.add_node,
@@ -324,7 +323,7 @@
         builder = _mod_index.GraphIndexBuilder(key_elements=2)
         for bad_char in bytearray(b'\t\n\x0b\x0c\r\x00 '):
             self.assertRaises(_mod_index.BadIndexKey, builder.add_node,
-                              (b'prefix', b'a%skey' % int2byte(bad_char)), b'data')
+                              (b'prefix', b'a%skey' % bytes([bad_char])), b'data')
 
     def test_add_node_bad_data(self):
         builder = _mod_index.GraphIndexBuilder()

=== modified file 'breezy/tests/test_inv.py'
--- breezy/tests/test_inv.py	2020-01-30 16:13:31 +0000
+++ breezy/tests/test_inv.py	2020-02-07 02:14:30 +0000
@@ -23,7 +23,6 @@
     tests,
     workingtree,
     )
-from ..sixish import text_type
 from ..bzr import (
     chk_map,
     groupcompress,
@@ -36,6 +35,7 @@
     InventoryFile,
     InventoryDirectory,
     InventoryEntry,
+    InvalidEntryName,
     TreeReference,
     mutable_inventory_from_tree,
     )
@@ -696,7 +696,7 @@
 class TestInventoryEntry(TestCase):
 
     def test_file_invalid_entry_name(self):
-        self.assertRaises(errors.InvalidEntryName, inventory.InventoryFile,
+        self.assertRaises(InvalidEntryName, inventory.InventoryFile,
                           b'123', 'a/hello.c', ROOT_ID)
 
     def test_file_backslash(self):
@@ -1234,7 +1234,7 @@
                          b'file-rev-id\nabcdefgh\n100\nY', bytes)
         ie2 = inv._bytes_to_entry(bytes)
         self.assertEqual(ie, ie2)
-        self.assertIsInstance(ie2.name, text_type)
+        self.assertIsInstance(ie2.name, str)
         self.assertEqual((b'filename', b'file-id', b'file-rev-id'),
                          inv._bytes_to_utf8name_key(bytes))
 
@@ -1251,7 +1251,7 @@
                          b'file-rev-id\n123456\n25\nN', bytes)
         ie2 = inv._bytes_to_entry(bytes)
         self.assertEqual(ie, ie2)
-        self.assertIsInstance(ie2.name, text_type)
+        self.assertIsInstance(ie2.name, str)
         self.assertEqual((b'\xce\xa9name', b'file-id', b'file-rev-id'),
                          inv._bytes_to_utf8name_key(bytes))
 
@@ -1263,7 +1263,7 @@
         self.assertEqual(b'dir: dir-id\nparent-id\ndirname\ndir-rev-id', bytes)
         ie2 = inv._bytes_to_entry(bytes)
         self.assertEqual(ie, ie2)
-        self.assertIsInstance(ie2.name, text_type)
+        self.assertIsInstance(ie2.name, str)
         self.assertEqual((b'dirname', b'dir-id', b'dir-rev-id'),
                          inv._bytes_to_utf8name_key(bytes))
 
@@ -1277,7 +1277,7 @@
                          b'dir-rev-id', bytes)
         ie2 = inv._bytes_to_entry(bytes)
         self.assertEqual(ie, ie2)
-        self.assertIsInstance(ie2.name, text_type)
+        self.assertIsInstance(ie2.name, str)
         self.assertIs(ie2.parent_id, None)
         self.assertEqual((b'dir\xce\xa9name', b'dir-id', b'dir-rev-id'),
                          inv._bytes_to_utf8name_key(bytes))
@@ -1292,8 +1292,8 @@
                          b'link-rev-id\ntarget/path', bytes)
         ie2 = inv._bytes_to_entry(bytes)
         self.assertEqual(ie, ie2)
-        self.assertIsInstance(ie2.name, text_type)
-        self.assertIsInstance(ie2.symlink_target, text_type)
+        self.assertIsInstance(ie2.name, str)
+        self.assertIsInstance(ie2.symlink_target, str)
         self.assertEqual((b'linkname', b'link-id', b'link-rev-id'),
                          inv._bytes_to_utf8name_key(bytes))
 
@@ -1308,8 +1308,8 @@
                          b'link-rev-id\ntarget/\xce\xa9path', bytes)
         ie2 = inv._bytes_to_entry(bytes)
         self.assertEqual(ie, ie2)
-        self.assertIsInstance(ie2.name, text_type)
-        self.assertIsInstance(ie2.symlink_target, text_type)
+        self.assertIsInstance(ie2.name, str)
+        self.assertIsInstance(ie2.symlink_target, str)
         self.assertEqual((b'link\xce\xa9name', b'link-id', b'link-rev-id'),
                          inv._bytes_to_utf8name_key(bytes))
 
@@ -1324,7 +1324,7 @@
                          b'tree-rev-id\nref-rev-id', bytes)
         ie2 = inv._bytes_to_entry(bytes)
         self.assertEqual(ie, ie2)
-        self.assertIsInstance(ie2.name, text_type)
+        self.assertIsInstance(ie2.name, str)
         self.assertEqual((b'tree\xce\xa9name', b'tree-root-id', b'tree-rev-id'),
                          inv._bytes_to_utf8name_key(bytes))
 

=== modified file 'breezy/tests/test_inventory_delta.py'
--- breezy/tests/test_inventory_delta.py	2020-02-09 01:16:06 +0000
+++ breezy/tests/test_inventory_delta.py	2020-02-13 23:57:28 +0000
@@ -19,6 +19,9 @@
 See doc/developer/inventory.txt for more information.
 """
 
+from io import (
+    BytesIO,
+    )
 from .. import osutils
 from ..bzr import (
     inventory,
@@ -27,9 +30,6 @@
 from ..bzr.inventory_delta import InventoryDeltaError
 from ..bzr.inventory import Inventory
 from ..revision import NULL_REVISION
-from ..sixish import (
-    BytesIO,
-    )
 from . import TestCase
 
 ### DO NOT REFLOW THESE TEXTS. NEW LINES ARE SIGNIFICANT. ###

=== modified file 'breezy/tests/test_lockdir.py'
--- breezy/tests/test_lockdir.py	2019-06-26 01:15:06 +0000
+++ breezy/tests/test_lockdir.py	2020-02-07 02:14:30 +0000
@@ -40,9 +40,6 @@
     LockDir,
     LockHeldInfo,
     )
-from ..sixish import (
-    text_type,
-    )
 from . import (
     features,
     TestCase,
@@ -668,7 +665,7 @@
 
     def test_unicode(self):
         info = LockHeldInfo.for_this_process(None)
-        self.assertContainsRe(text_type(info),
+        self.assertContainsRe(str(info),
                               r'held by .* on .* \(process #\d+\), acquired .* ago')
 
     def test_is_locked_by_this_process(self):

=== modified file 'breezy/tests/test_log.py'
--- breezy/tests/test_log.py	2019-06-29 19:50:18 +0000
+++ breezy/tests/test_log.py	2020-02-07 02:14:30 +0000
@@ -14,6 +14,10 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from io import (
+    BytesIO,
+    StringIO,
+    )
 import os
 import re
 
@@ -28,11 +32,6 @@
     gpg,
     trace,
     )
-from ..sixish import (
-    BytesIO,
-    StringIO,
-    unichr,
-    )
 
 
 class TestLogMixin(object):
@@ -223,7 +222,7 @@
 
     def test_commit_message_with_control_chars(self):
         wt = self.make_branch_and_tree('.')
-        msg = u"All 8-bit chars: " + ''.join([unichr(x) for x in range(256)])
+        msg = u"All 8-bit chars: " + ''.join([chr(x) for x in range(256)])
         msg = msg.replace(u'\r', u'\n')
         wt.commit(msg)
         lf = LogCatcher()
@@ -241,7 +240,7 @@
         # newline conversion, neither LF (\x0A) nor CR (\x0D) are
         # included in the test commit message, even though they are
         # valid XML 1.0 characters.
-        msg = "\x09" + ''.join([unichr(x) for x in range(0x20, 256)])
+        msg = "\x09" + ''.join([chr(x) for x in range(0x20, 256)])
         wt.commit(msg)
         lf = LogCatcher()
         log.show_log(wt.branch, lf, verbose=True)

=== modified file 'breezy/tests/test_matchers.py'
--- breezy/tests/test_matchers.py	2019-06-29 13:16:26 +0000
+++ breezy/tests/test_matchers.py	2020-02-07 02:14:30 +0000
@@ -19,7 +19,6 @@
 from testtools.matchers import *
 
 from ..bzr.smart.client import CallHookParams
-from ..sixish import PY3
 
 from . import (
     CapturedCall,
@@ -133,14 +132,9 @@
         t.add(['a', 'b', 'b/c'], [b'a-id', b'b-id', b'c-id'])
         mismatch = HasLayout(['a']).match(t)
         self.assertIsNot(None, mismatch)
-        if PY3:
-            self.assertEqual(
-                set(("['', 'a', 'b/', 'b/c']", "['a']")),
-                set(mismatch.describe().split(" != ")))
-        else:
-            self.assertEqual(
-                set(("[u'', u'a', u'b/', u'b/c']", "['a']")),
-                set(mismatch.describe().split(" != ")))
+        self.assertEqual(
+            set(("['', 'a', 'b/', 'b/c']", "['a']")),
+            set(mismatch.describe().split(" != ")))
 
     def test_no_dirs(self):
         # Some tree/repository formats do not support versioned directories
@@ -152,14 +146,9 @@
         self.assertIs(None, HasLayout(['', 'a', 'b/', 'b/c', 'd/']).match(t))
         mismatch = HasLayout([u'', u'a', u'd/']).match(t)
         self.assertIsNot(None, mismatch)
-        if PY3:
-            self.assertEqual(
-                set(("['', 'a', 'b/', 'b/c']", "['', 'a']")),
-                set(mismatch.describe().split(" != ")))
-        else:
-            self.assertEqual(
-                set(("[u'', u'a', u'b/', u'b/c']", "[u'', u'a']")),
-                set(mismatch.describe().split(" != ")))
+        self.assertEqual(
+            set(("['', 'a', 'b/', 'b/c']", "['', 'a']")),
+            set(mismatch.describe().split(" != ")))
 
 
 class TestHasPathRelations(TestCaseWithTransport):
@@ -237,11 +226,6 @@
         tree.commit('msg1', rev_id=b'a')
         tree.commit('msg2', rev_id=b'b')
         matcher = RevisionHistoryMatches([b'a', b'b', b'c'])
-        if PY3:
-            self.assertEqual(
-                set(("[b'a', b'b']", "[b'a', b'b', b'c']")),
-                set(matcher.match(tree.branch).describe().split(" != ")))
-        else:
-            self.assertEqual(
-                set(("['a', 'b']", "['a', 'b', 'c']")),
-                set(matcher.match(tree.branch).describe().split(" != ")))
+        self.assertEqual(
+            set(("[b'a', b'b']", "[b'a', b'b', b'c']")),
+            set(matcher.match(tree.branch).describe().split(" != ")))

=== modified file 'breezy/tests/test_merge.py'
--- breezy/tests/test_merge.py	2019-07-27 22:47:49 +0000
+++ breezy/tests/test_merge.py	2020-02-07 02:14:30 +0000
@@ -14,11 +14,11 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+import contextlib
 import os
 
 from .. import (
     branch as _mod_branch,
-    cleanup,
     conflicts,
     errors,
     memorytree,
@@ -37,7 +37,6 @@
 from ..errors import UnrelatedBranches, NoCommits
 from ..merge import transform_tree, merge_inner, _PlanMerge
 from ..osutils import basename, pathjoin, file_kind
-from ..sixish import int2byte
 from . import (
     features,
     TestCaseWithMemoryTransport,
@@ -565,8 +564,8 @@
         self.plan_merge_vf.fallback_versionedfiles.append(self.vf)
 
     def add_version(self, key, parents, text):
-        self.vf.add_lines(key, parents, [int2byte(
-            c) + b'\n' for c in bytearray(text)])
+        self.vf.add_lines(
+            key, parents, [bytes([c]) + b'\n' for c in bytearray(text)])
 
     def add_rev(self, prefix, revision_id, parents, text):
         self.add_version((prefix, revision_id), [(prefix, p) for p in parents],
@@ -574,7 +573,7 @@
 
     def add_uncommitted_version(self, key, parents, text):
         self.plan_merge_vf.add_lines(key, parents,
-                                     [int2byte(c) + b'\n' for c in bytearray(text)])
+                                     [bytes([c]) + b'\n' for c in bytearray(text)])
 
     def setup_plan_merge(self):
         self.add_rev(b'root', b'A', [], b'abc')
@@ -3179,7 +3178,7 @@
         :param merge_as: the path in a tree to add the new directory as.
         :returns: the conflicts from 'do_merge'.
         """
-        with cleanup.ExitStack() as stack:
+        with contextlib.ExitStack() as stack:
             # Open and lock the various tree and branch objects
             wt, subdir_relpath = WorkingTree.open_containing(merge_as)
             stack.enter_context(wt.lock_write())

=== modified file 'breezy/tests/test_merge3.py'
--- breezy/tests/test_merge3.py	2018-11-12 01:41:38 +0000
+++ breezy/tests/test_merge3.py	2020-02-07 02:14:30 +0000
@@ -14,16 +14,13 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from io import BytesIO
 
 from .. import (
     merge3,
     tests,
     )
 from ..errors import BinaryFile
-from ..sixish import (
-    BytesIO,
-    int2byte,
-    )
 
 
 def split_lines(t):
@@ -325,7 +322,7 @@
     def test_minimal_conflicts_unique(self):
         def add_newline(s):
             """Add a newline to each entry in the string"""
-            return [(int2byte(x) + b'\n') for x in bytearray(s)]
+            return [(bytes([x]) + b'\n') for x in bytearray(s)]
 
         base_text = add_newline(b"abcdefghijklm")
         this_text = add_newline(b"abcdefghijklmNOPQRSTUVWXYZ")
@@ -343,7 +340,7 @@
     def test_minimal_conflicts_nonunique(self):
         def add_newline(s):
             """Add a newline to each entry in the string"""
-            return [(int2byte(x) + b'\n') for x in bytearray(s)]
+            return [(bytes([x]) + b'\n') for x in bytearray(s)]
 
         base_text = add_newline(b"abacddefgghij")
         this_text = add_newline(b"abacddefgghijkalmontfprz")

=== modified file 'breezy/tests/test_mergeable.py'
--- breezy/tests/test_mergeable.py	2018-11-13 01:08:02 +0000
+++ breezy/tests/test_mergeable.py	2020-02-07 02:14:30 +0000
@@ -14,10 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-try:
-    import socketserver
-except ImportError:
-    import SocketServer as socketserver
+import socketserver
 
 from ..mergeable import read_mergeable_from_url
 from ..directory_service import directories

=== modified file 'breezy/tests/test_multiparent.py'
--- breezy/tests/test_multiparent.py	2019-03-02 21:46:18 +0000
+++ breezy/tests/test_multiparent.py	2020-02-07 02:14:30 +0000
@@ -21,7 +21,6 @@
     multiparent,
     tests,
     )
-from ..sixish import int2byte
 
 
 LINES_1 = b"a\nb\nc\nd\ne\n".splitlines(True)
@@ -184,7 +183,7 @@
 
     def add_version(self, vf, text, version_id, parent_ids):
         vf.add_version(
-            [(int2byte(t) + b'\n') for t in bytearray(text)],
+            [(bytes([t]) + b'\n') for t in bytearray(text)],
             version_id, parent_ids)
 
     def make_vf(self):

=== modified file 'breezy/tests/test_osutils.py'
--- breezy/tests/test_osutils.py	2019-06-16 15:36:08 +0000
+++ breezy/tests/test_osutils.py	2020-02-18 01:57:45 +0000
@@ -16,9 +16,8 @@
 
 """Tests for the osutils wrapper."""
 
-from __future__ import absolute_import, division
-
 import errno
+from io import BytesIO
 import os
 import select
 import socket
@@ -33,11 +32,6 @@
     trace,
     win32utils,
     )
-from ..sixish import (
-    BytesIO,
-    PY3,
-    text_type,
-    )
 from . import (
     features,
     file_utils,
@@ -405,7 +399,7 @@
         self.assertRaises(osutils.UnsupportedTimezoneFormat,
                           osutils.format_date, 0, timezone='foo')
         self.assertIsInstance(osutils.format_date(0), str)
-        self.assertIsInstance(osutils.format_local_date(0), text_type)
+        self.assertIsInstance(osutils.format_local_date(0), str)
         # Testing for the actual value of the local weekday without
         # duplicating the code from format_date is difficult.
         # Instead blackbox.test_locale should check for localized
@@ -947,10 +941,7 @@
                          osutils._win32_pathjoin('path/to/', 'foo'))
 
     def test_pathjoin_late_bugfix(self):
-        if sys.version_info < (2, 7, 6):
-            expected = '/foo'
-        else:
-            expected = 'C:/foo'
+        expected = 'C:/foo'
         self.assertEqual(expected,
                          osutils._win32_pathjoin('C:/path/to/', '/foo'))
         self.assertEqual(expected,
@@ -1409,11 +1400,11 @@
         # all abspaths are Unicode, and encode them back into utf8.
         for dirdetail, dirblock in osutils._walkdirs_utf8('.'):
             self.assertIsInstance(dirdetail[0], bytes)
-            if isinstance(dirdetail[1], text_type):
+            if isinstance(dirdetail[1], str):
                 dirdetail = (dirdetail[0], dirdetail[1].encode('utf8'))
                 dirblock = [list(info) for info in dirblock]
                 for info in dirblock:
-                    self.assertIsInstance(info[4], text_type)
+                    self.assertIsInstance(info[4], str)
                     info[4] = info[4].encode('utf8')
             new_dirblock = []
             for info in dirblock:
@@ -1740,10 +1731,7 @@
                 % (osutils.get_user_encoding(),))
 
         osutils.set_or_unset_env('BRZ_TEST_ENV_VAR', uni_val)
-        if PY3:
-            self.assertEqual(uni_val, os.environ.get('BRZ_TEST_ENV_VAR'))
-        else:
-            self.assertEqual(env_val, os.environ.get('BRZ_TEST_ENV_VAR'))
+        self.assertEqual(uni_val, os.environ.get('BRZ_TEST_ENV_VAR'))
 
     def test_unset(self):
         """Test that passing None will remove the env var"""
@@ -2004,13 +1992,9 @@
     def test_failure_to_load(self):
         self._try_loading()
         self.assertLength(1, osutils._extension_load_failures)
-        if PY3:
-            self.assertEqual(
-                osutils._extension_load_failures[0],
-                "No module named 'breezy._fictional_extension_py'")
-        else:
-            self.assertEqual(osutils._extension_load_failures[0],
-                             "No module named _fictional_extension_py")
+        self.assertEqual(
+            osutils._extension_load_failures[0],
+            "No module named 'breezy._fictional_extension_py'")
 
     def test_report_extension_load_failures_no_warning(self):
         self.assertTrue(self._try_loading())
@@ -2158,13 +2142,13 @@
     def test_is_unicode(self):
         self.overrideEnv('BRZ_TEST_PATH', './anywhere at all/')
         path = osutils.path_from_environ('BRZ_TEST_PATH')
-        self.assertIsInstance(path, text_type)
+        self.assertIsInstance(path, str)
         self.assertEqual(u'./anywhere at all/', path)
 
     def test_posix_path_env_ascii(self):
         self.overrideEnv('BRZ_TEST_PATH', '/tmp')
         home = osutils._posix_path_from_environ('BRZ_TEST_PATH')
-        self.assertIsInstance(home, text_type)
+        self.assertIsInstance(home, str)
         self.assertEqual(u'/tmp', home)
 
     def test_posix_path_env_unicode(self):
@@ -2174,34 +2158,26 @@
         self.assertEqual(u'/home/\xa7test',
                          osutils._posix_path_from_environ('BRZ_TEST_PATH'))
         osutils._fs_enc = "iso8859-5"
-        if PY3:
-            # In Python 3, os.environ returns unicode.
-            self.assertEqual(u'/home/\xa7test',
-                             osutils._posix_path_from_environ('BRZ_TEST_PATH'))
-        else:
-            self.assertEqual(u'/home/\u0407test',
-                             osutils._posix_path_from_environ('BRZ_TEST_PATH'))
-            osutils._fs_enc = "utf-8"
-            self.assertRaises(
-                errors.BadFilenameEncoding,
-                osutils._posix_path_from_environ, 'BRZ_TEST_PATH')
+        # In Python 3, os.environ returns unicode.
+        self.assertEqual(u'/home/\xa7test',
+                         osutils._posix_path_from_environ('BRZ_TEST_PATH'))
 
 
 class TestGetHomeDir(tests.TestCase):
 
     def test_is_unicode(self):
         home = osutils._get_home_dir()
-        self.assertIsInstance(home, text_type)
+        self.assertIsInstance(home, str)
 
     def test_posix_homeless(self):
         self.overrideEnv('HOME', None)
         home = osutils._get_home_dir()
-        self.assertIsInstance(home, text_type)
+        self.assertIsInstance(home, str)
 
     def test_posix_home_ascii(self):
         self.overrideEnv('HOME', '/home/test')
         home = osutils._posix_get_home_dir()
-        self.assertIsInstance(home, text_type)
+        self.assertIsInstance(home, str)
         self.assertEqual(u'/home/test', home)
 
     def test_posix_home_unicode(self):
@@ -2210,22 +2186,15 @@
         self.overrideAttr(osutils, "_fs_enc", "iso8859-1")
         self.assertEqual(u'/home/\xa7test', osutils._posix_get_home_dir())
         osutils._fs_enc = "iso8859-5"
-        if PY3:
-            # In python 3, os.environ returns unicode
-            self.assertEqual(u'/home/\xa7test', osutils._posix_get_home_dir())
-        else:
-            self.assertEqual(u'/home/\u0407test',
-                             osutils._posix_get_home_dir())
-            osutils._fs_enc = "utf-8"
-            self.assertRaises(errors.BadFilenameEncoding,
-                              osutils._posix_get_home_dir)
+        # In python 3, os.environ returns unicode
+        self.assertEqual(u'/home/\xa7test', osutils._posix_get_home_dir())
 
 
 class TestGetuserUnicode(tests.TestCase):
 
     def test_is_unicode(self):
         user = osutils.getuser_unicode()
-        self.assertIsInstance(user, text_type)
+        self.assertIsInstance(user, str)
 
     def envvar_to_override(self):
         if sys.platform == "win32":
@@ -2247,10 +2216,7 @@
                 % (osutils.get_user_encoding(),))
         uni_username = u'jrandom' + uni_val
         encoded_username = uni_username.encode(ue)
-        if PY3:
-            self.overrideEnv(self.envvar_to_override(), uni_username)
-        else:
-            self.overrideEnv(self.envvar_to_override(), encoded_username)
+        self.overrideEnv(self.envvar_to_override(), uni_username)
         self.assertEqual(uni_username, osutils.getuser_unicode())
 
 
@@ -2374,7 +2340,7 @@
 
     def test_returns_string_or_none(self):
         ret = osutils.get_fs_type(self.test_dir)
-        self.assertTrue(isinstance(ret, text_type) or ret is None)
+        self.assertTrue(isinstance(ret, str) or ret is None)
 
     def test_returns_most_specific(self):
         self.overrideAttr(

=== modified file 'breezy/tests/test_osutils_encodings.py'
--- breezy/tests/test_osutils_encodings.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_osutils_encodings.py	2020-02-07 02:14:30 +0000
@@ -23,7 +23,6 @@
 from .. import (
     osutils,
     )
-from ..sixish import PY3
 from . import (
     TestCase,
     )
@@ -88,20 +87,11 @@
                              stdin_encoding,
                              user_encoding='user_encoding',
                              enable_fake_encodings=True):
-        if PY3:
-            sys.stdout = StringIOWithEncoding()
-        else:
-            sys.stdout = BytesIOWithEncoding()
+        sys.stdout = StringIOWithEncoding()
         sys.stdout.encoding = stdout_encoding
-        if PY3:
-            sys.stderr = StringIOWithEncoding()
-        else:
-            sys.stderr = BytesIOWithEncoding()
+        sys.stderr = StringIOWithEncoding()
         sys.stderr.encoding = stderr_encoding
-        if PY3:
-            sys.stdin = StringIOWithEncoding()
-        else:
-            sys.stdin = BytesIOWithEncoding()
+        sys.stdin = StringIOWithEncoding()
         sys.stdin.encoding = stdin_encoding
         osutils._cached_user_encoding = user_encoding
         if enable_fake_encodings:
@@ -184,10 +174,7 @@
         self.overrideAttr(osutils, '_cached_user_encoding', None)
         self.overrideAttr(locale, 'getpreferredencoding', self.get_encoding)
         self.overrideAttr(locale, 'CODESET', None)
-        if PY3:
-            self.overrideAttr(sys, 'stderr', StringIOWithEncoding())
-        else:
-            self.overrideAttr(sys, 'stderr', BytesIOWithEncoding())
+        self.overrideAttr(sys, 'stderr', StringIOWithEncoding())
 
     def get_encoding(self, do_setlocale=True):
         return self._encoding

=== modified file 'breezy/tests/test_pack.py'
--- breezy/tests/test_pack.py	2020-02-09 13:40:47 +0000
+++ breezy/tests/test_pack.py	2020-02-13 23:57:28 +0000
@@ -16,13 +16,12 @@
 
 """Tests for breezy.pack."""
 
+from io import BytesIO
+
 from .. import errors, tests
 from ..bzr import (
     pack,
     )
-from ..sixish import (
-    BytesIO,
-    )
 
 
 class TestContainerSerialiser(tests.TestCase):

=== modified file 'breezy/tests/test_plugins.py'
--- breezy/tests/test_plugins.py	2019-10-13 23:31:40 +0000
+++ breezy/tests/test_plugins.py	2020-02-07 02:14:30 +0000
@@ -18,6 +18,7 @@
 """Tests for plugins"""
 
 import importlib
+from io import StringIO
 import logging
 import os
 import sys
@@ -30,10 +31,6 @@
     tests,
     )
 from ..tests.features import pkg_resources_feature
-from ..sixish import (
-    StringIO,
-    viewkeys,
-    )
 
 
 # TODO: Write a test for plugin decoration of commands.
@@ -301,7 +298,7 @@
         log = self.load_and_capture(name)
         self.assertNotContainsRe(log,
                                  r"It supports breezy version")
-        self.assertEqual({'wants100'}, viewkeys(self.plugin_warnings))
+        self.assertEqual({'wants100'}, self.plugin_warnings.keys())
         self.assertContainsRe(
             self.plugin_warnings['wants100'][0],
             r"It supports breezy version")
@@ -700,7 +697,7 @@
         self.create_plugin_package('ugly')
         self.overrideEnv('BRZ_DISABLE_PLUGINS', 'bad:ugly')
         self.load_with_paths(['.'])
-        self.assertEqual({'good'}, viewkeys(self.plugins))
+        self.assertEqual({'good'}, self.plugins.keys())
         self.assertPluginModules({
             'good': self.plugins['good'].module,
             'bad': None,

=== modified file 'breezy/tests/test_read_bundle.py'
--- breezy/tests/test_read_bundle.py	2019-06-30 10:50:40 +0000
+++ breezy/tests/test_read_bundle.py	2020-02-07 02:14:30 +0000
@@ -16,14 +16,12 @@
 
 """Test read_bundle works properly across various transports."""
 
+from io import BytesIO
+
 import breezy.mergeable
 from ..bzr.bundle.serializer import write_bundle
 import breezy.bzr.bzrdir
 from .. import errors
-from ..sixish import (
-    BytesIO,
-    text_type,
-    )
 from .. import tests
 from .test_transport import TestTransportImplementation
 from .per_transport import transport_test_permutations
@@ -88,7 +86,7 @@
 
     def test_read_mergeable_from_url(self):
         info = self.read_mergeable_from_url(
-            text_type(self.get_url(self.bundle_name)))
+            str(self.get_url(self.bundle_name)))
         revision = info.real_revisions[-1]
         self.assertEqual(b'commit-1', revision.revision_id)
 
@@ -107,6 +105,6 @@
             # transports (the test will fail even).
             raise tests.TestSkipped(
                 'Need a ConnectedTransport to test transport reuse')
-        url = text_type(self.get_url(self.bundle_name))
+        url = str(self.get_url(self.bundle_name))
         self.read_mergeable_from_url(url)
         self.assertEqual(1, len(self.possible_transports))

=== modified file 'breezy/tests/test_registry.py'
--- breezy/tests/test_registry.py	2018-11-12 01:41:38 +0000
+++ breezy/tests/test_registry.py	2020-02-07 02:14:30 +0000
@@ -26,7 +26,6 @@
     tests,
     )
 
-from ..sixish import viewitems
 
 
 class TestRegistry(tests.TestCase):
@@ -218,7 +217,7 @@
         self.assertEqual({'two': 'one', 'three': 'one'}, a_registry.aliases())
         self.assertEqual(
             {'one': ['three', 'two']},
-            {k: sorted(v) for (k, v) in viewitems(a_registry.alias_map())})
+            {k: sorted(v) for (k, v) in a_registry.alias_map().items()})
 
     def test_registry_alias_exists(self):
         a_registry = registry.Registry()

=== modified file 'breezy/tests/test_remote.py'
--- breezy/tests/test_remote.py	2020-01-31 10:39:02 +0000
+++ breezy/tests/test_remote.py	2020-02-07 02:14:30 +0000
@@ -25,6 +25,7 @@
 
 import base64
 import bz2
+from io import BytesIO
 import tarfile
 import zlib
 
@@ -69,11 +70,6 @@
     NULL_REVISION,
     Revision,
     )
-from ..sixish import (
-    BytesIO,
-    PY3,
-    text_type,
-    )
 from ..bzr.smart import medium, request
 from ..bzr.smart.client import _SmartClient
 from ..bzr.smart.repository import (
@@ -339,10 +335,7 @@
         client.add_success_response(b'yes',)
         transport = RemoteTransport('bzr://localhost/', _client=client)
         filename = u'/hell\u00d8'
-        if PY3:
-            result = transport.has(filename)
-        else:
-            result = transport.has(filename.encode('utf-8'))
+        result = transport.has(filename)
         self.assertEqual(
             [('call', b'has', (filename.encode('utf-8'),))],
             client._calls)
@@ -1787,7 +1780,7 @@
             branch._set_last_revision, b'rev-id')
         # The UTF-8 message from the response has been decoded into a unicode
         # object.
-        self.assertIsInstance(err.msg, text_type)
+        self.assertIsInstance(err.msg, str)
         self.assertEqual(rejection_msg_unicode, err.msg)
         branch.unlock()
         self.assertFinished(client)

=== modified file 'breezy/tests/test_selftest.py'
--- breezy/tests/test_selftest.py	2019-02-14 03:30:18 +0000
+++ breezy/tests/test_selftest.py	2020-02-07 02:14:30 +0000
@@ -19,7 +19,7 @@
 import gc
 import doctest
 from functools import reduce
-from io import BytesIO, TextIOWrapper
+from io import BytesIO, StringIO, TextIOWrapper
 import os
 import signal
 import sys
@@ -67,11 +67,6 @@
 from ..git import (
     workingtree as git_workingtree,
     )
-from ..sixish import (
-    PY3,
-    StringIO,
-    text_type,
-    )
 from ..symbol_versioning import (
     deprecated_function,
     deprecated_in,
@@ -809,8 +804,8 @@
 
         This is used to exercise the test framework.
         """
-        self.time(text_type, b'hello', errors='replace')
-        self.time(text_type, b'world', errors='replace')
+        self.time(str, b'hello', errors='replace')
+        self.time(str, b'world', errors='replace')
 
     def test_lsprofiling(self):
         """Verbose test result prints lsprof statistics from test cases."""
@@ -840,16 +835,10 @@
         # and then repeated but with 'world', rather than 'hello'.
         # this should appear in the output stream of our test result.
         output = result_stream.getvalue()
-        if PY3:
-            self.assertContainsRe(output,
-                                  r"LSProf output for <class 'str'>\(\(b'hello',\), {'errors': 'replace'}\)")
-            self.assertContainsRe(output,
-                                  r"LSProf output for <class 'str'>\(\(b'world',\), {'errors': 'replace'}\)")
-        else:
-            self.assertContainsRe(output,
-                                  r"LSProf output for <type 'unicode'>\(\('hello',\), {'errors': 'replace'}\)")
-            self.assertContainsRe(output,
-                                  r"LSProf output for <type 'unicode'>\(\('world',\), {'errors': 'replace'}\)\n")
+        self.assertContainsRe(output,
+                              r"LSProf output for <class 'str'>\(\(b'hello',\), {'errors': 'replace'}\)")
+        self.assertContainsRe(output,
+                              r"LSProf output for <class 'str'>\(\(b'world',\), {'errors': 'replace'}\)")
         self.assertContainsRe(output,
                               r" *CallCount *Recursive *Total\(ms\) *Inline\(ms\) *module:lineno\(function\)\n")
         self.assertContainsRe(output,
@@ -1305,11 +1294,8 @@
             def test_log_unicode(self):
                 self.log(u"\u2606")
                 self.fail("Now print that log!")
-        if PY3:
-            bio = BytesIO()
-            out = TextIOWrapper(bio, 'ascii', 'backslashreplace')
-        else:
-            bio = out = StringIO()
+        bio = BytesIO()
+        out = TextIOWrapper(bio, 'ascii', 'backslashreplace')
         self.overrideAttr(osutils, "get_terminal_encoding",
                           lambda trace=False: "ascii")
         self.run_test_runner(
@@ -1982,7 +1968,7 @@
 
     def test_assert_isinstance(self):
         self.assertIsInstance(2, int)
-        self.assertIsInstance(u'', (str, text_type))
+        self.assertIsInstance(u'', str)
         e = self.assertRaises(AssertionError, self.assertIsInstance, None, int)
         self.assertIn(
             str(e),
@@ -1994,16 +1980,10 @@
         e = self.assertRaises(AssertionError,
                               self.assertIsInstance, None, int,
                               "it's just not")
-        if PY3:
-            self.assertEqual(
-                str(e),
-                "None is an instance of <class 'NoneType'> rather "
-                "than <class 'int'>: it's just not")
-        else:
-            self.assertEqual(
-                str(e),
-                "None is an instance of <type 'NoneType'> "
-                "rather than <type 'int'>: it's just not")
+        self.assertEqual(
+            str(e),
+            "None is an instance of <class 'NoneType'> rather "
+            "than <class 'int'>: it's just not")
 
     def test_assertEndsWith(self):
         self.assertEndsWith('foo', 'oo')
@@ -2129,11 +2109,8 @@
 
     def run_selftest(self, **kwargs):
         """Run selftest returning its output."""
-        if PY3:
-            bio = BytesIO()
-            output = TextIOWrapper(bio, 'utf-8')
-        else:
-            bio = output = StringIO()
+        bio = BytesIO()
+        output = TextIOWrapper(bio, 'utf-8')
         old_transport = breezy.tests.default_transport
         old_root = tests.TestCaseWithMemoryTransport.TEST_ROOT
         tests.TestCaseWithMemoryTransport.TEST_ROOT = None
@@ -2142,9 +2119,8 @@
         finally:
             breezy.tests.default_transport = old_transport
             tests.TestCaseWithMemoryTransport.TEST_ROOT = old_root
-        if PY3:
-            output.flush()
-            output.detach()
+        output.flush()
+        output.detach()
         bio.seek(0)
         return bio
 
@@ -3155,17 +3131,8 @@
             # plugins can't be tested that way since selftest may be run with
             # --no-plugins
             ]
-        if __doc__ is not None and not PY3:
-            expected_test_list.extend([
-                # modules_to_doctest
-                'breezy.timestamp.format_highres_date',
-                ])
         suite = tests.test_suite()
-        if PY3:
-            self.assertEqual({"testmod_names"}, set(calls))
-        else:
-            self.assertEqual({"testmod_names", "modules_to_doctest"},
-                             set(calls))
+        self.assertEqual({"testmod_names", "modules_to_doctest"}, set(calls))
         self.assertSubset(expected_test_list, _test_ids(suite))
 
     def test_test_suite_list_and_start(self):
@@ -3497,11 +3464,8 @@
         """To be overridden by subclasses that run tests out of process"""
 
     def _run_selftest(self, **kwargs):
-        if PY3:
-            bio = BytesIO()
-            sio = TextIOWrapper(bio, 'utf-8')
-        else:
-            sio = bio = StringIO()
+        bio = BytesIO()
+        sio = TextIOWrapper(bio, 'utf-8')
         self._inject_stream_into_subunit(bio)
         tests.selftest(stream=sio, stop_on_failure=False, **kwargs)
         sio.flush()

=== modified file 'breezy/tests/test_server.py'
--- breezy/tests/test_server.py	2019-11-18 01:30:13 +0000
+++ breezy/tests/test_server.py	2020-02-07 02:14:30 +0000
@@ -16,10 +16,7 @@
 
 import errno
 import socket
-try:
-    import socketserver
-except ImportError:
-    import SocketServer as socketserver
+import socketserver
 import sys
 import threading
 

=== modified file 'breezy/tests/test_shelf_ui.py'
--- breezy/tests/test_shelf_ui.py	2019-06-29 13:16:26 +0000
+++ breezy/tests/test_shelf_ui.py	2020-02-07 02:14:30 +0000
@@ -15,6 +15,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
+from io import BytesIO
 import os
 import sys
 from textwrap import dedent
@@ -26,9 +27,6 @@
     shelf,
     tests,
     )
-from ..sixish import (
-    BytesIO,
-    )
 from . import script
 from . import (
     features,

=== modified file 'breezy/tests/test_smart_add.py'
--- breezy/tests/test_smart_add.py	2019-09-27 02:48:17 +0000
+++ breezy/tests/test_smart_add.py	2020-02-07 02:14:30 +0000
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from io import StringIO
+
 from .. import (
     add,
     cache_utf8,
@@ -23,9 +25,6 @@
 from ..bzr import (
     inventory,
     )
-from ..sixish import (
-    StringIO,
-    )
 
 
 class AddCustomIDAction(add.AddAction):

=== modified file 'breezy/tests/test_smart_transport.py'
--- breezy/tests/test_smart_transport.py	2019-06-30 10:50:40 +0000
+++ breezy/tests/test_smart_transport.py	2020-02-07 02:14:30 +0000
@@ -19,6 +19,7 @@
 # all of this deals with byte strings so this is safe
 import doctest
 import errno
+from io import BytesIO
 import os
 import socket
 import subprocess
@@ -55,10 +56,6 @@
     test_smart,
     test_server,
     )
-from ..sixish import (
-    BytesIO,
-    int2byte,
-    )
 from ..transport import (
     http,
     local,
@@ -3169,7 +3166,7 @@
         decoder, response_handler = self.make_logging_response_decoder()
         for byte in bytearray(simple_response):
             self.assertNotEqual(0, decoder.next_read_size())
-            decoder.accept_bytes(int2byte(byte))
+            decoder.accept_bytes(bytes([byte]))
         # Now the response is complete
         self.assertEqual(0, decoder.next_read_size())
 

=== modified file 'breezy/tests/test_smtp_connection.py'
--- breezy/tests/test_smtp_connection.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_smtp_connection.py	2020-02-07 02:14:30 +0000
@@ -14,10 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-try:
-    from email.message import Message
-except ImportError:  # python < 3
-    from email.Message import Message
+from email.message import Message
 import errno
 import smtplib
 import socket

=== modified file 'breezy/tests/test_source.py'
--- breezy/tests/test_source.py	2019-06-02 05:13:10 +0000
+++ breezy/tests/test_source.py	2020-02-18 01:57:45 +0000
@@ -444,23 +444,3 @@
             error_msg.extend(('', ''))
         if error_msg:
             self.fail('\n'.join(error_msg))
-
-    def test_feature_absolute_import(self):
-        """Using absolute imports means avoiding unnecesary stat and
-        open calls.
-
-        Make sure that all non-test files have absolute imports enabled.
-        """
-        missing_absolute_import = []
-        for fname, text in self.get_source_file_contents(
-                extensions=('.py', '.pyx')):
-            if "/tests/" in fname or "test_" in fname:
-                # We don't really care about tests
-                continue
-            if "from __future__ import absolute_import" not in text:
-                missing_absolute_import.append(fname)
-
-        if missing_absolute_import:
-            self.fail(
-                'The following files do not have absolute_import enabled:\n'
-                '\n' + '\n'.join(missing_absolute_import))

=== modified file 'breezy/tests/test_status.py'
--- breezy/tests/test_status.py	2018-11-12 01:41:38 +0000
+++ breezy/tests/test_status.py	2020-02-07 02:14:30 +0000
@@ -14,15 +14,13 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from io import StringIO
 
 from .. import (
     config,
     status as _mod_status,
     )
 from ..revisionspec import RevisionSpec
-from ..sixish import (
-    StringIO,
-    )
 from ..status import show_pending_merges, show_tree_status
 from . import TestCaseWithTransport
 

=== modified file 'breezy/tests/test_symbol_versioning.py'
--- breezy/tests/test_symbol_versioning.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_symbol_versioning.py	2020-02-07 02:14:30 +0000
@@ -19,7 +19,6 @@
 import warnings
 
 from breezy import symbol_versioning
-from breezy.sixish import PY3
 from breezy.symbol_versioning import (
     deprecated_function,
     deprecated_in,
@@ -70,19 +69,10 @@
         return 1
 
     def test_deprecated_static(self):
-        if PY3:
-            expected_warning = (
-                "breezy.tests.test_symbol_versioning.TestDeprecationWarnings."
-                "deprecated_static "
-                "was deprecated in version 0.7.0.", DeprecationWarning, 2)
-        else:
-            # XXX: The results are not quite right because the class name is not
-            # shown on Python 2- however it is enough to give people a good indication of
-            # where the problem is.
-            expected_warning = (
-                "breezy.tests.test_symbol_versioning."
-                "deprecated_static "
-                "was deprecated in version 0.7.0.", DeprecationWarning, 2)
+        expected_warning = (
+            "breezy.tests.test_symbol_versioning.TestDeprecationWarnings."
+            "deprecated_static "
+            "was deprecated in version 0.7.0.", DeprecationWarning, 2)
         expected_docstring = (
             'Deprecated static.\n'
             '\n'

=== modified file 'breezy/tests/test_textfile.py'
--- breezy/tests/test_textfile.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_textfile.py	2020-02-07 02:14:30 +0000
@@ -14,11 +14,9 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from io import BytesIO
 
 from ..errors import BinaryFile
-from ..sixish import (
-    BytesIO,
-    )
 from . import TestCase, TestCaseInTempDir
 from ..textfile import text_file, check_text_lines, check_text_path
 

=== modified file 'breezy/tests/test_trace.py'
--- breezy/tests/test_trace.py	2019-12-26 12:59:13 +0000
+++ breezy/tests/test_trace.py	2020-02-07 02:14:30 +0000
@@ -19,6 +19,7 @@
 """Tests for trace library"""
 
 import errno
+from io import StringIO
 import logging
 import os
 import re
@@ -30,10 +31,6 @@
     errors,
     trace,
     )
-from ..sixish import (
-    PY3,
-    StringIO,
-    )
 from . import features, TestCaseInTempDir, TestCase, TestSkipped
 from ..trace import (
     mutter, mutter_callsite, report_exception,
@@ -146,11 +143,7 @@
             raise errors.BzrCommandError(u'argument foo\xb5 does not exist')
         except errors.BzrCommandError:
             msg = _format_exception()
-        if PY3:
-            expected = 'brz: ERROR: argument foo\xb5 does not exist\n'
-        else:
-            # GZ 2017-06-10: Pretty bogus, should encode per the output stream
-            expected = 'brz: ERROR: argument foo\xc2\xb5 does not exist\n'
+        expected = 'brz: ERROR: argument foo\xb5 does not exist\n'
         self.assertEqual(msg, expected)
 
     def test_format_exception(self):
@@ -410,10 +403,7 @@
 
     def test_log_utf8_arg(self):
         logging.getLogger("brz").debug(b"%s", b"\xc2\xa7")
-        if PY3:
-            expected = u"   DEBUG  b'\\xc2\\xa7'\n"
-        else:
-            expected = u"   DEBUG  \xa7\n"
+        expected = u"   DEBUG  b'\\xc2\\xa7'\n"
         self.assertEqual(expected, self.get_log())
 
     def test_log_bytes_msg(self):
@@ -426,24 +416,12 @@
     def test_log_bytes_arg(self):
         logging.getLogger("brz").debug(b"%s", b"\xa7")
         log = self.get_log()
-        if PY3:
-            self.assertEqual(u"   DEBUG  b'\\xa7'\n", self.get_log())
-        else:
-            self.assertContainsString(log, "UnicodeDecodeError: ")
-            self.assertContainsRe(
-                log,
-                "Logging record unformattable: ?'%s' % \\(b?'\\\\xa7',\\)\n")
+        self.assertEqual(u"   DEBUG  b'\\xa7'\n", self.get_log())
 
     def test_log_mixed_strings(self):
         logging.getLogger("brz").debug(u"%s", b"\xa7")
         log = self.get_log()
-        if PY3:
-            self.assertEqual(u"   DEBUG  b'\\xa7'\n", self.get_log())
-        else:
-            self.assertContainsString(log, "UnicodeDecodeError: ")
-            self.assertContainsRe(
-                log,
-                "Logging record unformattable: u'%s' % \\('\\\\xa7',\\)\n")
+        self.assertEqual(u"   DEBUG  b'\\xa7'\n", self.get_log())
 
     def test_log_repr_broken(self):
         class BadRepr(object):

=== modified file 'breezy/tests/test_transform.py'
--- breezy/tests/test_transform.py	2019-09-21 23:05:12 +0000
+++ breezy/tests/test_transform.py	2020-02-07 02:14:30 +0000
@@ -63,11 +63,6 @@
 )
 from ..merge import Merge3Merger, Merger
 from ..mutabletree import MutableTree
-from ..sixish import (
-    BytesIO,
-    PY3,
-    text_type,
-    )
 from . import (
     features,
     TestCaseInTempDir,
@@ -892,7 +887,7 @@
         raw_conflicts = resolve_conflicts(tt)
         cooked_conflicts = cook_conflicts(raw_conflicts, tt)
         tt.finalize()
-        conflicts_s = [text_type(c) for c in cooked_conflicts]
+        conflicts_s = [str(c) for c in cooked_conflicts]
         self.assertEqual(len(cooked_conflicts), len(conflicts_s))
         self.assertEqual(conflicts_s[0], 'Conflict adding file dorothy.  '
                                          'Moved existing file to '
@@ -2611,12 +2606,8 @@
         new_globals.update(globals)
         new_func = types.FunctionType(func.__code__, new_globals,
                                       func.__name__, func.__defaults__)
-        if PY3:
-            setattr(instance, method_name,
-                    types.MethodType(new_func, instance))
-        else:
-            setattr(instance, method_name,
-                    types.MethodType(new_func, instance, instance.__class__))
+        setattr(instance, method_name,
+                types.MethodType(new_func, instance))
         self.addCleanup(delattr, instance, method_name)
 
     @staticmethod

=== modified file 'breezy/tests/test_transport.py'
--- breezy/tests/test_transport.py	2019-03-03 19:49:20 +0000
+++ breezy/tests/test_transport.py	2020-02-07 02:14:30 +0000
@@ -16,6 +16,7 @@
 
 
 import errno
+from io import BytesIO
 import os
 import subprocess
 import sys
@@ -28,9 +29,6 @@
     transport,
     urlutils,
     )
-from ..sixish import (
-    BytesIO,
-    )
 from ..transport import (
     chroot,
     fakenfs,

=== modified file 'breezy/tests/test_urlutils.py'
--- breezy/tests/test_urlutils.py	2020-01-12 13:56:10 +0000
+++ breezy/tests/test_urlutils.py	2020-02-07 02:14:30 +0000
@@ -23,10 +23,6 @@
 from ..errors import (
     PathNotChild,
     )
-from ..sixish import (
-    text_type,
-    PY3,
-    )
 from . import features, TestCaseInTempDir, TestCase, TestSkipped
 
 
@@ -129,14 +125,6 @@
         eq('http://host/~bob%2525-._',
            normalize_url(u'http://host/%7Ebob%2525%2D%2E%5F'))
 
-        if not PY3:
-            # On Python 2, normalize verifies URLs when they are not unicode
-            # (indicating they did not come from the user)
-            self.assertRaises(urlutils.InvalidURL, normalize_url,
-                              b'http://host/\xb5')
-            self.assertRaises(urlutils.InvalidURL,
-                              normalize_url, b'http://host/ ')
-
     def test_url_scheme_re(self):
         # Test paths that may be URLs
         def test_one(url, scheme_and_path):
@@ -449,7 +437,7 @@
 
         self.assertEqual(
             'file://HOST/path/to/r%C3%A4ksm%C3%B6rg%C3%A5s', result)
-        self.assertFalse(isinstance(result, text_type))
+        self.assertFalse(isinstance(result, str))
 
     def test_win32_local_path_from_url(self):
         from_url = urlutils._win32_local_path_from_url
@@ -678,7 +666,7 @@
         # Test that URLs are converted to nice unicode strings for display
         def test(expected, url, encoding='utf-8'):
             disp_url = urlutils.unescape_for_display(url, encoding=encoding)
-            self.assertIsInstance(disp_url, text_type)
+            self.assertIsInstance(disp_url, str)
             self.assertEqual(expected, disp_url)
 
         test('http://foo', 'http://foo')
@@ -727,14 +715,9 @@
         self.assertEqual('%', urlutils.unescape('%25'))
         self.assertEqual(u'\xe5', urlutils.unescape('%C3%A5'))
 
-        if not PY3:
-            self.assertRaises(urlutils.InvalidURL, urlutils.unescape, u'\xe5')
         self.assertRaises((TypeError, urlutils.InvalidURL),
                           urlutils.unescape, b'\xe5')
-        if not PY3:
-            self.assertRaises(urlutils.InvalidURL, urlutils.unescape, '%E5')
-        else:
-            self.assertEqual('\xe5', urlutils.unescape('%C3%A5'))
+        self.assertEqual('\xe5', urlutils.unescape('%C3%A5'))
 
     def test_escape_unescape(self):
         self.assertEqual(u'\xe5', urlutils.unescape(urlutils.escape(u'\xe5')))
@@ -1140,10 +1123,7 @@
 
     def test_unquote(self):
         self.assertEqual('%', urlutils.unquote('%25'))
-        if PY3:
-            self.assertEqual('\xe5', urlutils.unquote('%C3%A5'))
-        else:
-            self.assertEqual('\xc3\xa5', urlutils.unquote('%C3%A5'))
+        self.assertEqual('\xe5', urlutils.unquote('%C3%A5'))
         self.assertEqual(u"\xe5", urlutils.unquote(u'\xe5'))
 
     def test_unquote_to_bytes(self):

=== modified file 'breezy/tests/test_version.py'
--- breezy/tests/test_version.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_version.py	2020-02-07 02:14:30 +0000
@@ -16,6 +16,7 @@
 
 """Tests for versioning of breezy."""
 
+from io import StringIO
 import platform
 import re
 
@@ -24,10 +25,6 @@
     version,
     workingtree,
     )
-from ..sixish import (
-    PY3,
-    StringIO,
-    )
 from .scenarios import load_tests_apply_scenarios
 
 
@@ -78,6 +75,5 @@
         version.show_version(show_config=False, show_copyright=False,
                              to_file=out)
         expected = r'(?m)^  Platform: %s' % self._platform
-        if PY3:
-            expected = expected.encode('utf-8')
+        expected = expected.encode('utf-8')
         self.assertContainsRe(out.getvalue(), expected)

=== modified file 'breezy/tests/test_version_info.py'
--- breezy/tests/test_version_info.py	2018-11-12 01:41:38 +0000
+++ breezy/tests/test_version_info.py	2020-02-07 02:14:30 +0000
@@ -16,6 +16,10 @@
 
 """Tests for version_info"""
 
+from io import (
+    BytesIO,
+    StringIO,
+    )
 import os
 
 from .. import (
@@ -23,10 +27,6 @@
     tests,
     version_info_formats,
     )
-from ..sixish import (
-    BytesIO,
-    StringIO,
-    )
 from . import TestCaseWithTransport
 from ..rio import read_stanzas, read_stanzas_unicode
 

=== modified file 'breezy/tests/test_views.py'
--- breezy/tests/test_views.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_views.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 from . import TestCase
 
 from ..views import (

=== modified file 'breezy/tests/test_weave.py'
--- breezy/tests/test_weave.py	2018-11-12 01:41:38 +0000
+++ breezy/tests/test_weave.py	2020-02-07 02:14:30 +0000
@@ -21,15 +21,13 @@
 
 """test suite for weave algorithm"""
 
+from io import BytesIO
 from pprint import pformat
 
 from .. import (
     errors,
     )
 from ..osutils import sha_string
-from ..sixish import (
-    BytesIO,
-    )
 from . import TestCase, TestCaseInTempDir
 from ..bzr.weave import Weave, WeaveFormatError, WeaveInvalidChecksum
 from ..bzr.weavefile import write_weave, read_weave

=== modified file 'breezy/tests/test_wsgi.py'
--- breezy/tests/test_wsgi.py	2018-11-11 04:08:32 +0000
+++ breezy/tests/test_wsgi.py	2020-02-07 02:14:30 +0000
@@ -16,10 +16,9 @@
 
 """Tests for WSGI application"""
 
+from io import BytesIO
+
 from .. import tests
-from ..sixish import (
-    BytesIO,
-    )
 from ..bzr.smart import medium, protocol
 from ..transport.http import wsgi
 from ..transport import chroot, memory

=== modified file 'breezy/tests/test_xml.py'
--- breezy/tests/test_xml.py	2020-01-31 10:39:02 +0000
+++ breezy/tests/test_xml.py	2020-02-07 02:14:30 +0000
@@ -14,6 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from io import BytesIO
 
 from .. import (
     errors,
@@ -25,10 +26,6 @@
     xml7,
     xml8,
     )
-from ..sixish import (
-    BytesIO,
-    text_type,
-    )
 from ..bzr.inventory import Inventory
 from . import TestCase
 import breezy.bzr.xml5
@@ -491,7 +488,7 @@
         for parent_id in rev.parent_ids:
             self.assertIsInstance(parent_id, bytes)
         self.assertEqual(u'Include \xb5nicode characters\n', rev.message)
-        self.assertIsInstance(rev.message, text_type)
+        self.assertIsInstance(rev.message, str)
 
         # ie.revision should either be None or a utf-8 revision id
         inv = s_v5.read_inventory_from_lines(breezy.osutils.split_lines(_inventory_utf8_v5))
@@ -513,7 +510,7 @@
         for ((exp_path, exp_file_id, exp_parent_id, exp_rev_id),
              (act_path, act_ie)) in zip(expected, actual):
             self.assertEqual(exp_path, act_path)
-            self.assertIsInstance(act_path, text_type)
+            self.assertIsInstance(act_path, str)
             self.assertEqual(exp_file_id, act_ie.file_id)
             self.assertIsInstance(act_ie.file_id, bytes)
             self.assertEqual(exp_parent_id, act_ie.parent_id)

=== modified file 'breezy/tests/ui_testing.py'
--- breezy/tests/ui_testing.py	2018-03-24 15:16:49 +0000
+++ breezy/tests/ui_testing.py	2020-02-18 01:57:45 +0000
@@ -14,17 +14,12 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import io
 
 from .. import (
     ui,
 )
 from ..ui import text as ui_text
-from ..sixish import (
-    text_type,
-)
 
 
 class StringIOWithEncoding(io.StringIO):
@@ -54,7 +49,7 @@
     def __init__(self, stdin=None, stdout=None, stderr=None):
         if isinstance(stdin, bytes):
             stdin = stdin.decode()
-        if isinstance(stdin, text_type):
+        if isinstance(stdin, str):
             stdin = StringIOWithEncoding(stdin)
         if stdout is None:
             stdout = StringIOWithEncoding()

=== modified file 'breezy/textfile.py'
--- breezy/textfile.py	2018-06-18 00:19:26 +0000
+++ breezy/textfile.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Utilities for distinguishing binary files from text files"""
 
-from __future__ import absolute_import
-
 from itertools import chain
 
 from .errors import BinaryFile

=== modified file 'breezy/textmerge.py'
--- breezy/textmerge.py	2019-03-02 21:46:18 +0000
+++ breezy/textmerge.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 # Author: Martin Pool <mbp@canonical.com>
 #         Aaron Bentley <aaron.bentley@utoronto.ca>
 
-from __future__ import absolute_import
-
 from .lazy_import import lazy_import
 lazy_import(globals(), """
 import patiencediff

=== modified file 'breezy/timestamp.py'
--- breezy/timestamp.py	2018-11-11 04:08:32 +0000
+++ breezy/timestamp.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import calendar
 import time
 import re

=== modified file 'breezy/trace.py'
--- breezy/trace.py	2020-01-11 17:41:33 +0000
+++ breezy/trace.py	2020-02-18 01:57:45 +0000
@@ -45,8 +45,6 @@
 form.
 """
 
-from __future__ import absolute_import
-
 # FIXME: Unfortunately it turns out that python's logging module
 # is quite expensive, even when the message is not printed by any handlers.
 # We should perhaps change back to just simply doing it here.
@@ -57,6 +55,7 @@
 # that.
 
 import errno
+from io import StringIO
 import logging
 import os
 import sys
@@ -82,12 +81,6 @@
     errors,
     )
 
-from .sixish import (
-    PY3,
-    StringIO,
-    text_type,
-    )
-
 
 # global verbosity for breezy; controls the log level for stderr; 0=normal; <0
 # is quiet; >0 is verbose.
@@ -162,9 +155,6 @@
         fmt = fmt.decode('ascii', 'replace')
 
     if args:
-        if not PY3:
-            args = tuple(
-                _Bytes(arg) if isinstance(arg, bytes) else arg for arg in args)
         out = fmt % args
     else:
         out = fmt
@@ -306,12 +296,7 @@
         r'%Y-%m-%d %H:%M:%S')
     # after hooking output into brz_log, we also need to attach a stderr
     # handler, writing only at level info and with encoding
-    if sys.version_info[0] == 2:
-        stderr_handler = EncodedStreamHandler(
-            sys.stderr, osutils.get_terminal_encoding(), 'replace',
-            level=logging.INFO)
-    else:
-        stderr_handler = logging.StreamHandler(stream=sys.stderr)
+    stderr_handler = logging.StreamHandler(stream=sys.stderr)
     logging.getLogger('brz').addHandler(stderr_handler)
     return memento
 
@@ -615,12 +600,11 @@
 
     def emit(self, record):
         try:
-            if not isinstance(record.msg, text_type):
+            if not isinstance(record.msg, str):
                 msg = record.msg.decode("utf-8")
-                if PY3:
-                    record.msg = msg
+                record.msg = msg
             line = self.format(record)
-            if not isinstance(line, text_type):
+            if not isinstance(line, str):
                 line = line.decode("utf-8")
             self.stream.write(line.encode(self.encoding, self.errors) + b"\n")
         except Exception:

=== modified file 'breezy/transactions.py'
--- breezy/transactions.py	2018-11-11 04:08:32 +0000
+++ breezy/transactions.py	2020-02-18 01:57:45 +0000
@@ -36,8 +36,6 @@
 the object is an expensive one for obtaining.
 """
 
-from __future__ import absolute_import
-
 import sys
 
 from . import errors as errors

=== modified file 'breezy/transform.py'
--- breezy/transform.py	2020-02-09 17:10:01 +0000
+++ breezy/transform.py	2020-02-18 01:57:45 +0000
@@ -14,8 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
+import contextlib
 import os
 import errno
 from stat import S_ISREG, S_IEXEC
@@ -33,7 +32,6 @@
 from breezy import (
     annotate,
     bencode,
-    cleanup,
     controldir,
     commit,
     conflicts,
@@ -65,11 +63,6 @@
     supports_symlinks,
     )
 from .progress import ProgressPhase
-from .sixish import (
-    text_type,
-    viewitems,
-    viewvalues,
-    )
 from .tree import (
     InterTree,
     TreeChange,
@@ -239,7 +232,7 @@
         irrelevant.
 
         """
-        new_roots = [k for k, v in viewitems(self._new_parent)
+        new_roots = [k for k, v in self._new_parent.items()
                      if v == ROOT_PARENT]
         if len(new_roots) < 1:
             return
@@ -480,7 +473,7 @@
         file_id = self.tree_file_id(trans_id)
         if file_id is not None:
             return file_id
-        for key, value in viewitems(self._non_present_ids):
+        for key, value in self._non_present_ids.items():
             if value == trans_id:
                 return key
 
@@ -510,7 +503,7 @@
         Only new paths and parents of tree files with assigned ids are used.
         """
         by_parent = {}
-        items = list(viewitems(self._new_parent))
+        items = list(self._new_parent.items())
         items.extend((t, self.final_parent(t))
                      for t in list(self._tree_id_paths))
         for trans_id, parent_id in items:
@@ -635,7 +628,7 @@
     def _unversioned_parents(self, by_parent):
         """If parent directories are versioned, children must be versioned."""
         conflicts = []
-        for parent_id, children in viewitems(by_parent):
+        for parent_id, children in by_parent.items():
             if parent_id == ROOT_PARENT:
                 continue
             if self.final_file_id(parent_id) is not None:
@@ -697,7 +690,7 @@
         conflicts = []
         if (self._new_name, self._new_parent) == ({}, {}):
             return conflicts
-        for children in viewvalues(by_parent):
+        for children in by_parent.values():
             name_ids = []
             for child_tid in children:
                 name = self.final_name(child_tid)
@@ -732,7 +725,7 @@
         removed_tree_ids = set((self.tree_file_id(trans_id) for trans_id in
                                 self._removed_id))
         active_tree_ids = all_ids.difference(removed_tree_ids)
-        for trans_id, file_id in viewitems(self._new_id):
+        for trans_id, file_id in self._new_id.items():
             if file_id in active_tree_ids:
                 path = self._tree.id2path(file_id)
                 old_trans_id = self.trans_id_tree_path(path)
@@ -742,7 +735,7 @@
     def _parent_type_conflicts(self, by_parent):
         """Children must have a directory parent"""
         conflicts = []
-        for parent_id, children in viewitems(by_parent):
+        for parent_id, children in by_parent.items():
             if parent_id == ROOT_PARENT:
                 continue
             no_children = True
@@ -1112,17 +1105,17 @@
         :param serializer: A Serialiser like pack.ContainerSerializer.
         """
         new_name = {k.encode('utf-8'): v.encode('utf-8')
-                    for k, v in viewitems(self._new_name)}
+                    for k, v in self._new_name.items()}
         new_parent = {k.encode('utf-8'): v.encode('utf-8')
-                      for k, v in viewitems(self._new_parent)}
+                      for k, v in self._new_parent.items()}
         new_id = {k.encode('utf-8'): v
-                  for k, v in viewitems(self._new_id)}
+                  for k, v in self._new_id.items()}
         new_executability = {k.encode('utf-8'): int(v)
-                             for k, v in viewitems(self._new_executability)}
+                             for k, v in self._new_executability.items()}
         tree_path_ids = {k.encode('utf-8'): v.encode('utf-8')
-                         for k, v in viewitems(self._tree_path_ids)}
+                         for k, v in self._tree_path_ids.items()}
         non_present_ids = {k: v.encode('utf-8')
-                           for k, v in viewitems(self._non_present_ids)}
+                           for k, v in self._non_present_ids.items()}
         removed_contents = [trans_id.encode('utf-8')
                             for trans_id in self._removed_contents]
         removed_id = [trans_id.encode('utf-8')
@@ -1140,7 +1133,7 @@
             }
         yield serializer.bytes_record(bencode.bencode(attribs),
                                       ((b'attribs',),))
-        for trans_id, kind in sorted(viewitems(self._new_contents)):
+        for trans_id, kind in sorted(self._new_contents.items()):
             if kind == 'file':
                 with open(self._limbo_name(trans_id), 'rb') as cur_file:
                     lines = cur_file.readlines()
@@ -1166,18 +1159,18 @@
         attribs = bencode.bdecode(content)
         self._id_number = attribs[b'_id_number']
         self._new_name = {k.decode('utf-8'): v.decode('utf-8')
-                          for k, v in viewitems(attribs[b'_new_name'])}
+                          for k, v in attribs[b'_new_name'].items()}
         self._new_parent = {k.decode('utf-8'): v.decode('utf-8')
-                            for k, v in viewitems(attribs[b'_new_parent'])}
+                            for k, v in attribs[b'_new_parent'].items()}
         self._new_executability = {
             k.decode('utf-8'): bool(v)
-            for k, v in viewitems(attribs[b'_new_executability'])}
+            for k, v in attribs[b'_new_executability'].items()}
         self._new_id = {k.decode('utf-8'): v
-                        for k, v in viewitems(attribs[b'_new_id'])}
-        self._r_new_id = {v: k for k, v in viewitems(self._new_id)}
+                        for k, v in attribs[b'_new_id'].items()}
+        self._r_new_id = {v: k for k, v in self._new_id.items()}
         self._tree_path_ids = {}
         self._tree_id_paths = {}
-        for bytepath, trans_id in viewitems(attribs[b'_tree_path_ids']):
+        for bytepath, trans_id in attribs[b'_tree_path_ids'].items():
             path = bytepath.decode('utf-8')
             trans_id = trans_id.decode('utf-8')
             self._tree_path_ids[path] = trans_id
@@ -1189,7 +1182,7 @@
             for trans_id in attribs[b'_removed_contents'])
         self._non_present_ids = {
             k: v.decode('utf-8')
-            for k, v in viewitems(attribs[b'_non_present_ids'])}
+            for k, v in attribs[b'_non_present_ids'].items()}
         for ((trans_id, kind),), content in records:
             trans_id = trans_id.decode('utf-8')
             kind = kind.decode('ascii')
@@ -1280,7 +1273,7 @@
         if self._tree is None:
             return
         try:
-            limbo_paths = list(viewvalues(self._limbo_files))
+            limbo_paths = list(self._limbo_files.values())
             limbo_paths.extend(self._possibly_stale_limbo_files)
             limbo_paths.sort(reverse=True)
             for path in limbo_paths:
@@ -1748,8 +1741,8 @@
                             in (trans_id, None)):
                         use_direct_path = True
                 else:
-                    for l_filename, l_trans_id in viewitems(
-                            self._limbo_children_names[parent]):
+                    for l_filename, l_trans_id in (
+                            self._limbo_children_names[parent].items()):
                         if l_trans_id == trans_id:
                             continue
                         if l_filename.lower() == filename.lower():
@@ -1878,7 +1871,7 @@
 
         If inventory_delta is None, no inventory delta generation is performed.
         """
-        tree_paths = sorted(viewitems(self._tree_path_ids), reverse=True)
+        tree_paths = sorted(self._tree_path_ids.items(), reverse=True)
         with ui.ui_factory.nested_progress_bar() as child_pb:
             for num, (path, trans_id) in enumerate(tree_paths):
                 # do not attempt to move root into a subdirectory of itself.
@@ -1963,7 +1956,7 @@
         #       problems. (we could observe start time, and finish time, and if
         #       it is less than eg 10% overhead, add a sleep call.)
         paths = FinalPaths(self)
-        for trans_id, observed in viewitems(self._observed_sha1s):
+        for trans_id, observed in self._observed_sha1s.items():
             path = paths.get_path(trans_id)
             self._tree._observed_sha1(path, observed)
 
@@ -2110,7 +2103,7 @@
         tree_ids = set(self._transform._tree.all_file_ids())
         tree_ids.difference_update(self._transform.tree_file_id(t)
                                    for t in self._transform._removed_id)
-        tree_ids.update(viewvalues(self._transform._new_id))
+        tree_ids.update(self._transform._new_id.values())
         return tree_ids
 
     def all_versioned_paths(self):
@@ -2408,7 +2401,7 @@
                 executable = None
             if kind == 'symlink':
                 link_or_sha1 = os.readlink(limbo_name)
-                if not isinstance(link_or_sha1, text_type):
+                if not isinstance(link_or_sha1, str):
                     link_or_sha1 = link_or_sha1.decode(osutils._fs_enc)
         executable = tt._new_executability.get(trans_id, executable)
         return kind, size, executable, link_or_sha1
@@ -2593,7 +2586,7 @@
     :param delta_from_tree: If true, build_tree may use the input Tree to
         generate the inventory delta.
     """
-    with cleanup.ExitStack() as exit_stack:
+    with contextlib.ExitStack() as exit_stack:
         exit_stack.enter_context(wt.lock_tree_write())
         exit_stack.enter_context(tree.lock_read())
         if accelerator_tree is not None:
@@ -2702,7 +2695,7 @@
             precomputed_delta = None
         conflicts = cook_conflicts(raw_conflicts, tt)
         for conflict in conflicts:
-            trace.warning(text_type(conflict))
+            trace.warning(str(conflict))
         try:
             wt.add_conflicts(conflicts)
         except errors.UnsupportedOperation:
@@ -2896,7 +2889,7 @@
                     unversioned_filter=working_tree.is_ignored)
                 delta.report_changes(tt.iter_changes(), change_reporter)
             for conflict in conflicts:
-                trace.warning(text_type(conflict))
+                trace.warning(str(conflict))
             pp.next_phase()
             tt.apply()
             if working_tree.supports_merge_modified():

=== modified file 'breezy/transport/__init__.py'
--- breezy/transport/__init__.py	2019-09-21 11:49:02 +0000
+++ breezy/transport/__init__.py	2020-02-18 01:57:45 +0000
@@ -26,18 +26,12 @@
 it.
 """
 
-from __future__ import absolute_import
-
 import errno
+from io import BytesIO
 import sys
 
 from stat import S_ISDIR
 
-from ..sixish import (
-    BytesIO,
-    PY3,
-    string_types,
-    )
 from ..trace import (
     mutter,
     )

=== modified file 'breezy/transport/brokenrename.py'
--- breezy/transport/brokenrename.py	2018-11-11 04:08:32 +0000
+++ breezy/transport/brokenrename.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 """Transport implementation that doesn't detect clashing renames.
 """
 
-from __future__ import absolute_import
-
 from .. import (
     errors,
     urlutils,

=== modified file 'breezy/transport/chroot.py'
--- breezy/transport/chroot.py	2017-05-22 00:56:52 +0000
+++ breezy/transport/chroot.py	2020-02-18 01:57:45 +0000
@@ -18,8 +18,6 @@
 root.
 """
 
-from __future__ import absolute_import
-
 from . import (
     pathfilter,
     register_transport,

=== modified file 'breezy/transport/decorator.py'
--- breezy/transport/decorator.py	2018-11-11 04:08:32 +0000
+++ breezy/transport/decorator.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 stub functions to allow other decorators to be written easily.
 """
 
-from __future__ import absolute_import
-
 from . import (Transport, get_transport)
 
 

=== modified file 'breezy/transport/fakenfs.py'
--- breezy/transport/fakenfs.py	2018-11-11 04:08:32 +0000
+++ breezy/transport/fakenfs.py	2020-02-18 01:57:45 +0000
@@ -22,8 +22,6 @@
 To get a fake nfs transport use get_transport('fakenfs+' + real_url)
 """
 
-from __future__ import absolute_import
-
 from stat import S_ISDIR
 
 from .. import (

=== modified file 'breezy/transport/fakevfat.py'
--- breezy/transport/fakevfat.py	2018-11-11 04:08:32 +0000
+++ breezy/transport/fakevfat.py	2020-02-18 01:57:45 +0000
@@ -38,8 +38,6 @@
 
 """
 
-from __future__ import absolute_import
-
 import re
 
 from . import decorator

=== modified file 'breezy/transport/gio_transport.py'
--- breezy/transport/gio_transport.py	2018-11-11 04:08:32 +0000
+++ breezy/transport/gio_transport.py	2020-02-18 01:57:45 +0000
@@ -24,23 +24,15 @@
 supported by gio.
 """
 
-from __future__ import absolute_import
-
 from io import BytesIO
 import os
 import random
 import stat
 import time
-try:
-    from urllib.parse import (
-        urlparse,
-        urlunparse,
-        )
-except ImportError:
-    from urlparse import (
-        urlparse,
-        urlunparse,
-        )
+from urllib.parse import (
+    urlparse,
+    urlunparse,
+    )
 
 from .. import (
     config,
@@ -50,9 +42,6 @@
     debug,
     ui,
     )
-from ..sixish import (
-    text_type,
-    )
 from ..trace import mutter
 from . import (
     FileStream,
@@ -154,7 +143,7 @@
 
     def _relpath_to_url(self, relpath):
         full_url = urlutils.join(self.url, relpath)
-        if isinstance(full_url, text_type):
+        if isinstance(full_url, str):
             raise urlutils.InvalidURL(full_url)
         return full_url
 

=== modified file 'breezy/transport/http/__init__.py'
--- breezy/transport/http/__init__.py	2020-01-12 23:41:10 +0000
+++ breezy/transport/http/__init__.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 There are separate implementation modules for each http client implementation.
 """
 
-from __future__ import absolute_import
-
 DEBUG = 0
 
 import base64
@@ -35,19 +33,9 @@
 import urllib
 import weakref
 
-try:
-    import http.client as http_client
-except ImportError:
-    import httplib as http_client
-try:
-    import urllib.request as urllib_request
-except ImportError:  # python < 3
-    import urllib2 as urllib_request
-try:
-    from urllib.parse import urljoin, splitport, splittype, splithost, urlencode
-except ImportError:
-    from urlparse import urljoin
-    from urllib import splitport, splittype, splithost, urlencode
+import http.client as http_client
+import urllib.request as urllib_request
+from urllib.parse import urljoin, splitport, splittype, splithost, urlencode
 
 # TODO: handle_response should be integrated into the http/__init__.py
 from .response import handle_response
@@ -73,11 +61,6 @@
     urlutils,
 )
 from ...bzr.smart import medium
-from ...sixish import (
-    PY3,
-    reraise,
-    text_type,
-)
 from ...trace import mutter
 from ...transport import (
     ConnectedTransport,
@@ -89,18 +72,6 @@
     return 'Breezy/%s' % breezy_version
 
 
-try:
-    _ = (ssl.match_hostname, ssl.CertificateError)
-except AttributeError:
-    # Provide fallbacks for python < 2.7.9
-    def match_hostname(cert, host):
-        trace.warning(
-            '%s cannot be verified, https certificates verification is only'
-            ' available for python versions >= 2.7.9' % (host,))
-    ssl.match_hostname = match_hostname
-    ssl.CertificateError = ValueError
-
-
 # Note for packagers: if there is no package providing certs for your platform,
 # the curl project produces http://curl.haxx.se/ca/cacert.pem weekly.
 _ssl_ca_certs_known_locations = [
@@ -186,26 +157,6 @@
 kerberos = None
 
 
-class addinfourl(urllib_request.addinfourl):
-    '''Replacement addinfourl class compatible with python-2.7's xmlrpclib
-
-    In python-2.7, xmlrpclib expects that the response object that it receives
-    has a getheader method.  http_client.HTTPResponse provides this but
-    urllib_request.addinfourl does not.  Add the necessary functions here, ported to
-    use the internal data structures of addinfourl.
-    '''
-
-    def getheader(self, name, default=None):
-        if self.headers is None:
-            raise http_client.ResponseNotReady()
-        return self.headers.getheader(name, default)
-
-    def getheaders(self):
-        if self.headers is None:
-            raise http_client.ResponseNotReady()
-        return list(self.headers.items())
-
-
 class _ReportingFileSocket(object):
 
     def __init__(self, filesock, report_activity=None):
@@ -284,11 +235,10 @@
     # 8k chunks should be fine.
     _discarded_buf_size = 8192
 
-    if PY3:
-        def __init__(self, sock, debuglevel=0, method=None, url=None):
-            self.url = url
-            super(Response, self).__init__(
-                sock, debuglevel=debuglevel, method=method, url=url)
+    def __init__(self, sock, debuglevel=0, method=None, url=None):
+        self.url = url
+        super(Response, self).__init__(
+            sock, debuglevel=debuglevel, method=method, url=url)
 
     def begin(self):
         """Begin to read the response from the server.
@@ -424,11 +374,7 @@
     def __init__(self, host, port=None, proxied_host=None,
                  report_activity=None, ca_certs=None):
         AbstractHTTPConnection.__init__(self, report_activity=report_activity)
-        if PY3:
-            http_client.HTTPConnection.__init__(self, host, port)
-        else:
-            # Use strict=True since we don't support HTTP/0.9
-            http_client.HTTPConnection.__init__(self, host, port, strict=True)
+        http_client.HTTPConnection.__init__(self, host, port)
         self.proxied_host = proxied_host
         # ca_certs is ignored, it's only relevant for https
 
@@ -445,13 +391,8 @@
                  proxied_host=None,
                  report_activity=None, ca_certs=None):
         AbstractHTTPConnection.__init__(self, report_activity=report_activity)
-        if PY3:
-            http_client.HTTPSConnection.__init__(
-                self, host, port, key_file, cert_file)
-        else:
-            # Use strict=True since we don't support HTTP/0.9
-            http_client.HTTPSConnection.__init__(self, host, port,
-                                                 key_file, cert_file, strict=True)
+        http_client.HTTPSConnection.__init__(
+            self, host, port, key_file, cert_file)
         self.proxied_host = proxied_host
         self.ca_certs = ca_certs
 
@@ -547,10 +488,7 @@
 
     def set_proxy(self, proxy, type):
         """Set the proxy and remember the proxied host."""
-        if PY3:
-            host, port = splitport(self.host)
-        else:
-            host, port = splitport(self.get_host())
+        host, port = splitport(self.host)
         if port is None:
             # We need to set the default port ourselves way before it gets set
             # in the HTTP[S]Connection object at build time.
@@ -722,17 +660,14 @@
         exc_type, exc_val, exc_tb = sys.exc_info()
         if exc_type == socket.gaierror:
             # No need to retry, that will not help
-            if PY3:
-                origin_req_host = request.origin_req_host
-            else:
-                origin_req_host = request.get_origin_req_host()
+            origin_req_host = request.origin_req_host
             raise errors.ConnectionError("Couldn't resolve host '%s'"
                                          % origin_req_host,
                                          orig_error=exc_val)
         elif isinstance(exc_val, http_client.ImproperConnectionState):
             # The http_client pipeline is in incorrect state, it's a bug in our
             # implementation.
-            reraise(exc_type, exc_val, exc_tb)
+            raise exc_val
         else:
             if first_try:
                 if self._debuglevel >= 2:
@@ -771,10 +706,7 @@
                     # far outside our scope, so closing the
                     # connection and retrying is the best we can
                     # do.
-                    if PY3:
-                        selector = request.selector
-                    else:
-                        selector = request.get_selector()
+                    selector = request.selector
                     my_exception = errors.ConnectionError(
                         msg='while sending %s %s:' % (request.get_method(),
                                                       selector),
@@ -786,7 +718,7 @@
                     url = request.get_full_url()
                     print('  Failed again, %s %r' % (method, url))
                     print('  Will raise: [%r]' % my_exception)
-                reraise(type(my_exception), my_exception, exc_tb)
+                raise my_exception.with_traceback(exc_tb)
         return response
 
     def do_open(self, http_class, request, first_try=True):
@@ -813,10 +745,7 @@
 
         try:
             method = request.get_method()
-            if PY3:
-                url = request.selector
-            else:
-                url = request.get_selector()
+            url = request.selector
             if sys.version_info[:2] >= (3, 6):
                 connection._send_request(method, url,
                                          # FIXME: implements 100-continue
@@ -853,57 +782,8 @@
             response = self.retry_or_raise(http_class, request, first_try)
             convert_to_addinfourl = False
 
-        if PY3:
-            response.msg = response.reason
-            return response
-
-# FIXME: HTTPConnection does not fully support 100-continue (the
-# server responses are just ignored)
-
-#        if code == 100:
-#            mutter('Will send the body')
-#            # We can send the body now
-#            body = request.data
-#            if body is None:
-#                raise URLError("No data given")
-#            connection.send(body)
-#            response = connection.getresponse()
-
-        if self._debuglevel >= 2:
-            print('Receives response: %r' % response)
-            print('  For: %r(%r)' % (request.get_method(),
-                                     request.get_full_url()))
-
-        if convert_to_addinfourl:
-            # Shamelessly copied from urllib_request
-            req = request
-            r = response
-            r.recv = r.read
-            fp = socket._fileobject(r, bufsize=65536)
-            resp = addinfourl(fp, r.msg, req.get_full_url())
-            resp.code = r.status
-            resp.msg = r.reason
-            resp.version = r.version
-            if self._debuglevel >= 2:
-                print('Create addinfourl: %r' % resp)
-                print('  For: %r(%r)' % (request.get_method(),
-                                         request.get_full_url()))
-            if 'http' in debug.debug_flags:
-                version = 'HTTP/%d.%d'
-                try:
-                    version = version % (resp.version / 10,
-                                         resp.version % 10)
-                except:
-                    version = 'HTTP/%r' % resp.version
-                trace.mutter('< %s %s %s' % (version, resp.code,
-                                             resp.msg))
-                # Use the raw header lines instead of treating resp.info() as a
-                # dict since we may miss duplicated headers otherwise.
-                hdrs = [h.rstrip('\r\n') for h in resp.info().headers]
-                trace.mutter('< ' + '\n< '.join(hdrs) + '\n')
-        else:
-            resp = response
-        return resp
+        response.msg = response.reason
+        return response
 
 
 class HTTPHandler(AbstractHTTPHandler):
@@ -997,10 +877,7 @@
         # and that we MAY avoid following the redirections. But
         # if we want to be sure, we MUST follow them.
 
-        if PY3:
-            origin_req_host = req.origin_req_host
-        else:
-            origin_req_host = req.get_origin_req_host()
+        origin_req_host = req.origin_req_host
 
         if code in (301, 302, 303, 307):
             return Request(req.get_method(), newurl,
@@ -1185,10 +1062,7 @@
         return None
 
     def set_proxy(self, request, type):
-        if PY3:
-            host = request.host
-        else:
-            host = request.get_host()
+        host = request.host
         if self.proxy_bypass(host):
             return request
 
@@ -1323,10 +1197,7 @@
                 # Let's be ready for next round
                 self._retry_count = None
                 return None
-        if PY3:
-            server_headers = headers.get_all(self.auth_required_header)
-        else:
-            server_headers = headers.getheaders(self.auth_required_header)
+        server_headers = headers.get_all(self.auth_required_header)
         if not server_headers:
             # The http error MUST have the associated
             # header. This must never happen in production code.
@@ -1684,10 +1555,7 @@
         return True
 
     def build_auth_header(self, auth, request):
-        if PY3:
-            selector = request.selector
-        else:
-            selector = request.get_selector()
+        selector = request.selector
         url_scheme, url_selector = splittype(selector)
         sel_host, uri = splithost(url_selector)
 
@@ -2005,10 +1873,7 @@
             def getheader(self, name, default=None):
                 if self._actual.headers is None:
                     raise http_client.ResponseNotReady()
-                if PY3:
-                    return self._actual.headers.get(name, default)
-                else:
-                    return self._actual.headers.getheader(name, default)
+                return self._actual.headers.get(name, default)
 
             def getheaders(self):
                 if self._actual.headers is None:

=== modified file 'breezy/transport/http/ca_bundle.py'
--- breezy/transport/http/ca_bundle.py	2017-05-22 00:56:52 +0000
+++ breezy/transport/http/ca_bundle.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Auto-detect of CA bundle for SSL connections"""
 
-from __future__ import absolute_import
-
 import os
 import sys
 from ...trace import mutter

=== modified file 'breezy/transport/http/response.py'
--- breezy/transport/http/response.py	2019-05-19 23:13:46 +0000
+++ breezy/transport/http/response.py	2020-02-18 01:57:45 +0000
@@ -21,27 +21,16 @@
 responses.
 """
 
-from __future__ import absolute_import
-
 import cgi
+from io import BytesIO
 import os
-try:
-    import http.client as http_client
-except ImportError:  # python < 3
-    import httplib as http_client
-try:
-    import email.utils as email_utils
-except ImportError:  # python < 3
-    import rfc822 as email_utils
+import http.client as http_client
+import email.utils as email_utils
 
 from ... import (
     errors,
     osutils,
     )
-from ...sixish import (
-    BytesIO,
-    PY3,
-    )
 
 
 class ResponseFile(object):
@@ -80,8 +69,6 @@
         :param size:  The number of bytes to read.  Leave unspecified or pass
             -1 to read to EOF.
         """
-        if size is None and not PY3:
-            size = -1
         data = self._file.read(size)
         self._pos += len(data)
         return data
@@ -220,10 +207,7 @@
         Parse the headers including the empty line following them so that we
         are ready to read the data itself.
         """
-        if PY3:
-            self._headers = http_client.parse_headers(self._file)
-        else:
-            self._headers = http_client.HTTPMessage(self._file, seekable=0)
+        self._headers = http_client.parse_headers(self._file)
         # Extract the range definition
         content_range = self._headers.get('content-range', None)
         if content_range is None:

=== modified file 'breezy/transport/http/wsgi.py'
--- breezy/transport/http/wsgi.py	2018-11-11 04:08:32 +0000
+++ breezy/transport/http/wsgi.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
     http://www.python.org/dev/peps/pep-0333/
 """
 
-from __future__ import absolute_import
-
 from io import BytesIO
 
 from ...bzr.smart import medium

=== modified file 'breezy/transport/local.py'
--- breezy/transport/local.py	2019-03-04 00:16:27 +0000
+++ breezy/transport/local.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 This is a fairly thin wrapper on regular file IO.
 """
 
-from __future__ import absolute_import
-
 import os
 from stat import ST_MODE, S_ISDIR, S_IMODE
 import sys

=== modified file 'breezy/transport/log.py'
--- breezy/transport/log.py	2019-06-16 19:53:27 +0000
+++ breezy/transport/log.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Transport decorator that logs transport operations to brz.log."""
 
-from __future__ import absolute_import
-
 # see also the transportstats plugin, which gives you some summary information
 # in a machine-readable dump
 

=== modified file 'breezy/transport/memory.py'
--- breezy/transport/memory.py	2019-03-04 01:49:32 +0000
+++ breezy/transport/memory.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 so this is primarily useful for testing.
 """
 
-from __future__ import absolute_import
-
 import contextlib
 from io import (
     BytesIO,

=== modified file 'breezy/transport/nosmart.py'
--- breezy/transport/nosmart.py	2018-11-11 04:08:32 +0000
+++ breezy/transport/nosmart.py	2020-02-18 01:57:45 +0000
@@ -21,8 +21,6 @@
 to never have a smart medium.
 """
 
-from __future__ import absolute_import
-
 from .. import errors
 from ..transport import decorator
 

=== modified file 'breezy/transport/pathfilter.py'
--- breezy/transport/pathfilter.py	2018-11-11 04:08:32 +0000
+++ breezy/transport/pathfilter.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """A transport decorator that filters all paths that are passed to it."""
 
-from __future__ import absolute_import
-
 from .. import urlutils
 
 from . import (

=== modified file 'breezy/transport/readonly.py'
--- breezy/transport/readonly.py	2017-05-22 00:56:52 +0000
+++ breezy/transport/readonly.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Implementation of Transport that adapts another transport to be readonly."""
 
-from __future__ import absolute_import
-
 from ..errors import TransportNotPossible, NoSmartMedium
 from ..transport import decorator
 

=== modified file 'breezy/transport/remote.py'
--- breezy/transport/remote.py	2019-02-04 21:06:48 +0000
+++ breezy/transport/remote.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 imported from breezy.bzr.smart.
 """
 
-from __future__ import absolute_import
-
 __all__ = ['RemoteTransport', 'RemoteTCPTransport', 'RemoteSSHTransport']
 
 from io import BytesIO
@@ -37,7 +35,6 @@
 from ..bzr import (
     remote,
     )
-from ..sixish import PY3
 from ..bzr.smart import client, medium
 
 
@@ -472,13 +469,13 @@
     def list_dir(self, relpath):
         resp = self._call2(b'list_dir', self._remote_path(relpath))
         if resp[0] == b'names':
-            return [name.decode('utf-8') if PY3 else name for name in resp[1:]]
+            return [name.decode('utf-8') for name in resp[1:]]
         raise errors.UnexpectedSmartServerResponse(resp)
 
     def iter_files_recursive(self):
         resp = self._call2(b'iter_files_recursive', self._remote_path(''))
         if resp[0] == b'names':
-            return [name.decode('utf-8') if PY3 else name for name in resp[1:]]
+            return [name.decode('utf-8') for name in resp[1:]]
         raise errors.UnexpectedSmartServerResponse(resp)
 
 

=== modified file 'breezy/transport/sftp.py'
--- breezy/transport/sftp.py	2018-11-11 04:08:32 +0000
+++ breezy/transport/sftp.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Implementation of Transport over SFTP, using paramiko."""
 
-from __future__ import absolute_import
-
 # TODO: Remove the transport-based lock_read and lock_write methods.  They'll
 # then raise TransportNotPossible, which will break remote access to any
 # formats which rely on OS-level locks.  That should be fine as those formats
@@ -49,9 +47,6 @@
                       ParamikoNotPresent,
                       )
 from ..osutils import fancy_rename
-from ..sixish import (
-    zip,
-    )
 from ..trace import mutter, warning
 from ..transport import (
     FileFileStream,

=== modified file 'breezy/transport/ssh.py'
--- breezy/transport/ssh.py	2019-06-26 00:13:55 +0000
+++ breezy/transport/ssh.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Foundation SSH support for SFTP and smart server."""
 
-from __future__ import absolute_import
-
 import errno
 import getpass
 import logging

=== modified file 'breezy/transport/trace.py'
--- breezy/transport/trace.py	2018-11-18 19:48:57 +0000
+++ breezy/transport/trace.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 and then delegates it.
 """
 
-from __future__ import absolute_import
-
 from ..transport import decorator
 
 

=== modified file 'breezy/transport/unlistable.py'
--- breezy/transport/unlistable.py	2018-11-11 04:08:32 +0000
+++ breezy/transport/unlistable.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Transport implementation that disables listing to simulate HTTP cheaply."""
 
-from __future__ import absolute_import
-
 from ..transport import Transport
 from ..transport import decorator
 

=== modified file 'breezy/tree.py'
--- breezy/tree.py	2020-02-08 22:40:33 +0000
+++ breezy/tree.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 """Tree classes, representing directory at point in time.
 """
 
-from __future__ import absolute_import
-
 try:
     from collections.abc import deque
 except ImportError:  # python < 3.7
@@ -45,10 +43,6 @@
     osutils,
     )
 from .inter import InterObject
-from .sixish import (
-    text_type,
-    viewvalues,
-    )
 
 
 class FileTimestampUnavailable(errors.BzrError):

=== modified file 'breezy/treebuilder.py'
--- breezy/treebuilder.py	2018-05-27 16:53:07 +0000
+++ breezy/treebuilder.py	2020-02-18 01:57:45 +0000
@@ -20,8 +20,6 @@
 can be extremely useful in testing for instance.
 """
 
-from __future__ import absolute_import
-
 from . import errors
 
 

=== modified file 'breezy/tsort.py'
--- breezy/tsort.py	2018-11-16 12:25:18 +0000
+++ breezy/tsort.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Topological sorting routines."""
 
-from __future__ import absolute_import
-
 
 from . import (
     errors,

=== modified file 'breezy/tuned_gzip.py'
--- breezy/tuned_gzip.py	2018-11-11 04:08:32 +0000
+++ breezy/tuned_gzip.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """Legacy breezy specific gzip tunings."""
 
-from __future__ import absolute_import
-
 import struct
 import zlib
 

=== modified file 'breezy/ui/__init__.py'
--- breezy/ui/__init__.py	2018-11-16 11:52:31 +0000
+++ breezy/ui/__init__.py	2020-02-18 01:57:45 +0000
@@ -41,8 +41,6 @@
     back to working through the terminal.
 """
 
-from __future__ import absolute_import
-
 import warnings
 
 from ..lazy_import import lazy_import
@@ -54,12 +52,6 @@
     )
 """)
 
-from ..sixish import (
-    PY3,
-    string_types,
-    text_type,
-    )
-
 
 _valid_boolean_strings = dict(yes=True, no=False,
                               y=True, n=False,
@@ -89,7 +81,7 @@
     if accepted_values is None:
         accepted_values = _valid_boolean_strings
     val = None
-    if isinstance(s, string_types):
+    if isinstance(s, str):
         try:
             val = accepted_values[s.lower()]
         except KeyError:
@@ -319,14 +311,14 @@
             fail = "brz warning: %r, %r" % (warning_id, message_args)
             warnings.warn("no template for warning: "
                           + fail)   # so tests will fail etc
-            return text_type(fail)
+            return str(fail)
         try:
-            return text_type(template) % message_args
+            return str(template) % message_args
         except ValueError as e:
             fail = "brz unprintable warning: %r, %r, %s" % (
                 warning_id, message_args, e)
             warnings.warn(fail)   # so tests will fail etc
-            return text_type(fail)
+            return str(fail)
 
     def choose(self, msg, choices, default=None):
         """Prompt the user for a list of alternatives.

=== modified file 'breezy/ui/text.py'
--- breezy/ui/text.py	2019-02-15 01:17:22 +0000
+++ breezy/ui/text.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Text UI, write output to the console."""
 
-from __future__ import absolute_import
-
 import codecs
 import io
 import os
@@ -40,9 +38,6 @@
     osutils,
     trace,
     )
-from ..sixish import (
-    text_type,
-    )
 from . import (
     NullProgressView,
     UIFactory,
@@ -325,7 +320,7 @@
         :param kwargs: Dictionary of arguments to insert into the prompt,
             to allow UIs to reformat the prompt.
         """
-        if not isinstance(prompt, text_type):
+        if not isinstance(prompt, str):
             raise ValueError("prompt %r not a unicode string" % prompt)
         if kwargs:
             # See <https://launchpad.net/bugs/365891>

=== modified file 'breezy/uncommit.py'
--- breezy/uncommit.py	2018-11-12 01:41:38 +0000
+++ breezy/uncommit.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Remove the last revision from the history of the current branch."""
 
-from __future__ import absolute_import
-
 # TODO: make the guts of this methods on tree, branch.
 
 from . import (

=== modified file 'breezy/upgrade.py'
--- breezy/upgrade.py	2019-07-07 17:24:23 +0000
+++ breezy/upgrade.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """brz upgrade logic."""
 
-from __future__ import absolute_import
-
 from . import (
     errors,
     trace,

=== modified file 'breezy/upstream_import.py'
--- breezy/upstream_import.py	2019-06-17 23:01:58 +0000
+++ breezy/upstream_import.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Import upstream source into a branch"""
 
-from __future__ import absolute_import
-
 import errno
 from io import (
     BytesIO,
@@ -34,9 +32,6 @@
 from .errors import (BzrError, NoSuchFile, BzrCommandError, NotBranchError)
 from .osutils import (pathjoin, isdir, file_iterator, basename,
                       file_kind, splitpath)
-from .sixish import (
-    text_type,
-    )
 from .trace import warning
 from .transform import resolve_conflicts, cook_conflicts
 from .transport import get_transport
@@ -258,7 +253,7 @@
         # interpret relative to fs encoding, which would match native
         # behaviour better.
         relative_path = member.name
-        if not isinstance(relative_path, text_type):
+        if not isinstance(relative_path, str):
             relative_path = relative_path.decode('utf-8')
         if prefix is not None:
             relative_path = relative_path[len(prefix) + 1:]

=== modified file 'breezy/url_policy_open.py'
--- breezy/url_policy_open.py	2019-06-09 19:08:17 +0000
+++ breezy/url_policy_open.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Branch opening with URL-based restrictions."""
 
-from __future__ import absolute_import
-
 import threading
 
 from . import (

=== modified file 'breezy/urlutils.py'
--- breezy/urlutils.py	2020-01-12 14:46:54 +0000
+++ breezy/urlutils.py	2020-02-18 01:57:45 +0000
@@ -16,16 +16,11 @@
 
 """A collection of function for handling URL operations."""
 
-from __future__ import absolute_import
-
 import os
 import re
 import sys
 
-try:
-    import urlparse
-except ImportError:
-    from urllib import parse as urlparse
+from urllib import parse as urlparse
 
 from . import (
     errors,
@@ -37,12 +32,6 @@
 from posixpath import split as _posix_split
 """)
 
-from .sixish import (
-    int2byte,
-    PY3,
-    text_type,
-    unichr,
-    )
 
 
 class InvalidURL(errors.PathError):
@@ -99,74 +88,14 @@
     return split(url, exclude_trailing_slash=exclude_trailing_slash)[0]
 
 
-if PY3:
-    quote_from_bytes = urlparse.quote_from_bytes
-    quote = urlparse.quote
-    unquote_to_bytes = urlparse.unquote_to_bytes
-else:
-    # Private copies of quote and unquote, copied from Python's urllib module
-    # because urllib unconditionally imports socket, which imports ssl.
-
-    always_safe = ('ABCDEFGHIJKLMNOPQRSTUVWXYZ'
-                   'abcdefghijklmnopqrstuvwxyz'
-                   '0123456789' '_.-')
-    _safe_map = {}
-    for i, c in zip(range(256), ''.join(map(chr, range(256)))):
-        _safe_map[c] = c if (
-            i < 128 and c in always_safe) else '%{0:02X}'.format(i)
-    _safe_quoters = {}
-
-    def quote_from_bytes(s, safe='/'):
-        """quote('abc def') -> 'abc%20def'
-
-        Each part of a URL, e.g. the path info, the query, etc., has a
-        different set of reserved characters that must be quoted.
-
-        RFC 2396 Uniform Resource Identifiers (URI): Generic Syntax lists
-        the following reserved characters.
-
-        reserved    = ";" | "/" | "?" | ":" | "@" | "&" | "=" | "+" |
-                      "$" | ","
-
-        Each of these characters is reserved in some component of a URL,
-        but not necessarily in all of them.
-
-        By default, the quote function is intended for quoting the path
-        section of a URL.  Thus, it will not encode '/'.  This character
-        is reserved, but in typical usage the quote function is being
-        called on a path where the existing slash characters are used as
-        reserved characters.
-        """
-        # fastpath
-        if not s:
-            if s is None:
-                raise TypeError('None object cannot be quoted')
-            return s
-        cachekey = (safe, always_safe)
-        try:
-            (quoter, safe) = _safe_quoters[cachekey]
-        except KeyError:
-            safe_map = _safe_map.copy()
-            safe_map.update([(c, c) for c in safe])
-            quoter = safe_map.__getitem__
-            safe = always_safe + safe
-            _safe_quoters[cachekey] = (quoter, safe)
-        if not s.rstrip(safe):
-            return s
-        return ''.join(map(quoter, s))
-
-    quote = quote_from_bytes
-    unquote_to_bytes = urlparse.unquote
-
-
+quote_from_bytes = urlparse.quote_from_bytes
+quote = urlparse.quote
+unquote_to_bytes = urlparse.unquote_to_bytes
 unquote = urlparse.unquote
 
 
 def escape(relpath, safe='/~'):
     """Escape relpath to be a valid url."""
-    if not isinstance(relpath, str) and sys.version_info[0] == 2:
-        # GZ 2019-06-16: Should use _fs_enc instead here really?
-        relpath = relpath.encode('utf-8')
     return quote(relpath, safe=safe)
 
 
@@ -411,7 +340,7 @@
         return local_path_to_url(url)
     prefix = url[:path_start]
     path = url[path_start:]
-    if not isinstance(url, text_type):
+    if not isinstance(url, str):
         for c in url:
             if c not in _url_safe_characters:
                 raise InvalidURL(url, 'URLs can only contain specific'
@@ -691,28 +620,13 @@
     #       try to encode the UNICODE => ASCII, and then decode
     #       it into utf-8.
 
-    if PY3:
-        if isinstance(url, text_type):
-            try:
-                url.encode("ascii")
-            except UnicodeError as e:
-                raise InvalidURL(
-                    url, 'URL was not a plain ASCII url: %s' % (e,))
-        return urlparse.unquote(url)
-    else:
-        if isinstance(url, text_type):
-            try:
-                url = url.encode("ascii")
-            except UnicodeError as e:
-                raise InvalidURL(
-                    url, 'URL was not a plain ASCII url: %s' % (e,))
-        unquoted = unquote(url)
+    if isinstance(url, str):
         try:
-            unicode_path = unquoted.decode('utf-8')
+            url.encode("ascii")
         except UnicodeError as e:
             raise InvalidURL(
-                url, 'Unable to encode the URL as utf-8: %s' % (e,))
-        return unicode_path
+                url, 'URL was not a plain ASCII url: %s' % (e,))
+    return urlparse.unquote(url)
 
 
 # These are characters that if escaped, should stay that way
@@ -720,8 +634,8 @@
 _no_decode_ords = [ord(c) for c in _no_decode_chars]
 _no_decode_hex = (['%02x' % o for o in _no_decode_ords]
                   + ['%02X' % o for o in _no_decode_ords])
-_hex_display_map = dict(([('%02x' % o, int2byte(o)) for o in range(256)]
-                         + [('%02X' % o, int2byte(o)) for o in range(256)]))
+_hex_display_map = dict(([('%02x' % o, bytes([o])) for o in range(256)]
+                         + [('%02X' % o, bytes([o])) for o in range(256)]))
 # These entries get mapped to themselves
 _hex_display_map.update((hex, b'%' + hex.encode('ascii'))
                         for hex in _no_decode_hex)
@@ -765,11 +679,10 @@
             escaped_chunks[j] = _hex_display_map[item[:2]]
         except KeyError:
             # Put back the percent symbol
-            escaped_chunks[j] = b'%' + \
-                (item[:2].encode('utf-8') if PY3 else item[:2])
+            escaped_chunks[j] = b'%' + (item[:2].encode('utf-8'))
         except UnicodeDecodeError:
-            escaped_chunks[j] = unichr(int(item[:2], 16)).encode('utf-8')
-        escaped_chunks[j] += (item[2:].encode('utf-8') if PY3 else item[2:])
+            escaped_chunks[j] = chr(int(item[:2], 16)).encode('utf-8')
+        escaped_chunks[j] += (item[2:].encode('utf-8'))
     unescaped = b''.join(escaped_chunks)
     try:
         decoded = unescaped.decode('utf-8')
@@ -933,7 +846,7 @@
         # unicode.
         if isinstance(url, str):
             pass
-        elif isinstance(url, text_type):
+        elif isinstance(url, str):
             try:
                 url = url.encode()
             except UnicodeEncodeError:
@@ -1004,7 +917,7 @@
         # unicode.
         if isinstance(relpath, str):
             pass
-        elif isinstance(relpath, text_type):
+        elif isinstance(relpath, str):
             try:
                 relpath = relpath.encode()
             except UnicodeEncodeError:
@@ -1042,8 +955,6 @@
         """
         if offset is not None:
             relative = unescape(offset)
-            if sys.version_info[0] == 2:
-                relative = relative.encode('utf-8')
             path = self._combine_paths(self.path, relative)
             path = quote(path, safe="/~")
         else:

=== modified file 'breezy/utextwrap.py'
--- breezy/utextwrap.py	2018-11-11 04:08:32 +0000
+++ breezy/utextwrap.py	2020-02-18 01:57:45 +0000
@@ -23,8 +23,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 import textwrap
 from unicodedata import east_asian_width as _eawidth
 

=== modified file 'breezy/util/__init__.py'
--- breezy/util/__init__.py	2011-12-18 15:28:38 +0000
+++ breezy/util/__init__.py	2020-02-18 01:57:45 +0000
@@ -1,1 +0,0 @@
-from __future__ import absolute_import

=== modified file 'breezy/util/_bencode_py.py'
--- breezy/util/_bencode_py.py	2018-11-11 04:08:32 +0000
+++ breezy/util/_bencode_py.py	2020-02-18 01:57:45 +0000
@@ -15,8 +15,6 @@
 #
 # Modifications copyright (C) 2008 Canonical Ltd
 
-from __future__ import absolute_import
-
 import sys
 
 
@@ -144,12 +142,8 @@
 encode_func = {}
 encode_func[type(Bencached(0))] = encode_bencached
 encode_func[int] = encode_int
-if sys.version_info < (3,):
-    encode_func[long] = encode_int
-    int_to_bytes = str
-else:
-    def int_to_bytes(n):
-        return b'%d' % n
+def int_to_bytes(n):
+    return b'%d' % n
 encode_func[bytes] = encode_string
 encode_func[list] = encode_list
 encode_func[tuple] = encode_list

=== modified file 'breezy/util/simplemapi.py'
--- breezy/util/simplemapi.py	2018-11-11 04:08:32 +0000
+++ breezy/util/simplemapi.py	2020-02-18 01:57:45 +0000
@@ -36,8 +36,6 @@
 software, please contact me at the above email address.
 """
 
-from __future__ import absolute_import
-
 import os
 from ctypes import *
 

=== modified file 'breezy/version.py'
--- breezy/version.py	2019-06-16 01:03:51 +0000
+++ breezy/version.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Report on version of breezy"""
 
-from __future__ import absolute_import
-
 import os
 import platform
 import sys
@@ -30,7 +28,6 @@
     osutils,
     trace,
     )
-from .sixish import text_type
 
 
 def show_version(show_config=True, show_copyright=True, to_file=None):
@@ -71,7 +68,7 @@
     to_file.write("  Python standard library:" + ' ')
     to_file.write(os.path.dirname(os.__file__) + '\n')
     platform_str = platform.platform(aliased=1)
-    if not isinstance(platform_str, text_type):
+    if not isinstance(platform_str, str):
         platform_str = platform_str.decode('utf-8')
     to_file.write("  Platform: %s\n" % platform_str)
     to_file.write("  breezy: ")
@@ -84,7 +81,7 @@
     if show_config:
         config_dir = osutils.normpath(
             bedding.config_dir())  # use native slashes
-        if not isinstance(config_dir, text_type):
+        if not isinstance(config_dir, str):
             config_dir = config_dir.decode(osutils.get_user_encoding())
         to_file.write("  Breezy configuration: %s\n" % (config_dir,))
         to_file.write("  Breezy log file: ")

=== modified file 'breezy/version_info_formats/__init__.py'
--- breezy/version_info_formats/__init__.py	2019-06-30 12:59:05 +0000
+++ breezy/version_info_formats/__init__.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """Routines for extracting all version information from a bzr branch."""
 
-from __future__ import absolute_import
-
 import time
 
 from breezy.osutils import local_time_offset, format_date

=== modified file 'breezy/version_info_formats/format_custom.py'
--- breezy/version_info_formats/format_custom.py	2018-11-11 04:08:32 +0000
+++ breezy/version_info_formats/format_custom.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 """A generator which creates a template-based output from the current
    tree info."""
 
-from __future__ import absolute_import
-
 import codecs
 
 from breezy import errors
@@ -26,7 +24,6 @@
     NULL_REVISION,
     )
 from breezy.lazy_regex import lazy_compile
-from breezy.sixish import PY3
 from breezy.version_info_formats import (
     create_date_str,
     VersionInfoBuilder,
@@ -76,8 +73,6 @@
     def process(self, tpl):
         unicode_escape = codecs.getdecoder("unicode_escape")
         tpl = unicode_escape(tpl)[0]
-        if not PY3:
-            tpl = tpl.encode('utf-8')
         pos = 0
         while True:
             match = self._tag_re.search(tpl, pos)

=== modified file 'breezy/version_info_formats/format_python.py'
--- breezy/version_info_formats/format_python.py	2020-01-31 17:43:44 +0000
+++ breezy/version_info_formats/format_python.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """A generator which creates a python script from the current tree info"""
 
-from __future__ import absolute_import
-
 import pprint
 
 from breezy import errors

=== modified file 'breezy/version_info_formats/format_rio.py'
--- breezy/version_info_formats/format_rio.py	2018-11-11 04:08:32 +0000
+++ breezy/version_info_formats/format_rio.py	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 
 """A generator which creates a rio stanza of the current tree info"""
 
-from __future__ import absolute_import
-
 from breezy import (
     errors,
     hooks,

=== modified file 'breezy/views.py'
--- breezy/views.py	2018-11-12 01:41:38 +0000
+++ breezy/views.py	2020-02-18 01:57:45 +0000
@@ -22,8 +22,6 @@
   tree.views.lookup_view()
 """
 
-from __future__ import absolute_import
-
 import re
 
 from . import (

=== modified file 'breezy/win32utils.py'
--- breezy/win32utils.py	2019-06-16 15:37:44 +0000
+++ breezy/win32utils.py	2020-02-18 01:57:45 +0000
@@ -19,8 +19,6 @@
 Only one dependency: ctypes should be installed.
 """
 
-from __future__ import absolute_import
-
 import glob
 import os
 import struct

=== modified file 'breezy/workingtree.py'
--- breezy/workingtree.py	2020-02-18 03:11:01 +0000
+++ breezy/workingtree.py	2020-02-21 03:58:42 +0000
@@ -27,8 +27,7 @@
 WorkingTree.open(dir).
 """
 
-from __future__ import absolute_import
-
+import contextlib
 import errno
 import os
 import sys
@@ -41,7 +40,6 @@
 import stat
 
 from breezy import (
-    cleanup,
     conflicts as _mod_conflicts,
     filters as _mod_filters,
     merge,
@@ -1002,7 +1000,7 @@
     def revert(self, filenames=None, old_tree=None, backups=True,
                pb=None, report_changes=False):
         from .conflicts import resolve
-        with cleanup.ExitStack() as exit_stack:
+        with contextlib.ExitStack() as exit_stack:
             exit_stack.enter_context(self.lock_tree_write())
             if old_tree is None:
                 basis_tree = self.basis_tree()

=== modified file 'brz'
--- brz	2020-01-31 17:43:44 +0000
+++ brz	2020-02-18 01:57:45 +0000
@@ -16,8 +16,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import absolute_import
-
 """Breezy -- a free distributed version-control tool"""
 
 import os
@@ -25,7 +23,7 @@
 import warnings
 
 # update this on each release
-_script_version = (3, 1, 0)
+_script_version = (3, 2, 0)
 
 NEED_VERS = (2, 7)
 

=== modified file 'doc/developers/releasing.txt'
--- doc/developers/releasing.txt	2019-06-18 10:52:09 +0000
+++ doc/developers/releasing.txt	2020-02-14 00:03:37 +0000
@@ -53,8 +53,8 @@
 Differences in the release process between beta and stable release will be
 mentioned when needed.
 
-When do we relase ?
-===================
+When do we release ?
+====================
 
 As of September 2018, we maintain a single series: 3.0.
 
@@ -105,14 +105,12 @@
 #. Start a new release-notes file::
 
        cd doc/en/release-notes
-       cp series-template.txt brz-x.y.txt  # e.g. brz-3.1.txt
-       brz add brz-3.1.txt
+       brz cp series-template.txt brz-x.y.txt  # e.g. brz-3.1.txt
 
 #. Start a new whats-new file::
 
        cd doc/en/whats-new
-       cp template.txt brz-x.y.txt  # e.g. brz-3.1.txt
-       brz add brz-x.y.txt
+       brz cp template.txt brz-x.y.txt  # e.g. brz-3.1.txt
 
 #. Update ``doc/en/index.txt`` to point to the new whats-new file.
 
@@ -129,7 +127,7 @@
 
 #. Make a local branch to prepare the release::
 
-        brz branch lp:brz/x.y x.y-dev
+       brz branch lp:brz/x.y x.y-dev
 
    If you're doing your first beta release, branch from trunk::
 

=== modified file 'doc/en/index.txt'
--- doc/en/index.txt	2019-03-06 14:23:50 +0000
+++ doc/en/index.txt	2020-02-14 00:03:37 +0000
@@ -10,7 +10,7 @@
 .. toctree::
    :maxdepth: 1
 
-   whats-new/whats-new-in-3.1
+   whats-new/whats-new-in-3.2
    user-guide/index
    tutorials/index
    quick-reference/index

=== added file 'doc/en/release-notes/brz-3.2.txt'
--- doc/en/release-notes/brz-3.2.txt	1970-01-01 00:00:00 +0000
+++ doc/en/release-notes/brz-3.2.txt	2020-02-14 00:03:37 +0000
@@ -0,0 +1,62 @@
+####################
+Breezy Release Notes
+####################
+
+.. toctree::
+   :maxdepth: 1
+
+brz 3.2.0
+#########
+
+:Codename: Nirvana
+:3.2.0: NOT RELEASED YET
+
+External Compatibility Breaks
+*****************************
+
+.. These may require users to change the way they use Breezy.
+
+New Features
+************
+
+.. New commands, options, etc that users may wish to try out.
+
+Improvements
+************
+
+.. Improvements to existing commands, especially improved performance 
+   or memory usage, or better results.
+
+Bug Fixes
+*********
+
+.. Fixes for situations where brz would previously crash or give incorrect
+   or undesirable results.
+
+Documentation
+*************
+
+.. Improved or updated documentation.
+
+API Changes
+***********
+
+.. Changes that may require updates in plugins or other code that uses
+   breezy.
+
+Internals
+*********
+
+.. Major internal changes, unlikely to be visible to users or plugin 
+   developers, but interesting for brz developers.
+
+Testing
+*******
+
+.. Fixes and changes that are only relevant to brz's test framework and 
+   suite.  This can include new facilities for writing tests, fixes to 
+   spurious test failures and changes to the way things should be tested.
+
+
+..
+   vim: tw=74 ft=rst ff=unix

=== added file 'doc/en/whats-new/whats-new-in-3.2.txt'
--- doc/en/whats-new/whats-new-in-3.2.txt	1970-01-01 00:00:00 +0000
+++ doc/en/whats-new/whats-new-in-3.2.txt	2020-02-16 23:17:30 +0000
@@ -0,0 +1,27 @@
+*************************
+What's New in Breezy x.y?
+*************************
+
+Breezy x.y is still under development, and will be released in Month Year.
+This document accumulates a high level summary of what's changed.  See the
+:doc:`../release-notes/index` for a full list.
+
+The ``brz lp-propose`` command has been removed in favour of the ``brz propose`` command,
+which also supports Launchpad.
+
+Further information
+*******************
+
+For more detailed information on the changes made, see the the
+:doc:`../release-notes/index` for:
+
+* the interim brz `milestones <https://launchpad.net/bzr/x.y>`_
+* the plugins you use.
+
+For a summary of changes made in earlier releases, see:
+
+* :doc:`whats-new-in-2.1`
+* :doc:`whats-new-in-2.2`
+* :doc:`whats-new-in-2.3`
+<intermediate series here>
+* :doc:`whats-new-in-x.(y-1)`

=== modified file 'profile_imports.py'
--- profile_imports.py	2018-11-18 19:48:57 +0000
+++ profile_imports.py	2020-02-18 01:57:45 +0000
@@ -17,8 +17,6 @@
 
 """A custom importer and regex compiler which logs time spent."""
 
-from __future__ import absolute_import
-
 import re
 import sys
 import time
@@ -108,8 +106,6 @@
     # /usr/lib/python2.6/email/__init__.py then there may be only one
     # parameter
     # level has different default between Python 2 and 3, but codebase
-    # uses `from __future__ import absolute_import` so can just use 0.
-
     if globals is None:
         # can't determine the scope name afaics; we could peek up the stack to
         # see where this is being called from, but it should be a rare case.

=== modified file 'setup.py'
--- setup.py	2020-01-31 17:43:44 +0000
+++ setup.py	2020-02-21 04:28:46 +0000
@@ -12,8 +12,8 @@
 import copy
 import glob
 
-if sys.version_info < (2, 7):
-    sys.stderr.write("[ERROR] Not a supported Python version. Need 2.7+\n")
+if sys.version_info < (3, 5):
+    sys.stderr.write("[ERROR] Not a supported Python version. Need 3.5+\n")
     sys.exit(1)
 
 
@@ -64,7 +64,6 @@
         ],
     'install_requires': [
         'configobj',
-        'six>=1.9.0',
         'patiencediff',
         # Technically, Breezy works without these two dependencies too. But there's
         # no way to enable them by default and let users opt out.
@@ -595,12 +594,6 @@
         includes.append(module)
 
     additional_packages = set()
-    if sys.version.startswith('2.7'):
-        additional_packages.add('xml.etree')
-    else:
-        import warnings
-        warnings.warn('Unknown Python version.\n'
-                      'Please check setup.py script for compatibility.')
 
     # Although we currently can't enforce it, we consider it an error for
     # py2exe to report any files are "missing".  Such modules we know aren't

=== modified file 'tools/brzflakes.py'
--- tools/brzflakes.py	2018-11-16 11:37:47 +0000
+++ tools/brzflakes.py	2020-02-18 01:57:45 +0000
@@ -1,7 +1,5 @@
 #!/usr/bin/python3
 
-from __future__ import absolute_import
-
 import ast
 
 from pyflakes.checker import Checker, ImportationFrom

=== modified file 'tools/capture_tree.py'
--- tools/capture_tree.py	2018-11-17 16:19:11 +0000
+++ tools/capture_tree.py	2020-02-18 01:57:45 +0000
@@ -8,8 +8,6 @@
 This can be useful in tests that need to recreate directory
 contents."""
 
-from __future__ import print_function
-
 import os
 import sys
 

=== modified file 'tools/prepare_for_latex.py'
--- tools/prepare_for_latex.py	2020-01-31 17:43:44 +0000
+++ tools/prepare_for_latex.py	2020-02-18 01:57:45 +0000
@@ -26,8 +26,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from __future__ import print_function
-
 import os
 import re
 import shutil

=== modified file 'tools/rst2prettyhtml.py'
--- tools/rst2prettyhtml.py	2020-01-31 17:43:44 +0000
+++ tools/rst2prettyhtml.py	2020-02-07 02:14:30 +0000
@@ -2,7 +2,7 @@
 
 import errno
 import os
-from breezy.sixish import StringIO
+from io import StringIO
 import sys
 
 try:

=== removed file 'tools/testr-run.py'
--- tools/testr-run.py	2020-01-31 10:39:02 +0000
+++ tools/testr-run.py	1970-01-01 00:00:00 +0000
@@ -1,71 +0,0 @@
-#!/usr/bin/python3
-
-import argparse
-import subprocess
-from subunit.v2 import StreamResultToBytes
-import sys
-import tempfile
-from testrepository.testlist import parse_enumeration, parse_list, write_list
-
-
-def main():
-    parser = argparse.ArgumentParser(
-        description="Test runner that supports both Python 2 and Python 3.")
-
-    parser.add_argument(
-        "--load-list", metavar="PATH", help="Path to read list of tests to run from.",
-        type=str)
-    parser.add_argument(
-        "--list", help="List available tests.", action="store_true")
-
-    args = parser.parse_args()
-
-    if args.list:
-        testids = []
-        output = subprocess.check_output(
-            ['python2', './brz', 'selftest', '--subunit2', '--list'])
-        for n in parse_enumeration(output):
-            testids.append('python2.' + n)
-
-        output = subprocess.check_output(
-            ['python3', './brz', 'selftest', '--subunit2', '--list'])
-        for n in parse_enumeration(output):
-            testids.append('python3.' + n)
-        stream = StreamResultToBytes(sys.stdout)
-        for testid in testids:
-            stream.status(test_id=testid, test_status='exists')
-    else:
-        if args.load_list:
-            py2_tests = []
-            py3_tests = []
-            with open(args.load_list, 'rb') as f:
-                all_tests = parse_list(f.read())
-            for testname in all_tests:
-                if testname.startswith("python2."):
-                    py2_tests.append(testname[len('python2.'):].strip())
-                elif testname.startswith("python3."):
-                    py3_tests.append(testname[len('python3.'):].strip())
-                else:
-                    sys.stderr.write("unknown prefix %s\n" % testname)
-            if py2_tests:
-                with tempfile.NamedTemporaryFile() as py2f:
-                    write_list(py2f, py2_tests)
-                    py2f.flush()
-                    subprocess.call(
-                        'python2 ./brz selftest --subunit2 --load-list=%s | subunit-filter -s --passthrough --rename "^" "python2."' % py2f.name, shell=True)
-
-            if py3_tests:
-                with tempfile.NamedTemporaryFile() as py3f:
-                    write_list(py3f, py3_tests)
-                    py3f.flush()
-                    subprocess.call(
-                        'python3 ./brz selftest --subunit2 --load-list=%s | subunit-filter -s --passthrough --rename "^" "python3."' % py3f.name, shell=True)
-        else:
-            subprocess.call(
-                'python2 ./brz selftest --subunit2 | subunit-filter -s --passthrough --rename "^" "python2."', shell=True)
-            subprocess.call(
-                'python3 ./brz selftest --subunit2 | subunit-filter -s --passthrough --rename "^" "python3."', shell=True)
-
-
-if __name__ == '__main__':
-    main()

